/* Upgrades.c generated by valac 0.16.0, the Vala compiler
 * generated from Upgrades.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* Class for aggregating one-off "upgrade" tasks that occur at startup, such as*/
/* moving or deleting files. This occurs after the UI is shown, so it's not appropriate*/
/* for database updates and such.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_UPGRADES (upgrades_get_type ())
#define UPGRADES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPGRADES, Upgrades))
#define UPGRADES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UPGRADES, UpgradesClass))
#define IS_UPGRADES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPGRADES))
#define IS_UPGRADES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UPGRADES))
#define UPGRADES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UPGRADES, UpgradesClass))

typedef struct _Upgrades Upgrades;
typedef struct _UpgradesClass UpgradesClass;
typedef struct _UpgradesPrivate UpgradesPrivate;

#define TYPE_UPGRADE_TASK (upgrade_task_get_type ())
#define UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UPGRADE_TASK, UpgradeTask))
#define IS_UPGRADE_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UPGRADE_TASK))
#define UPGRADE_TASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_UPGRADE_TASK, UpgradeTaskIface))

typedef struct _UpgradeTask UpgradeTask;
typedef struct _UpgradeTaskIface UpgradeTaskIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MIMICS_REMOVAL_TASK (mimics_removal_task_get_type ())
#define MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTask))
#define MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))
#define IS_MIMICS_REMOVAL_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIMICS_REMOVAL_TASK))
#define IS_MIMICS_REMOVAL_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIMICS_REMOVAL_TASK))
#define MIMICS_REMOVAL_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskClass))

typedef struct _MimicsRemovalTask MimicsRemovalTask;
typedef struct _MimicsRemovalTaskClass MimicsRemovalTaskClass;
#define _upgrades_unref0(var) ((var == NULL) ? NULL : (var = (upgrades_unref (var), NULL)))
typedef struct _ParamSpecUpgrades ParamSpecUpgrades;
typedef struct _MimicsRemovalTaskPrivate MimicsRemovalTaskPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Upgrades {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UpgradesPrivate * priv;
};

struct _UpgradesClass {
	GTypeClass parent_class;
	void (*finalize) (Upgrades *self);
};

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UpgradeTaskIface {
	GTypeInterface parent_iface;
	guint64 (*get_step_count) (UpgradeTask* self);
	void (*execute) (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target);
};

struct _UpgradesPrivate {
	guint64 total_steps;
	GeeLinkedList* task_list;
};

struct _ParamSpecUpgrades {
	GParamSpec parent_instance;
};

struct _MimicsRemovalTask {
	GObject parent_instance;
	MimicsRemovalTaskPrivate * priv;
};

struct _MimicsRemovalTaskClass {
	GObjectClass parent_class;
};

struct _MimicsRemovalTaskPrivate {
	GFile* mimic_dir;
	guint64 num_mimics;
};


static gpointer upgrades_parent_class = NULL;
static Upgrades* upgrades_instance;
static Upgrades* upgrades_instance = NULL;
static gpointer mimics_removal_task_parent_class = NULL;
static UpgradeTaskIface* mimics_removal_task_upgrade_task_parent_iface = NULL;

gpointer upgrades_ref (gpointer instance);
void upgrades_unref (gpointer instance);
GParamSpec* param_spec_upgrades (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_upgrades (GValue* value, gpointer v_object);
void value_take_upgrades (GValue* value, gpointer v_object);
gpointer value_get_upgrades (const GValue* value);
GType upgrades_get_type (void) G_GNUC_CONST;
GType upgrade_task_get_type (void) G_GNUC_CONST;
#define UPGRADES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UPGRADES, UpgradesPrivate))
enum  {
	UPGRADES_DUMMY_PROPERTY
};
static Upgrades* upgrades_new (void);
static Upgrades* upgrades_construct (GType object_type);
static void upgrades_add (Upgrades* self, UpgradeTask* task);
MimicsRemovalTask* mimics_removal_task_new (void);
MimicsRemovalTask* mimics_removal_task_construct (GType object_type);
GType mimics_removal_task_get_type (void) G_GNUC_CONST;
void upgrades_init (void);
Upgrades* upgrades_get_instance (void);
guint64 upgrades_get_step_count (Upgrades* self);
void upgrades_execute (Upgrades* self, ProgressMonitor monitor, void* monitor_target);
void upgrade_task_execute (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target);
guint64 upgrade_task_get_step_count (UpgradeTask* self);
static void upgrades_finalize (Upgrades* obj);
#define MIMICS_REMOVAL_TASK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MIMICS_REMOVAL_TASK, MimicsRemovalTaskPrivate))
enum  {
	MIMICS_REMOVAL_TASK_DUMMY_PROPERTY
};
GFile* app_dirs_get_data_dir (void);
static guint64 mimics_removal_task_real_get_step_count (UpgradeTask* base);
guint64 count_files_in_directory (GFile* dir, GError** error);
static void mimics_removal_task_real_execute (UpgradeTask* base, ProgressMonitor monitor, void* monitor_target);
void delete_all_files (GFile* dir, GeeSet* exceptions, ProgressMonitor monitor, void* monitor_target, guint64 file_count, GCancellable* cancellable, GError** error);
static void mimics_removal_task_finalize (GObject* obj);


static Upgrades* upgrades_construct (GType object_type) {
	Upgrades* self = NULL;
	MimicsRemovalTask* _tmp0_;
	MimicsRemovalTask* _tmp1_;
#line 15 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = (Upgrades*) g_type_create_instance (object_type);
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = mimics_removal_task_new ();
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp1_ = _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	upgrades_add (self, UPGRADE_TASK (_tmp1_));
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_g_object_unref0 (_tmp1_);
#line 15 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return self;
#line 158 "Upgrades.c"
}


static Upgrades* upgrades_new (void) {
#line 15 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return upgrades_construct (TYPE_UPGRADES);
#line 165 "Upgrades.c"
}


void upgrades_init (void) {
	Upgrades* _tmp0_;
	Upgrades* _tmp1_;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = upgrades_instance;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_assert (_tmp0_ == NULL);
#line 23 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp1_ = upgrades_new ();
#line 23 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_upgrades_unref0 (upgrades_instance);
#line 23 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	upgrades_instance = _tmp1_;
#line 182 "Upgrades.c"
}


static gpointer _upgrades_ref0 (gpointer self) {
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return self ? upgrades_ref (self) : NULL;
#line 189 "Upgrades.c"
}


Upgrades* upgrades_get_instance (void) {
	Upgrades* result = NULL;
	Upgrades* _tmp0_;
	Upgrades* _tmp1_;
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = upgrades_instance;
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp1_ = _upgrades_ref0 (_tmp0_);
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	result = _tmp1_;
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return result;
#line 205 "Upgrades.c"
}


guint64 upgrades_get_step_count (Upgrades* self) {
	guint64 result = 0ULL;
	guint64 _tmp0_;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_val_if_fail (IS_UPGRADES (self), 0ULL);
#line 32 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = self->priv->total_steps;
#line 32 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return result;
#line 220 "Upgrades.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return self ? g_object_ref (self) : NULL;
#line 227 "Upgrades.c"
}


void upgrades_execute (Upgrades* self, ProgressMonitor monitor, void* monitor_target) {
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (IS_UPGRADES (self));
#line 234 "Upgrades.c"
	{
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _task_list;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _task_size;
		gint _task_index;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp0_ = self->priv->task_list;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_task_list = _tmp1_;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp2_ = _task_list;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp3_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp2_));
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp4_ = _tmp3_;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_task_size = _tmp4_;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_task_index = -1;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		while (TRUE) {
#line 262 "Upgrades.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			UpgradeTask* task;
			UpgradeTask* _tmp11_;
			ProgressMonitor _tmp12_;
			void* _tmp12__target;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp5_ = _task_index;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_task_index = _tmp5_ + 1;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp6_ = _task_index;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp7_ = _task_size;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
				break;
#line 285 "Upgrades.c"
			}
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp8_ = _task_list;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp9_ = _task_index;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp10_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_tmp8_), _tmp9_);
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			task = (UpgradeTask*) _tmp10_;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp11_ = task;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp12_ = monitor;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_tmp12__target = monitor_target;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			upgrade_task_execute (_tmp11_, _tmp12_, _tmp12__target);
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			_g_object_unref0 (task);
#line 305 "Upgrades.c"
		}
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_g_object_unref0 (_task_list);
#line 309 "Upgrades.c"
	}
}


static void upgrades_add (Upgrades* self, UpgradeTask* task) {
	guint64 _tmp0_;
	UpgradeTask* _tmp1_;
	guint64 _tmp2_ = 0ULL;
	GeeLinkedList* _tmp3_;
	UpgradeTask* _tmp4_;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (IS_UPGRADES (self));
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (IS_UPGRADE_TASK (task));
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = self->priv->total_steps;
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp1_ = task;
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp2_ = upgrade_task_get_step_count (_tmp1_);
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv->total_steps = _tmp0_ + _tmp2_;
#line 43 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp3_ = self->priv->task_list;
#line 43 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp4_ = task;
#line 43 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp3_), _tmp4_);
#line 338 "Upgrades.c"
}


static void value_upgrades_init (GValue* value) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	value->data[0].v_pointer = NULL;
#line 345 "Upgrades.c"
}


static void value_upgrades_free_value (GValue* value) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		upgrades_unref (value->data[0].v_pointer);
#line 354 "Upgrades.c"
	}
}


static void value_upgrades_copy_value (const GValue* src_value, GValue* dest_value) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (src_value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		dest_value->data[0].v_pointer = upgrades_ref (src_value->data[0].v_pointer);
#line 364 "Upgrades.c"
	} else {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		dest_value->data[0].v_pointer = NULL;
#line 368 "Upgrades.c"
	}
}


static gpointer value_upgrades_peek_pointer (const GValue* value) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return value->data[0].v_pointer;
#line 376 "Upgrades.c"
}


static gchar* value_upgrades_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (collect_values[0].v_pointer) {
#line 383 "Upgrades.c"
		Upgrades* object;
		object = collect_values[0].v_pointer;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		if (object->parent_instance.g_class == NULL) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 390 "Upgrades.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 394 "Upgrades.c"
		}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = upgrades_ref (object);
#line 398 "Upgrades.c"
	} else {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 402 "Upgrades.c"
	}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return NULL;
#line 406 "Upgrades.c"
}


static gchar* value_upgrades_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Upgrades** object_p;
	object_p = collect_values[0].v_pointer;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (!object_p) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 417 "Upgrades.c"
	}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (!value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		*object_p = NULL;
#line 423 "Upgrades.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		*object_p = value->data[0].v_pointer;
#line 427 "Upgrades.c"
	} else {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		*object_p = upgrades_ref (value->data[0].v_pointer);
#line 431 "Upgrades.c"
	}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return NULL;
#line 435 "Upgrades.c"
}


GParamSpec* param_spec_upgrades (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUpgrades* spec;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UPGRADES), NULL);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return G_PARAM_SPEC (spec);
#line 449 "Upgrades.c"
}


gpointer value_get_upgrades (const GValue* value) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES), NULL);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return value->data[0].v_pointer;
#line 458 "Upgrades.c"
}


void value_set_upgrades (GValue* value, gpointer v_object) {
	Upgrades* old;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	old = value->data[0].v_pointer;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (v_object) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = v_object;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		upgrades_ref (value->data[0].v_pointer);
#line 478 "Upgrades.c"
	} else {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 482 "Upgrades.c"
	}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (old) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		upgrades_unref (old);
#line 488 "Upgrades.c"
	}
}


void value_take_upgrades (GValue* value, gpointer v_object) {
	Upgrades* old;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UPGRADES));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	old = value->data[0].v_pointer;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (v_object) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UPGRADES));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = v_object;
#line 507 "Upgrades.c"
	} else {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		value->data[0].v_pointer = NULL;
#line 511 "Upgrades.c"
	}
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (old) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		upgrades_unref (old);
#line 517 "Upgrades.c"
	}
}


static void upgrades_class_init (UpgradesClass * klass) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	upgrades_parent_class = g_type_class_peek_parent (klass);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	UPGRADES_CLASS (klass)->finalize = upgrades_finalize;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_type_class_add_private (klass, sizeof (UpgradesPrivate));
#line 529 "Upgrades.c"
}


static void upgrades_instance_init (Upgrades * self) {
	GeeLinkedList* _tmp0_;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv = UPGRADES_GET_PRIVATE (self);
#line 12 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv->total_steps = (guint64) 0;
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = gee_linked_list_new (TYPE_UPGRADE_TASK, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv->task_list = _tmp0_;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->ref_count = 1;
#line 545 "Upgrades.c"
}


static void upgrades_finalize (Upgrades* obj) {
	Upgrades * self;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = UPGRADES (obj);
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_g_object_unref0 (self->priv->task_list);
#line 555 "Upgrades.c"
}


GType upgrades_get_type (void) {
	static volatile gsize upgrades_type_id__volatile = 0;
	if (g_once_init_enter (&upgrades_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_upgrades_init, value_upgrades_free_value, value_upgrades_copy_value, value_upgrades_peek_pointer, "p", value_upgrades_collect_value, "p", value_upgrades_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UpgradesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upgrades_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Upgrades), 0, (GInstanceInitFunc) upgrades_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType upgrades_type_id;
		upgrades_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Upgrades", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&upgrades_type_id__volatile, upgrades_type_id);
	}
	return upgrades_type_id__volatile;
}


gpointer upgrades_ref (gpointer instance) {
	Upgrades* self;
	self = instance;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_atomic_int_inc (&self->ref_count);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return instance;
#line 580 "Upgrades.c"
}


void upgrades_unref (gpointer instance) {
	Upgrades* self;
	self = instance;
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		UPGRADES_GET_CLASS (self)->finalize (self);
#line 10 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 593 "Upgrades.c"
	}
}


guint64 upgrade_task_get_step_count (UpgradeTask* self) {
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_val_if_fail (IS_UPGRADE_TASK (self), 0ULL);
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return UPGRADE_TASK_GET_INTERFACE (self)->get_step_count (self);
#line 603 "Upgrades.c"
}


void upgrade_task_execute (UpgradeTask* self, ProgressMonitor monitor, void* monitor_target) {
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_return_if_fail (IS_UPGRADE_TASK (self));
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	UPGRADE_TASK_GET_INTERFACE (self)->execute (self, monitor, monitor_target);
#line 612 "Upgrades.c"
}


static void upgrade_task_base_init (UpgradeTaskIface * iface) {
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	static gboolean initialized = FALSE;
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (!initialized) {
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		initialized = TRUE;
#line 623 "Upgrades.c"
	}
}


GType upgrade_task_get_type (void) {
	static volatile gsize upgrade_task_type_id__volatile = 0;
	if (g_once_init_enter (&upgrade_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UpgradeTaskIface), (GBaseInitFunc) upgrade_task_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType upgrade_task_type_id;
		upgrade_task_type_id = g_type_register_static (G_TYPE_INTERFACE, "UpgradeTask", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (upgrade_task_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&upgrade_task_type_id__volatile, upgrade_task_type_id);
	}
	return upgrade_task_type_id__volatile;
}


static guint64 mimics_removal_task_real_get_step_count (UpgradeTask* base) {
	MimicsRemovalTask * self;
	guint64 result = 0ULL;
	guint64 _tmp5_;
	GError * _inner_error_ = NULL;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = MIMICS_REMOVAL_TASK (base);
#line 648 "Upgrades.c"
	{
		GFile* _tmp0_;
		guint64 _tmp1_ = 0ULL;
		guint64 _tmp2_;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp0_ = self->priv->mimic_dir;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp1_ = count_files_in_directory (_tmp0_, &_inner_error_);
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp2_ = _tmp1_;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		if (_inner_error_ != NULL) {
#line 661 "Upgrades.c"
			goto __catch536_g_error;
		}
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		self->priv->num_mimics = _tmp2_;
#line 666 "Upgrades.c"
	}
	goto __finally536;
	__catch536_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		e = _inner_error_;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_inner_error_ = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp3_ = e;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp4_ = _tmp3_->message;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_debug ("Upgrades.vala:72: Error on deleting mimics: %s", _tmp4_);
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_g_error_free0 (e);
#line 686 "Upgrades.c"
	}
	__finally536:
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (_inner_error_ != NULL) {
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_clear_error (&_inner_error_);
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		return 0ULL;
#line 697 "Upgrades.c"
	}
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp5_ = self->priv->num_mimics;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	result = _tmp5_;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return result;
#line 705 "Upgrades.c"
}


static void mimics_removal_task_real_execute (UpgradeTask* base, ProgressMonitor monitor, void* monitor_target) {
	MimicsRemovalTask * self;
	GError * _inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = MIMICS_REMOVAL_TASK (base);
#line 714 "Upgrades.c"
	{
		GFile* _tmp0_;
		ProgressMonitor _tmp1_;
		void* _tmp1__target;
		guint64 _tmp2_;
		GFile* _tmp3_;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp0_ = self->priv->mimic_dir;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp1_ = monitor;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp1__target = monitor_target;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp2_ = self->priv->num_mimics;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		delete_all_files (_tmp0_, NULL, _tmp1_, _tmp1__target, _tmp2_, NULL, &_inner_error_);
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		if (_inner_error_ != NULL) {
#line 733 "Upgrades.c"
			goto __catch537_g_error;
		}
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp3_ = self->priv->mimic_dir;
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_file_delete (_tmp3_, NULL, &_inner_error_);
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		if (_inner_error_ != NULL) {
#line 742 "Upgrades.c"
			goto __catch537_g_error;
		}
	}
	goto __finally537;
	__catch537_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		e = _inner_error_;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_inner_error_ = NULL;
#line 82 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp4_ = e;
#line 82 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_tmp5_ = _tmp4_->message;
#line 82 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_debug ("Upgrades.vala:82: Could not delete mimics: %s", _tmp5_);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		_g_error_free0 (e);
#line 764 "Upgrades.c"
	}
	__finally537:
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	if (_inner_error_ != NULL) {
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		g_clear_error (&_inner_error_);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
		return;
#line 775 "Upgrades.c"
	}
}


MimicsRemovalTask* mimics_removal_task_construct (GType object_type) {
	MimicsRemovalTask * self = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = (MimicsRemovalTask*) g_object_new (object_type, NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return self;
#line 786 "Upgrades.c"
}


MimicsRemovalTask* mimics_removal_task_new (void) {
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	return mimics_removal_task_construct (TYPE_MIMICS_REMOVAL_TASK);
#line 793 "Upgrades.c"
}


static void mimics_removal_task_class_init (MimicsRemovalTaskClass * klass) {
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	mimics_removal_task_parent_class = g_type_class_peek_parent (klass);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	g_type_class_add_private (klass, sizeof (MimicsRemovalTaskPrivate));
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	G_OBJECT_CLASS (klass)->finalize = mimics_removal_task_finalize;
#line 804 "Upgrades.c"
}


static void mimics_removal_task_upgrade_task_interface_init (UpgradeTaskIface * iface) {
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	mimics_removal_task_upgrade_task_parent_iface = g_type_interface_peek_parent (iface);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	iface->get_step_count = (guint64 (*)(UpgradeTask*)) mimics_removal_task_real_get_step_count;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	iface->execute = (void (*)(UpgradeTask*, ProgressMonitor, void*)) mimics_removal_task_real_execute;
#line 815 "Upgrades.c"
}


static void mimics_removal_task_instance_init (MimicsRemovalTask * self) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv = MIMICS_REMOVAL_TASK_GET_PRIVATE (self);
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp0_ = app_dirs_get_data_dir ();
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp1_ = _tmp0_;
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_tmp2_ = g_file_get_child (_tmp1_, "mimics");
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv->mimic_dir = _tmp2_;
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_g_object_unref0 (_tmp1_);
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self->priv->num_mimics = (guint64) 0;
#line 837 "Upgrades.c"
}


static void mimics_removal_task_finalize (GObject* obj) {
	MimicsRemovalTask * self;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	self = MIMICS_REMOVAL_TASK (obj);
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	_g_object_unref0 (self->priv->mimic_dir);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/Upgrades.vala"
	G_OBJECT_CLASS (mimics_removal_task_parent_class)->finalize (obj);
#line 849 "Upgrades.c"
}


GType mimics_removal_task_get_type (void) {
	static volatile gsize mimics_removal_task_type_id__volatile = 0;
	if (g_once_init_enter (&mimics_removal_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MimicsRemovalTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mimics_removal_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MimicsRemovalTask), 0, (GInstanceInitFunc) mimics_removal_task_instance_init, NULL };
		static const GInterfaceInfo upgrade_task_info = { (GInterfaceInitFunc) mimics_removal_task_upgrade_task_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType mimics_removal_task_type_id;
		mimics_removal_task_type_id = g_type_register_static (G_TYPE_OBJECT, "MimicsRemovalTask", &g_define_type_info, 0);
		g_type_add_interface_static (mimics_removal_task_type_id, TYPE_UPGRADE_TASK, &upgrade_task_info);
		g_once_init_leave (&mimics_removal_task_type_id__volatile, mimics_removal_task_type_id);
	}
	return mimics_removal_task_type_id__volatile;
}



