/* FaceTable.c generated by valac 0.16.0, the Vala compiler
 * generated from FaceTable.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_ROW (face_row_get_type ())
#define FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_ROW, FaceRow))
#define FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_ROW, FaceRowClass))
#define IS_FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_ROW))
#define IS_FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_ROW))
#define FACE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_ROW, FaceRowClass))

typedef struct _FaceRow FaceRow;
typedef struct _FaceRowClass FaceRowClass;
typedef struct _FaceRowPrivate FaceRowPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecFaceRow ParamSpecFaceRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;
typedef struct _FaceTablePrivate FaceTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _face_row_unref0(var) ((var == NULL) ? NULL : (var = (face_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FaceID {
	gint64 id;
};

struct _FaceRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FaceRowPrivate * priv;
	FaceID face_id;
	gchar* name;
	time_t time_created;
};

struct _FaceRowClass {
	GTypeClass parent_class;
	void (*finalize) (FaceRow *self);
};

struct _ParamSpecFaceRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _FaceTable {
	DatabaseTable parent_instance;
	FaceTablePrivate * priv;
};

struct _FaceTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer face_row_parent_class = NULL;
static gpointer face_table_parent_class = NULL;
static FaceTable* face_table_instance;
static FaceTable* face_table_instance = NULL;
extern sqlite3* database_table_db;

GType face_id_get_type (void) G_GNUC_CONST;
FaceID* face_id_dup (const FaceID* self);
void face_id_free (FaceID* self);
#define FACE_ID_INVALID ((gint64) (-1))
void face_id_init (FaceID *self, gint64 id);
gboolean face_id_is_invalid (FaceID *self);
gboolean face_id_is_valid (FaceID *self);
gpointer face_row_ref (gpointer instance);
void face_row_unref (gpointer instance);
GParamSpec* param_spec_face_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_face_row (GValue* value, gpointer v_object);
void value_take_face_row (GValue* value, gpointer v_object);
gpointer value_get_face_row (const GValue* value);
GType face_row_get_type (void) G_GNUC_CONST;
enum  {
	FACE_ROW_DUMMY_PROPERTY
};
FaceRow* face_row_new (void);
FaceRow* face_row_construct (GType object_type);
static void face_row_finalize (FaceRow* obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType face_table_get_type (void) G_GNUC_CONST;
enum  {
	FACE_TABLE_DUMMY_PROPERTY
};
static FaceTable* face_table_new (void);
static FaceTable* face_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
FaceTable* face_table_get_instance (void);
GQuark database_error_quark (void);
FaceRow* face_table_add (FaceTable* self, const gchar* name, GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method, gint res, GError** error);
void face_table_create_from_row (FaceTable* self, FaceRow* row, FaceID* result, GError** error);
void face_table_remove (FaceTable* self, FaceID* face_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gchar* face_table_get_name (FaceTable* self, FaceID* face_id, GError** error);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
FaceRow* face_table_get_row (FaceTable* self, FaceID* face_id, GError** error);
GeeList* face_table_get_all_rows (FaceTable* self, GError** error);
void face_table_rename (FaceTable* self, FaceID* face_id, const gchar* new_name, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
static void face_table_finalize (DatabaseTable* obj);


void face_id_init (FaceID *self, gint64 id) {
	gint64 _tmp0_;
#line 12 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	memset (self, 0, sizeof (FaceID));
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = id;
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	(*self).id = _tmp0_;
#line 183 "FaceTable.c"
}


gboolean face_id_is_invalid (FaceID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = _tmp0_ == FACE_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 196 "FaceTable.c"
}


gboolean face_id_is_valid (FaceID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = _tmp0_ != FACE_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 209 "FaceTable.c"
}


FaceID* face_id_dup (const FaceID* self) {
	FaceID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	dup = g_new0 (FaceID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	memcpy (dup, self, sizeof (FaceID));
#line 7 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return dup;
#line 221 "FaceTable.c"
}


void face_id_free (FaceID* self) {
#line 7 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_free (self);
#line 228 "FaceTable.c"
}


GType face_id_get_type (void) {
	static volatile gsize face_id_type_id__volatile = 0;
	if (g_once_init_enter (&face_id_type_id__volatile)) {
		GType face_id_type_id;
		face_id_type_id = g_boxed_type_register_static ("FaceID", (GBoxedCopyFunc) face_id_dup, (GBoxedFreeFunc) face_id_free);
		g_once_init_leave (&face_id_type_id__volatile, face_id_type_id);
	}
	return face_id_type_id__volatile;
}


FaceRow* face_row_construct (GType object_type) {
	FaceRow* self = NULL;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	self = (FaceRow*) g_type_create_instance (object_type);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return self;
#line 249 "FaceTable.c"
}


FaceRow* face_row_new (void) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return face_row_construct (TYPE_FACE_ROW);
#line 256 "FaceTable.c"
}


static void value_face_row_init (GValue* value) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	value->data[0].v_pointer = NULL;
#line 263 "FaceTable.c"
}


static void value_face_row_free_value (GValue* value) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		face_row_unref (value->data[0].v_pointer);
#line 272 "FaceTable.c"
	}
}


static void value_face_row_copy_value (const GValue* src_value, GValue* dest_value) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = face_row_ref (src_value->data[0].v_pointer);
#line 282 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 286 "FaceTable.c"
	}
}


static gpointer value_face_row_peek_pointer (const GValue* value) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 294 "FaceTable.c"
}


static gchar* value_face_row_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (collect_values[0].v_pointer) {
#line 301 "FaceTable.c"
		FaceRow* object;
		object = collect_values[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 308 "FaceTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 312 "FaceTable.c"
		}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = face_row_ref (object);
#line 316 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 320 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return NULL;
#line 324 "FaceTable.c"
}


static gchar* value_face_row_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	FaceRow** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (!object_p) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 335 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (!value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		*object_p = NULL;
#line 341 "FaceTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		*object_p = value->data[0].v_pointer;
#line 345 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		*object_p = face_row_ref (value->data[0].v_pointer);
#line 349 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return NULL;
#line 353 "FaceTable.c"
}


GParamSpec* param_spec_face_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecFaceRow* spec;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FACE_ROW), NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return G_PARAM_SPEC (spec);
#line 367 "FaceTable.c"
}


gpointer value_get_face_row (const GValue* value) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW), NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 376 "FaceTable.c"
}


void value_set_face_row (GValue* value, gpointer v_object) {
	FaceRow* old;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (v_object) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		face_row_ref (value->data[0].v_pointer);
#line 396 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 400 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (old) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		face_row_unref (old);
#line 406 "FaceTable.c"
	}
}


void value_take_face_row (GValue* value, gpointer v_object) {
	FaceRow* old;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (v_object) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 425 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 429 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (old) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		face_row_unref (old);
#line 435 "FaceTable.c"
	}
}


static void face_row_class_init (FaceRowClass * klass) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	face_row_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	FACE_ROW_CLASS (klass)->finalize = face_row_finalize;
#line 445 "FaceTable.c"
}


static void face_row_instance_init (FaceRow * self) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	self->ref_count = 1;
#line 452 "FaceTable.c"
}


static void face_row_finalize (FaceRow* obj) {
	FaceRow * self;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	self = FACE_ROW (obj);
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_g_free0 (self->name);
#line 462 "FaceTable.c"
}


GType face_row_get_type (void) {
	static volatile gsize face_row_type_id__volatile = 0;
	if (g_once_init_enter (&face_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_face_row_init, value_face_row_free_value, value_face_row_copy_value, value_face_row_peek_pointer, "p", value_face_row_collect_value, "p", value_face_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (FaceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceRow), 0, (GInstanceInitFunc) face_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType face_row_type_id;
		face_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FaceRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&face_row_type_id__volatile, face_row_type_id);
	}
	return face_row_type_id__volatile;
}


gpointer face_row_ref (gpointer instance) {
	FaceRow* self;
	self = instance;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return instance;
#line 487 "FaceTable.c"
}


void face_row_unref (gpointer instance) {
	FaceRow* self;
	self = instance;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		FACE_ROW_GET_CLASS (self)->finalize (self);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 500 "FaceTable.c"
	}
}


static FaceTable* face_table_construct (GType object_type) {
	FaceTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	self = (FaceTable*) database_table_construct (object_type);
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	database_table_set_table_name (DATABASE_TABLE (self), "FaceTable");
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "FaceTable " "(" "id INTEGER NOT NULL PRIMARY KEY, " "name TEXT NOT NULL, " "time_created TIMESTAMP" ")", -1, &_tmp1_, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp2_;
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp5_;
#line 48 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp6_ = res;
#line 48 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 544 "FaceTable.c"
		gint _tmp7_;
#line 49 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp7_ = res;
#line 49 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		database_table_fatal ("create FaceTable", _tmp7_);
#line 550 "FaceTable.c"
	}
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return self;
#line 556 "FaceTable.c"
}


static FaceTable* face_table_new (void) {
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return face_table_construct (TYPE_FACE_TABLE);
#line 563 "FaceTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 570 "FaceTable.c"
}


FaceTable* face_table_get_instance (void) {
	FaceTable* result = NULL;
	FaceTable* _tmp0_;
	FaceTable* _tmp2_;
	FaceTable* _tmp3_;
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = face_table_instance;
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_tmp0_ == NULL) {
#line 583 "FaceTable.c"
		FaceTable* _tmp1_;
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp1_ = face_table_new ();
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_database_table_unref0 (face_table_instance);
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		face_table_instance = _tmp1_;
#line 591 "FaceTable.c"
	}
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = face_table_instance;
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = _tmp3_;
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 601 "FaceTable.c"
}


FaceRow* face_table_add (FaceTable* self, const gchar* name, GError** error) {
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	gulong _tmp4_ = 0UL;
	time_t time_created;
	sqlite3_stmt* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	time_t _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_;
	FaceRow* _tmp19_;
	FaceRow* row;
	FaceRow* _tmp20_;
	sqlite3* _tmp21_;
	gint64 _tmp22_ = 0LL;
	FaceRow* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	FaceRow* _tmp26_;
	time_t _tmp27_;
	GError * _inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp2_;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = now_sec ();
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	time_created = (time_t) _tmp4_;
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp5_ = stmt;
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp6_ = name;
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp8_ = g_free;
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp9_ = sqlite3_bind_text (_tmp5_, 1, _tmp7_, -1, _tmp8_);
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp9_;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp10_ = res;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp10_ == SQLITE_OK);
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp11_ = stmt;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp12_ = time_created;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp13_ = sqlite3_bind_int64 (_tmp11_, 2, (gint64) _tmp12_);
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp13_;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp14_ = res;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp14_ == SQLITE_OK);
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp15_ = stmt;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp16_ = sqlite3_step (_tmp15_);
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp16_;
#line 73 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp17_ = res;
#line 73 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_tmp17_ != SQLITE_DONE) {
#line 699 "FaceTable.c"
		gint _tmp18_;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp18_ = res;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.add", _tmp18_, &_inner_error_);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (_inner_error_ != NULL) {
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error_);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				return NULL;
#line 715 "FaceTable.c"
			} else {
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				return NULL;
#line 725 "FaceTable.c"
			}
		}
	}
#line 76 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp19_ = face_row_new ();
#line 76 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	row = _tmp19_;
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp20_ = row;
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp21_ = database_table_db;
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp22_ = sqlite3_last_insert_rowid (_tmp21_);
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	face_id_init (&_tmp20_->face_id, _tmp22_);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp23_ = row;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp24_ = name;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp25_ = g_strdup (_tmp24_);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_g_free0 (_tmp23_->name);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp23_->name = _tmp25_;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp26_ = row;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp27_ = time_created;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp26_->time_created = _tmp27_;
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = row;
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 763 "FaceTable.c"
}


void face_table_create_from_row (FaceTable* self, FaceRow* row, FaceID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	FaceRow* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	FaceRow* _tmp12_;
	time_t _tmp13_;
	gint _tmp14_ = 0;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	gint _tmp17_ = 0;
	gint _tmp18_;
	sqlite3* _tmp20_;
	gint64 _tmp21_ = 0LL;
	FaceID _tmp22_ = {0};
	GError * _inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_ROW (row));
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp2_;
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp5_ = row;
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp6_ = _tmp5_->name;
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp8_ = g_free;
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp9_ = sqlite3_bind_text (_tmp4_, 1, _tmp7_, -1, _tmp8_);
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp9_;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp10_ = res;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp10_ == SQLITE_OK);
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp11_ = stmt;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp12_ = row;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp13_ = _tmp12_->time_created;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp14_ = sqlite3_bind_int64 (_tmp11_, 2, (gint64) _tmp13_);
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp14_;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp15_ = res;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp15_ == SQLITE_OK);
#line 95 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp16_ = stmt;
#line 95 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp17_ = sqlite3_step (_tmp16_);
#line 95 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp17_;
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp18_ = res;
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_tmp18_ != SQLITE_DONE) {
#line 853 "FaceTable.c"
		gint _tmp19_;
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp19_ = res;
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.create_from_row", _tmp19_, &_inner_error_);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (_inner_error_ != NULL) {
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error_);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				return;
#line 869 "FaceTable.c"
			} else {
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				g_clear_error (&_inner_error_);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				return;
#line 879 "FaceTable.c"
			}
		}
	}
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp20_ = database_table_db;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp21_ = sqlite3_last_insert_rowid (_tmp20_);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	face_id_init (&_tmp22_, _tmp21_);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	*result = _tmp22_;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return;
#line 895 "FaceTable.c"
}


void face_table_remove (FaceTable* self, FaceID* face_id, GError** error) {
	FaceID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	database_table_delete_by_id (DATABASE_TABLE (self), _tmp1_, &_inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_inner_error_ != NULL) {
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return;
#line 921 "FaceTable.c"
		} else {
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_clear_error (&_inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return;
#line 929 "FaceTable.c"
		}
	}
}


gchar* face_table_get_name (FaceTable* self, FaceID* face_id, GError** error) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	FaceID _tmp0_;
	gint64 _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = database_table_select_by_id (DATABASE_TABLE (self), _tmp1_, "name", &_tmp2_);
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp2_;
#line 108 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (!_tmp3_) {
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		result = NULL;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		return result;
#line 967 "FaceTable.c"
	}
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp5_ = sqlite3_column_text (_tmp4_, 0);
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = _tmp6_;
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 981 "FaceTable.c"
}


FaceRow* face_table_get_row (FaceTable* self, FaceID* face_id, GError** error) {
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	FaceID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_;
	FaceRow* _tmp14_;
	FaceRow* row;
	FaceRow* _tmp15_;
	FaceID _tmp16_;
	FaceRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
	FaceRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	gint64 _tmp23_ = 0LL;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, time_created FROM FaceTable WHERE id=?", -1, &_tmp1_, NULL);
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp2_;
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp5_ = *face_id;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp6_ = _tmp5_.id;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp7_ = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp7_;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp8_ = res;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp8_ == SQLITE_OK);
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp9_ = stmt;
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp10_ = sqlite3_step (_tmp9_);
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp10_;
#line 124 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp11_ = res;
#line 124 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_tmp11_ == SQLITE_DONE) {
#line 125 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		result = NULL;
#line 125 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 125 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		return result;
#line 1061 "FaceTable.c"
	} else {
		gint _tmp12_;
#line 126 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp12_ = res;
#line 126 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (_tmp12_ != SQLITE_ROW) {
#line 1068 "FaceTable.c"
			gint _tmp13_;
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp13_ = res;
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			database_table_throw_error ("FaceTable.get_row", _tmp13_, &_inner_error_);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			if (_inner_error_ != NULL) {
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					g_propagate_error (error, _inner_error_);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					return NULL;
#line 1084 "FaceTable.c"
				} else {
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					g_clear_error (&_inner_error_);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					return NULL;
#line 1094 "FaceTable.c"
				}
			}
		}
	}
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp14_ = face_row_new ();
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	row = _tmp14_;
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp15_ = row;
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp16_ = *face_id;
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp15_->face_id = _tmp16_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp17_ = row;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp18_ = stmt;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp19_ = sqlite3_column_text (_tmp18_, 0);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_g_free0 (_tmp17_->name);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp17_->name = _tmp20_;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp21_ = row;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp22_ = stmt;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp23_ = sqlite3_column_int64 (_tmp22_, 1);
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp21_->time_created = (time_t) _tmp23_;
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = row;
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 1135 "FaceTable.c"
}


GeeList* face_table_get_all_rows (FaceTable* self, GError** error) {
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	GeeArrayList* _tmp4_;
	GeeList* rows;
	GError * _inner_error_ = NULL;
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created FROM FaceTable", -1, &_tmp1_, NULL);
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	res = _tmp2_;
#line 141 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 141 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, face_row_unref, NULL);
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	rows = GEE_LIST (_tmp4_);
#line 1170 "FaceTable.c"
	{
		gboolean _tmp5_;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		_tmp5_ = TRUE;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		while (TRUE) {
#line 1177 "FaceTable.c"
			gboolean _tmp6_;
			sqlite3_stmt* _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_;
			FaceRow* _tmp12_;
			FaceRow* row;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			gint64 _tmp15_ = 0LL;
			FaceRow* _tmp16_;
			sqlite3_stmt* _tmp17_;
			const gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			FaceRow* _tmp20_;
			sqlite3_stmt* _tmp21_;
			gint64 _tmp22_ = 0LL;
			GeeList* _tmp23_;
			FaceRow* _tmp24_;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp6_ = _tmp5_;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			if (!_tmp6_) {
#line 1200 "FaceTable.c"
			}
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp5_ = FALSE;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp7_ = stmt;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp8_ = sqlite3_step (_tmp7_);
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			res = _tmp8_;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp9_ = res;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			if (_tmp9_ == SQLITE_DONE) {
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				break;
#line 1216 "FaceTable.c"
			} else {
				gint _tmp10_;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				_tmp10_ = res;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
				if (_tmp10_ != SQLITE_ROW) {
#line 1223 "FaceTable.c"
					gint _tmp11_;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					_tmp11_ = res;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", _tmp11_, &_inner_error_);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
					if (_inner_error_ != NULL) {
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error_);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							return NULL;
#line 1241 "FaceTable.c"
						} else {
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							g_clear_error (&_inner_error_);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
							return NULL;
#line 1253 "FaceTable.c"
						}
					}
				}
			}
#line 153 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp12_ = face_row_new ();
#line 153 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			row = _tmp12_;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp13_ = row;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp15_ = sqlite3_column_int64 (_tmp14_, 0);
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			face_id_init (&_tmp13_->face_id, _tmp15_);
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp16_ = row;
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp17_ = stmt;
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp18_ = sqlite3_column_text (_tmp17_, 1);
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_g_free0 (_tmp16_->name);
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp16_->name = _tmp19_;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp20_ = row;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp21_ = stmt;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp22_ = sqlite3_column_int64 (_tmp21_, 2);
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp20_->time_created = (time_t) _tmp22_;
#line 158 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp23_ = rows;
#line 158 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_tmp24_ = row;
#line 158 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			gee_collection_add (GEE_COLLECTION (_tmp23_), _tmp24_);
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1298 "FaceTable.c"
		}
	}
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	result = rows;
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	return result;
#line 1307 "FaceTable.c"
}


void face_table_rename (FaceTable* self, FaceID* face_id, const gchar* new_name, GError** error) {
	FaceID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	g_return_if_fail (new_name != NULL);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	_tmp2_ = new_name;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp1_, "name", _tmp2_, &_inner_error_);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	if (_inner_error_ != NULL) {
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error_);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return;
#line 1338 "FaceTable.c"
		} else {
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			g_clear_error (&_inner_error_);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
			return;
#line 1346 "FaceTable.c"
		}
	}
}


static void face_table_class_init (FaceTableClass * klass) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	face_table_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	DATABASE_TABLE_CLASS (klass)->finalize = face_table_finalize;
#line 1357 "FaceTable.c"
}


static void face_table_instance_init (FaceTable * self) {
}


static void face_table_finalize (DatabaseTable* obj) {
	FaceTable * self;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	self = FACE_TABLE (obj);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/db/FaceTable.vala"
	DATABASE_TABLE_CLASS (face_table_parent_class)->finalize (obj);
#line 1371 "FaceTable.c"
}


GType face_table_get_type (void) {
	static volatile gsize face_table_type_id__volatile = 0;
	if (g_once_init_enter (&face_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FaceTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceTable), 0, (GInstanceInitFunc) face_table_instance_init, NULL };
		GType face_table_type_id;
		face_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "FaceTable", &g_define_type_info, 0);
		g_once_init_leave (&face_table_type_id__volatile, face_table_type_id);
	}
	return face_table_type_id__volatile;
}



