/* image.c generated by valac 0.16.0, the Vala compiler
 * generated from image.vala, do not modify */

/* Copyright 2009-2012 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>


#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;

#define TYPE_RGB_TRANSFORMATION (rgb_transformation_get_type ())
#define RGB_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_TRANSFORMATION, RGBTransformation))
#define RGB_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_TRANSFORMATION, RGBTransformationClass))
#define IS_RGB_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_TRANSFORMATION))
#define IS_RGB_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_TRANSFORMATION))
#define RGB_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_TRANSFORMATION, RGBTransformationClass))

typedef struct _RGBTransformation RGBTransformation;
typedef struct _RGBTransformationClass RGBTransformationClass;

#define TYPE_SATURATION_TRANSFORMATION (saturation_transformation_get_type ())
#define SATURATION_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SATURATION_TRANSFORMATION, SaturationTransformation))
#define SATURATION_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SATURATION_TRANSFORMATION, SaturationTransformationClass))
#define IS_SATURATION_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SATURATION_TRANSFORMATION))
#define IS_SATURATION_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SATURATION_TRANSFORMATION))
#define SATURATION_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SATURATION_TRANSFORMATION, SaturationTransformationClass))

typedef struct _SaturationTransformation SaturationTransformation;
typedef struct _SaturationTransformationClass SaturationTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



gboolean is_color_parsable (const gchar* spec);
void parse_color (const gchar* spec, GdkRGBA* result);
void fetch_color (const gchar* spec, GdkRGBA* result);
void set_source_color_from_string (cairo_t* ctx, const gchar* spec);
#define MIN_SCALED_WIDTH 10
#define MIN_SCALED_HEIGHT 10
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
#define DEGREE (G_PI / 180.0)
void draw_rounded_corners_filled (cairo_t* ctx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion);
void context_rounded_corners (cairo_t* cx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion);
gint dimensions_minor_axis (Dimensions *self);
guchar shift_color_byte (gint b, gint shift);
void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha);
void dim_pixbuf (GdkPixbuf* pixbuf);
PixelTransformer* pixel_transformer_new (void);
PixelTransformer* pixel_transformer_construct (GType object_type);
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
#define SATURATION_TRANSFORMATION_MIN_PARAMETER (-16.0f)
SaturationTransformation* saturation_transformation_new (gfloat client_parameter);
SaturationTransformation* saturation_transformation_construct (GType object_type, gfloat client_parameter);
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
GType rgb_transformation_get_type (void) G_GNUC_CONST;
GType saturation_transformation_get_type (void) G_GNUC_CONST;
void pixel_transformer_attach_transformation (PixelTransformer* self, PixelTransformation* trans);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect);
gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b);
gchar* rectangle_to_string (GdkRectangle* rect);
void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result);
void scale_point (GdkPoint* p, gdouble factor, GdkPoint* result);
void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);
void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);
void fix_cairo_pixbuf (GdkPixbuf* pixbuf);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
gdouble degrees_to_radians (gdouble theta);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void rotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, gboolean invert, GdkPoint* result);
void derotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void clamp_inside_rotated_image (Box* src, gint img_w, gint img_h, gdouble angle_deg, gboolean preserve_geom, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);


gboolean is_color_parsable (const gchar* spec) {
	gboolean result = FALSE;
	GdkColor color = {0};
	const gchar* _tmp0_;
	GdkColor _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
#line 7 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (spec != NULL, FALSE);
#line 9 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = spec;
#line 9 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = gdk_color_parse (_tmp0_, &_tmp1_);
#line 9 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	color = _tmp1_;
#line 9 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp2_;
#line 9 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 171 "image.c"
}


void parse_color (const gchar* spec, GdkRGBA* result) {
	const gchar* _tmp0_;
	GdkRGBA _tmp1_ = {0};
#line 12 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = spec;
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	fetch_color (_tmp0_, &_tmp1_);
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _tmp1_;
#line 13 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 188 "image.c"
}


void fetch_color (const gchar* spec, GdkRGBA* result) {
	GdkRGBA rgba = {0};
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 16 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 17 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 18 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = spec;
#line 18 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = gdk_rgba_parse (&rgba, _tmp0_);
#line 18 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (!_tmp1_) {
#line 206 "image.c"
		const gchar* _tmp2_;
#line 19 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = spec;
#line 19 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		g_error ("image.vala:19: Can't parse color %s", _tmp2_);
#line 212 "image.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = rgba;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 218 "image.c"
}


void set_source_color_from_string (cairo_t* ctx, const gchar* spec) {
	const gchar* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA rgba;
	cairo_t* _tmp2_;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
#line 24 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (ctx != NULL);
#line 24 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = spec;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	fetch_color (_tmp0_, &_tmp1_);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rgba = _tmp1_;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = ctx;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = rgba;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = _tmp3_.red;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = rgba;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.green;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = rgba;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = _tmp7_.blue;
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_set_source_rgb (_tmp2_, _tmp4_, _tmp6_, _tmp8_);
#line 259 "image.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return self ? g_object_ref (self) : NULL;
#line 266 "image.c"
}


GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions original;
	gint _tmp2_;
	gboolean _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions scaled;
	gboolean _tmp5_ = FALSE;
	Dimensions _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	gboolean _tmp14_;
	Dimensions _tmp17_ = {0};
	GdkPixbuf* _tmp18_;
	Dimensions _tmp19_;
	gint _tmp20_;
	Dimensions _tmp21_;
	gint _tmp22_;
	GdkInterpType _tmp23_;
	GdkPixbuf* _tmp24_ = NULL;
#line 32 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dimensions_for_pixbuf (_tmp0_, &_tmp1_);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	original = _tmp1_;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = scale;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = scale_up;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dimensions_get_scaled (&original, _tmp2_, _tmp3_, &_tmp4_);
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	scaled = _tmp4_;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = original;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = _tmp6_.width;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = scaled;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = _tmp8_.width;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp7_ == _tmp9_) {
#line 319 "image.c"
		Dimensions _tmp10_;
		gint _tmp11_;
		Dimensions _tmp12_;
		gint _tmp13_;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp10_ = original;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp11_ = _tmp10_.height;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = scaled;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp13_ = _tmp12_.height;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp5_ = _tmp11_ == _tmp13_;
#line 334 "image.c"
	} else {
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp5_ = FALSE;
#line 338 "image.c"
	}
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = _tmp5_;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp14_) {
#line 344 "image.c"
		GdkPixbuf* _tmp15_;
		GdkPixbuf* _tmp16_;
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp15_ = pixbuf;
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		result = _tmp16_;
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		return result;
#line 355 "image.c"
	}
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dimensions_with_min (&scaled, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp17_);
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	scaled = _tmp17_;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = pixbuf;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = scaled;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = _tmp19_.width;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = scaled;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp22_ = _tmp21_.height;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp23_ = interp;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp24_ = gdk_pixbuf_scale_simple (_tmp18_, _tmp20_, _tmp22_, _tmp23_);
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp24_;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 379 "image.c"
}


GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions original;
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_;
	gint _tmp4_;
	Dimensions _tmp5_;
	gint _tmp6_;
	gboolean _tmp11_;
	Dimensions _tmp14_ = {0};
	GdkPixbuf* _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	Dimensions _tmp18_;
	gint _tmp19_;
	GdkInterpType _tmp20_;
	GdkPixbuf* _tmp21_ = NULL;
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (resized != NULL, NULL);
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dimensions_for_pixbuf (_tmp0_, &_tmp1_);
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	original = _tmp1_;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = original;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = _tmp3_.width;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *resized;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.width;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp4_ == _tmp6_) {
#line 422 "image.c"
		Dimensions _tmp7_;
		gint _tmp8_;
		Dimensions _tmp9_;
		gint _tmp10_;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp7_ = original;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp8_ = _tmp7_.height;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp9_ = *resized;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp10_ = _tmp9_.height;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = _tmp8_ == _tmp10_;
#line 437 "image.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = FALSE;
#line 441 "image.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp11_) {
#line 447 "image.c"
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = pixbuf;
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		result = _tmp13_;
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		return result;
#line 458 "image.c"
	}
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dimensions_with_min (resized, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp14_);
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*resized = _tmp14_;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = pixbuf;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = *resized;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp17_ = _tmp16_.width;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = *resized;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = _tmp18_.height;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = interp;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = gdk_pixbuf_scale_simple (_tmp15_, _tmp17_, _tmp19_, _tmp20_);
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp21_;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 482 "image.c"
}


void draw_rounded_corners_filled (cairo_t* ctx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion) {
	cairo_t* _tmp0_;
	Dimensions _tmp1_;
	GdkPoint _tmp2_;
	gdouble _tmp3_;
	cairo_t* _tmp4_;
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (ctx != NULL);
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (dim != NULL);
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (origin != NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = ctx;
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = *dim;
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *origin;
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = radius_proportion;
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	context_rounded_corners (_tmp0_, &_tmp1_, &_tmp2_, _tmp3_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = ctx;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_paint (_tmp4_);
#line 512 "image.c"
}


void context_rounded_corners (cairo_t* cx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion) {
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gdouble left;
	GdkPoint _tmp4_;
	gint _tmp5_;
	gdouble top;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	gdouble right;
	GdkPoint _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gdouble bottom;
	gint _tmp14_ = 0;
	gdouble _tmp15_;
	gdouble radius;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (cx != NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (dim != NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (origin != NULL);
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = radius_proportion;
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = CLAMP (_tmp0_, 2.0, 100.0);
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	radius_proportion = _tmp1_;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *origin;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp2_.x;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	left = (gdouble) _tmp3_;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = *origin;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = _tmp4_.y;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	top = (gdouble) _tmp5_;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = *origin;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = _tmp6_.x;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = *dim;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = _tmp8_.width;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	right = (gdouble) (_tmp7_ + _tmp9_);
#line 71 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp10_ = *origin;
#line 71 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp10_.y;
#line 71 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = *dim;
#line 71 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = _tmp12_.height;
#line 71 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	bottom = (gdouble) (_tmp11_ + _tmp13_);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = dimensions_minor_axis (dim);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = radius_proportion;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	radius = ((gdouble) _tmp14_) / _tmp15_;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = cx;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_move_to (_tmp16_, left, top);
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp17_ = cx;
#line 79 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_arc (_tmp17_, right - radius, top + radius, radius, (-90) * DEGREE, 0 * DEGREE);
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = cx;
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_arc (_tmp18_, right - radius, bottom - radius, radius, 0 * DEGREE, 90 * DEGREE);
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = cx;
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_arc (_tmp19_, left + radius, bottom - radius, radius, 90 * DEGREE, 180 * DEGREE);
#line 82 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = cx;
#line 82 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_arc (_tmp20_, left + radius, top + radius, radius, 180 * DEGREE, 270 * DEGREE);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = cx;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_clip (_tmp21_);
#line 618 "image.c"
}


inline guchar shift_color_byte (gint b, gint shift) {
	guchar result = '\0';
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = b;
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = shift;
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = CLAMP (_tmp0_ + _tmp1_, 0, 255);
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = (guchar) _tmp2_;
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 637 "image.c"
}


void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gboolean _tmp11_;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gboolean _tmp15_;
	GdkPixbuf* _tmp16_;
	gint _tmp17_ = 0;
	gint width;
	GdkPixbuf* _tmp18_;
	gint _tmp19_ = 0;
	gint height;
	GdkPixbuf* _tmp20_;
	gint _tmp21_ = 0;
	gint rowstride;
	GdkPixbuf* _tmp22_;
	gint _tmp23_ = 0;
	gint channels;
	GdkPixbuf* _tmp24_;
	guint8* _tmp25_ = NULL;
	guchar* pixels;
	gint _tmp26_;
	GdkPixbuf* _tmp27_;
	GdkColorspace _tmp28_ = 0;
	GdkPixbuf* _tmp29_;
	gint _tmp30_ = 0;
#line 90 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = red;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp1_ >= (-255)) {
#line 680 "image.c"
		gint _tmp2_;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = red;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = _tmp2_ <= 255;
#line 686 "image.c"
	} else {
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = FALSE;
#line 690 "image.c"
	}
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp0_;
#line 91 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp3_);
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = green;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp5_ >= (-255)) {
#line 700 "image.c"
		gint _tmp6_;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp6_ = green;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp4_ = _tmp6_ <= 255;
#line 706 "image.c"
	} else {
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp4_ = FALSE;
#line 710 "image.c"
	}
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = _tmp4_;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp7_);
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = blue;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp9_ >= (-255)) {
#line 720 "image.c"
		gint _tmp10_;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp10_ = blue;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp8_ = _tmp10_ <= 255;
#line 726 "image.c"
	} else {
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp8_ = FALSE;
#line 730 "image.c"
	}
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp8_;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp11_);
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = alpha;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp13_ >= (-255)) {
#line 740 "image.c"
		gint _tmp14_;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp14_ = alpha;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = _tmp14_ <= 255;
#line 746 "image.c"
	} else {
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = FALSE;
#line 750 "image.c"
	}
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = _tmp12_;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp15_);
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = pixbuf;
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp17_ = gdk_pixbuf_get_width (_tmp16_);
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	width = _tmp17_;
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = pixbuf;
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 97 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	height = _tmp19_;
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = pixbuf;
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = gdk_pixbuf_get_rowstride (_tmp20_);
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rowstride = _tmp21_;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp22_ = pixbuf;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp23_ = gdk_pixbuf_get_n_channels (_tmp22_);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	channels = _tmp23_;
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp24_ = pixbuf;
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp25_ = gdk_pixbuf_get_pixels (_tmp24_);
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	pixels = _tmp25_;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp26_ = channels;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp26_ >= 3);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp27_ = pixbuf;
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp28_ = gdk_pixbuf_get_colorspace (_tmp27_);
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp28_ == GDK_COLORSPACE_RGB);
#line 104 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp29_ = pixbuf;
#line 104 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp30_ = gdk_pixbuf_get_bits_per_sample (_tmp29_);
#line 104 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp30_ == 8);
#line 802 "image.c"
	{
		gint y;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		y = 0;
#line 807 "image.c"
		{
			gboolean _tmp31_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
			_tmp31_ = TRUE;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
			while (TRUE) {
#line 814 "image.c"
				gboolean _tmp32_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint y_offset;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp32_ = _tmp31_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				if (!_tmp32_) {
#line 825 "image.c"
					gint _tmp33_;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp33_ = y;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					y = _tmp33_ + 1;
#line 831 "image.c"
				}
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp31_ = FALSE;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp34_ = y;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp35_ = height;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					break;
#line 843 "image.c"
				}
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp36_ = y;
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp37_ = rowstride;
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				y_offset = _tmp36_ * _tmp37_;
#line 851 "image.c"
				{
					gint x;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					x = 0;
#line 856 "image.c"
					{
						gboolean _tmp38_;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
						_tmp38_ = TRUE;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
						while (TRUE) {
#line 863 "image.c"
							gboolean _tmp39_;
							gint _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _tmp44_;
							gint _tmp45_;
							gint offset;
							gint _tmp46_;
							gint _tmp55_;
							gint _tmp64_;
							gboolean _tmp73_ = FALSE;
							gint _tmp74_;
							gboolean _tmp76_;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp39_ = _tmp38_;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (!_tmp39_) {
#line 881 "image.c"
								gint _tmp40_;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp40_ = x;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								x = _tmp40_ + 1;
#line 887 "image.c"
							}
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp38_ = FALSE;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp41_ = x;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp42_ = width;
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (!(_tmp41_ < _tmp42_)) {
#line 109 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								break;
#line 899 "image.c"
							}
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp43_ = y_offset;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp44_ = x;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp45_ = channels;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							offset = _tmp43_ + (_tmp44_ * _tmp45_);
#line 112 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp46_ = red;
#line 112 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (_tmp46_ != 0) {
#line 913 "image.c"
								guchar* _tmp47_;
								gint _tmp48_;
								guchar* _tmp49_;
								gint _tmp50_;
								guchar _tmp51_;
								gint _tmp52_;
								guchar _tmp53_ = '\0';
								guchar _tmp54_;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp47_ = pixels;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp48_ = offset;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp49_ = pixels;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp50_ = offset;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp51_ = _tmp49_[_tmp50_];
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp52_ = red;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp53_ = shift_color_byte ((gint) _tmp51_, _tmp52_);
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp47_[_tmp48_] = _tmp53_;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp54_ = _tmp47_[_tmp48_];
#line 940 "image.c"
							}
#line 115 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp55_ = green;
#line 115 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (_tmp55_ != 0) {
#line 946 "image.c"
								guchar* _tmp56_;
								gint _tmp57_;
								guchar* _tmp58_;
								gint _tmp59_;
								guchar _tmp60_;
								gint _tmp61_;
								guchar _tmp62_ = '\0';
								guchar _tmp63_;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp56_ = pixels;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp57_ = offset;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp58_ = pixels;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp59_ = offset;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp60_ = _tmp58_[_tmp59_ + 1];
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp61_ = green;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp62_ = shift_color_byte ((gint) _tmp60_, _tmp61_);
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp56_[_tmp57_ + 1] = _tmp62_;
#line 116 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp63_ = _tmp56_[_tmp57_ + 1];
#line 973 "image.c"
							}
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp64_ = blue;
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (_tmp64_ != 0) {
#line 979 "image.c"
								guchar* _tmp65_;
								gint _tmp66_;
								guchar* _tmp67_;
								gint _tmp68_;
								guchar _tmp69_;
								gint _tmp70_;
								guchar _tmp71_ = '\0';
								guchar _tmp72_;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp65_ = pixels;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp66_ = offset;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp67_ = pixels;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp68_ = offset;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp69_ = _tmp67_[_tmp68_ + 2];
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp70_ = blue;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp71_ = shift_color_byte ((gint) _tmp69_, _tmp70_);
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp65_[_tmp66_ + 2] = _tmp71_;
#line 119 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp72_ = _tmp65_[_tmp66_ + 2];
#line 1006 "image.c"
							}
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp74_ = alpha;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (_tmp74_ != 0) {
#line 1012 "image.c"
								gint _tmp75_;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp75_ = channels;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp73_ = _tmp75_ >= 4;
#line 1018 "image.c"
							} else {
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp73_ = FALSE;
#line 1022 "image.c"
							}
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							_tmp76_ = _tmp73_;
#line 121 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
							if (_tmp76_) {
#line 1028 "image.c"
								guchar* _tmp77_;
								gint _tmp78_;
								guchar* _tmp79_;
								gint _tmp80_;
								guchar _tmp81_;
								gint _tmp82_;
								guchar _tmp83_ = '\0';
								guchar _tmp84_;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp77_ = pixels;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp78_ = offset;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp79_ = pixels;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp80_ = offset;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp81_ = _tmp79_[_tmp80_ + 3];
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp82_ = alpha;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp83_ = shift_color_byte ((gint) _tmp81_, _tmp82_);
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp77_[_tmp78_ + 3] = _tmp83_;
#line 122 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
								_tmp84_ = _tmp77_[_tmp78_ + 3];
#line 1055 "image.c"
							}
						}
					}
				}
			}
		}
	}
}


void dim_pixbuf (GdkPixbuf* pixbuf) {
	PixelTransformer* _tmp0_;
	PixelTransformer* transformer;
	SaturationTransformation* _tmp1_;
	SaturationTransformation* sat;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = pixel_transformer_new ();
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	transformer = _tmp0_;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = saturation_transformation_new (SATURATION_TRANSFORMATION_MIN_PARAMETER);
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	sat = _tmp1_;
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	pixel_transformer_attach_transformation (transformer, PIXEL_TRANSFORMATION (sat));
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = pixbuf;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	pixel_transformer_transform_pixbuf (transformer, _tmp2_, NULL);
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = pixbuf;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	shift_colors (_tmp3_, 0, 0, 0, -100);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_pixel_transformation_unref0 (sat);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_pixel_transformer_unref0 (transformer);
#line 1097 "image.c"
}


gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	gboolean _tmp11_;
	gboolean _tmp15_;
	gboolean _tmp21_;
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (rect != NULL, FALSE);
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = x;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = _tmp4_.x;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp3_ >= _tmp5_) {
#line 1122 "image.c"
		gint _tmp6_;
		GdkRectangle _tmp7_;
		gint _tmp8_;
		GdkRectangle _tmp9_;
		gint _tmp10_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp6_ = x;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp7_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp8_ = _tmp7_.x;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp9_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp10_ = _tmp9_.width;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = _tmp6_ < (_tmp8_ + _tmp10_);
#line 1140 "image.c"
	} else {
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = FALSE;
#line 1144 "image.c"
	}
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp11_) {
#line 1150 "image.c"
		gint _tmp12_;
		GdkRectangle _tmp13_;
		gint _tmp14_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = y;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp13_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp14_ = _tmp13_.y;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = _tmp12_ >= _tmp14_;
#line 1162 "image.c"
	} else {
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = FALSE;
#line 1166 "image.c"
	}
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = _tmp1_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp15_) {
#line 1172 "image.c"
		gint _tmp16_;
		GdkRectangle _tmp17_;
		gint _tmp18_;
		GdkRectangle _tmp19_;
		gint _tmp20_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp16_ = y;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp17_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp18_ = _tmp17_.y;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp19_ = *rect;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp20_ = _tmp19_.height;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = _tmp16_ <= (_tmp18_ + _tmp20_);
#line 1190 "image.c"
	} else {
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = FALSE;
#line 1194 "image.c"
	}
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = _tmp0_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp21_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 1202 "image.c"
}


gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	gboolean _tmp11_;
	gboolean _tmp16_;
	gboolean _tmp21_;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = *a;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *b;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.x;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp4_ == _tmp6_) {
#line 1232 "image.c"
		GdkRectangle _tmp7_;
		gint _tmp8_;
		GdkRectangle _tmp9_;
		gint _tmp10_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp7_ = *a;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp8_ = _tmp7_.y;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp9_ = *b;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp10_ = _tmp9_.y;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = _tmp8_ == _tmp10_;
#line 1247 "image.c"
	} else {
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = FALSE;
#line 1251 "image.c"
	}
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp11_) {
#line 1257 "image.c"
		GdkRectangle _tmp12_;
		gint _tmp13_;
		GdkRectangle _tmp14_;
		gint _tmp15_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp12_ = *a;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp13_ = _tmp12_.width;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp14_ = *b;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp15_ = _tmp14_.width;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = _tmp13_ == _tmp15_;
#line 1272 "image.c"
	} else {
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = FALSE;
#line 1276 "image.c"
	}
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = _tmp1_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp16_) {
#line 1282 "image.c"
		GdkRectangle _tmp17_;
		gint _tmp18_;
		GdkRectangle _tmp19_;
		gint _tmp20_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp17_ = *a;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp18_ = _tmp17_.height;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp19_ = *b;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp20_ = _tmp19_.height;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = _tmp18_ == _tmp20_;
#line 1297 "image.c"
	} else {
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp0_ = FALSE;
#line 1301 "image.c"
	}
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = _tmp0_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp21_;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 1309 "image.c"
}


gchar* rectangle_to_string (GdkRectangle* rect) {
	gchar* result = NULL;
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_ = NULL;
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (rect != NULL, NULL);
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = *rect;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = _tmp0_.x;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *rect;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp2_.y;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = *rect;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = _tmp4_.width;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = *rect;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = _tmp6_.height;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = g_strdup_printf ("%d,%d %dx%d", _tmp1_, _tmp3_, _tmp5_, _tmp7_);
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = _tmp8_;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 1348 "image.c"
}


void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result) {
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_;
	gint _tmp8_;
	gint _tmp9_ = 0;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp14_ = 0;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	Dimensions _tmp17_;
	gint _tmp18_;
	gint _tmp19_ = 0;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (original != NULL);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (max != NULL);
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = *original;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = _tmp0_.x;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *max;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp2_.width;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = CLAMP (_tmp1_, 0, _tmp3_);
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rect.x = _tmp4_;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *original;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = *max;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = _tmp7_.height;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rect.y = _tmp9_;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp10_ = *original;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = _tmp10_.width;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = *max;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = _tmp12_.width;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = CLAMP (_tmp11_, 0, _tmp13_);
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rect.width = _tmp14_;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = *original;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = _tmp15_.height;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp17_ = *max;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = _tmp17_.height;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = CLAMP (_tmp16_, 0, _tmp18_);
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rect.height = _tmp19_;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = rect;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 1432 "image.c"
}


void scale_point (GdkPoint* p, gdouble factor, GdkPoint* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
	gdouble _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
#line 157 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (p != NULL);
#line 158 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_.x = 0;
#line 158 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_ = _tmp0_;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = factor;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *p;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp2_.x;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.x = (gint) ((_tmp1_ * _tmp3_) + 0.5);
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = factor;
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *p;
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.y = (gint) ((_tmp4_ * _tmp6_) + 0.5);
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _result_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 1471 "image.c"
}


void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
	GdkPoint _tmp1_;
	gint _tmp2_;
	GdkPoint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_.x = 0;
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_ = _tmp0_;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = *p1;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = _tmp1_.x;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = *p2;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.x = _tmp2_ + _tmp4_;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *p1;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = *p2;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = _tmp7_.y;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.y = _tmp6_ + _tmp8_;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _result_;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 1518 "image.c"
}


void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
	GdkPoint _tmp1_;
	gint _tmp2_;
	GdkPoint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 174 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_.x = 0;
#line 174 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_ = _tmp0_;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = *p1;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = _tmp1_.x;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = *p2;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.x = _tmp2_ - _tmp4_;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = *p1;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = *p2;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = _tmp7_.y;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_result_.y = _tmp6_ - _tmp8_;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _result_;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 1565 "image.c"
}


void fix_cairo_pixbuf (GdkPixbuf* pixbuf) {
	GdkPixbuf* _tmp0_;
	void* _tmp1_;
	void* _tmp2_;
	guchar* gdk_pixels;
#line 182 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = _tmp1_;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	gdk_pixels = _tmp2_;
#line 1584 "image.c"
	{
		gint j;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		j = 0;
#line 1589 "image.c"
		{
			gboolean _tmp3_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
			_tmp3_ = TRUE;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
			while (TRUE) {
#line 1596 "image.c"
				gboolean _tmp4_;
				gint _tmp6_;
				GdkPixbuf* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				guchar* _tmp10_;
				guchar* p;
				guchar* _tmp11_;
				GdkPixbuf* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				guchar* end;
				guchar* _tmp27_;
				GdkPixbuf* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp4_ = _tmp3_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				if (!_tmp4_) {
#line 1617 "image.c"
					gint _tmp5_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp5_ = j;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					j = _tmp5_ + 1;
#line 1623 "image.c"
				}
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp3_ = FALSE;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp6_ = j;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp7_ = pixbuf;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp8_ = gdk_pixbuf_get_height (_tmp7_);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp9_ = _tmp8_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				if (!(_tmp6_ < _tmp9_)) {
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					break;
#line 1639 "image.c"
				}
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp10_ = gdk_pixels;
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				p = _tmp10_;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp11_ = p;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp12_ = pixbuf;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp14_ = _tmp13_;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				end = _tmp11_ + (4 * _tmp14_);
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				while (TRUE) {
#line 1657 "image.c"
					guchar* _tmp15_;
					guchar* _tmp16_;
					guchar* _tmp17_;
					guchar _tmp18_;
					guchar tmp;
					guchar* _tmp19_;
					guchar* _tmp20_;
					guchar _tmp21_;
					guchar _tmp22_;
					guchar* _tmp23_;
					guchar _tmp24_;
					guchar _tmp25_;
					guchar* _tmp26_;
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp15_ = p;
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp16_ = end;
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					if (!(_tmp15_ < _tmp16_)) {
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
						break;
#line 1679 "image.c"
					}
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp17_ = p;
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp18_ = _tmp17_[0];
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					tmp = _tmp18_;
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp19_ = p;
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp20_ = p;
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp21_ = _tmp20_[2];
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp19_[0] = _tmp21_;
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp22_ = _tmp19_[0];
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp23_ = p;
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp24_ = tmp;
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp23_[2] = _tmp24_;
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp25_ = _tmp23_[2];
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					_tmp26_ = p;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
					p = _tmp26_ + 4;
#line 1709 "image.c"
				}
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp27_ = gdk_pixels;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp28_ = pixbuf;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp29_ = gdk_pixbuf_get_rowstride (_tmp28_);
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				_tmp30_ = _tmp29_;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
				gdk_pixels = _tmp27_ + _tmp30_;
#line 1721 "image.c"
			}
		}
	}
}


/**
 * Finds the size of the smallest axially-aligned rectangle that could contain
 * a rectangle src_width by src_height, rotated by angle.
 *
 * @param src_width The width of the incoming rectangle.
 * @param src_height The height of the incoming rectangle.
 * @param angle The amount to rotate by, given in degrees.
 * @param dest_width The width of the computed rectangle.
 * @param dest_height The height of the computed rectangle.
 */
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height) {
	gdouble _vala_dest_width = 0.0;
	gdouble _vala_dest_height = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_ = 0.0;
#line 219 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = angle;
#line 219 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = degrees_to_radians (_tmp0_);
#line 219 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = fabs (_tmp1_);
#line 219 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	angle = _tmp2_;
#line 220 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = angle;
#line 220 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_assert (_tmp3_ <= G_PI_2);
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = src_width;
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = angle;
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = cos (_tmp5_);
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = src_height;
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = angle;
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = sin (_tmp8_);
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_vala_dest_width = (_tmp4_ * _tmp6_) + (_tmp7_ * _tmp9_);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp10_ = src_height;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = angle;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = cos (_tmp11_);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = src_width;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = angle;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = sin (_tmp14_);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_vala_dest_height = (_tmp10_ * _tmp12_) + (_tmp13_ * _tmp15_);
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (dest_width) {
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		*dest_width = _vala_dest_width;
#line 1801 "image.c"
	}
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (dest_height) {
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		*dest_height = _vala_dest_height;
#line 1807 "image.c"
	}
}


/**
 * @brief Rotates a pixbuf to an arbitrary angle, given in degrees, and returns the rotated pixbuf.
 *
 * @param source_pixbuf The source image that needs to be angled.
 * @param angle The angle the source image should be rotated by.
 */
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle) {
	GdkPixbuf* result = NULL;
	gdouble _tmp0_;
	gdouble x_tmp = 0.0;
	gdouble y_tmp = 0.0;
	GdkPixbuf* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_;
	gdouble _tmp15_ = 0.0;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* dest_pixbuf;
	cairo_format_t _tmp17_ = 0;
	GdkPixbuf* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GdkPixbuf* _tmp21_;
	void* _tmp22_;
	void* _tmp23_;
	cairo_format_t _tmp24_;
	GdkPixbuf* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GdkPixbuf* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	GdkPixbuf* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	cairo_surface_t* _tmp34_;
	cairo_surface_t* surface;
	cairo_surface_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* context;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	GdkPixbuf* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	GdkPixbuf* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	cairo_t* _tmp45_;
	cairo_t* _tmp46_;
	GdkPixbuf* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	GdkPixbuf* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	cairo_t* _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_ = 0.0;
	cairo_t* _tmp56_;
	GdkPixbuf* _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	GdkPixbuf* _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	cairo_t* _tmp63_;
	GdkPixbuf* _tmp64_;
	cairo_t* _tmp65_;
	cairo_pattern_t* _tmp66_ = NULL;
	cairo_t* _tmp67_;
	GdkPixbuf* _tmp68_;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (source_pixbuf), NULL);
#line 235 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = angle;
#line 235 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp0_ == 0.0) {
#line 1898 "image.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = source_pixbuf;
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		result = _tmp2_;
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		return result;
#line 1909 "image.c"
	}
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = source_pixbuf;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = gdk_pixbuf_get_width (_tmp3_);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = _tmp4_;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = source_pixbuf;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = gdk_pixbuf_get_height (_tmp6_);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = _tmp7_;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = angle;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	compute_arb_rotated_size ((gdouble) _tmp5_, (gdouble) _tmp8_, _tmp9_, &_tmp10_, &_tmp11_);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	x_tmp = _tmp10_;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	y_tmp = _tmp11_;
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = x_tmp;
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = round (_tmp12_);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = y_tmp;
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = round (_tmp14_);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, (gint) _tmp13_, (gint) _tmp15_);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dest_pixbuf = _tmp16_;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = source_pixbuf;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = gdk_pixbuf_get_has_alpha (_tmp18_);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = _tmp19_;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp20_) {
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp17_ = CAIRO_FORMAT_ARGB32;
#line 1953 "image.c"
	} else {
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp17_ = CAIRO_FORMAT_RGB24;
#line 1957 "image.c"
	}
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = dest_pixbuf;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp22_ = gdk_pixbuf_get_pixels (_tmp21_);
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp23_ = _tmp22_;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp24_ = _tmp17_;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp25_ = dest_pixbuf;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp26_ = gdk_pixbuf_get_width (_tmp25_);
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp27_ = _tmp26_;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp28_ = dest_pixbuf;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp29_ = gdk_pixbuf_get_height (_tmp28_);
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp30_ = _tmp29_;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp31_ = dest_pixbuf;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp32_ = gdk_pixbuf_get_rowstride (_tmp31_);
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp33_ = _tmp32_;
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp34_ = cairo_image_surface_create_for_data ((guchar*) _tmp23_, _tmp24_, _tmp27_, _tmp30_, _tmp33_);
#line 249 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	surface = _tmp34_;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp35_ = surface;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp36_ = cairo_create (_tmp35_);
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	context = _tmp36_;
#line 256 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp37_ = context;
#line 256 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_set_source_rgb (_tmp37_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp38_ = context;
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp39_ = dest_pixbuf;
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp40_ = gdk_pixbuf_get_width (_tmp39_);
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp41_ = _tmp40_;
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp42_ = dest_pixbuf;
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp43_ = gdk_pixbuf_get_height (_tmp42_);
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp44_ = _tmp43_;
#line 257 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_rectangle (_tmp38_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp41_, (gdouble) _tmp44_);
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp45_ = context;
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_fill (_tmp45_);
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp46_ = context;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp47_ = dest_pixbuf;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp48_ = gdk_pixbuf_get_width (_tmp47_);
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp49_ = _tmp48_;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp50_ = dest_pixbuf;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp51_ = gdk_pixbuf_get_height (_tmp50_);
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp52_ = _tmp51_;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_translate (_tmp46_, (gdouble) (_tmp49_ / 2), (gdouble) (_tmp52_ / 2));
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp53_ = context;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp54_ = angle;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp55_ = degrees_to_radians (_tmp54_);
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_rotate (_tmp53_, _tmp55_);
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp56_ = context;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp57_ = source_pixbuf;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp58_ = gdk_pixbuf_get_width (_tmp57_);
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp59_ = _tmp58_;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp60_ = source_pixbuf;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp61_ = gdk_pixbuf_get_height (_tmp60_);
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp62_ = _tmp61_;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_translate (_tmp56_, (gdouble) ((-_tmp59_) / 2), (gdouble) ((-_tmp62_) / 2));
#line 264 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp63_ = context;
#line 264 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp64_ = source_pixbuf;
#line 264 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	gdk_cairo_set_source_pixbuf (_tmp63_, _tmp64_, (gdouble) 0, (gdouble) 0);
#line 265 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp65_ = context;
#line 265 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp66_ = cairo_get_source (_tmp65_);
#line 265 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_pattern_set_filter (_tmp66_, CAIRO_FILTER_BEST);
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp67_ = context;
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_paint (_tmp67_);
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp68_ = dest_pixbuf;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	fix_cairo_pixbuf (_tmp68_);
#line 272 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	result = dest_pixbuf;
#line 272 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_cairo_destroy0 (context);
#line 272 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_cairo_surface_destroy0 (surface);
#line 272 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return result;
#line 2087 "image.c"
}


/**
 * @brief Rotates a point around the upper left corner of an image to an arbitrary angle,
 * given in degrees, and returns the rotated point, translated such that it, along with its attendant
 * image, are in positive x, positive y.
 *
 * @note May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be rotated and scaled.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void rotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, gboolean invert, GdkPoint* result) {
	gdouble _tmp0_;
	gdouble dest_width = 0.0;
	gdouble dest_height = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	cairo_matrix_t matrix = {0};
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GdkPoint _tmp15_;
	gint _tmp16_;
	gdouble dest_x;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gdouble dest_y;
	gdouble _tmp19_;
	gdouble _tmp20_;
	GdkPoint _tmp21_ = {0};
#line 288 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 291 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = angle;
#line 291 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp0_ == 0.0) {
#line 2136 "image.c"
		GdkPoint _tmp1_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp1_ = *source_point;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		*result = _tmp1_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		return;
#line 2144 "image.c"
	}
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = img_w;
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = img_h;
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_ = angle;
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	compute_arb_rotated_size ((gdouble) _tmp2_, (gdouble) _tmp3_, _tmp4_, &_tmp5_, &_tmp6_);
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dest_width = _tmp5_;
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dest_height = _tmp6_;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_matrix_init_identity (&matrix);
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = dest_width;
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp8_ = dest_height;
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_matrix_translate (&matrix, _tmp7_ / 2, _tmp8_ / 2);
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = angle;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp10_ = degrees_to_radians (_tmp9_);
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_matrix_rotate (&matrix, _tmp10_);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = img_w;
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = img_h;
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_matrix_translate (&matrix, (gdouble) ((-_tmp11_) / 2), (gdouble) ((-_tmp12_) / 2));
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_ = invert;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp13_) {
#line 2182 "image.c"
		cairo_status_t _tmp14_ = 0;
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp14_ = cairo_matrix_invert (&matrix);
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		g_assert (_tmp14_ == CAIRO_STATUS_SUCCESS);
#line 2188 "image.c"
	}
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = *source_point;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = _tmp15_.x;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dest_x = (gdouble) _tmp16_;
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp17_ = *source_point;
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = _tmp17_.y;
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	dest_y = (gdouble) _tmp18_;
#line 309 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	cairo_matrix_transform_point (&matrix, &dest_x, &dest_y);
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = dest_x;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = dest_y;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_.x = (gint) _tmp19_;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_.y = (gint) _tmp20_;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _tmp21_;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 2216 "image.c"
}


/**
 * @brief <u>De</u>rotates a point around the upper left corner of an image from an arbitrary angle,
 * given in degrees, and returns the de-rotated point, taking into account any translation necessary
 * to make sure all of the rotated image stays in positive x, positive y.
 *
 * @note May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be de-rotated.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void derotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, GdkPoint* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gdouble _tmp3_;
	GdkPoint _tmp4_ = {0};
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = *source_point;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = img_w;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = img_h;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = angle;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	rotate_point_arb (&_tmp0_, _tmp1_, _tmp2_, _tmp3_, TRUE, &_tmp4_);
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _tmp4_;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 2255 "image.c"
}


void clamp_inside_rotated_image (Box* src, gint img_w, gint img_h, gdouble angle_deg, gboolean preserve_geom, Box* result) {
	Box _tmp0_;
	gint _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_ = {0};
	gint _tmp5_;
	gint _tmp6_;
	gdouble _tmp7_;
	GdkPoint _tmp8_ = {0};
	GdkPoint top_left;
	Box _tmp9_;
	gint _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	GdkPoint _tmp13_ = {0};
	gint _tmp14_;
	gint _tmp15_;
	gdouble _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint top_right;
	Box _tmp18_;
	gint _tmp19_;
	Box _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp22_ = {0};
	gint _tmp23_;
	gint _tmp24_;
	gdouble _tmp25_;
	GdkPoint _tmp26_ = {0};
	GdkPoint bottom_left;
	Box _tmp27_;
	gint _tmp28_;
	Box _tmp29_;
	gint _tmp30_;
	GdkPoint _tmp31_ = {0};
	gint _tmp32_;
	gint _tmp33_;
	gdouble _tmp34_;
	GdkPoint _tmp35_ = {0};
	GdkPoint bottom_right;
	gdouble _tmp36_;
	gdouble _tmp37_ = 0.0;
	gdouble angle;
	gint top_offset;
	gint bottom_offset;
	gint left_offset;
	gint right_offset;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	gint _tmp42_ = 0;
	gint top;
	gint _tmp43_;
	GdkPoint _tmp47_;
	gint _tmp48_;
	GdkPoint _tmp49_;
	gint _tmp50_;
	gint _tmp51_ = 0;
	gint bottom;
	gint _tmp52_;
	gint _tmp53_;
	GdkPoint _tmp58_;
	gint _tmp59_;
	GdkPoint _tmp60_;
	gint _tmp61_;
	gint _tmp62_ = 0;
	gint left;
	gint _tmp63_;
	GdkPoint _tmp67_;
	gint _tmp68_;
	GdkPoint _tmp69_;
	gint _tmp70_;
	gint _tmp71_ = 0;
	gint right;
	gint _tmp72_;
	gint _tmp73_;
	Box _tmp78_ = {0};
	gboolean _tmp79_;
#line 333 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	g_return_if_fail (src != NULL);
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp0_ = *src;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp1_ = _tmp0_.left;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp2_ = *src;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp3_ = _tmp2_.top;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_.x = _tmp1_;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp4_.y = _tmp3_;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp5_ = img_w;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp6_ = img_h;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp7_ = angle_deg;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	derotate_point_arb (&_tmp4_, _tmp5_, _tmp6_, _tmp7_, &_tmp8_);
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	top_left = _tmp8_;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp9_ = *src;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp10_ = _tmp9_.right;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp11_ = *src;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp12_ = _tmp11_.top;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_.x = _tmp10_;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp13_.y = _tmp12_;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp14_ = img_w;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp15_ = img_h;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp16_ = angle_deg;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	derotate_point_arb (&_tmp13_, _tmp14_, _tmp15_, _tmp16_, &_tmp17_);
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	top_right = _tmp17_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp18_ = *src;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp19_ = _tmp18_.left;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp20_ = *src;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp21_ = _tmp20_.bottom;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp22_.x = _tmp19_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp22_.y = _tmp21_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp23_ = img_w;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp24_ = img_h;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp25_ = angle_deg;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	derotate_point_arb (&_tmp22_, _tmp23_, _tmp24_, _tmp25_, &_tmp26_);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	bottom_left = _tmp26_;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp27_ = *src;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp28_ = _tmp27_.right;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp29_ = *src;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp30_ = _tmp29_.bottom;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp31_.x = _tmp28_;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp31_.y = _tmp30_;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp32_ = img_w;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp33_ = img_h;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp34_ = angle_deg;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	derotate_point_arb (&_tmp31_, _tmp32_, _tmp33_, _tmp34_, &_tmp35_);
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	bottom_right = _tmp35_;
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp36_ = angle_deg;
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp37_ = degrees_to_radians (_tmp36_);
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	angle = _tmp37_;
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	top_offset = 0;
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	bottom_offset = 0;
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	left_offset = 0;
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	right_offset = 0;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp38_ = top_left;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp39_ = _tmp38_.y;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp40_ = top_right;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp41_ = _tmp40_.y;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp42_ = MIN (_tmp39_, _tmp41_);
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	top = _tmp42_;
#line 345 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp43_ = top;
#line 345 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp43_ < 0) {
#line 2459 "image.c"
		gint _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_ = 0.0;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp44_ = top;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp45_ = angle;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp46_ = cos (_tmp45_);
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		top_offset = (gint) ((0 - _tmp44_) * _tmp46_);
#line 2471 "image.c"
	}
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp47_ = bottom_left;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp48_ = _tmp47_.y;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp49_ = bottom_right;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp50_ = _tmp49_.y;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp51_ = MAX (_tmp48_, _tmp50_);
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	bottom = _tmp51_;
#line 349 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp52_ = bottom;
#line 349 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp53_ = img_h;
#line 349 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp52_ > _tmp53_) {
#line 2491 "image.c"
		gint _tmp54_;
		gint _tmp55_;
		gdouble _tmp56_;
		gdouble _tmp57_ = 0.0;
#line 350 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp54_ = img_h;
#line 350 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp55_ = bottom;
#line 350 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp56_ = angle;
#line 350 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp57_ = cos (_tmp56_);
#line 350 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		bottom_offset = (gint) ((_tmp54_ - _tmp55_) * _tmp57_);
#line 2506 "image.c"
	}
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp58_ = top_left;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp59_ = _tmp58_.x;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp60_ = bottom_left;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp61_ = _tmp60_.x;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp62_ = MIN (_tmp59_, _tmp61_);
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	left = _tmp62_;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp63_ = left;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp63_ < 0) {
#line 2524 "image.c"
		gint _tmp64_;
		gdouble _tmp65_;
		gdouble _tmp66_ = 0.0;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp64_ = left;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp65_ = angle;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp66_ = cos (_tmp65_);
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		left_offset = (gint) ((0 - _tmp64_) * _tmp66_);
#line 2536 "image.c"
	}
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp67_ = top_right;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp68_ = _tmp67_.x;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp69_ = bottom_right;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp70_ = _tmp69_.x;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp71_ = MAX (_tmp68_, _tmp70_);
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	right = _tmp71_;
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp72_ = right;
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp73_ = img_w;
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp72_ > _tmp73_) {
#line 2556 "image.c"
		gint _tmp74_;
		gint _tmp75_;
		gdouble _tmp76_;
		gdouble _tmp77_ = 0.0;
#line 358 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp74_ = img_w;
#line 358 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp75_ = right;
#line 358 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp76_ = angle;
#line 358 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp77_ = cos (_tmp76_);
#line 358 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		right_offset = (gint) ((_tmp74_ - _tmp75_) * _tmp77_);
#line 2571 "image.c"
	}
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	_tmp79_ = preserve_geom;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	if (_tmp79_) {
#line 2577 "image.c"
		gint _tmp80_;
		gint _tmp81_;
		gint _tmp82_;
		gint _tmp83_;
		Box _tmp84_ = {0};
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp80_ = left_offset;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp81_ = right_offset;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp82_ = top_offset;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp83_ = bottom_offset;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		box_get_offset (src, _tmp80_ + _tmp81_, _tmp82_ + _tmp83_, &_tmp84_);
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp78_ = _tmp84_;
#line 2595 "image.c"
	} else {
		Box _tmp85_;
		gint _tmp86_;
		gint _tmp87_;
		Box _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		Box _tmp91_;
		gint _tmp92_;
		gint _tmp93_;
		Box _tmp94_;
		gint _tmp95_;
		gint _tmp96_;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp85_ = *src;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp86_ = _tmp85_.left;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp87_ = left_offset;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp88_ = *src;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp89_ = _tmp88_.top;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp90_ = top_offset;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp91_ = *src;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp92_ = _tmp91_.right;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp93_ = right_offset;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp94_ = *src;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp95_ = _tmp94_.bottom;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		_tmp96_ = bottom_offset;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
		box_init (&_tmp78_, _tmp86_ + _tmp87_, _tmp89_ + _tmp90_, _tmp92_ + _tmp93_, _tmp95_ + _tmp96_);
#line 2635 "image.c"
	}
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	*result = _tmp78_;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/util/image.vala"
	return;
#line 2641 "image.c"
}



