/* DirectoryMonitor.c generated by valac 0.16.0, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2009-2012 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* _tmp0_;
	GeeArrayList* file_children;
	GeeArrayList* _tmp1_;
	GeeArrayList* dir_children;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GFile* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint count;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _dir_child_size;
	gint _dir_child_index;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gpointer _tmp18_;
	GFile* dir_child;
	DirectoryMonitorFileInfoMap* _tmp19_;
	GFile* _tmp20_;
	GFileInfo* _tmp21_;
	GFileInfo* dir_info;
	GFileInfo* _tmp22_;
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GFile* _tmp26_;
	GFileInfo* _tmp27_;
	GFile* _tmp28_;
	GFile* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GFile* _tmp32_;
	GFile* _tmp33_;
	GFileInfo* _tmp34_;
	GeeArrayList* _tmp35_;
	GeeArrayList* _tmp36_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _file_child_size;
	gint _file_child_index;
	gint _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GeeArrayList* _tmp43_;
	gint _tmp44_;
	gpointer _tmp45_;
	GFile* file_child;
	DirectoryMonitorFileInfoMap* _tmp46_;
	GFile* _tmp47_;
	GFileInfo* _tmp48_;
	GFileInfo* file_info;
	GFileInfo* _tmp49_;
	GFile* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GFile* _tmp53_;
	GFile* _tmp54_;
	GFile* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	GFileInfo* _tmp60_;
	DirectoryMonitorFileInfoMap* _tmp61_;
	GFile* _tmp62_;
	DirectoryMonitorFileInfoMap* _tmp63_;
	GFile* _tmp64_;
	GFileInfo* _tmp65_;
	gboolean _tmp66_;
	gboolean updated;
	GFile* _tmp67_;
	GFileInfo* _tmp68_;
	GFile* _tmp69_;
	GFileInfo* _tmp70_;
	GFile* _tmp71_;
	GFile* _tmp72_;
	GFileInfo* _tmp73_;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* _tmp0_;
	GeeArrayList* file_children;
	GeeArrayList* _tmp1_;
	GeeArrayList* dir_children;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GFile* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint count;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _dir_child_size;
	gint _dir_child_index;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gpointer _tmp18_;
	GFile* dir_child;
	GFile* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _file_child_size;
	gint _file_child_index;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GeeArrayList* _tmp28_;
	gint _tmp29_;
	gpointer _tmp30_;
	GFile* file_child;
	DirectoryMonitorFileInfoMap* _tmp31_;
	GFile* _tmp32_;
	GFile* _tmp33_;
	gboolean _tmp34_;
	DirectoryMonitorFileInfoMap* _tmp35_;
	GFile* _tmp36_;
	GFile* _tmp37_;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	GFileInfo* _tmp8_;
	GFileInfo* _tmp9_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp10_;
	GFile* _tmp11_;
	GCancellable* _tmp12_;
	GFileInfo* _tmp13_;
	GFileInfo* _tmp14_;
	GError* err;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _tmp18_;
	const gchar* _tmp19_;
	gboolean _tmp20_;
	GFileInfo* _tmp21_;
	gboolean _tmp22_;
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean _tmp26_;
	GFileInfo* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gboolean _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp34_;
	GFileInfo* _tmp35_;
	GFileType _tmp36_;
	const gchar* _tmp37_;
	GFile* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GFileInfo* _tmp41_;
	GFileType _tmp42_;
	GEnumValue* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gboolean _tmp46_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFile* _tmp47_;
	GCancellable* _tmp48_;
	GFileEnumerator* _tmp49_;
	GFileEnumerator* enumerator;
	gboolean _tmp50_;
	gboolean _tmp51_;
	GFileEnumerator* _tmp52_;
	GCancellable* _tmp53_;
	GList* _tmp54_;
	GList* infos;
	GList* _tmp55_;
	GList* _tmp56_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp57_;
	GFileInfo* info;
	GFileInfo* _tmp58_;
	gboolean _tmp59_;
	GFile* _tmp60_;
	GFileInfo* _tmp61_;
	const gchar* _tmp62_;
	GFile* _tmp63_;
	GFile* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	GFileInfo* _tmp67_;
	gboolean _tmp68_;
	GFileInfo* _tmp69_;
	GFileType _tmp70_;
	GeeHashMap* _tmp71_;
	GeeHashMap* _tmp72_;
	GeeHashMap* _tmp73_;
	GFile* _tmp74_;
	GFileInfo* _tmp75_;
	const gchar* _tmp76_;
	GFile* _tmp77_;
	GFile* _tmp78_;
	GFileInfo* _tmp79_;
	GeeHashMap* _tmp80_;
	GeeHashMap* _tmp81_;
	GeeHashMap* _tmp82_;
	GFile* _tmp83_;
	GFileInfo* _tmp84_;
	const gchar* _tmp85_;
	GFile* _tmp86_;
	GFile* _tmp87_;
	GFileInfo* _tmp88_;
	GError* err2;
	GFile* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	GError* _tmp92_;
	const gchar* _tmp93_;
	gboolean _tmp94_;
	gboolean _tmp95_;
	GFile* _tmp96_;
	GFileInfo* _tmp97_;
	GFile* _tmp98_;
	GFileInfo* _tmp99_;
	GFile* _tmp100_;
	GFileInfo* _tmp101_;
	GeeHashMap* _tmp102_;
	GeeHashMap* _tmp103_;
	gboolean _tmp104_;
	gboolean _tmp105_;
	gboolean _tmp106_;
	GeeHashMap* _tmp107_;
	gboolean _tmp108_;
	GeeHashMap* _tmp109_;
	GeeSet* _tmp110_;
	GeeSet* _tmp111_;
	GeeSet* _tmp112_;
	GeeIterator* _tmp113_;
	GeeIterator* _tmp114_;
	GeeIterator* _subdir_it;
	GeeIterator* _tmp115_;
	gboolean _tmp116_;
	GeeIterator* _tmp117_;
	gpointer _tmp118_;
	GFile* subdir;
	gint _tmp119_;
	gint _tmp120_;
	GFile* _tmp121_;
	GeeHashMap* _tmp122_;
	GFile* _tmp123_;
	gpointer _tmp124_;
	GFileInfo* _tmp125_;
	gboolean _tmp126_;
	GFile* _tmp127_;
	GeeHashMap* _tmp128_;
	GFile* _tmp129_;
	gpointer _tmp130_;
	GFileInfo* _tmp131_;
	gboolean _tmp132_;
	gboolean _tmp133_;
	GError * _inner_error_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeMapIterator* _tmp5_;
	gpointer _tmp6_;
	GFile* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	GFileInfo* _tmp10_;
	GeeMapIterator* _tmp11_;
	gpointer _tmp12_;
	GFile* _tmp13_;
	GeeMapIterator* _tmp14_;
	gpointer _tmp15_;
	GFileInfo* _tmp16_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};


static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define DIRECTORY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIRECTORY_MONITOR, DirectoryMonitorPrivate))
enum  {
	DIRECTORY_MONITOR_DUMMY_PROPERTY
};
static GType directory_monitor_ftype_get_type (void) G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
void directory_monitor_mdbg (const gchar* msg);
gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_);
gboolean file_equal (void* _a, void* _b);
static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
gboolean directory_monitor_has_started (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
const gchar* g_file_type_to_string (GFileType self);
static void directory_monitor_explore_async_data_free (gpointer _data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gchar* get_file_info_id (GFileInfo* info);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
guint file_hash (void* _file);
static guint _file_hash_ghash_func (gconstpointer key);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
gulong now_ms (void);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable);
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_closed (DirectoryMonitor* self);
enum  {
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj);
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
static void directory_monitor_finalize (GObject* obj);


static GType directory_monitor_ftype_get_type (void) {
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 799 "DirectoryMonitor.c"
}


DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = root;
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->root = _tmp1_;
#line 460 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = recurse;
#line 460 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->recurse = _tmp2_;
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = monitoring;
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->monitoring = _tmp3_;
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return self;
#line 831 "DirectoryMonitor.c"
}


DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 838 "DirectoryMonitor.c"
}


void directory_monitor_mdbg (const gchar* msg) {
#line 464 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 845 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_recursive (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->recurse;
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 860 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_monitoring (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 474 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 875 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = root;
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_equal (_tmp0_, _tmp1_);
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (_tmp2_);
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = root;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-deleted", _tmp3_);
#line 900 "DirectoryMonitor.c"
}


void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
#line 909 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean removed;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean updated;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFileInfo* _tmp11_;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = old_root;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	removed = _tmp2_;
#line 487 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (removed);
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->files;
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = new_root;
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = new_root_info;
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = directory_monitor_file_info_map_update (_tmp3_, _tmp4_, _tmp5_);
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp6_;
#line 490 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = new_root;
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->root = _tmp8_;
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = old_root;
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = new_root;
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = new_root_info;
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, _tmp9_, _tmp10_, _tmp11_);
#line 974 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GFile* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFileInfo* _tmp13_;
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = old_root;
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_equal (_tmp0_, _tmp1_);
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (_tmp2_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = old_root;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = new_root;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = g_file_get_path (_tmp6_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = _tmp7_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = g_strdup_printf ("root moved: %s -> %s", _tmp5_, _tmp8_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp9_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp10_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp10_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp8_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = old_root;
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = new_root;
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = new_root_info;
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-moved", _tmp11_, _tmp12_, _tmp13_);
#line 1039 "DirectoryMonitor.c"
}


void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
#line 1048 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self) {
#line 505 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-started");
#line 1057 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_started (DirectoryMonitor* self) {
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
#line 1066 "DirectoryMonitor.c"
}


static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 513 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 513 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 513 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, _tmp4_, _tmp5_);
#line 1100 "DirectoryMonitor.c"
}


void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
#line 1109 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file discovered: %s", _tmp2_);
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 518 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 518 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 518 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-discovered", _tmp5_, _tmp6_);
#line 1147 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
#line 1156 "DirectoryMonitor.c"
}


static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 523 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, _tmp4_, _tmp5_);
#line 1190 "DirectoryMonitor.c"
}


void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
#line 1199 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory discovered: %s", _tmp2_);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 530 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 530 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 530 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-discovered", _tmp5_, _tmp6_);
#line 1237 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
#line 1246 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 534 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = reason;
#line 534 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:534: discovery failed: %s", _tmp0_);
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = reason;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-failed", _tmp1_);
#line 1263 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
#line 1272 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self) {
#line 539 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-completed");
#line 1279 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_completed (DirectoryMonitor* self) {
#line 538 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 538 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
#line 1288 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_is_file_create_move (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old_file = _tmp2_;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old_file_info = _tmp3_;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp4_) {
#line 1322 "DirectoryMonitor.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = old_file;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = file;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = info;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, _tmp5_, _tmp6_, _tmp7_);
#line 1334 "DirectoryMonitor.c"
	} else {
		DirectoryMonitorFileInfoMap* _tmp8_;
		GFile* _tmp9_;
		GFileInfo* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean updated;
		gboolean _tmp12_;
		GFile* _tmp13_;
		GFileInfo* _tmp14_;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->files;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = file;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = info;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = directory_monitor_file_info_map_update (_tmp8_, _tmp9_, _tmp10_);
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		updated = _tmp11_;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = updated;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert (_tmp12_);
#line 551 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp13_ = file;
#line 551 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp14_ = info;
#line 551 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, _tmp13_, _tmp14_);
#line 1364 "DirectoryMonitor.c"
	}
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 1370 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file created: %s", _tmp2_);
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-created", _tmp5_, _tmp6_);
#line 1408 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
#line 1417 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean updated;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFileInfo* _tmp8_;
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = old_file;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 565 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = self->priv->files;
#line 565 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = new_file;
#line 565 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = new_file_info;
#line 565 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = directory_monitor_file_info_map_update (_tmp2_, _tmp3_, _tmp4_);
#line 565 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp5_;
#line 566 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 568 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = old_file;
#line 568 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = new_file;
#line 568 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = new_file_info;
#line 568 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, _tmp6_, _tmp7_, _tmp8_);
#line 1466 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFileInfo* _tmp10_;
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = old_file;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = new_file;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("file moved: %s -> %s", _tmp2_, _tmp5_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = old_file;
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = new_file;
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = new_file_info;
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-moved", _tmp8_, _tmp9_, _tmp10_);
#line 1520 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1529 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file altered: %s", _tmp2_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 578 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 578 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-altered", _tmp5_);
#line 1562 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
#line 1571 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 583 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 585 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 585 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 585 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, _tmp4_, _tmp5_);
#line 1607 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file alteration completed: %s", _tmp2_);
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 590 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 590 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 590 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-alteration-completed", _tmp5_, _tmp6_);
#line 1645 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
#line 1654 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file attributes altered: %s", _tmp2_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 595 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 595 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-attributes-altered", _tmp5_);
#line 1687 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file);
#line 1696 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean removed;
	GFile* _tmp3_;
#line 598 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 598 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	removed = _tmp2_;
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (removed);
#line 602 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = file;
#line 602 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, _tmp3_);
#line 1724 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file deleted: %s", _tmp2_);
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 606 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 607 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 607 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-deleted", _tmp5_);
#line 1757 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
#line 1766 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_is_file_create_move (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old_dir = _tmp2_;
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old_dir_info = _tmp3_;
#line 613 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp4_) {
#line 1800 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		DirectoryMonitorFileInfoMap* _tmp7_;
		GFile* _tmp8_;
		GFileInfo* _tmp9_;
		GFile* _tmp10_;
		GFileInfo* _tmp11_;
#line 619 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->files;
#line 619 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = old_dir;
#line 619 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->parent_moved;
#line 619 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (_tmp5_, _tmp6_, _tmp7_);
#line 621 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp8_ = old_dir;
#line 621 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = old_dir_info;
#line 621 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = dir;
#line 621 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = info;
#line 621 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 1826 "DirectoryMonitor.c"
	} else {
		DirectoryMonitorFileInfoMap* _tmp12_;
		GFile* _tmp13_;
		GFileInfo* _tmp14_;
		gboolean _tmp15_ = FALSE;
		gboolean updated;
		gboolean _tmp16_;
		GFile* _tmp17_;
		GFileInfo* _tmp18_;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = self->priv->files;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp13_ = dir;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp14_ = info;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = directory_monitor_file_info_map_update (_tmp12_, _tmp13_, _tmp14_);
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		updated = _tmp15_;
#line 624 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp16_ = updated;
#line 624 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert (_tmp16_);
#line 626 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp17_ = dir;
#line 626 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp18_ = info;
#line 626 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, _tmp17_, _tmp18_);
#line 1856 "DirectoryMonitor.c"
	}
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 1862 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 630 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 630 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory created: %s", _tmp2_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 632 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 632 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 632 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-created", _tmp5_, _tmp6_);
#line 1900 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 630 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 630 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
#line 1909 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info) {
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (old_dir_info));
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = old_dir;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = old_dir_info;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = new_dir;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = new_dir_info;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_, NULL, NULL);
#line 1938 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, _data_);
#line 1957 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_internal_notify_directory_moved);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = old_dir;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->old_dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = old_dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->old_dir_info = _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = new_dir;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->new_dir = _tmp6_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = new_dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->new_dir_info = _tmp8_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2008 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2016 "DirectoryMonitor.c"
}


static gboolean _file_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = file_equal (a, b);
#line 642 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 2025 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2039 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
#line 673 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 2048 "DirectoryMonitor.c"
}


static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_) {
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 0:
#line 2057 "DirectoryMonitor.c"
		goto _state_0;
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 1:
#line 2061 "DirectoryMonitor.c"
		goto _state_1;
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 2:
#line 2065 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2070 "DirectoryMonitor.c"
	}
	_state_0:
#line 642 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_equal_gequal_func);
#line 642 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_equal_gequal_func);
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->old_dir;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->file_children;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp5_ = _data_->dir_children;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = 0;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->_tmp3_, GEE_COLLECTION (_data_->_tmp4_), GEE_COLLECTION (_data_->_tmp5_));
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->count = _data_->_tmp6_;
#line 645 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp7_ = _data_->count;
#line 645 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp7_ > 0) {
#line 2099 "DirectoryMonitor.c"
		{
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->dir_children;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp9_;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->_dir_child_list;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp10_));
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp12_;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->_dir_child_index;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_tmp13_ + 1;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp14_ = _data_->_dir_child_index;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp15_ = _data_->_dir_child_size;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp14_ < _data_->_tmp15_)) {
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 2131 "DirectoryMonitor.c"
				}
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->_dir_child_list;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp17_ = _data_->_dir_child_index;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = NULL;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp16_), _data_->_tmp17_);
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp18_;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->self->priv->files;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->dir_child;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp21_ = NULL;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp21_ = directory_monitor_file_info_map_get_info (_data_->_tmp19_, _data_->_tmp20_);
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->dir_info = _data_->_tmp21_;
#line 651 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->dir_info;
#line 651 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_data_->_tmp22_ == NULL) {
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp23_ = _data_->dir_child;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp24_ = NULL;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp24_ = g_file_get_path (_data_->_tmp23_);
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp25_ = _data_->_tmp24_;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:652: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp25_);
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp25_);
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_info);
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_child);
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					continue;
#line 2175 "DirectoryMonitor.c"
				}
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp26_ = _data_->dir_child;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp27_ = _data_->dir_info;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp28_ = _data_->new_dir;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp29_ = _data_->dir_child;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = NULL;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = g_file_get_basename (_data_->_tmp29_);
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = NULL;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = g_file_get_child (_data_->_tmp28_, _data_->_tmp31_);
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->dir_info;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved (_data_->self, _data_->_tmp26_, _data_->_tmp27_, _data_->_tmp33_, _data_->_tmp34_, directory_monitor_async_internal_notify_directory_moved_ready, _data_);
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return FALSE;
#line 2205 "DirectoryMonitor.c"
				_state_1:
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (_data_->self, _data_->_res_);
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp33_);
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp31_);
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_info);
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2217 "DirectoryMonitor.c"
			}
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2221 "DirectoryMonitor.c"
		}
		{
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp35_ = _data_->file_children;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp36_ = _g_object_ref0 (_data_->_tmp35_);
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp36_;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp37_ = _data_->_file_child_list;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp38_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp37_));
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp39_ = _data_->_tmp38_;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp39_;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp40_ = _data_->_file_child_index;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_tmp40_ + 1;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp41_ = _data_->_file_child_index;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp42_ = _data_->_file_child_size;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp41_ < _data_->_tmp42_)) {
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 2254 "DirectoryMonitor.c"
				}
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp43_ = _data_->_file_child_list;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp44_ = _data_->_file_child_index;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp45_ = NULL;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp45_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp43_), _data_->_tmp44_);
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp45_;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp46_ = _data_->self->priv->files;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp47_ = _data_->file_child;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp48_ = NULL;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp48_ = directory_monitor_file_info_map_get_info (_data_->_tmp46_, _data_->_tmp47_);
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->file_info = _data_->_tmp48_;
#line 664 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp49_ = _data_->file_info;
#line 664 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_data_->_tmp49_ == NULL) {
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp50_ = _data_->file_child;
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp51_ = NULL;
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp51_ = g_file_get_path (_data_->_tmp50_);
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp52_ = _data_->_tmp51_;
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:665: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp52_);
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp52_);
#line 667 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_info);
#line 667 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_child);
#line 667 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					continue;
#line 2298 "DirectoryMonitor.c"
				}
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp53_ = _data_->file_child;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp54_ = _data_->new_dir;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp55_ = _data_->file_child;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp56_ = NULL;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp56_ = g_file_get_basename (_data_->_tmp55_);
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp57_ = _data_->_tmp56_;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp58_ = NULL;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp58_ = g_file_get_child (_data_->_tmp54_, _data_->_tmp57_);
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp59_ = _data_->_tmp58_;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp60_ = _data_->file_info;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (_data_->self, _data_->_tmp53_, _data_->_tmp59_, _data_->_tmp60_);
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp59_);
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp57_);
#line 673 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, _data_, NULL);
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return FALSE;
#line 2332 "DirectoryMonitor.c"
				_state_2:
				;
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_info);
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2339 "DirectoryMonitor.c"
			}
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2343 "DirectoryMonitor.c"
		}
	}
#line 680 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp61_ = _data_->self->priv->files;
#line 680 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp62_ = _data_->old_dir;
#line 680 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_data_->_tmp61_, _data_->_tmp62_, NULL);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp63_ = _data_->self->priv->files;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp64_ = _data_->new_dir;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp65_ = _data_->new_dir_info;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp66_ = FALSE;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp66_ = directory_monitor_file_info_map_update (_data_->_tmp63_, _data_->_tmp64_, _data_->_tmp65_);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->updated = _data_->_tmp66_;
#line 683 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (_data_->updated);
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp67_ = _data_->old_dir;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp68_ = _data_->old_dir_info;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (_data_->self, _data_->_tmp67_, _data_->_tmp68_);
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp69_ = _data_->new_dir;
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp70_ = _data_->new_dir_info;
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->_tmp69_, _data_->_tmp70_);
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp71_ = _data_->old_dir;
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp72_ = _data_->new_dir;
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp73_ = _data_->new_dir_info;
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (_data_->self, _data_->_tmp71_, _data_->_tmp72_, _data_->_tmp73_);
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2394 "DirectoryMonitor.c"
	} else {
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2398 "DirectoryMonitor.c"
	}
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return FALSE;
#line 2404 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFileInfo* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp13_ = FALSE;
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = old_dir;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = new_dir;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("directory moved: %s -> %s", _tmp2_, _tmp5_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 694 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = old_dir;
#line 694 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = new_dir;
#line 694 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = new_dir_info;
#line 694 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-moved", _tmp8_, _tmp9_, _tmp10_);
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = old_dir;
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->root;
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = g_file_equal (_tmp11_, _tmp12_);
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp13_) {
#line 2469 "DirectoryMonitor.c"
		GFile* _tmp14_;
		GFile* _tmp15_;
		GFileInfo* _tmp16_;
#line 697 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp14_ = old_dir;
#line 697 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = new_dir;
#line 697 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp16_ = new_dir_info;
#line 697 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, _tmp14_, _tmp15_, _tmp16_);
#line 2481 "DirectoryMonitor.c"
	}
}


void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 2491 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory altered: %s", _tmp2_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 701 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 702 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 702 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-altered", _tmp5_);
#line 2524 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
#line 2533 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 705 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 705 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 705 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 707 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 709 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 709 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 709 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, _tmp4_, _tmp5_);
#line 2569 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory alteration completed: %s", _tmp2_);
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 714 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 714 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 714 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-alteration-completed", _tmp5_, _tmp6_);
#line 2607 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
#line 2616 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory attributes altered: %s", _tmp2_);
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 718 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-attributes-altered", _tmp5_);
#line 2649 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir);
#line 2658 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_ = NULL;
	GFileInfo* info;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_get_info (_tmp0_, _tmp1_);
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	info = _tmp2_;
#line 724 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (info != NULL);
#line 727 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = dir;
#line 727 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, _tmp3_, info);
#line 729 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 729 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, _tmp4_, FALSE, NULL, NULL);
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 2693 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, _data_);
#line 2706 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_notify_directory_deleted);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = already_removed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->already_removed = _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2738 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2746 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2760 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 2769 "DirectoryMonitor.c"
}


static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_) {
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 0:
#line 2778 "DirectoryMonitor.c"
		goto _state_0;
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 1:
#line 2782 "DirectoryMonitor.c"
		goto _state_1;
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 2:
#line 2786 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2791 "DirectoryMonitor.c"
	}
	_state_0:
#line 740 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_equal_gequal_func);
#line 740 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 741 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_equal_gequal_func);
#line 741 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->dir;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->file_children;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp5_ = _data_->dir_children;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = 0;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->_tmp3_, GEE_COLLECTION (_data_->_tmp4_), GEE_COLLECTION (_data_->_tmp5_));
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->count = _data_->_tmp6_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp7_ = _data_->count;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp7_ > 0) {
#line 2820 "DirectoryMonitor.c"
		{
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->dir_children;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp9_;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->_dir_child_list;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp10_));
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp12_;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->_dir_child_index;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_tmp13_ + 1;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp14_ = _data_->_dir_child_index;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp15_ = _data_->_dir_child_size;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp14_ < _data_->_tmp15_)) {
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 2852 "DirectoryMonitor.c"
				}
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->_dir_child_list;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp17_ = _data_->_dir_child_index;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = NULL;
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp16_), _data_->_tmp17_);
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp18_;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->dir_child;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted (_data_->self, _data_->_tmp19_, FALSE, directory_monitor_async_notify_directory_deleted_ready, _data_);
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return FALSE;
#line 2872 "DirectoryMonitor.c"
				_state_1:
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (_data_->self, _data_->_res_);
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2878 "DirectoryMonitor.c"
			}
#line 751 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2882 "DirectoryMonitor.c"
		}
		{
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp20_ = _data_->file_children;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp21_ = _g_object_ref0 (_data_->_tmp20_);
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp21_;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp22_ = _data_->_file_child_list;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp23_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp22_));
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp24_ = _data_->_tmp23_;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp24_;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp25_ = _data_->_file_child_index;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_tmp25_ + 1;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp26_ = _data_->_file_child_index;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp27_ = _data_->_file_child_size;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp26_ < _data_->_tmp27_)) {
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 2915 "DirectoryMonitor.c"
				}
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp28_ = _data_->_file_child_list;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp29_ = _data_->_file_child_index;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = NULL;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp28_), _data_->_tmp29_);
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp30_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp31_ = _data_->self->priv->files;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->file_child;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (_data_->_tmp31_, _data_->_tmp32_, NULL);
#line 759 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->file_child;
#line 759 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (_data_->self, _data_->_tmp33_);
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, _data_, NULL);
#line 762 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 762 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return FALSE;
#line 2943 "DirectoryMonitor.c"
				_state_2:
				;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2948 "DirectoryMonitor.c"
			}
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2952 "DirectoryMonitor.c"
		}
	}
#line 766 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp34_ = _data_->already_removed;
#line 766 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_data_->_tmp34_) {
#line 767 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp35_ = _data_->self->priv->files;
#line 767 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp36_ = _data_->dir;
#line 767 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_data_->_tmp35_, _data_->_tmp36_, NULL);
#line 2965 "DirectoryMonitor.c"
	}
#line 769 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp37_ = _data_->dir;
#line 769 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (_data_->self, _data_->_tmp37_);
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2979 "DirectoryMonitor.c"
	} else {
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2983 "DirectoryMonitor.c"
	}
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return FALSE;
#line 2989 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory deleted: %s", _tmp2_);
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-deleted", _tmp5_);
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = dir;
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->root;
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_equal (_tmp6_, _tmp7_);
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 3033 "DirectoryMonitor.c"
		GFile* _tmp9_;
#line 777 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = dir;
#line 777 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, _tmp9_);
#line 3039 "DirectoryMonitor.c"
	}
}


void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
#line 3049 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_closed (DirectoryMonitor* self) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("monitoring of %s closed", _tmp2_);
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 781 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "closed");
#line 3077 "DirectoryMonitor.c"
}


void directory_monitor_notify_closed (DirectoryMonitor* self) {
#line 780 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 780 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
#line 3086 "DirectoryMonitor.c"
}


GFile* directory_monitor_get_root (DirectoryMonitor* self) {
	GFile* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 785 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 3104 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 789 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 789 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->root;
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_has_prefix (_tmp0_, _tmp1_);
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 3127 "DirectoryMonitor.c"
}


gboolean directory_monitor_has_started (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 793 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->started;
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 3142 "DirectoryMonitor.c"
}


void directory_monitor_start_discovery (DirectoryMonitor* self) {
	gboolean _tmp0_;
	GFile* _tmp1_;
#line 797 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 798 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->started;
#line 798 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (!_tmp0_);
#line 800 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 801 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 803 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 806 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 807 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->root;
#line 807 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_explore_async (self, _tmp1_, NULL, TRUE, NULL, NULL);
#line 3167 "DirectoryMonitor.c"
}


static void directory_monitor_real_close (DirectoryMonitor* self) {
	GCancellable* _tmp0_;
	GeeHashMap* _tmp12_;
#line 814 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 814 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 3178 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _monitor_it;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = gee_abstract_map_get_values (GEE_MAP (_tmp1_));
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_monitor_it = _tmp6_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 3205 "DirectoryMonitor.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			GFileMonitor* monitor;
			GFileMonitor* _tmp11_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp7_ = _monitor_it;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp8_) {
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 3220 "DirectoryMonitor.c"
			}
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp9_ = _monitor_it;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			monitor = (GFileMonitor*) _tmp10_;
#line 818 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp11_ = monitor;
#line 818 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, _tmp11_);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3234 "DirectoryMonitor.c"
		}
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_monitor_it);
#line 3238 "DirectoryMonitor.c"
	}
#line 820 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->monitors;
#line 820 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (_tmp12_));
#line 822 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 3246 "DirectoryMonitor.c"
}


void directory_monitor_close (DirectoryMonitor* self) {
#line 812 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 812 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
#line 3255 "DirectoryMonitor.c"
}


static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info) {
	DirectoryMonitorFType result = 0;
	GFileInfo* _tmp0_;
	GFileType _tmp1_ = 0;
	GFileType file_type;
	GFileType _tmp2_;
#line 825 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), 0);
#line 826 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 826 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_info_get_file_type (_tmp0_);
#line 826 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	file_type = _tmp1_;
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = file_type;
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_tmp2_) {
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_TYPE_REGULAR:
#line 3279 "DirectoryMonitor.c"
		{
#line 829 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 829 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 3285 "DirectoryMonitor.c"
		}
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 3289 "DirectoryMonitor.c"
		{
#line 832 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 832 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 3295 "DirectoryMonitor.c"
		}
		default:
		{
			GFileType _tmp3_;
			GEnumValue* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp3_ = file_type;
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp4_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), _tmp3_);
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp5_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp6_ = _tmp5_;
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp6_);
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_tmp6_);
#line 836 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 836 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 3319 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_explore_async_data_free (gpointer _data) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorExploreAsyncData, _data_);
#line 3336 "DirectoryMonitor.c"
}


static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	gboolean _tmp5_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_explore_async);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir_info = _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = in_discovery;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->in_discovery = _tmp5_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3376 "DirectoryMonitor.c"
}


static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorExploreAsyncData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 3384 "DirectoryMonitor.c"
}


static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3398 "DirectoryMonitor.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3405 "DirectoryMonitor.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_list_free (self);
#line 3414 "DirectoryMonitor.c"
}


static guint _file_hash_ghash_func (gconstpointer key) {
	guint result;
	result = file_hash (key);
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 3423 "DirectoryMonitor.c"
}


static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_) {
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 0:
#line 3432 "DirectoryMonitor.c"
		goto _state_0;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 1:
#line 3436 "DirectoryMonitor.c"
		goto _state_1;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 2:
#line 3440 "DirectoryMonitor.c"
		goto _state_2;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 3:
#line 3444 "DirectoryMonitor.c"
		goto _state_3;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 4:
#line 3448 "DirectoryMonitor.c"
		goto _state_4;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 5:
#line 3452 "DirectoryMonitor.c"
		goto _state_5;
		default:
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 3457 "DirectoryMonitor.c"
	}
	_state_0:
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->files;
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = _data_->dir;
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->dir_info;
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = FALSE;
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = directory_monitor_file_info_map_contains (_data_->_tmp0_, _data_->_tmp1_, _data_->_tmp2_);
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp3_) {
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp4_ = _data_->dir;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp5_ = NULL;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp5_ = g_file_get_path (_data_->_tmp4_);
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:842: Directory loop detected at %s, not explorin" \
"g", _data_->_tmp6_);
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp6_);
#line 844 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp7_ = _data_->in_discovery;
#line 844 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp7_);
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3492 "DirectoryMonitor.c"
		} else {
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3496 "DirectoryMonitor.c"
		}
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 3502 "DirectoryMonitor.c"
	}
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = _data_->dir_info;
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->local_dir_info = _data_->_tmp9_;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp10_ = _data_->local_dir_info;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp10_ == NULL) {
#line 3514 "DirectoryMonitor.c"
		{
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->dir;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->self->priv->cancellable;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_state_ = 1;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_file_query_info_async (_data_->_tmp11_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp12_, directory_monitor_explore_async_ready, _data_);
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return FALSE;
#line 3526 "DirectoryMonitor.c"
			_state_1:
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = NULL;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = g_file_query_info_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error_);
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_data_->_inner_error_ != NULL) {
#line 3536 "DirectoryMonitor.c"
				goto __catch425_g_error;
			}
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 853 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->local_dir_info = _data_->_tmp14_;
#line 3543 "DirectoryMonitor.c"
		}
		goto __finally425;
		__catch425_g_error:
		{
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->err = _data_->_inner_error_;
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_inner_error_ = NULL;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = _data_->dir;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = NULL;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = g_file_get_path (_data_->_tmp15_);
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp18_ = _data_->err;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:856: Unable to retrieve info on %s: %s", _data_->_tmp17_, _data_->_tmp19_);
#line 856 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_data_->_tmp17_);
#line 858 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp20_ = _data_->in_discovery;
#line 858 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp20_);
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_error_free0 (_data_->err);
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_data_->_state_ == 0) {
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3580 "DirectoryMonitor.c"
			} else {
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 3584 "DirectoryMonitor.c"
			}
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return FALSE;
#line 3590 "DirectoryMonitor.c"
		}
		__finally425:
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_clear_error (&_data_->_inner_error_);
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return FALSE;
#line 3603 "DirectoryMonitor.c"
		}
	}
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp21_ = _data_->local_dir_info;
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp22_ = FALSE;
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp22_ = g_file_info_get_is_hidden (_data_->_tmp21_);
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp22_) {
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp23_ = _data_->dir;
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp24_ = NULL;
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp24_ = g_file_get_path (_data_->_tmp23_);
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:865: Ignoring hidden directory %s", _data_->_tmp25_);
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp25_);
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp26_ = _data_->in_discovery;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp26_);
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3636 "DirectoryMonitor.c"
		} else {
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3640 "DirectoryMonitor.c"
		}
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 869 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 3646 "DirectoryMonitor.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp27_ = _data_->local_dir_info;
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp28_ = NULL;
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp28_ = get_file_info_id (_data_->_tmp27_);
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp30_ = _data_->_tmp29_ == NULL;
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_data_->_tmp29_);
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp30_) {
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp31_ = _data_->dir;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp32_ = NULL;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp32_ = g_file_get_path (_data_->_tmp31_);
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:876: Unable to retrieve file ID on %s: skipping", _data_->_tmp33_);
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp33_);
#line 878 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp34_ = _data_->in_discovery;
#line 878 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp34_);
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3684 "DirectoryMonitor.c"
		} else {
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3688 "DirectoryMonitor.c"
		}
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 3694 "DirectoryMonitor.c"
	}
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp35_ = _data_->local_dir_info;
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp36_ = 0;
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp36_ = g_file_info_get_file_type (_data_->_tmp35_);
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp36_ != G_FILE_TYPE_DIRECTORY) {
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp37_ = NULL;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp37_ = _ ("Unable to monitor %s: Not a directory (%s)");
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp38_ = _data_->dir;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp39_ = NULL;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp39_ = g_file_get_path (_data_->_tmp38_);
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp40_ = _data_->_tmp39_;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp41_ = _data_->local_dir_info;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp42_ = 0;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp42_ = g_file_info_get_file_type (_data_->_tmp41_);
#line 886 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp43_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), _data_->_tmp42_);
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp44_ = NULL;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp44_ = g_strdup_printf (_data_->_tmp37_, _data_->_tmp40_, (_data_->_tmp43_ != NULL) ? _data_->_tmp43_->value_name : NULL);
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (_data_->self, _data_->_tmp45_);
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp45_);
#line 885 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp40_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp46_ = _data_->in_discovery;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp46_);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3746 "DirectoryMonitor.c"
		} else {
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3750 "DirectoryMonitor.c"
		}
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 3756 "DirectoryMonitor.c"
	}
#line 897 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->dir_map = NULL;
#line 898 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->file_map = NULL;
#line 3762 "DirectoryMonitor.c"
	{
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp47_ = _data_->dir;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp48_ = _data_->self->priv->cancellable;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_state_ = 2;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_file_enumerate_children_async (_data_->_tmp47_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp48_, directory_monitor_explore_async_ready, _data_);
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 3774 "DirectoryMonitor.c"
		_state_2:
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp49_ = NULL;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp49_ = g_file_enumerate_children_finish (_data_->_tmp47_, _data_->_res_, &_data_->_inner_error_);
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->enumerator = _data_->_tmp49_;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 3784 "DirectoryMonitor.c"
			goto __catch426_g_error;
		}
		{
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp50_ = TRUE;
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp51_ = _data_->_tmp50_;
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!_data_->_tmp51_) {
#line 3796 "DirectoryMonitor.c"
				}
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp50_ = FALSE;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp52_ = _data_->enumerator;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp53_ = _data_->self->priv->cancellable;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_state_ = 3;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_file_enumerator_next_files_async (_data_->_tmp52_, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp53_, directory_monitor_explore_async_ready, _data_);
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return FALSE;
#line 3810 "DirectoryMonitor.c"
				_state_3:
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp54_ = NULL;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp54_ = g_file_enumerator_next_files_finish (_data_->_tmp52_, _data_->_res_, &_data_->_inner_error_);
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->infos = _data_->_tmp54_;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_data_->_inner_error_ != NULL) {
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->enumerator);
#line 3822 "DirectoryMonitor.c"
					goto __catch426_g_error;
				}
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp55_ = _data_->infos;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_data_->_tmp55_ == NULL) {
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					__g_list_free__g_object_unref0_0 (_data_->infos);
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 3833 "DirectoryMonitor.c"
				}
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp56_ = _data_->infos;
#line 3837 "DirectoryMonitor.c"
				{
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->info_collection = _data_->_tmp56_;
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_data_->_tmp57_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_data_->info = _data_->_tmp57_;
#line 3847 "DirectoryMonitor.c"
						{
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp58_ = _data_->info;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp59_ = FALSE;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp59_ = g_file_info_get_is_hidden (_data_->_tmp58_);
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							if (_data_->_tmp59_) {
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp60_ = _data_->dir;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp61_ = _data_->info;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp62_ = NULL;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp62_ = g_file_info_get_name (_data_->_tmp61_);
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp63_ = NULL;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp63_ = g_file_get_child (_data_->_tmp60_, _data_->_tmp62_);
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp64_ = _data_->_tmp63_;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp65_ = NULL;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp65_ = g_file_get_path (_data_->_tmp64_);
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_data_->_tmp66_ = _data_->_tmp65_;
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:912: Skipping hidden file/directory %s", _data_->_tmp66_);
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp66_);
#line 912 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->_tmp64_);
#line 915 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 915 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								continue;
#line 3887 "DirectoryMonitor.c"
							}
#line 919 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp67_ = _data_->info;
#line 919 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp68_ = FALSE;
#line 919 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp68_ = directory_monitor_is_file_symlink_supported (_data_->_tmp67_);
#line 919 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							if (!_data_->_tmp68_) {
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								continue;
#line 3901 "DirectoryMonitor.c"
							}
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp69_ = _data_->info;
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp70_ = 0;
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_data_->_tmp70_ = g_file_info_get_file_type (_data_->_tmp69_);
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							switch (_data_->_tmp70_) {
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								case G_FILE_TYPE_REGULAR:
#line 3913 "DirectoryMonitor.c"
								{
#line 924 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp71_ = _data_->file_map;
#line 924 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									if (_data_->_tmp71_ == NULL) {
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_data_->_tmp72_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->file_map);
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_data_->file_map = _data_->_tmp72_;
#line 3925 "DirectoryMonitor.c"
									}
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp73_ = _data_->file_map;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp74_ = _data_->dir;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp75_ = _data_->info;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp76_ = NULL;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp76_ = g_file_info_get_name (_data_->_tmp75_);
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp77_ = NULL;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp77_ = g_file_get_child (_data_->_tmp74_, _data_->_tmp76_);
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp78_ = _data_->_tmp77_;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp79_ = _data_->info;
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (_data_->_tmp73_), _data_->_tmp78_, _data_->_tmp79_);
#line 927 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp78_);
#line 928 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									break;
#line 3951 "DirectoryMonitor.c"
								}
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 3955 "DirectoryMonitor.c"
								{
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp80_ = _data_->dir_map;
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									if (_data_->_tmp80_ == NULL) {
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_data_->_tmp81_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->dir_map);
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
										_data_->dir_map = _data_->_tmp81_;
#line 3967 "DirectoryMonitor.c"
									}
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp82_ = _data_->dir_map;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp83_ = _data_->dir;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp84_ = _data_->info;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp85_ = NULL;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp85_ = g_file_info_get_name (_data_->_tmp84_);
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp86_ = NULL;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp86_ = g_file_get_child (_data_->_tmp83_, _data_->_tmp85_);
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp87_ = _data_->_tmp86_;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_data_->_tmp88_ = _data_->info;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (_data_->_tmp82_), _data_->_tmp87_, _data_->_tmp88_);
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp87_);
#line 935 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									break;
#line 3993 "DirectoryMonitor.c"
								}
								default:
								{
#line 939 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
									break;
#line 3999 "DirectoryMonitor.c"
								}
							}
#line 909 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
							_g_object_unref0 (_data_->info);
#line 4004 "DirectoryMonitor.c"
						}
					}
				}
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				__g_list_free__g_object_unref0_0 (_data_->infos);
#line 4010 "DirectoryMonitor.c"
			}
		}
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->enumerator);
#line 4015 "DirectoryMonitor.c"
	}
	goto __finally426;
	__catch426_g_error:
	{
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->err2 = _data_->_inner_error_;
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_inner_error_ = NULL;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp89_ = _data_->dir;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp90_ = NULL;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp90_ = g_file_get_path (_data_->_tmp89_);
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp91_ = _data_->_tmp90_;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp92_ = _data_->err2;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp93_ = _data_->_tmp92_->message;
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:944: Aborted directory traversal of %s: %s", _data_->_tmp91_, _data_->_tmp93_);
#line 944 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp91_);
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp94_ = _data_->in_discovery;
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp94_);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_error_free0 (_data_->err2);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4056 "DirectoryMonitor.c"
		} else {
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 4060 "DirectoryMonitor.c"
		}
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 4066 "DirectoryMonitor.c"
	}
	__finally426:
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_inner_error_ != NULL) {
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_clear_error (&_data_->_inner_error_);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 4083 "DirectoryMonitor.c"
	}
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp95_ = _data_->in_discovery;
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp95_) {
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp96_ = _data_->dir;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp97_ = _data_->local_dir_info;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (_data_->self, _data_->_tmp96_, _data_->_tmp97_);
#line 4095 "DirectoryMonitor.c"
	} else {
#line 955 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp98_ = _data_->dir;
#line 955 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp99_ = _data_->local_dir_info;
#line 955 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (_data_->self, _data_->_tmp98_, _data_->_tmp99_);
#line 4103 "DirectoryMonitor.c"
	}
#line 959 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp100_ = _data_->dir;
#line 959 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp101_ = _data_->local_dir_info;
#line 959 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->_tmp100_, _data_->_tmp101_);
#line 962 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp102_ = _data_->file_map;
#line 962 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp102_ != NULL) {
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp103_ = _data_->file_map;
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp104_ = _data_->in_discovery;
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_state_ = 4;
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files (_data_->self, GEE_MAP (_data_->_tmp103_), _data_->_tmp104_, directory_monitor_explore_async_ready, _data_);
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 4125 "DirectoryMonitor.c"
		_state_4:
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (_data_->self, _data_->_res_);
#line 4129 "DirectoryMonitor.c"
	}
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp106_ = _data_->self->priv->recurse;
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp106_) {
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp107_ = _data_->dir_map;
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp105_ = _data_->_tmp107_ != NULL;
#line 4139 "DirectoryMonitor.c"
	} else {
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp105_ = FALSE;
#line 4143 "DirectoryMonitor.c"
	}
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp108_ = _data_->_tmp105_;
#line 966 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_tmp108_) {
#line 4149 "DirectoryMonitor.c"
		{
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp109_ = _data_->dir_map;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp110_ = gee_abstract_map_get_keys (GEE_MAP (_data_->_tmp109_));
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp111_ = _data_->_tmp110_;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp112_ = _data_->_tmp111_;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp113_ = NULL;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp113_ = gee_iterable_iterator (GEE_ITERABLE (_data_->_tmp112_));
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp114_ = _data_->_tmp113_;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp112_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_subdir_it = _data_->_tmp114_;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp115_ = _data_->_subdir_it;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp116_ = FALSE;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp116_ = gee_iterator_next (_data_->_tmp115_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!_data_->_tmp116_) {
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 4181 "DirectoryMonitor.c"
				}
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp117_ = _data_->_subdir_it;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp118_ = NULL;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp118_ = gee_iterator_get (_data_->_tmp117_);
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->subdir = (GFile*) _data_->_tmp118_;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp119_ = _data_->self->priv->outstanding_exploration_dirs;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->self->priv->outstanding_exploration_dirs = _data_->_tmp119_ + 1;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_data_->_tmp120_ = _data_->self->priv->outstanding_exploration_dirs;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_data_->_tmp120_ > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp121_ = _data_->subdir;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp122_ = _data_->dir_map;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp123_ = _data_->subdir;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp124_ = NULL;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp124_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_data_->_tmp122_), _data_->_tmp123_);
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp125_ = (GFileInfo*) _data_->_tmp124_;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp126_ = _data_->in_discovery;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_state_ = 5;
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp121_, _data_->_tmp125_, _data_->_tmp126_, directory_monitor_explore_async_ready, _data_);
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					return FALSE;
#line 4219 "DirectoryMonitor.c"
					_state_5:
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_explore_finish (_data_->self, _data_->_res_);
#line 969 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp125_);
#line 4225 "DirectoryMonitor.c"
				} else {
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp127_ = _data_->subdir;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp128_ = _data_->dir_map;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp129_ = _data_->subdir;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp130_ = NULL;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp130_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_data_->_tmp128_), _data_->_tmp129_);
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp131_ = (GFileInfo*) _data_->_tmp130_;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_data_->_tmp132_ = _data_->in_discovery;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp127_, _data_->_tmp131_, _data_->_tmp132_, NULL, NULL);
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp131_);
#line 4245 "DirectoryMonitor.c"
				}
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->subdir);
#line 4249 "DirectoryMonitor.c"
			}
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_subdir_it);
#line 4253 "DirectoryMonitor.c"
		}
	}
#line 975 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp133_ = _data_->in_discovery;
#line 975 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp133_);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_map);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_map);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->local_dir_info);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4270 "DirectoryMonitor.c"
	} else {
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4274 "DirectoryMonitor.c"
	}
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return FALSE;
#line 4280 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files_data_free (gpointer _data) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, _data_);
#line 4293 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	DirectoryMonitor* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	gboolean _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_notify_directory_files);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = map;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->map = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = in_discovery;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->in_discovery = _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_files_co (_data_);
#line 4325 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 4333 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 4342 "DirectoryMonitor.c"
}


static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_) {
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 0:
#line 4351 "DirectoryMonitor.c"
		goto _state_0;
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case 1:
#line 4355 "DirectoryMonitor.c"
		goto _state_1;
		default:
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 4360 "DirectoryMonitor.c"
	}
	_state_0:
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->map;
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = NULL;
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_map_map_iterator (_data_->_tmp0_);
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_data_->iter = _data_->_tmp1_;
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	while (TRUE) {
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp2_ = _data_->iter;
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp3_ = FALSE;
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp3_ = gee_map_iterator_next (_data_->_tmp2_);
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (!_data_->_tmp3_) {
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 4383 "DirectoryMonitor.c"
		}
#line 981 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_tmp4_ = _data_->in_discovery;
#line 981 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_data_->_tmp4_) {
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->iter;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp6_ = NULL;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp6_ = gee_map_iterator_get_key (_data_->_tmp5_);
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp7_ = (GFile*) _data_->_tmp6_;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->iter;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = NULL;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = gee_map_iterator_get_value (_data_->_tmp8_);
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = (GFileInfo*) _data_->_tmp9_;
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (_data_->self, _data_->_tmp7_, _data_->_tmp10_);
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 982 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 4411 "DirectoryMonitor.c"
		} else {
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->iter;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = NULL;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = gee_map_iterator_get_key (_data_->_tmp11_);
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = (GFile*) _data_->_tmp12_;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->iter;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = NULL;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = gee_map_iterator_get_value (_data_->_tmp14_);
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = (GFileInfo*) _data_->_tmp15_;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (_data_->self, _data_->_tmp13_, _data_->_tmp16_);
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp16_);
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 4435 "DirectoryMonitor.c"
		}
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, _data_, NULL);
#line 987 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_data_->_state_ = 1;
#line 987 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 4443 "DirectoryMonitor.c"
		_state_1:
		;
	}
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->iter);
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4453 "DirectoryMonitor.c"
	} else {
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4457 "DirectoryMonitor.c"
	}
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 978 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return FALSE;
#line 4463 "DirectoryMonitor.c"
}


static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery) {
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp5_;
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->outstanding_exploration_dirs;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (_tmp0_ > 0);
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->outstanding_exploration_dirs;
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = _tmp1_ - 1;
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = in_discovery;
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp3_) {
#line 4487 "DirectoryMonitor.c"
		gint _tmp4_;
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->outstanding_exploration_dirs;
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp4_ == 0;
#line 4493 "DirectoryMonitor.c"
	} else {
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = FALSE;
#line 4497 "DirectoryMonitor.c"
	}
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp2_;
#line 997 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp5_) {
#line 998 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 4505 "DirectoryMonitor.c"
	}
}


static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 1026 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_on_monitor_notification (self, file, other_file, event_type);
#line 4513 "DirectoryMonitor.c"
}


static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* id;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GFileMonitor* monitor;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	GFileMonitor* _tmp19_;
	GFileMonitor* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_;
	GError * _inner_error_ = NULL;
#line 1004 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1004 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 1004 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp0_) {
#line 1006 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1006 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4554 "DirectoryMonitor.c"
	}
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = dir;
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_get_id (_tmp1_, _tmp2_, _tmp3_);
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 1009 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = id;
#line 1009 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp5_ == NULL) {
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4576 "DirectoryMonitor.c"
	}
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->monitors;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = id;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_);
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4592 "DirectoryMonitor.c"
	}
#line 1016 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	monitor = NULL;
#line 4596 "DirectoryMonitor.c"
	{
		GFile* _tmp9_;
		GFileMonitor* _tmp10_ = NULL;
		GFileMonitor* _tmp11_;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = dir;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = g_file_monitor_directory (_tmp9_, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error_);
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 4609 "DirectoryMonitor.c"
			goto __catch427_g_error;
		}
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		monitor = _tmp11_;
#line 4616 "DirectoryMonitor.c"
	}
	goto __finally427;
	__catch427_g_error:
	{
		GError* err = NULL;
		GFile* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = dir;
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp14_ = _tmp13_;
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = err;
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp16_ = _tmp15_->message;
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1020: Unable to monitor %s: %s", _tmp14_, _tmp16_);
#line 1020 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp14_);
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4655 "DirectoryMonitor.c"
	}
	__finally427:
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return FALSE;
#line 4670 "DirectoryMonitor.c"
	}
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp17_ = self->priv->monitors;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp18_ = id;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = monitor;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp17_), _tmp18_, _tmp19_);
#line 1026 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp20_ = monitor;
#line 1026 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_connect_object (_tmp20_, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp21_ = dir;
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp23_ = _tmp22_;
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp24_ = g_strdup_printf ("Added monitor for %s", _tmp23_);
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp25_ = _tmp24_;
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp25_);
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp25_);
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp23_);
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = TRUE;
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 4708 "DirectoryMonitor.c"
}


static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* id;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_ = NULL;
	GFileMonitor* monitor;
	GFileMonitor* _tmp9_;
	GeeHashMap* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean removed;
	gboolean _tmp13_;
	GFileMonitor* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1035 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 1035 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp0_) {
#line 1036 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1036 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4751 "DirectoryMonitor.c"
	}
#line 1038 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 1038 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = dir;
#line 1038 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 1038 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_get_id (_tmp1_, _tmp2_, _tmp3_);
#line 1038 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 1039 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = id;
#line 1039 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp5_ == NULL) {
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4773 "DirectoryMonitor.c"
	}
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->monitors;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = id;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_);
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	monitor = (GFileMonitor*) _tmp8_;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = monitor;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp9_ == NULL) {
#line 1044 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1044 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1044 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1044 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 4795 "DirectoryMonitor.c"
	}
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = self->priv->monitors;
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = id;
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp10_), _tmp11_, NULL);
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	removed = _tmp12_;
#line 1047 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = removed;
#line 1047 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_assert (_tmp13_);
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = monitor;
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, _tmp14_);
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp15_ = dir;
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp16_ = g_file_get_path (_tmp15_);
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp17_ = _tmp16_;
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp18_ = g_strdup_printf ("Removed monitor for %s", _tmp17_);
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = _tmp18_;
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp19_);
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp19_);
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp17_);
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = TRUE;
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 4837 "DirectoryMonitor.c"
}


static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor) {
	GFileMonitor* _tmp0_;
	guint _tmp1_ = 0U;
	GFileMonitor* _tmp2_;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1056 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_MONITOR (monitor));
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = monitor;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp1_, NULL, FALSE);
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = monitor;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_file_monitor_cancel (_tmp2_);
#line 4859 "DirectoryMonitor.c"
}


static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_on_completed (self, source_object, res);
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_unref (self);
#line 4868 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events (self);
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 4877 "DirectoryMonitor.c"
}


static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileMonitorEvent _tmp5_;
	GEnumValue* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFileMonitorEvent _tmp15_;
	DirectoryMonitorQueryInfoQueueElement* _tmp16_;
	DirectoryMonitorQueryInfoQueueElement* query_info;
	GeeQueue* _tmp17_;
	DirectoryMonitorQueryInfoQueueElement* _tmp18_;
	GFileMonitorEvent _tmp19_;
#line 1061 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1061 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1061 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = other_file;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 4910 "DirectoryMonitor.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = other_file;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp3_;
#line 4921 "DirectoryMonitor.c"
	} else {
		gchar* _tmp4_;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = g_strdup ("(none)");
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp4_;
#line 4930 "DirectoryMonitor.c"
	}
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = event;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp5_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = file;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp0_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp6_ != NULL) ? _tmp6_->value_name : NULL, _tmp9_, _tmp10_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp12_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp12_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp9_);
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = file;
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = other_file;
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp15_ = event;
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp16_ = directory_monitor_query_info_queue_element_new (self, _tmp13_, _tmp14_, _tmp15_);
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	query_info = _tmp16_;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp17_ = self->priv->query_info_queue;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp18_ = query_info;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_queue_offer (_tmp17_, _tmp18_);
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = event;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_tmp19_) {
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 4978 "DirectoryMonitor.c"
		{
			GFile* _tmp20_;
			GCancellable* _tmp21_;
			DirectoryMonitorQueryInfoQueueElement* _tmp22_;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp20_ = file;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp21_ = self->priv->cancellable;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp22_ = query_info;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_file_query_info_async (_tmp20_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp21_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp22_));
#line 1080 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 4993 "DirectoryMonitor.c"
		}
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 4997 "DirectoryMonitor.c"
		{
			guint _tmp23_;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp23_ = self->priv->delete_timer_id;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp23_ == ((guint) 0)) {
#line 5004 "DirectoryMonitor.c"
				guint _tmp24_ = 0U;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp24_ = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				self->priv->delete_timer_id = _tmp24_;
#line 5010 "DirectoryMonitor.c"
			}
#line 1088 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 5014 "DirectoryMonitor.c"
		}
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 5018 "DirectoryMonitor.c"
		{
			GFile* _tmp25_;
#line 1093 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp25_ = other_file;
#line 1093 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp25_ != NULL) {
#line 5025 "DirectoryMonitor.c"
				GFile* _tmp26_;
				GCancellable* _tmp27_;
				DirectoryMonitorQueryInfoQueueElement* _tmp28_;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp26_ = other_file;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp27_ = self->priv->cancellable;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp28_ = query_info;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_file_query_info_async (_tmp26_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp27_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp28_));
#line 5037 "DirectoryMonitor.c"
			} else {
				GeeQueue* _tmp29_;
				DirectoryMonitorQueryInfoQueueElement* _tmp30_;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1097: Unable to process MOVED event: no other_fi" \
"le");
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp29_ = self->priv->query_info_queue;
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp30_ = query_info;
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (_tmp29_), _tmp30_);
#line 5049 "DirectoryMonitor.c"
			}
#line 1100 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 5053 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorQueryInfoQueueElement* _tmp31_;
			DirectoryMonitorQueryInfoQueueElement* _tmp32_;
#line 1104 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp31_ = query_info;
#line 1104 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp31_->completed = TRUE;
#line 1105 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp32_ = query_info;
#line 1105 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, _tmp32_);
#line 1106 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 5069 "DirectoryMonitor.c"
		}
	}
#line 1061 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_directory_monitor_query_info_queue_element_unref0 (query_info);
#line 1061 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 5076 "DirectoryMonitor.c"
}


static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	DirectoryMonitorQueryInfoQueueElement* _tmp2_;
	gboolean _tmp5_;
	gboolean _tmp8_;
#line 1110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail ((query_info == NULL) || DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (query_info));
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = query_info;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 5094 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* _tmp3_;
		GFileInfo* _tmp4_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = query_info;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_->info;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 5103 "DirectoryMonitor.c"
	} else {
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 5107 "DirectoryMonitor.c"
	}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp1_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp5_) {
#line 5113 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* _tmp6_;
		GFileMonitorEvent _tmp7_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = query_info;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = _tmp6_->event;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp7_ == G_FILE_MONITOR_EVENT_CREATED;
#line 5122 "DirectoryMonitor.c"
	} else {
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 5126 "DirectoryMonitor.c"
	}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = _tmp0_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 5132 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp9_;
		DirectoryMonitorQueryInfoQueueElement* _tmp10_;
		GFileInfo* _tmp11_;
		GFile* _tmp12_ = NULL;
		GFile* match;
		GFile* _tmp13_;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = self->priv->files;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = query_info;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->info;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = directory_monitor_file_info_map_find_match (_tmp9_, _tmp11_);
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		match = _tmp12_;
#line 1117 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp13_ = match;
#line 1117 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_tmp13_ != NULL) {
#line 5153 "DirectoryMonitor.c"
			gboolean matched;
			gboolean _tmp52_;
#line 1118 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			matched = FALSE;
#line 5158 "DirectoryMonitor.c"
			{
				GeeQueue* _tmp14_;
				GeeIterator* _tmp15_ = NULL;
				GeeIterator* _enqueued_it;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp14_ = self->priv->query_info_queue;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp15_ = gee_iterable_iterator (GEE_ITERABLE (_tmp14_));
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_enqueued_it = _tmp15_;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				while (TRUE) {
#line 5171 "DirectoryMonitor.c"
					GeeIterator* _tmp16_;
					gboolean _tmp17_ = FALSE;
					GeeIterator* _tmp18_;
					gpointer _tmp19_ = NULL;
					DirectoryMonitorQueryInfoQueueElement* enqueued;
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
					DirectoryMonitorQueryInfoQueueElement* _tmp22_;
					GFileMonitorEvent _tmp23_;
					gboolean _tmp26_;
					gboolean _tmp31_;
					DirectoryMonitorQueryInfoQueueElement* _tmp32_;
					GFile* _tmp33_;
					gchar* _tmp34_ = NULL;
					gchar* _tmp35_;
					DirectoryMonitorQueryInfoQueueElement* _tmp36_;
					GFile* _tmp37_;
					gchar* _tmp38_ = NULL;
					gchar* _tmp39_;
					gchar* _tmp40_ = NULL;
					gchar* _tmp41_;
					DirectoryMonitorQueryInfoQueueElement* _tmp42_;
					DirectoryMonitorQueryInfoQueueElement* _tmp43_;
					DirectoryMonitorQueryInfoQueueElement* _tmp44_;
					GFile* _tmp45_;
					GFile* _tmp46_;
					DirectoryMonitorQueryInfoQueueElement* _tmp47_;
					DirectoryMonitorQueryInfoQueueElement* _tmp48_;
					GFileInfo* _tmp49_;
					GFileInfo* _tmp50_;
					DirectoryMonitorQueryInfoQueueElement* _tmp51_;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp16_ = _enqueued_it;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp17_ = gee_iterator_next (_tmp16_);
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (!_tmp17_) {
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						break;
#line 5211 "DirectoryMonitor.c"
					}
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp18_ = _enqueued_it;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp19_;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp22_ = enqueued;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp23_ = _tmp22_->event;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (_tmp23_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp21_ = TRUE;
#line 5227 "DirectoryMonitor.c"
					} else {
						DirectoryMonitorQueryInfoQueueElement* _tmp24_;
						gboolean _tmp25_;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp24_ = enqueued;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp25_ = _tmp24_->completed;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp21_ = _tmp25_;
#line 5237 "DirectoryMonitor.c"
					}
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp26_ = _tmp21_;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (_tmp26_) {
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp20_ = TRUE;
#line 5245 "DirectoryMonitor.c"
					} else {
						GFile* _tmp27_;
						DirectoryMonitorQueryInfoQueueElement* _tmp28_;
						GFile* _tmp29_;
						gboolean _tmp30_ = FALSE;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp27_ = match;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp28_ = enqueued;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp29_ = _tmp28_->file;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp30_ = g_file_equal (_tmp27_, _tmp29_);
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp20_ = !_tmp30_;
#line 5261 "DirectoryMonitor.c"
					}
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp31_ = _tmp20_;
#line 1120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (_tmp31_) {
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						continue;
#line 5271 "DirectoryMonitor.c"
					}
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp32_ = query_info;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp33_ = _tmp32_->file;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp34_ = g_file_get_path (_tmp33_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp35_ = _tmp34_;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp36_ = enqueued;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp37_ = _tmp36_->file;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp38_ = g_file_get_path (_tmp37_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp39_ = _tmp38_;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp40_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp35_, _tmp39_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp41_ = _tmp40_;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp41_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_free0 (_tmp41_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_free0 (_tmp39_);
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_free0 (_tmp35_);
#line 1129 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp42_ = enqueued;
#line 1129 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp42_->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp43_ = enqueued;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp44_ = query_info;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp45_ = _tmp44_->file;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp46_ = _g_object_ref0 (_tmp45_);
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp43_->other_file);
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp43_->other_file = _tmp46_;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp47_ = enqueued;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp48_ = query_info;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp49_ = _tmp48_->info;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp50_ = _g_object_ref0 (_tmp49_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp47_->info);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp47_->info = _tmp50_;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp51_ = enqueued;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp51_->completed = TRUE;
#line 1134 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					matched = TRUE;
#line 1136 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1136 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5339 "DirectoryMonitor.c"
				}
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_enqueued_it);
#line 5343 "DirectoryMonitor.c"
			}
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp52_ = matched;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp52_) {
#line 5349 "DirectoryMonitor.c"
				GeeQueue* _tmp53_;
				DirectoryMonitorQueryInfoQueueElement* _tmp54_;
#line 1140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp53_ = self->priv->query_info_queue;
#line 1140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp54_ = query_info;
#line 1140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (_tmp53_), _tmp54_);
#line 5358 "DirectoryMonitor.c"
			}
		}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 5363 "DirectoryMonitor.c"
	}
	{
		gboolean _tmp55_;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp55_ = TRUE;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5371 "DirectoryMonitor.c"
			gboolean _tmp56_;
			GeeQueue* _tmp57_;
			gpointer _tmp58_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* next;
			gboolean _tmp59_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp60_;
			gboolean _tmp63_;
			GeeQueue* _tmp64_;
			gpointer _tmp65_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* n;
			DirectoryMonitorQueryInfoQueueElement* _tmp66_;
			DirectoryMonitorQueryInfoQueueElement* _tmp67_;
			DirectoryMonitorQueryInfoQueueElement* _tmp68_;
			guint _tmp69_;
			DirectoryMonitorQueryInfoQueueElement* _tmp70_;
			GFileMonitorEvent _tmp71_;
			GEnumValue* _tmp72_;
			DirectoryMonitorQueryInfoQueueElement* _tmp73_;
			GFile* _tmp74_;
			gchar* _tmp75_ = NULL;
			gchar* _tmp76_;
			gchar* _tmp77_ = NULL;
			gchar* _tmp78_;
			DirectoryMonitorQueryInfoQueueElement* _tmp79_;
			GError* _tmp80_;
			gboolean _tmp93_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp94_;
			GFileInfo* _tmp95_;
			gboolean _tmp100_;
			gboolean _tmp110_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp111_;
			GFileInfo* _tmp112_;
			gboolean _tmp116_;
			DirectoryMonitorQueryInfoQueueElement* _tmp126_;
			GFile* _tmp127_;
			DirectoryMonitorQueryInfoQueueElement* _tmp128_;
			GFile* _tmp129_;
			DirectoryMonitorQueryInfoQueueElement* _tmp130_;
			GFileInfo* _tmp131_;
			DirectoryMonitorQueryInfoQueueElement* _tmp132_;
			GFileMonitorEvent _tmp133_;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp56_ = _tmp55_;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp56_) {
#line 5417 "DirectoryMonitor.c"
			}
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp55_ = FALSE;
#line 1147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp57_ = self->priv->query_info_queue;
#line 1147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp58_ = gee_queue_peek (_tmp57_);
#line 1147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp58_;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp60_ = next;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp60_ == NULL) {
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp59_ = TRUE;
#line 5433 "DirectoryMonitor.c"
			} else {
				DirectoryMonitorQueryInfoQueueElement* _tmp61_;
				gboolean _tmp62_;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp61_ = next;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp62_ = _tmp61_->completed;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp59_ = !_tmp62_;
#line 5443 "DirectoryMonitor.c"
			}
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp63_ = _tmp59_;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp63_) {
#line 1149 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1149 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 5453 "DirectoryMonitor.c"
			}
#line 1152 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp64_ = self->priv->query_info_queue;
#line 1152 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp65_ = gee_queue_poll (_tmp64_);
#line 1152 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp65_;
#line 1153 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp66_ = next;
#line 1153 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp67_ = n;
#line 1153 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp66_ == _tmp67_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp68_ = next;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp69_ = _tmp68_->position;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp70_ = next;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp71_ = _tmp70_->event;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp72_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp71_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp73_ = next;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp74_ = _tmp73_->file;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp75_ = g_file_get_path (_tmp74_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp76_ = _tmp75_;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp77_ = g_strdup_printf ("Completed info query %u for %s on %s", _tmp69_, (_tmp72_ != NULL) ? _tmp72_->value_name : NULL, _tmp76_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp78_ = _tmp77_;
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp78_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_tmp78_);
#line 1155 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_tmp76_);
#line 1158 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp79_ = next;
#line 1158 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp80_ = _tmp79_->err;
#line 1158 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp80_ != NULL) {
#line 5501 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp81_;
				GFile* _tmp82_;
				gchar* _tmp83_ = NULL;
				gchar* _tmp84_;
				DirectoryMonitorQueryInfoQueueElement* _tmp85_;
				GFileMonitorEvent _tmp86_;
				GEnumValue* _tmp87_;
				DirectoryMonitorQueryInfoQueueElement* _tmp88_;
				GError* _tmp89_;
				const gchar* _tmp90_;
				gchar* _tmp91_ = NULL;
				gchar* _tmp92_;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp81_ = next;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp82_ = _tmp81_->file;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp83_ = g_file_get_path (_tmp82_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp84_ = _tmp83_;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp85_ = next;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp86_ = _tmp85_->event;
#line 1160 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp87_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp86_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp88_ = next;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp89_ = _tmp88_->err;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp90_ = _tmp89_->message;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp91_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp84_, (_tmp87_ != NULL) ? _tmp87_->value_name : NULL, _tmp90_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp92_ = _tmp91_;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp92_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp92_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp84_);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 5550 "DirectoryMonitor.c"
			}
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp94_ = next;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp95_ = _tmp94_->info;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp95_ != NULL) {
#line 5558 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp96_;
				GFileInfo* _tmp97_;
				gchar* _tmp98_ = NULL;
				gchar* _tmp99_;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp96_ = next;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp97_ = _tmp96_->info;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp98_ = get_file_info_id (_tmp97_);
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp99_ = _tmp98_;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp93_ = _tmp99_ == NULL;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp99_);
#line 5575 "DirectoryMonitor.c"
			} else {
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp93_ = FALSE;
#line 5579 "DirectoryMonitor.c"
			}
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp100_ = _tmp93_;
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp100_) {
#line 5585 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp101_;
				GFile* _tmp102_;
				gchar* _tmp103_ = NULL;
				gchar* _tmp104_;
				DirectoryMonitorQueryInfoQueueElement* _tmp105_;
				GFileMonitorEvent _tmp106_;
				GEnumValue* _tmp107_;
				gchar* _tmp108_ = NULL;
				gchar* _tmp109_;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp101_ = next;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp102_ = _tmp101_->file;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp103_ = g_file_get_path (_tmp102_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp104_ = _tmp103_;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp105_ = next;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp106_ = _tmp105_->event;
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp107_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp106_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp108_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp104_, (_tmp107_ != NULL) ? _tmp107_->value_name : NULL);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp109_ = _tmp108_;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp109_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp109_);
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp104_);
#line 1170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 5625 "DirectoryMonitor.c"
			}
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp111_ = next;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp112_ = _tmp111_->info;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp112_ != NULL) {
#line 5633 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp113_;
				GFileInfo* _tmp114_;
				gboolean _tmp115_ = FALSE;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp113_ = next;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp114_ = _tmp113_->info;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp115_ = directory_monitor_is_file_symlink_supported (_tmp114_);
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp110_ = !_tmp115_;
#line 5645 "DirectoryMonitor.c"
			} else {
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp110_ = FALSE;
#line 5649 "DirectoryMonitor.c"
			}
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp116_ = _tmp110_;
#line 1174 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp116_) {
#line 5655 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp117_;
				GFile* _tmp118_;
				gchar* _tmp119_ = NULL;
				gchar* _tmp120_;
				DirectoryMonitorQueryInfoQueueElement* _tmp121_;
				GFileMonitorEvent _tmp122_;
				GEnumValue* _tmp123_;
				gchar* _tmp124_ = NULL;
				gchar* _tmp125_;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp117_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp118_ = _tmp117_->file;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp119_ = g_file_get_path (_tmp118_);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp120_ = _tmp119_;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp121_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp122_ = _tmp121_->event;
#line 1176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp123_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp122_);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp124_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp120_, (_tmp123_ != NULL) ? _tmp123_->value_name : NULL);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp125_ = _tmp124_;
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp125_);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp125_);
#line 1175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp120_);
#line 1178 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1178 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1178 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 5695 "DirectoryMonitor.c"
			}
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp126_ = next;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp127_ = _tmp126_->file;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp128_ = next;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp129_ = _tmp128_->other_file;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp130_ = next;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp131_ = _tmp130_->info;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp132_ = next;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp133_ = _tmp132_->event;
#line 1181 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, _tmp127_, _tmp129_, _tmp131_, _tmp133_);
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (n);
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (next);
#line 5719 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileMonitorEvent _tmp5_;
	GEnumValue* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	GFileMonitorEvent _tmp13_;
#line 1185 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1185 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1185 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1185 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail ((info == NULL) || G_IS_FILE_INFO (info));
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = other_file;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 5749 "DirectoryMonitor.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = other_file;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp3_;
#line 5760 "DirectoryMonitor.c"
	} else {
		gchar* _tmp4_;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = g_strdup ("(null)");
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp4_;
#line 5769 "DirectoryMonitor.c"
	}
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = event;
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp5_);
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = file;
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp0_;
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp6_ != NULL) ? _tmp6_->value_name : NULL, _tmp9_, _tmp10_);
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp12_);
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp12_);
#line 1187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp9_);
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = event;
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_tmp13_) {
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 5799 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp14_;
			GFileInfo* _tmp15_;
			DirectoryMonitorFType _tmp16_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp17_;
#line 1194 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp14_ = info;
#line 1194 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp14_ != NULL);
#line 1196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp15_ = info;
#line 1196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp16_ = directory_monitor_get_ftype (_tmp15_);
#line 1196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp16_;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp17_ = ftype;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp17_) {
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5822 "DirectoryMonitor.c"
				{
					GFile* _tmp18_;
					GFileInfo* _tmp19_;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp18_ = file;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp19_ = info;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, _tmp18_, _tmp19_);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5834 "DirectoryMonitor.c"
				}
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5838 "DirectoryMonitor.c"
				{
					gint _tmp20_;
					GFile* _tmp21_;
					GFileInfo* _tmp22_;
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp20_ = self->priv->outstanding_exploration_dirs;
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs = _tmp20_ + 1;
#line 1208 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 1208 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp22_ = info;
#line 1208 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (self, _tmp21_, _tmp22_, FALSE, NULL, NULL);
#line 1209 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5855 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp23_;
#line 1212 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp23_ = ftype;
#line 1212 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp23_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5866 "DirectoryMonitor.c"
				}
			}
#line 1215 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 5871 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 5875 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp24_;
			GFile* _tmp25_;
			GFileInfo* _tmp26_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp27_;
			GFileInfo* _tmp33_;
			DirectoryMonitorFType _tmp34_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp35_;
#line 1219 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp24_ = info;
#line 1219 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp24_ == NULL);
#line 1221 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp25_ = file;
#line 1221 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp26_ = directory_monitor_get_file_info (self, _tmp25_);
#line 1221 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			local_info = _tmp26_;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp27_ = local_info;
#line 1222 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp27_ == NULL) {
#line 5900 "DirectoryMonitor.c"
				GFile* _tmp28_;
				gchar* _tmp29_ = NULL;
				gchar* _tmp30_;
				gchar* _tmp31_ = NULL;
				gchar* _tmp32_;
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp28_ = file;
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp29_ = g_file_get_path (_tmp28_);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp30_ = _tmp29_;
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp31_ = g_strdup_printf ("Changed event for unknown file %s", _tmp30_);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp32_ = _tmp31_;
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp32_);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp32_);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp30_);
#line 1225 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1225 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 5926 "DirectoryMonitor.c"
			}
#line 1228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp33_ = local_info;
#line 1228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp34_ = directory_monitor_get_ftype (_tmp33_);
#line 1228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp34_;
#line 1229 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp35_ = ftype;
#line 1229 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp35_) {
#line 1229 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5940 "DirectoryMonitor.c"
				{
					GFile* _tmp36_;
#line 1231 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp36_ = file;
#line 1231 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, _tmp36_);
#line 1232 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5949 "DirectoryMonitor.c"
				}
#line 1229 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5953 "DirectoryMonitor.c"
				{
					GFile* _tmp37_;
#line 1235 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp37_ = file;
#line 1235 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, _tmp37_);
#line 1236 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5962 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp38_;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp38_ = ftype;
#line 1239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp38_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1240 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 5973 "DirectoryMonitor.c"
				}
			}
#line 1242 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1242 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 5980 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 5984 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp39_;
			GFileInfo* _tmp40_;
			DirectoryMonitorFType _tmp41_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp42_;
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp39_ = info;
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp39_ != NULL);
#line 1247 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp40_ = info;
#line 1247 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp41_ = directory_monitor_get_ftype (_tmp40_);
#line 1247 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp41_;
#line 1248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp42_ = ftype;
#line 1248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp42_) {
#line 1248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6007 "DirectoryMonitor.c"
				{
					GFile* _tmp43_;
					GFileInfo* _tmp44_;
#line 1250 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp43_ = file;
#line 1250 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp44_ = info;
#line 1250 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, _tmp43_, _tmp44_);
#line 1251 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6019 "DirectoryMonitor.c"
				}
#line 1248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6023 "DirectoryMonitor.c"
				{
					GFile* _tmp45_;
					GFileInfo* _tmp46_;
#line 1254 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp45_ = file;
#line 1254 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp46_ = info;
#line 1254 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, _tmp45_, _tmp46_);
#line 1255 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6035 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp47_;
#line 1258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp47_ = ftype;
#line 1258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp47_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6046 "DirectoryMonitor.c"
				}
			}
#line 1261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6051 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 6055 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp48_;
			GFile* _tmp49_;
			GFileInfo* _tmp50_;
			DirectoryMonitorFType _tmp51_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp52_;
#line 1264 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp48_ = info;
#line 1264 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp48_ != NULL);
#line 1265 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp49_ = other_file;
#line 1265 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp49_ != NULL);
#line 1269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp50_ = info;
#line 1269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp51_ = directory_monitor_get_ftype (_tmp50_);
#line 1269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp51_;
#line 1270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp52_ = ftype;
#line 1270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp52_) {
#line 1270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6083 "DirectoryMonitor.c"
				{
					GFile* _tmp53_;
					GFile* _tmp54_;
					GFileInfo* _tmp55_;
#line 1272 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp53_ = file;
#line 1272 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp54_ = other_file;
#line 1272 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp55_ = info;
#line 1272 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, _tmp53_, _tmp54_, _tmp55_);
#line 1273 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6098 "DirectoryMonitor.c"
				}
#line 1270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6102 "DirectoryMonitor.c"
				{
					DirectoryMonitorFileInfoMap* _tmp56_;
					GFile* _tmp57_;
					GFileInfo* _tmp58_ = NULL;
					GFileInfo* old_dir_info;
					GFileInfo* _tmp59_;
					GFile* _tmp63_;
					GFileInfo* _tmp64_;
					GFile* _tmp65_;
					GFileInfo* _tmp66_;
#line 1277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp56_ = self->priv->files;
#line 1277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp57_ = file;
#line 1277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp58_ = directory_monitor_file_info_map_get_info (_tmp56_, _tmp57_);
#line 1277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					old_dir_info = _tmp58_;
#line 1278 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp59_ = old_dir_info;
#line 1278 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (_tmp59_ == NULL) {
#line 6125 "DirectoryMonitor.c"
						GFile* _tmp60_;
						gchar* _tmp61_ = NULL;
						gchar* _tmp62_;
#line 1279 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp60_ = file;
#line 1279 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp61_ = g_file_get_path (_tmp60_);
#line 1279 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp62_ = _tmp61_;
#line 1279 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1279: Directory moved event for unknown file %s", _tmp62_);
#line 1279 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_g_free0 (_tmp62_);
#line 1281 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_g_object_unref0 (old_dir_info);
#line 1281 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						break;
#line 6143 "DirectoryMonitor.c"
					}
#line 1284 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp63_ = file;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp64_ = old_dir_info;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp65_ = other_file;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp66_ = info;
#line 1284 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, _tmp63_, _tmp64_, _tmp65_, _tmp66_);
#line 1285 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (old_dir_info);
#line 1285 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6159 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp67_;
#line 1288 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp67_ = ftype;
#line 1288 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp67_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6170 "DirectoryMonitor.c"
				}
			}
#line 1291 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6175 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 6179 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp68_;
			GFile* _tmp69_;
			GFileInfo* _tmp70_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp71_;
			GFileInfo* _tmp75_;
			DirectoryMonitorFType _tmp76_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp77_;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp68_ = info;
#line 1294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp68_ == NULL);
#line 1296 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp69_ = file;
#line 1296 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp70_ = directory_monitor_get_file_info (self, _tmp69_);
#line 1296 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			local_info = _tmp70_;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp71_ = local_info;
#line 1297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp71_ == NULL) {
#line 6204 "DirectoryMonitor.c"
				GFile* _tmp72_;
				gchar* _tmp73_ = NULL;
				gchar* _tmp74_;
#line 1298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp72_ = file;
#line 1298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp73_ = g_file_get_path (_tmp72_);
#line 1298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp74_ = _tmp73_;
#line 1298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1298: Deleted event for unknown file %s", _tmp74_);
#line 1298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp74_);
#line 1300 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1300 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 6222 "DirectoryMonitor.c"
			}
#line 1303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp75_ = local_info;
#line 1303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp76_ = directory_monitor_get_ftype (_tmp75_);
#line 1303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp76_;
#line 1304 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp77_ = ftype;
#line 1304 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp77_) {
#line 1304 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6236 "DirectoryMonitor.c"
				{
					GFile* _tmp78_;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp78_ = file;
#line 1306 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, _tmp78_);
#line 1307 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6245 "DirectoryMonitor.c"
				}
#line 1304 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6249 "DirectoryMonitor.c"
				{
					GFile* _tmp79_;
#line 1310 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp79_ = file;
#line 1310 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, _tmp79_);
#line 1311 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6258 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp80_;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp80_ = ftype;
#line 1314 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp80_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1315 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6269 "DirectoryMonitor.c"
				}
			}
#line 1317 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1317 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6276 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 6280 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp81_;
			GFile* _tmp82_;
			GFileInfo* _tmp83_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp84_;
			GFileInfo* _tmp88_;
			DirectoryMonitorFType _tmp89_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp90_;
#line 1321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp81_ = info;
#line 1321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp81_ == NULL);
#line 1323 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp82_ = file;
#line 1323 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp83_ = directory_monitor_get_file_info (self, _tmp82_);
#line 1323 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			local_info = _tmp83_;
#line 1324 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp84_ = local_info;
#line 1324 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp84_ == NULL) {
#line 6305 "DirectoryMonitor.c"
				GFile* _tmp85_;
				gchar* _tmp86_ = NULL;
				gchar* _tmp87_;
#line 1325 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp85_ = file;
#line 1325 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp86_ = g_file_get_path (_tmp85_);
#line 1325 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp87_ = _tmp86_;
#line 1325 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1325: Attribute changed event for unknown file %" \
"s", _tmp87_);
#line 1325 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_tmp87_);
#line 1327 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1327 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 6323 "DirectoryMonitor.c"
			}
#line 1330 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp88_ = local_info;
#line 1330 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp89_ = directory_monitor_get_ftype (_tmp88_);
#line 1330 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp89_;
#line 1331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp90_ = ftype;
#line 1331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp90_) {
#line 1331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6337 "DirectoryMonitor.c"
				{
					GFile* _tmp91_;
#line 1333 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp91_ = file;
#line 1333 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, _tmp91_);
#line 1334 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6346 "DirectoryMonitor.c"
				}
#line 1331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6350 "DirectoryMonitor.c"
				{
					GFile* _tmp92_;
#line 1337 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp92_ = file;
#line 1337 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, _tmp92_);
#line 1338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6359 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp93_;
#line 1341 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp93_ = ftype;
#line 1341 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp93_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1342 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 6370 "DirectoryMonitor.c"
				}
			}
#line 1344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6377 "DirectoryMonitor.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
#line 6383 "DirectoryMonitor.c"
		{
#line 1349 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6387 "DirectoryMonitor.c"
		}
		default:
		{
			GFileMonitorEvent _tmp94_;
			GEnumValue* _tmp95_;
#line 1352 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp94_ = event;
#line 1352 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp95_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp94_);
#line 1352 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1352: Unknown directory monitor event %s", (_tmp95_ != NULL) ? _tmp95_->value_name : NULL);
#line 1353 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			break;
#line 6401 "DirectoryMonitor.c"
		}
	}
#line 1185 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 6406 "DirectoryMonitor.c"
}


static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info) {
	GFile* _vala_old_file = NULL;
	GFileInfo* _vala_old_file_info = NULL;
	gboolean result = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* match;
	GFile* _tmp3_;
#line 1359 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1359 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1359 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1362 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->parent_moved;
#line 1362 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 1362 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_find_match (_tmp0_, _tmp1_);
#line 1362 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	match = _tmp2_;
#line 1363 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = match;
#line 1363 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp3_ != NULL) {
#line 6437 "DirectoryMonitor.c"
		GFile* _tmp4_;
		GFile* _tmp5_;
		DirectoryMonitorFileInfoMap* _tmp6_;
		GFile* _tmp7_;
		GFileInfo* _tmp8_ = NULL;
		DirectoryMonitorFileInfoMap* _tmp9_;
		GFile* _tmp10_;
		GFileInfo* _tmp11_;
#line 1364 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = match;
#line 1364 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 1364 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_vala_old_file = _tmp5_;
#line 1365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = self->priv->parent_moved;
#line 1365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = match;
#line 1365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp8_ = directory_monitor_file_info_map_get_info (_tmp6_, _tmp7_);
#line 1365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 1365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_vala_old_file_info = _tmp8_;
#line 1367 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = self->priv->parent_moved;
#line 1367 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = match;
#line 1367 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = info;
#line 1367 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_tmp9_, _tmp10_, _tmp11_);
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = TRUE;
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (old_file) {
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			*old_file = _vala_old_file;
#line 6480 "DirectoryMonitor.c"
		} else {
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file);
#line 6484 "DirectoryMonitor.c"
		}
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (old_file_info) {
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			*old_file_info = _vala_old_file_info;
#line 6490 "DirectoryMonitor.c"
		} else {
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file_info);
#line 6494 "DirectoryMonitor.c"
		}
#line 1369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 6498 "DirectoryMonitor.c"
	}
#line 1372 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file);
#line 1372 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_vala_old_file = NULL;
#line 1373 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file_info);
#line 1373 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_vala_old_file_info = NULL;
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = FALSE;
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (match);
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old_file) {
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*old_file = _vala_old_file;
#line 6516 "DirectoryMonitor.c"
	} else {
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 6520 "DirectoryMonitor.c"
	}
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old_file_info) {
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*old_file_info = _vala_old_file_info;
#line 6526 "DirectoryMonitor.c"
	} else {
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 6530 "DirectoryMonitor.c"
	}
#line 1375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 6534 "DirectoryMonitor.c"
}


static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gulong _tmp0_ = 0UL;
	gulong expiration;
	gboolean any_deleted;
	gboolean any_expired;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 1378 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1379 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = now_ms ();
#line 1379 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	expiration = _tmp0_ - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1381 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1382 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	any_expired = FALSE;
#line 6556 "DirectoryMonitor.c"
	{
		GeeQueue* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _element_it;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->query_info_queue;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_element_it = _tmp2_;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 6569 "DirectoryMonitor.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* element;
			DirectoryMonitorQueryInfoQueueElement* _tmp7_;
			GFileMonitorEvent _tmp8_;
			DirectoryMonitorQueryInfoQueueElement* _tmp9_;
			gulong _tmp10_;
			gulong _tmp11_;
			DirectoryMonitorQueryInfoQueueElement* _tmp12_;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp3_ = _element_it;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp4_) {
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 6589 "DirectoryMonitor.c"
			}
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp5_ = _element_it;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp6_;
#line 1384 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp7_ = element;
#line 1384 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp8_ = _tmp7_->event;
#line 1384 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp8_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1385 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1385 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 6607 "DirectoryMonitor.c"
			}
#line 1387 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1389 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp9_ = element;
#line 1389 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp10_ = _tmp9_->time_created_msec;
#line 1389 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp11_ = expiration;
#line 1389 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp10_ > _tmp11_) {
#line 1390 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1390 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 6623 "DirectoryMonitor.c"
			}
#line 1393 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp12_ = element;
#line 1393 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp12_->completed = TRUE;
#line 1394 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			any_expired = TRUE;
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (element);
#line 6633 "DirectoryMonitor.c"
		}
#line 1383 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_element_it);
#line 6637 "DirectoryMonitor.c"
	}
#line 1397 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = any_expired;
#line 1397 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp13_) {
#line 1398 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 6645 "DirectoryMonitor.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = any_deleted;
#line 1400 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp14_) {
#line 1401 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 6653 "DirectoryMonitor.c"
	}
#line 1403 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = any_deleted;
#line 1403 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 6659 "DirectoryMonitor.c"
}


GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_ = NULL;
#line 1407 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1407 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1408 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_get_info (_tmp0_, _tmp1_);
#line 1408 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 1408 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 6682 "DirectoryMonitor.c"
}


GeeCollection* directory_monitor_get_files (DirectoryMonitor* self) {
	GeeCollection* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GeeCollection* _tmp1_ = NULL;
#line 1413 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1414 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1414 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_all (_tmp0_);
#line 1414 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1414 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 6700 "DirectoryMonitor.c"
}


GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
#line 1420 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1420 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = self->priv->cancellable;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_query_info (_tmp0_, _tmp1_, _tmp2_);
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp3_;
#line 1421 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 6726 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info) {
	gboolean result = FALSE;
	GFileInfo* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFileInfo* _tmp2_;
	DirectoryMonitorFType _tmp3_ = 0;
	DirectoryMonitorFType ftype;
	DirectoryMonitorFType _tmp4_;
#line 1431 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1432 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 1432 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_info_get_is_symlink (_tmp0_);
#line 1432 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp1_) {
#line 1433 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = TRUE;
#line 1433 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 6750 "DirectoryMonitor.c"
	}
#line 1435 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 1435 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_get_ftype (_tmp2_);
#line 1435 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	ftype = _tmp3_;
#line 1436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = ftype;
#line 1436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	switch (_tmp4_) {
#line 1436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6764 "DirectoryMonitor.c"
		{
#line 1438 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1438 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 6770 "DirectoryMonitor.c"
		}
#line 1436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6774 "DirectoryMonitor.c"
		{
#line 1441 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1441 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 6780 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorFType _tmp5_;
#line 1444 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp5_ = ftype;
#line 1444 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_assert (_tmp5_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1446 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = FALSE;
#line 1446 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 6793 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 6806 "DirectoryMonitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6825 "DirectoryMonitor.c"
	} else {
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6831 "DirectoryMonitor.c"
	}
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 6837 "DirectoryMonitor.c"
}


static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 388 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 6844 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_started (DirectoryMonitor* self) {
}


static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 394 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 394 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6857 "DirectoryMonitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6876 "DirectoryMonitor.c"
	} else {
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6882 "DirectoryMonitor.c"
	}
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6888 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6897 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
#line 402 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 6904 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_completed (DirectoryMonitor* self) {
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 407 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 6913 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 410 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 410 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6922 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 6933 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file) {
#line 417 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6940 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6949 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 425 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6956 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 428 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6963 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6972 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 436 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 6983 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 440 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 6990 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 445 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 445 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6999 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 448 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 7006 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 452 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 7013 "DirectoryMonitor.c"
}


static void directory_monitor_real_closed (DirectoryMonitor* self) {
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	DirectoryMonitor* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFileMonitorEvent _tmp6_;
	guint _tmp7_;
	gulong _tmp8_ = 0UL;
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((other_file == NULL) || G_IS_FILE (other_file), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = owner;
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 98 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->owner = _tmp1_;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = file;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->file = _tmp3_;
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = other_file;
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 100 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->other_file = _tmp5_;
#line 101 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = event;
#line 101 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->event = _tmp6_;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = directory_monitor_query_info_queue_element_current;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_current = _tmp7_ + 1;
#line 102 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->position = _tmp7_;
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = now_ms ();
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->time_created_msec = _tmp8_;
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return self;
#line 7080 "DirectoryMonitor.c"
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 96 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 7087 "DirectoryMonitor.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 7094 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult) {
	GObject* _tmp0_;
	GFile* _tmp1_;
	GFile* source_file;
	DirectoryMonitor* _tmp7_;
	GError * _inner_error_ = NULL;
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail ((source == NULL) || G_IS_OBJECT (source));
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (aresult));
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = source;
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (G_FILE (_tmp0_));
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	source_file = _tmp1_;
#line 7116 "DirectoryMonitor.c"
	{
		GAsyncResult* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_;
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = aresult;
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_query_info_finish (source_file, _tmp2_, &_inner_error_);
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 7129 "DirectoryMonitor.c"
			goto __catch428_g_error;
		}
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (self->info);
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		self->info = _tmp4_;
#line 7136 "DirectoryMonitor.c"
	}
	goto __finally428;
	__catch428_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		GError* _tmp6_;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = err;
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = _g_error_copy0 (_tmp5_);
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_error_free0 (self->err);
#line 113 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		self->err = _tmp6_;
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 7158 "DirectoryMonitor.c"
	}
	__finally428:
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (source_file);
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return;
#line 7171 "DirectoryMonitor.c"
	}
#line 117 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->completed = TRUE;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = self->owner;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_process_query_queue (_tmp7_, self);
#line 106 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (source_file);
#line 7181 "DirectoryMonitor.c"
}


static void directory_monitor_value_query_info_queue_element_init (GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 7188 "DirectoryMonitor.c"
}


static void directory_monitor_value_query_info_queue_element_free_value (GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
#line 7197 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value, GValue* dest_value) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
#line 7207 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7211 "DirectoryMonitor.c"
	}
}


static gpointer directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 7219 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_query_info_queue_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 7226 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* object;
		object = collect_values[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7233 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7237 "DirectoryMonitor.c"
		}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
#line 7241 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7245 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return NULL;
#line 7249 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorQueryInfoQueueElement** object_p;
	object_p = collect_values[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!object_p) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7260 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 7266 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 7270 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 7274 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return NULL;
#line 7278 "DirectoryMonitor.c"
}


static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 7292 "DirectoryMonitor.c"
}


static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 7301 "DirectoryMonitor.c"
}


static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 7321 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7325 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 7331 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 7350 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7354 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 7360 "DirectoryMonitor.c"
	}
}


static void directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS (klass)->finalize = directory_monitor_query_info_queue_element_finalize;
#line 7370 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self) {
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->info = NULL;
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->err = NULL;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->completed = FALSE;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 7383 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj) {
	DirectoryMonitorQueryInfoQueueElement * self;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT (obj);
#line 86 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 87 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->info);
#line 93 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_error_free0 (self->err);
#line 7401 "DirectoryMonitor.c"
}


static GType directory_monitor_query_info_queue_element_get_type (void) {
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}


static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return instance;
#line 7426 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_unref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7439 "DirectoryMonitor.c"
	}
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type) {
	DirectoryMonitorFileInfoMap* self = NULL;
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return self;
#line 7450 "DirectoryMonitor.c"
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void) {
#line 134 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 7457 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id) {
	GFile* _vala_normalized = NULL;
	gchar* _vala_id = NULL;
	gboolean result = FALSE;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* local_info;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* file_id;
	const gchar* _tmp9_;
	GeeHashMap* _tmp10_;
	const gchar* _tmp11_;
	gpointer _tmp12_ = NULL;
	GFile* known_file;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	GFile* _tmp19_;
	GFile* _tmp20_;
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 140 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	local_info = _tmp1_;
#line 141 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = local_info;
#line 141 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 7499 "DirectoryMonitor.c"
		GeeHashMap* _tmp3_;
		GFile* _tmp4_;
		gpointer _tmp5_ = NULL;
		GFileInfo* _tmp6_;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = file;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp3_), _tmp4_);
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		local_info = (GFileInfo*) _tmp5_;
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = local_info;
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_tmp6_ == NULL) {
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_vala_normalized = NULL;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_vala_id = NULL;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = FALSE;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (normalized) {
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				*normalized = _vala_normalized;
#line 7534 "DirectoryMonitor.c"
			} else {
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_vala_normalized);
#line 7538 "DirectoryMonitor.c"
			}
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (id) {
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				*id = _vala_id;
#line 7544 "DirectoryMonitor.c"
			} else {
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (_vala_id);
#line 7548 "DirectoryMonitor.c"
			}
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 7552 "DirectoryMonitor.c"
		}
	}
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = local_info;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = get_file_info_id (_tmp7_);
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	file_id = _tmp8_;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = file_id;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp9_ == NULL) {
#line 153 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 153 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_vala_normalized = NULL;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_vala_id = NULL;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (file_id);
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (normalized) {
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			*normalized = _vala_normalized;
#line 7583 "DirectoryMonitor.c"
		} else {
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 7587 "DirectoryMonitor.c"
		}
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (id) {
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			*id = _vala_id;
#line 7593 "DirectoryMonitor.c"
		} else {
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 7597 "DirectoryMonitor.c"
		}
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 7601 "DirectoryMonitor.c"
	}
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = self->priv->id_map;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp11_ = file_id;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp10_), _tmp11_);
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	known_file = (GFile*) _tmp12_;
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = file_id;
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = g_strdup ((const gchar*) _tmp13_);
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (_vala_id);
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_vala_id = _tmp14_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp16_ = known_file;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp16_ != NULL) {
#line 7623 "DirectoryMonitor.c"
		GFile* _tmp17_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp17_ = known_file;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = _tmp17_;
#line 7629 "DirectoryMonitor.c"
	} else {
		GFile* _tmp18_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp18_ = file;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = _tmp18_;
#line 7636 "DirectoryMonitor.c"
	}
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = _tmp15_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_normalized);
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_vala_normalized = _tmp20_;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = TRUE;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (known_file);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (file_id);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (local_info);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (normalized) {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*normalized = _vala_normalized;
#line 7658 "DirectoryMonitor.c"
	} else {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 7662 "DirectoryMonitor.c"
	}
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (id) {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*id = _vala_id;
#line 7668 "DirectoryMonitor.c"
	} else {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 7672 "DirectoryMonitor.c"
	}
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 7676 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFileInfo* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* existing_id;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	gboolean _tmp14_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp19_;
	GFileInfo* _tmp20_;
	GFile* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	GeeHashMap* _tmp24_;
	GFile* _tmp25_;
	GFileInfo* _tmp26_;
	GeeHashMap* _tmp27_;
	const gchar* _tmp28_;
	GFile* _tmp29_;
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 167 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 7718 "DirectoryMonitor.c"
		GeeHashMap* _tmp3_;
		GFile* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean removed;
		gboolean _tmp6_;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = file;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp3_), _tmp4_, NULL);
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		removed = _tmp5_;
#line 171 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = removed;
#line 171 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert (_tmp6_);
#line 7736 "DirectoryMonitor.c"
	}
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = info;
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = get_file_info_id (_tmp7_);
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	existing_id = _tmp8_;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = existing_id;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp10_ != NULL) {
#line 7748 "DirectoryMonitor.c"
		GeeHashMap* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = self->priv->id_map;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = existing_id;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp13_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp11_), _tmp12_);
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp13_;
#line 7760 "DirectoryMonitor.c"
	} else {
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = FALSE;
#line 7764 "DirectoryMonitor.c"
	}
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = _tmp9_;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp14_) {
#line 7770 "DirectoryMonitor.c"
		GeeHashMap* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_ = FALSE;
		gboolean removed;
		gboolean _tmp18_;
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp15_ = self->priv->id_map;
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp16_ = existing_id;
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp17_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp15_), _tmp16_, NULL);
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		removed = _tmp17_;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp18_ = removed;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_assert (_tmp18_);
#line 7788 "DirectoryMonitor.c"
	}
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = file;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp20_ = info;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp23_ = directory_monitor_file_info_map_normalize_file (self, _tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = _tmp21_;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp22_;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp23_) {
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (existing_id);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 7816 "DirectoryMonitor.c"
	}
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp24_ = self->priv->map;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp25_ = normalized;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp26_ = info;
#line 186 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp24_), _tmp25_, _tmp26_);
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp27_ = self->priv->id_map;
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp28_ = id;
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp29_ = normalized;
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp27_), _tmp28_, _tmp29_);
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = TRUE;
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (existing_id);
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 7844 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GeeHashMap* _tmp5_;
	GFile* _tmp6_;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_normalize_file (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = _tmp2_;
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp3_;
#line 195 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp4_) {
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 7891 "DirectoryMonitor.c"
	}
#line 198 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->map;
#line 198 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = normalized;
#line 198 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_, NULL);
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->id_map;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = id;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp7_), _tmp8_, NULL);
#line 201 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = TRUE;
#line 201 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 201 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 201 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 7913 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
#line 206 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 206 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (files));
#line 7922 "DirectoryMonitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _file_it;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = files;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_file_it = _tmp1_;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7935 "DirectoryMonitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GFile* file;
			GFile* _tmp6_;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp2_ = _file_it;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp3_) {
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 7950 "DirectoryMonitor.c"
			}
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp4_ = _file_it;
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp5_;
#line 208 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp6_ = file;
#line 208 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, _tmp6_, NULL);
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 7964 "DirectoryMonitor.c"
		}
#line 207 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7968 "DirectoryMonitor.c"
	}
}


static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
#line 211 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 211 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 211 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_normalize_file (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = _tmp2_;
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp3_;
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp4_) {
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = FALSE;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8015 "DirectoryMonitor.c"
	}
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->id_map;
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = id;
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_);
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = _tmp7_;
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8031 "DirectoryMonitor.c"
}


static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gchar* result = NULL;
	GFileInfo* _tmp0_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
#line 220 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 220 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 220 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp0_ != NULL) {
#line 8054 "DirectoryMonitor.c"
		GFileInfo* _tmp1_;
		gchar* _tmp2_ = NULL;
#line 223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = info;
#line 223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = get_file_info_id (_tmp1_);
#line 223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = _tmp2_;
#line 223 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8065 "DirectoryMonitor.c"
	}
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = file;
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp6_ = directory_monitor_file_info_map_normalize_file (self, _tmp3_, NULL, &_tmp4_, &_tmp5_);
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = _tmp4_;
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp5_;
#line 227 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp6_) {
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8089 "DirectoryMonitor.c"
	}
#line 230 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = id;
#line 230 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 230 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8097 "DirectoryMonitor.c"
}


static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self) {
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 233 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = GEE_COLLECTION (_tmp2_);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8118 "DirectoryMonitor.c"
}


static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file) {
	GFileInfo* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp3_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	GeeHashMap* _tmp8_;
	GFile* _tmp9_;
	gpointer _tmp10_ = NULL;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 239 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	info = (GFileInfo*) _tmp2_;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp3_ != NULL) {
#line 241 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = info;
#line 241 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8158 "DirectoryMonitor.c"
	}
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp7_ = directory_monitor_file_info_map_normalize_file (self, _tmp4_, NULL, &_tmp5_, &_tmp6_);
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = _tmp5_;
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp6_;
#line 245 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp7_) {
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8184 "DirectoryMonitor.c"
	}
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp8_ = self->priv->map;
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp9_ = normalized;
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp10_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp8_), _tmp9_);
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp10_;
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8202 "DirectoryMonitor.c"
}


static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable) {
	GFileInfo* result = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp12_;
	gboolean _tmp13_ = FALSE;
	GFileInfo* _tmp14_;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gchar* id;
	const gchar* _tmp17_;
	GeeHashMap* _tmp18_;
	const gchar* _tmp19_;
	gpointer _tmp20_ = NULL;
	GFile* normalized;
	GFile* _tmp21_;
	GeeHashMap* _tmp22_;
	GFile* _tmp23_;
	gpointer _tmp24_ = NULL;
	GError * _inner_error_ = NULL;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (self, _tmp0_);
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	info = _tmp1_;
#line 253 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 253 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = info;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8248 "DirectoryMonitor.c"
	}
	{
		GFile* _tmp3_;
		GCancellable* _tmp4_;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_;
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = file;
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = cancellable;
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = g_file_query_info (_tmp3_, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, _tmp4_, &_inner_error_);
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 8265 "DirectoryMonitor.c"
			goto __catch429_g_error;
		}
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		info = _tmp6_;
#line 8272 "DirectoryMonitor.c"
	}
	goto __finally429;
	__catch429_g_error:
	{
		GError* err = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = file;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp8_ = g_file_get_path (_tmp7_);
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = err;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->message;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:261: Unable to query file ID of %s: %s", _tmp9_, _tmp11_);
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (_tmp9_);
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8309 "DirectoryMonitor.c"
	}
	__finally429:
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return NULL;
#line 8322 "DirectoryMonitor.c"
	}
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp12_ = info;
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp13_ = directory_monitor_is_file_symlink_supported (_tmp12_);
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!_tmp13_) {
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8336 "DirectoryMonitor.c"
	}
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp14_ = info;
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp15_ = g_file_info_get_attribute_string (_tmp14_, G_FILE_ATTRIBUTE_ID_FILE);
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	id = _tmp16_;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp17_ = id;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp17_ == NULL) {
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8358 "DirectoryMonitor.c"
	}
#line 273 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp18_ = self->priv->id_map;
#line 273 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp19_ = id;
#line 273 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp20_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp18_), _tmp19_);
#line 273 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	normalized = (GFile*) _tmp20_;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp21_ = normalized;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp21_ == NULL) {
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8382 "DirectoryMonitor.c"
	}
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp22_ = self->priv->map;
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp23_ = file;
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp24_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp22_), _tmp23_);
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp24_;
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8400 "DirectoryMonitor.c"
}


static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match) {
	GFile* result = NULL;
	GFileInfo* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* match_id;
	const gchar* _tmp2_;
	GFileInfo* _tmp3_;
	gint64 _tmp4_ = 0LL;
	gint64 match_size;
	GFileInfo* _tmp5_;
	GTimeVal _tmp6_ = {0};
	GTimeVal match_time;
#line 280 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 280 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (match), NULL);
#line 281 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = match;
#line 281 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = get_file_info_id (_tmp0_);
#line 281 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	match_id = _tmp1_;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = match_id;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		result = NULL;
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_free0 (match_id);
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return result;
#line 8436 "DirectoryMonitor.c"
	}
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = match;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_info_get_size (_tmp3_);
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	match_size = _tmp4_;
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp5_ = match;
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	match_time = _tmp6_;
#line 8450 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeSet* _tmp10_;
		GeeIterator* _tmp11_ = NULL;
		GeeIterator* _tmp12_;
		GeeIterator* _file_it;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->map;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp8_ = gee_abstract_map_get_keys (GEE_MAP (_tmp7_));
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp11_ = gee_iterable_iterator (GEE_ITERABLE (_tmp10_));
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp12_ = _tmp11_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp10_);
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_file_it = _tmp12_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8477 "DirectoryMonitor.c"
			GeeIterator* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GeeIterator* _tmp15_;
			gpointer _tmp16_ = NULL;
			GFile* file;
			GeeHashMap* _tmp17_;
			GFile* _tmp18_;
			gpointer _tmp19_ = NULL;
			GFileInfo* info;
			GFileInfo* _tmp20_;
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			gboolean _tmp24_;
			gint64 _tmp25_;
			GFileInfo* _tmp26_;
			gint64 _tmp27_ = 0LL;
			GFileInfo* _tmp28_;
			GTimeVal _tmp29_ = {0};
			GTimeVal time;
			GTimeVal _tmp30_;
			glong _tmp31_;
			GTimeVal _tmp32_;
			glong _tmp33_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp13_ = _file_it;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp14_ = gee_iterator_next (_tmp13_);
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp14_) {
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 8510 "DirectoryMonitor.c"
			}
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp15_ = _file_it;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp16_;
#line 290 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp17_ = self->priv->map;
#line 290 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp18_ = file;
#line 290 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp19_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp17_), _tmp18_);
#line 290 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			info = (GFileInfo*) _tmp19_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp20_ = info;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp21_ = get_file_info_id (_tmp20_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp22_ = _tmp21_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp23_ = match_id;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp24_ = g_strcmp0 (_tmp22_, _tmp23_) == 0;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (_tmp22_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp24_) {
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				result = file;
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (_file_it);
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_free0 (match_id);
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				return result;
#line 8550 "DirectoryMonitor.c"
			}
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp25_ = match_size;
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp26_ = info;
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp27_ = g_file_info_get_size (_tmp26_);
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp25_ != _tmp27_) {
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 298 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 8566 "DirectoryMonitor.c"
			}
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp28_ = info;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			g_file_info_get_modification_time (_tmp28_, &_tmp29_);
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			time = _tmp29_;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp30_ = time;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp31_ = _tmp30_.tv_sec;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp32_ = match_time;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp33_ = _tmp32_.tv_sec;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp31_ != _tmp33_) {
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 8590 "DirectoryMonitor.c"
			}
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			result = file;
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (info);
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_file_it);
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_free0 (match_id);
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return result;
#line 8602 "DirectoryMonitor.c"
		}
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8606 "DirectoryMonitor.c"
	}
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = NULL;
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_free0 (match_id);
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 8614 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents) {
	GeeArrayList* pruned;
	GeeArrayList* _tmp28_;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
#line 312 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	pruned = NULL;
#line 8629 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _file_it;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8656 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			GFile* file;
			GFile* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* parent;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp7_) {
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 8673 "DirectoryMonitor.c"
			}
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp8_ = _file_it;
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp9_;
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp10_ = file;
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp11_ = g_file_get_parent (_tmp10_);
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			parent = _tmp11_;
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 8689 "DirectoryMonitor.c"
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				gboolean _tmp15_ = FALSE;
				GFile* _tmp26_;
				GFile* _tmp27_ = NULL;
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp12_ = parent;
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (!(_tmp12_ != NULL)) {
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 8702 "DirectoryMonitor.c"
				}
#line 316 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp13_ = parent;
#line 316 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp14_ = root;
#line 316 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp15_ = g_file_equal (_tmp13_, _tmp14_);
#line 316 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				if (_tmp15_) {
#line 8712 "DirectoryMonitor.c"
					GeeArrayList* _tmp16_;
					GeeArrayList* _tmp18_;
					GFile* _tmp19_;
					DirectoryMonitorFileInfoMap* _tmp20_;
					GFile* _tmp21_;
					GeeHashMap* _tmp22_;
					GFile* _tmp23_;
					gpointer _tmp24_ = NULL;
					GFileInfo* _tmp25_;
#line 317 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp16_ = pruned;
#line 317 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					if (_tmp16_ == NULL) {
#line 8726 "DirectoryMonitor.c"
						GeeArrayList* _tmp17_;
#line 318 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_tmp17_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 318 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						_g_object_unref0 (pruned);
#line 318 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
						pruned = _tmp17_;
#line 8734 "DirectoryMonitor.c"
					}
#line 320 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp18_ = pruned;
#line 320 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 320 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp18_), _tmp19_);
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp20_ = descendents;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp22_ = self->priv->map;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp23_ = file;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp24_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp22_), _tmp23_);
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp25_ = (GFileInfo*) _tmp24_;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (_tmp20_, _tmp21_, _tmp25_);
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp25_);
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 8760 "DirectoryMonitor.c"
				}
#line 326 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp26_ = parent;
#line 326 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp27_ = g_file_get_parent (_tmp26_);
#line 326 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 326 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				parent = _tmp27_;
#line 8770 "DirectoryMonitor.c"
			}
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8776 "DirectoryMonitor.c"
		}
#line 313 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8780 "DirectoryMonitor.c"
	}
#line 330 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp28_ = pruned;
#line 330 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (_tmp28_ != NULL) {
#line 8786 "DirectoryMonitor.c"
		GeeArrayList* _tmp29_;
#line 331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp29_ = pruned;
#line 331 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, GEE_COLLECTION (_tmp29_));
#line 8792 "DirectoryMonitor.c"
	}
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (pruned);
#line 8796 "DirectoryMonitor.c"
}


static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs) {
	gint result = 0;
	gint count;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), 0);
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (files), 0);
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (dirs), 0);
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	count = 0;
#line 8813 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _file_it;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8840 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			GFile* file;
			GFile* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* parent;
			gboolean _tmp12_ = FALSE;
			GFile* _tmp13_;
			gboolean _tmp17_;
			GeeHashMap* _tmp18_;
			GFile* _tmp19_;
			gpointer _tmp20_ = NULL;
			GFileInfo* _tmp21_;
			DirectoryMonitorFType _tmp22_ = 0;
			DirectoryMonitorFType _tmp23_;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp24_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (!_tmp7_) {
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				break;
#line 8868 "DirectoryMonitor.c"
			}
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp8_ = _file_it;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp9_;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp10_ = file;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp11_ = g_file_get_parent (_tmp10_);
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			parent = _tmp11_;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp13_ = parent;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp13_ == NULL) {
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp12_ = TRUE;
#line 8888 "DirectoryMonitor.c"
			} else {
				GFile* _tmp14_;
				GFile* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp14_ = parent;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp15_ = root;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp16_ = g_file_equal (_tmp14_, _tmp15_);
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_tmp12_ = !_tmp16_;
#line 8901 "DirectoryMonitor.c"
			}
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp17_ = _tmp12_;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			if (_tmp17_) {
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				continue;
#line 8913 "DirectoryMonitor.c"
			}
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp18_ = self->priv->map;
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp19_ = file;
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp20_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp18_), _tmp19_);
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp21_ = (GFileInfo*) _tmp20_;
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp22_ = directory_monitor_get_ftype (_tmp21_);
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp23_ = _tmp22_;
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (_tmp21_);
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			ftype = _tmp23_;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_tmp24_ = ftype;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			switch (_tmp24_) {
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 8937 "DirectoryMonitor.c"
				{
					GeeCollection* _tmp25_;
					GFile* _tmp26_;
					gint _tmp27_;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp25_ = files;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp26_ = file;
#line 346 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					gee_collection_add (_tmp25_, _tmp26_);
#line 347 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp27_ = count;
#line 347 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					count = _tmp27_ + 1;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 8954 "DirectoryMonitor.c"
				}
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 8958 "DirectoryMonitor.c"
				{
					GeeCollection* _tmp28_;
					GFile* _tmp29_;
					gint _tmp30_;
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp28_ = dirs;
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp29_ = file;
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					gee_collection_add (_tmp28_, _tmp29_);
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp30_ = count;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					count = _tmp30_ + 1;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 8975 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp31_;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					_tmp31_ = ftype;
#line 356 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					g_assert (_tmp31_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
					break;
#line 8986 "DirectoryMonitor.c"
				}
			}
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8993 "DirectoryMonitor.c"
		}
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8997 "DirectoryMonitor.c"
	}
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	result = count;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return result;
#line 9003 "DirectoryMonitor.c"
}


static void directory_monitor_value_file_info_map_init (GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 9010 "DirectoryMonitor.c"
}


static void directory_monitor_value_file_info_map_free_value (GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
#line 9019 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_file_info_map_copy_value (const GValue* src_value, GValue* dest_value) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
#line 9029 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9033 "DirectoryMonitor.c"
	}
}


static gpointer directory_monitor_value_file_info_map_peek_pointer (const GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 9041 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_file_info_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 9048 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* object;
		object = collect_values[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9055 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9059 "DirectoryMonitor.c"
		}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
#line 9063 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9067 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return NULL;
#line 9071 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_file_info_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorFileInfoMap** object_p;
	object_p = collect_values[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!object_p) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9082 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 9088 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 9092 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 9096 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return NULL;
#line 9100 "DirectoryMonitor.c"
}


static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecFileInfoMap* spec;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 9114 "DirectoryMonitor.c"
}


static gpointer directory_monitor_value_get_file_info_map (const GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 9123 "DirectoryMonitor.c"
}


static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (v_object) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 9143 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9147 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 9153 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (v_object) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 9172 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9176 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (old) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 9182 "DirectoryMonitor.c"
	}
}


static void directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_file_info_map_finalize;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_type_class_add_private (klass, sizeof (DirectoryMonitorFileInfoMapPrivate));
#line 9194 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self) {
	GeeHashMap* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GeeHashMap* _tmp3_;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv = DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE (self);
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, _file_hash_ghash_func, _file_equal_gequal_func, NULL);
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->map = _tmp0_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = g_str_hash;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = g_str_equal;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp1_, _tmp2_, _file_equal_gequal_func);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->id_map = _tmp3_;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 9219 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorFileInfoMap * self;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR_FILE_INFO_MAP (obj);
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->map);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->id_map);
#line 9231 "DirectoryMonitor.c"
}


static GType directory_monitor_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}


static gpointer directory_monitor_file_info_map_ref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	return instance;
#line 9256 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_unref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9269 "DirectoryMonitor.c"
	}
}


static void directory_monitor_class_init (DirectoryMonitorClass * klass) {
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_type_class_add_private (klass, sizeof (DirectoryMonitorPrivate));
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_deleted = directory_monitor_real_notify_root_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_moved = directory_monitor_real_notify_root_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_started = directory_monitor_real_notify_discovery_started;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_file_discovered = directory_monitor_real_internal_notify_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_discovered = directory_monitor_real_notify_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_directory_discovered = directory_monitor_real_internal_notify_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_discovered = directory_monitor_real_notify_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_failed = directory_monitor_real_notify_discovery_failed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_completed = directory_monitor_real_notify_discovery_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = directory_monitor_real_notify_file_created;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = directory_monitor_real_notify_file_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = directory_monitor_real_notify_file_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = directory_monitor_real_notify_file_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = directory_monitor_real_notify_file_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = directory_monitor_real_notify_file_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_created = directory_monitor_real_notify_directory_created;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_moved = directory_monitor_real_notify_directory_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_altered = directory_monitor_real_notify_directory_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_alteration_completed = directory_monitor_real_notify_directory_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_attributes_altered = directory_monitor_real_notify_directory_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_deleted = directory_monitor_real_notify_directory_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_closed = directory_monitor_real_notify_closed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->close = directory_monitor_real_close;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->root_moved = directory_monitor_real_root_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->root_deleted = directory_monitor_real_root_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = directory_monitor_real_discovery_started;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = directory_monitor_real_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_discovered = directory_monitor_real_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_failed = directory_monitor_real_discovery_failed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = directory_monitor_real_discovery_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_created = directory_monitor_real_file_created;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_moved = directory_monitor_real_file_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_altered = directory_monitor_real_file_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_deleted = directory_monitor_real_file_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_created = directory_monitor_real_directory_created;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_moved = directory_monitor_real_directory_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_altered = directory_monitor_real_directory_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_deleted = directory_monitor_real_directory_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->closed = directory_monitor_real_closed;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("root_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("root_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("file_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, g_file_info_get_type ());
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("directory_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9407 "DirectoryMonitor.c"
}


static void directory_monitor_instance_init (DirectoryMonitor * self) {
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GCancellable* _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv = DIRECTORY_MONITOR_GET_PRIVATE (self);
#line 368 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 368 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->monitors = _tmp0_;
#line 369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, directory_monitor_query_info_queue_element_unref, NULL);
#line 369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->query_info_queue = GEE_QUEUE (_tmp1_);
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_new ();
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->files = _tmp2_;
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_new ();
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->parent_moved = _tmp3_;
#line 373 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_tmp4_ = g_cancellable_new ();
#line 373 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->cancellable = _tmp4_;
#line 374 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 0;
#line 375 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->started = FALSE;
#line 376 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 377 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self->priv->delete_timer_id = (guint) 0;
#line 9447 "DirectoryMonitor.c"
}


static void directory_monitor_finalize (GObject* obj) {
	DirectoryMonitor * self;
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR (obj);
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 368 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 369 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->query_info_queue);
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->files);
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
#line 373 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 60 "/builddir/build/BUILD/shotwell-0.12.0/src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
#line 9469 "DirectoryMonitor.c"
}


GType directory_monitor_get_type (void) {
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}



