/* ViewCollection.c generated by valac 0.16.0, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
typedef struct _ViewManagerPrivate ViewManagerPrivate;
typedef struct _ParamSpecViewManager ParamSpecViewManager;
typedef struct _ViewFilterPrivate ViewFilterPrivate;
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected_unselected) (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*notify_view_filter_installed) (ViewCollection* self, ViewFilter* filter);
	void (*notify_view_filter_removed) (ViewCollection* self, ViewFilter* filter);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*view_filter_installed) (ViewCollection* self, ViewFilter* filer);
	void (*view_filter_removed) (ViewCollection* self, ViewFilter* filer);
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*CreateViewPredicate) (DataSource* source, void* user_data);
struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};


static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
gpointer view_filter_ref (gpointer instance);
void view_filter_unref (gpointer instance);
GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_filter (GValue* value, gpointer v_object);
void value_take_view_filter (GValue* value, gpointer v_object);
gpointer value_get_view_filter (const GValue* value);
GType view_filter_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer view_collection_monitor_ref (gpointer instance);
void view_collection_monitor_unref (gpointer instance);
GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void view_collection_value_set_monitor (GValue* value, gpointer v_object);
void view_collection_value_take_monitor (GValue* value, gpointer v_object);
gpointer view_collection_value_get_monitor (const GValue* value);
GType view_collection_monitor_get_type (void) G_GNUC_CONST;
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
ViewCollection* view_collection_new (const gchar* name);
ViewCollection* view_collection_construct (GType object_type, const gchar* name);
DataCollection* data_collection_new (const gchar* name);
DataCollection* data_collection_construct (GType object_type, const gchar* name);
void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
void view_collection_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
gchar* data_collection_to_string (DataCollection* self);
void data_collection_clear (DataCollection* self);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_all_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self);
void data_collection_close (DataCollection* self);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target);
void data_collection_freeze_notifications (DataCollection* self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target);
GeeCollection* data_collection_get_all (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
Comparator data_collection_get_comparator (DataCollection* self, void** result_target);
ComparatorPredicate data_collection_get_comparator_predicate (DataCollection* self, void** result_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target);
DataSource* data_view_get_source (DataView* self);
gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f);
void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f);
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view);
gboolean view_filter_predicate (ViewFilter* self, DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added);
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self);
gboolean data_collection_add (DataCollection* self, DataObject* object);
static gboolean view_collection_real_add (DataCollection* base, DataObject* object);
void data_view_internal_set_visible (DataView* self, gboolean visible);
GeeCollection* data_collection_get_singleton (DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
Marker* data_collection_start_marking (DataCollection* self);
void marker_mark (Marker* self, DataObject* object);
gint marker_get_count (Marker* self);
void data_collection_remove_marked (DataCollection* self, Marker* m);
static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
gboolean data_set_contains (DataSet* self, DataObject* object);
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
void data_collection_notify_ordering_changed (DataCollection* self);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
gboolean data_set_remove (DataSet* self, DataObject* object);
static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
void data_set_reset_comparator (DataSet* self);
void data_collection_reset_comparator (DataCollection* self);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeList* data_set_get_all (DataSet* self);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint data_set_get_count (DataSet* self);
gint data_collection_get_count (DataCollection* self);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
DataObject* data_set_get_at (DataSet* self, gint index);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
gint data_set_index_of (DataSet* self, DataObject* object);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector);
gchar* data_source_get_typename (DataSource* self);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
gboolean data_set_remove_many (DataSet* self, GeeCollection* objects);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_select_all (ViewCollection* self);
void marker_mark_all (Marker* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_all (ViewCollection* self);
void marker_mark_many (Marker* self, GeeCollection* list);
GeeList* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source);
GeeCollection* view_collection_get_sources (ViewCollection* self);
gboolean view_collection_has_source_of_type (ViewCollection* self, GType t);
gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t);
GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t);
GeeList* view_collection_get_selected_sources (ViewCollection* self);
DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index);
GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t);
gint view_collection_index_of_source (ViewCollection* self, DataSource* source);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_thawed (DataCollection* base);
void data_collection_notify_thawed (DataCollection* self);
gboolean view_collection_are_items_filtered_out (ViewCollection* self);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_selection_group_altered (ViewCollection* self);
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible);
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer);
enum  {
	VIEW_COLLECTION_MONITOR_DUMMY_PROPERTY
};
ViewCollectionMonitor* view_collection_monitor_new (void);
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_MONITOR_IMPL_DUMMY_PROPERTY
};
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
enum  {
	VIEW_FILTER_DUMMY_PROPERTY
};
static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view);
ViewFilter* view_filter_construct (GType object_type);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter* obj);


ViewCollection* view_collection_construct (GType object_type, const gchar* name) {
	ViewCollection* self = NULL;
	const gchar* _tmp0_;
#line 126 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = name;
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, _tmp0_);
#line 126 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 668 "ViewCollection.c"
}


ViewCollection* view_collection_new (const gchar* name) {
#line 126 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 675 "ViewCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 682 "ViewCollection.c"
}


static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
	gboolean _tmp0_ = FALSE;
	GeeCollection* _tmp1_;
	gboolean _tmp5_;
	gboolean has_selected;
	gboolean _tmp6_ = FALSE;
	GeeCollection* _tmp7_;
	gboolean _tmp11_;
	gboolean has_unselected;
	gboolean _tmp12_;
	gboolean _tmp14_;
	GeeCollection* sum = NULL;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp19_;
	GeeCollection* _tmp37_;
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail ((selected == NULL) || GEE_IS_COLLECTION (selected));
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail ((unselected == NULL) || GEE_IS_COLLECTION (unselected));
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = selected;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 710 "ViewCollection.c"
		GeeCollection* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = selected;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = gee_collection_get_size (_tmp2_);
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ > 0;
#line 722 "ViewCollection.c"
	} else {
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = FALSE;
#line 726 "ViewCollection.c"
	}
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp0_;
#line 132 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	has_selected = _tmp5_;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = unselected;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp7_ != NULL) {
#line 736 "ViewCollection.c"
		GeeCollection* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = unselected;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp9_ = gee_collection_get_size (_tmp8_);
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp10_ = _tmp9_;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = _tmp10_ > 0;
#line 748 "ViewCollection.c"
	} else {
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = FALSE;
#line 752 "ViewCollection.c"
	}
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp11_ = _tmp6_;
#line 133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	has_unselected = _tmp11_;
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp12_ = has_selected;
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 762 "ViewCollection.c"
		GeeCollection* _tmp13_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp13_ = selected;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-selected", GEE_ITERABLE (_tmp13_));
#line 768 "ViewCollection.c"
	}
#line 138 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp14_ = has_unselected;
#line 138 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp14_) {
#line 774 "ViewCollection.c"
		GeeCollection* _tmp15_;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp15_ = unselected;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-unselected", GEE_ITERABLE (_tmp15_));
#line 780 "ViewCollection.c"
	}
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp17_ = has_selected;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp17_) {
#line 786 "ViewCollection.c"
		gboolean _tmp18_;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp18_ = has_unselected;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp16_ = !_tmp18_;
#line 792 "ViewCollection.c"
	} else {
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp16_ = FALSE;
#line 796 "ViewCollection.c"
	}
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp19_ = _tmp16_;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp19_) {
#line 802 "ViewCollection.c"
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp20_ = selected;
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (sum);
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		sum = _tmp21_;
#line 813 "ViewCollection.c"
	} else {
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_;
		gboolean _tmp25_;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp23_ = has_selected;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (!_tmp23_) {
#line 822 "ViewCollection.c"
			gboolean _tmp24_;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp24_ = has_unselected;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp22_ = _tmp24_;
#line 828 "ViewCollection.c"
		} else {
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp22_ = FALSE;
#line 832 "ViewCollection.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp25_ = _tmp22_;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp25_) {
#line 838 "ViewCollection.c"
			GeeCollection* _tmp26_;
			GeeCollection* _tmp27_;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp26_ = unselected;
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (sum);
#line 145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			sum = _tmp27_;
#line 849 "ViewCollection.c"
		} else {
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gboolean _tmp31_;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp29_ = has_selected;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp29_) {
#line 858 "ViewCollection.c"
				gboolean _tmp30_;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp30_ = has_unselected;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp28_ = !_tmp30_;
#line 864 "ViewCollection.c"
			} else {
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp28_ = FALSE;
#line 868 "ViewCollection.c"
			}
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp31_ = _tmp28_;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp31_) {
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				sum = NULL;
#line 878 "ViewCollection.c"
			} else {
				GeeHashSet* _tmp32_;
				GeeCollection* _tmp33_;
				GeeCollection* _tmp34_;
				GeeCollection* _tmp35_;
				GeeCollection* _tmp36_;
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp32_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 149 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				sum = GEE_COLLECTION (_tmp32_);
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp33_ = sum;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp34_ = selected;
#line 150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp33_, _tmp34_);
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp35_ = sum;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp36_ = unselected;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp35_, _tmp36_);
#line 903 "ViewCollection.c"
			}
		}
	}
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp37_ = sum;
#line 154 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp37_ != NULL) {
#line 911 "ViewCollection.c"
		GeeCollection* _tmp38_;
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp38_ = sum;
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (_tmp38_));
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 919 "ViewCollection.c"
	}
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (sum);
#line 923 "ViewCollection.c"
}


void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected_unselected (self, selected, unselected);
#line 932 "ViewCollection.c"
}


static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "selection-group-altered");
#line 939 "ViewCollection.c"
}


void view_collection_notify_selection_group_altered (ViewCollection* self) {
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 160 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 948 "ViewCollection.c"
}


static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
	DataView* _tmp0_;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = view;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", _tmp0_);
#line 960 "ViewCollection.c"
}


void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 969 "ViewCollection.c"
}


static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "views-altered", _tmp0_);
#line 981 "ViewCollection.c"
}


void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 990 "ViewCollection.c"
}


static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
	DataView* _tmp0_;
#line 172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = view;
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", _tmp0_);
#line 1002 "ViewCollection.c"
}


void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 1011 "ViewCollection.c"
}


static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 177 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", _tmp0_);
#line 1023 "ViewCollection.c"
}


void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 1032 "ViewCollection.c"
}


static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
	GeeCollection* _tmp0_;
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (shown));
#line 181 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = shown;
#line 181 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-shown", _tmp0_);
#line 1044 "ViewCollection.c"
}


void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
#line 1053 "ViewCollection.c"
}


static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
	GeeCollection* _tmp0_;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = hidden;
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-hidden", _tmp0_);
#line 1065 "ViewCollection.c"
}


void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
#line 1074 "ViewCollection.c"
}


static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
	GeeCollection* _tmp0_;
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = changed;
#line 189 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-visibility-changed", _tmp0_);
#line 1086 "ViewCollection.c"
}


void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
#line 1095 "ViewCollection.c"
}


static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
	ViewFilter* _tmp0_;
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 193 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = filter;
#line 193 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "view-filter-installed", _tmp0_);
#line 1107 "ViewCollection.c"
}


void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 192 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_installed (self, filter);
#line 1116 "ViewCollection.c"
}


static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
	ViewFilter* _tmp0_;
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = filter;
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "view-filter-removed", _tmp0_);
#line 1128 "ViewCollection.c"
}


void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_removed (self, filter);
#line 1137 "ViewCollection.c"
}


static void view_collection_real_clear (DataCollection* base) {
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	GeeHashMultiMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp5_;
#line 200 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_multi_map_get_size (GEE_MULTI_MAP (_tmp1_));
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_ > 0) {
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 1160 "ViewCollection.c"
	} else {
		ViewCollection* _tmp4_;
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->mirroring;
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1167 "ViewCollection.c"
	}
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp0_;
#line 203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_) {
#line 1173 "ViewCollection.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
#line 204 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = data_collection_to_string (DATA_COLLECTION (self));
#line 204 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = _tmp6_;
#line 204 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_warning ("ViewCollection.vala:204: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp7_);
#line 204 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_free0 (_tmp7_);
#line 206 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 1186 "ViewCollection.c"
	}
#line 209 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (DATA_COLLECTION (self));
#line 1190 "ViewCollection.c"
}


static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self) {
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 1197 "ViewCollection.c"
}


static void view_collection_real_close (DataCollection* base) {
	ViewCollection * self;
	GeeSet* _tmp8_;
#line 212 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 1210 "ViewCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1223 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			ViewFilter* f;
			ViewFilter* _tmp6_;
			guint _tmp7_ = 0U;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 1239 "ViewCollection.c"
			}
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp5_;
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = f;
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp7_, NULL, FALSE);
#line 216 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1255 "ViewCollection.c"
		}
#line 215 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 1259 "ViewCollection.c"
	}
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = self->priv->filters;
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_collection_clear (GEE_COLLECTION (_tmp8_));
#line 219 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
#line 1267 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	ViewCollectionMonitor* result = NULL;
	SourceCollection* _tmp0_;
	ViewManager* _tmp1_;
	Alteration* _tmp2_;
	ViewCollectionMonitorImpl* _tmp3_;
	ViewCollectionMonitorImpl* monitor;
	GeeHashMultiMap* _tmp4_;
	SourceCollection* _tmp5_;
	ViewCollectionMonitorImpl* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GeeCollection* _tmp8_;
	gboolean _tmp12_;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((initial == NULL) || GEE_IS_COLLECTION (initial), NULL);
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_freeze_notifications (DATA_COLLECTION (self));
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = sources;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = manager;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = prereq;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_monitor_impl_new (self, _tmp0_, _tmp1_, _tmp2_);
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	monitor = _tmp3_;
#line 232 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = self->priv->monitors;
#line 232 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = sources;
#line 232 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = monitor;
#line 232 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_multi_map_set (GEE_MULTI_MAP (_tmp4_), _tmp5_, _tmp6_);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = initial;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp8_ != NULL) {
#line 1320 "ViewCollection.c"
		GeeCollection* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp9_ = initial;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp10_ = gee_collection_get_size (_tmp9_);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp11_ = _tmp10_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = _tmp11_ > 0;
#line 1332 "ViewCollection.c"
	} else {
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = FALSE;
#line 1336 "ViewCollection.c"
	}
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp12_ = _tmp7_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 1342 "ViewCollection.c"
		GeeArrayList* _tmp13_;
		GeeArrayList* created_views;
		GeeArrayList* _tmp25_;
		ProgressMonitor _tmp26_;
		void* _tmp26__target;
		GeeCollection* _tmp27_ = NULL;
		GeeCollection* _tmp28_;
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp13_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 236 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		created_views = _tmp13_;
#line 1354 "ViewCollection.c"
		{
			GeeCollection* _tmp14_;
			GeeIterator* _tmp15_ = NULL;
			GeeIterator* _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = initial;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = gee_iterable_iterator (GEE_ITERABLE (_tmp14_));
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_source_it = _tmp15_;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 1367 "ViewCollection.c"
				GeeIterator* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GeeIterator* _tmp18_;
				gpointer _tmp19_ = NULL;
				DataSource* source;
				GeeArrayList* _tmp20_;
				ViewManager* _tmp21_;
				DataSource* _tmp22_;
				DataView* _tmp23_ = NULL;
				DataView* _tmp24_;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = gee_iterator_next (_tmp16_);
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp17_) {
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 1386 "ViewCollection.c"
				}
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				source = (DataSource*) _tmp19_;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp20_ = created_views;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp21_ = manager;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp22_ = source;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = view_manager_create_view (_tmp21_, _tmp22_);
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp24_ = _tmp23_;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp20_), _tmp24_);
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp24_);
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1410 "ViewCollection.c"
			}
#line 237 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_source_it);
#line 1414 "ViewCollection.c"
		}
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp25_ = created_views;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp26_ = progress_monitor;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp26__target = progress_monitor_target;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp27_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp25_), _tmp26_, _tmp26__target);
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp28_ = _tmp27_;
#line 240 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp28_);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (created_views);
#line 1430 "ViewCollection.c"
	} else {
		SourceCollection* _tmp29_;
		SourceCollection* _tmp30_;
		GeeCollection* _tmp31_ = NULL;
		GeeIterable* _tmp32_;
		ProgressMonitor _tmp33_;
		void* _tmp33__target;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp29_ = sources;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp30_ = sources;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp31_ = data_collection_get_all (DATA_COLLECTION (_tmp30_));
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp32_ = GEE_ITERABLE (_tmp31_);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp33_ = progress_monitor;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp33__target = progress_monitor_target;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_add_sources (self, _tmp29_, _tmp32_, _tmp33_, _tmp33__target);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp32_);
#line 1454 "ViewCollection.c"
	}
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_thaw_notifications (DATA_COLLECTION (self));
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = VIEW_COLLECTION_MONITOR (monitor);
#line 248 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 1462 "ViewCollection.c"
}


static gpointer _view_collection_monitor_ref0 (gpointer self) {
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self ? view_collection_monitor_ref (self) : NULL;
#line 1469 "ViewCollection.c"
}


void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m) {
	ViewCollectionMonitor* _tmp0_;
	ViewCollectionMonitorImpl* _tmp1_;
	ViewCollectionMonitorImpl* monitor;
	GeeHashMultiMap* _tmp2_;
	SourceCollection* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean removed;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (VIEW_COLLECTION_IS_MONITOR (m));
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = m;
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _view_collection_monitor_ref0 (VIEW_COLLECTION_MONITOR_IMPL (_tmp0_));
#line 252 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	monitor = _tmp1_;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->monitors;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = monitor->sources;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = gee_multi_map_remove (GEE_MULTI_MAP (_tmp2_), _tmp3_, monitor);
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	removed = _tmp4_;
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (removed);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_view_collection_monitor_unref0 (monitor);
#line 1503 "ViewCollection.c"
}


void view_collection_halt_all_monitoring (ViewCollection* self) {
	GeeHashMultiMap* _tmp0_;
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->monitors;
#line 259 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_multi_map_clear (GEE_MULTI_MAP (_tmp0_));
#line 1515 "ViewCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1522 "ViewCollection.c"
}


static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 276 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, added);
#line 1529 "ViewCollection.c"
}


static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_removed (self, removed);
#line 1536 "ViewCollection.c"
}


void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target) {
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	CreateView _tmp2_;
	void* _tmp2__target;
	CreateViewPredicate _tmp3_;
	void* _tmp3__target;
	ViewCollection* _tmp4_;
	void* _tmp5_ = NULL;
	Comparator _tmp6_ = NULL;
	ViewCollection* _tmp7_;
	void* _tmp8_ = NULL;
	ComparatorPredicate _tmp9_ = NULL;
	ViewCollection* _tmp10_;
	GeeCollection* _tmp11_ = NULL;
	GeeCollection* _tmp12_;
	ViewCollection* _tmp13_;
	ViewCollection* _tmp14_;
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 262 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 264 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 265 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = to_mirror;
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring = _tmp1_;
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = mirroring_ctor;
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2__target = mirroring_ctor_target;
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = _tmp2_;
#line 269 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = _tmp2__target;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = should_mirror;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3__target = should_mirror_target;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->should_mirror = _tmp3_;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->should_mirror_target = _tmp3__target;
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = to_mirror;
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_comparator (DATA_COLLECTION (_tmp4_), &_tmp5_);
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = to_mirror;
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = data_collection_get_comparator_predicate (DATA_COLLECTION (_tmp7_), &_tmp8_);
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_set_comparator (DATA_COLLECTION (self), _tmp6_, _tmp5_, _tmp9_, _tmp8_);
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp10_ = self->priv->mirroring;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp11_ = data_collection_get_all (DATA_COLLECTION (_tmp10_));
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp12_ = _tmp11_;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, GEE_ITERABLE (_tmp12_));
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp12_);
#line 276 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp13_ = self->priv->mirroring;
#line 276 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (DATA_COLLECTION (_tmp13_), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp14_ = self->priv->mirroring;
#line 277 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (DATA_COLLECTION (_tmp14_), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1620 "ViewCollection.c"
}


void view_collection_halt_mirroring (ViewCollection* self) {
	ViewCollection* _tmp0_;
#line 280 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 281 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->mirroring;
#line 281 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 1632 "ViewCollection.c"
		ViewCollection* _tmp1_;
		guint _tmp2_ = 0U;
		ViewCollection* _tmp3_;
		guint _tmp4_ = 0U;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = self->priv->mirroring;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp1_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = self->priv->mirroring;
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp3_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1649 "ViewCollection.c"
	}
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 1655 "ViewCollection.c"
}


void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target) {
	GeeArrayList* _tmp0_;
	GeeArrayList* copy_view;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_copy));
#line 292 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 292 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	copy_view = _tmp0_;
#line 1673 "ViewCollection.c"
	{
		ViewCollection* _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = to_copy;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (DATA_COLLECTION (_tmp1_));
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1697 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataView* _tmp11_;
			DataView* view;
			CreateViewPredicate _tmp12_;
			void* _tmp12__target;
			DataView* _tmp13_;
			DataSource* _tmp14_ = NULL;
			DataSource* _tmp15_;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 1721 "ViewCollection.c"
			}
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (DATA_VIEW (_tmp10_));
#line 294 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = _tmp11_;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = should_copy;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12__target = should_copy_target;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = view;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = data_view_get_source (_tmp13_);
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = _tmp14_;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp16_ = _tmp12_ (_tmp15_, _tmp12__target);
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp17_ = _tmp16_;
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp15_);
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp17_) {
#line 1753 "ViewCollection.c"
				GeeArrayList* _tmp18_;
				CreateView _tmp19_;
				void* _tmp19__target;
				DataView* _tmp20_;
				DataSource* _tmp21_ = NULL;
				DataSource* _tmp22_;
				DataView* _tmp23_ = NULL;
				DataView* _tmp24_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = copy_view;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = copying_ctor;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19__target = copying_ctor_target;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp20_ = view;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp21_ = data_view_get_source (_tmp20_);
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp22_ = _tmp21_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = _tmp19_ (_tmp22_, _tmp19__target);
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp24_ = _tmp23_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp18_), DATA_OBJECT (_tmp24_));
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp24_);
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp22_);
#line 1784 "ViewCollection.c"
			}
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 1790 "ViewCollection.c"
		}
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 1794 "ViewCollection.c"
	}
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp25_ = copy_view;
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp26_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp25_), NULL, NULL);
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp27_ = _tmp26_;
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp27_);
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (copy_view);
#line 1806 "ViewCollection.c"
}


gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f) {
	gboolean result = FALSE;
	GeeSet* _tmp0_;
	ViewFilter* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 302 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (f), FALSE);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = f;
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_contains (GEE_COLLECTION (_tmp0_), _tmp1_);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 1829 "ViewCollection.c"
}


void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f) {
	ViewFilter* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeSet* _tmp2_;
	ViewFilter* _tmp3_;
	ViewFilter* _tmp4_;
	ViewFilter* _tmp5_;
#line 306 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 306 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = f;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_is_view_filter_installed (self, _tmp0_);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_) {
#line 308 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 1852 "ViewCollection.c"
	}
#line 310 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->filters;
#line 310 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = f;
#line 310 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_collection_add (GEE_COLLECTION (_tmp2_), _tmp3_);
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = f;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (_tmp4_, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 317 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = f;
#line 317 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_installed (self, _tmp5_);
#line 1870 "ViewCollection.c"
}


void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f) {
	ViewFilter* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeSet* _tmp2_;
	ViewFilter* _tmp3_;
	ViewFilter* _tmp4_;
	guint _tmp5_ = 0U;
	ViewFilter* _tmp6_;
#line 320 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 320 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = f;
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_is_view_filter_installed (self, _tmp0_);
#line 321 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp1_) {
#line 322 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 1894 "ViewCollection.c"
	}
#line 324 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->filters;
#line 324 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = f;
#line 324 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_collection_remove (GEE_COLLECTION (_tmp2_), _tmp3_);
#line 325 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = f;
#line 325 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp5_, NULL, FALSE);
#line 325 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 331 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = f;
#line 331 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_removed (self, _tmp6_);
#line 1914 "ViewCollection.c"
}


static void view_collection_on_view_filter_refresh (ViewCollection* self) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_;
#line 334 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 335 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 335 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = GEE_COLLECTION (_tmp0_);
#line 335 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 335 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1931 "ViewCollection.c"
}


static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 1941 "ViewCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1954 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			ViewFilter* f;
			ViewFilter* _tmp6_;
			DataView* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 1971 "ViewCollection.c"
			}
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp5_;
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = f;
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = view_filter_predicate (_tmp6_, _tmp7_);
#line 341 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp8_) {
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				result = FALSE;
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_view_filter_unref0 (f);
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_f_it);
#line 342 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				return result;
#line 1995 "ViewCollection.c"
			}
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1999 "ViewCollection.c"
		}
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 2003 "ViewCollection.c"
	}
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 344 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 2009 "ViewCollection.c"
}


static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
#line 347 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 347 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = IS_DATA_VIEW (_tmp0_);
#line 348 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 2027 "ViewCollection.c"
}


static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added) {
	DataCollection* _tmp0_;
	GeeIterable* _tmp1_;
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (sources));
#line 351 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = sources;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = added;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_add_sources (self, SOURCE_COLLECTION (_tmp0_), _tmp1_, NULL, NULL);
#line 2046 "ViewCollection.c"
}


static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self) {
	DataView* result;
	result = view_manager_create_view (self, source);
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 2055 "ViewCollection.c"
}


static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	DataView* created_view;
	GeeArrayList* created_views;
	DataView* _tmp37_;
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 359 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	created_view = NULL;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	created_views = NULL;
#line 2073 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = added;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_source_it = _tmp1_;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2086 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataSource* source;
			CreateView factory;
			void* factory_target;
			GDestroyNotify factory_target_destroy_notify;
			CreateView _tmp22_;
			void* _tmp22__target;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 2105 "ViewCollection.c"
			}
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp5_;
#line 362 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory = NULL;
#line 362 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 362 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 2119 "ViewCollection.c"
			{
				GeeHashMultiMap* _tmp6_;
				SourceCollection* _tmp7_;
				GeeCollection* _tmp8_ = NULL;
				GeeCollection* _tmp9_;
				GeeIterator* _tmp10_ = NULL;
				GeeIterator* _tmp11_;
				GeeIterator* _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp6_ = self->priv->monitors;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp7_ = sources;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp8_ = gee_multi_map_get (GEE_MULTI_MAP (_tmp6_), _tmp7_);
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = _tmp8_;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11_ = _tmp10_;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp9_);
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_monitor_it = _tmp11_;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2146 "ViewCollection.c"
					GeeIterator* _tmp12_;
					gboolean _tmp13_ = FALSE;
					GeeIterator* _tmp14_;
					gpointer _tmp15_ = NULL;
					ViewCollectionMonitorImpl* monitor;
					ViewCollectionMonitorImpl* _tmp16_;
					ViewManager* _tmp17_;
					DataSource* _tmp18_;
					gboolean _tmp19_ = FALSE;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp12_ = _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp13_ = gee_iterator_next (_tmp12_);
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (!_tmp13_) {
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						break;
#line 2164 "ViewCollection.c"
					}
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp14_ = _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) _tmp15_;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp16_ = monitor;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp17_ = _tmp16_->manager;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp18_ = source;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp19_ = view_manager_include_in_view (_tmp17_, _tmp18_);
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp19_) {
#line 2182 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp20_;
						ViewManager* _tmp21_;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp20_ = monitor;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp21_ = _tmp20_->manager;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory_target = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory_target_destroy_notify = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory = _view_manager_create_view_create_view;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory_target = view_manager_ref (_tmp21_);
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						factory_target_destroy_notify = view_manager_unref;
#line 367 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 367 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						break;
#line 2207 "ViewCollection.c"
					}
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor);
#line 2211 "ViewCollection.c"
				}
#line 363 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_it);
#line 2215 "ViewCollection.c"
			}
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp22_ = factory;
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp22__target = factory_target;
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp22_ != NULL) {
#line 2223 "ViewCollection.c"
				CreateView _tmp23_;
				void* _tmp23__target;
				DataSource* _tmp24_;
				DataView* _tmp25_ = NULL;
				DataView* new_view;
				GeeArrayList* _tmp26_;
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = factory;
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23__target = factory_target;
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp24_ = source;
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp25_ = _tmp23_ (_tmp24_, _tmp23__target);
#line 372 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				new_view = _tmp25_;
#line 376 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp26_ = created_views;
#line 376 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp26_ != NULL) {
#line 2244 "ViewCollection.c"
					GeeArrayList* _tmp27_;
					DataView* _tmp28_;
#line 377 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp27_ = created_views;
#line 377 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp28_ = new_view;
#line 377 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp27_), _tmp28_);
#line 2253 "ViewCollection.c"
				} else {
					DataView* _tmp29_;
#line 378 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp29_ = created_view;
#line 378 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp29_ == NULL) {
#line 2260 "ViewCollection.c"
						DataView* _tmp30_;
						DataView* _tmp31_;
#line 379 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp30_ = new_view;
#line 379 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp31_ = _g_object_ref0 (_tmp30_);
#line 379 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 379 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						created_view = _tmp31_;
#line 2271 "ViewCollection.c"
					} else {
						GeeArrayList* _tmp32_;
						GeeArrayList* _tmp33_;
						DataView* _tmp34_;
						GeeArrayList* _tmp35_;
						DataView* _tmp36_;
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp32_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (created_views);
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						created_views = _tmp32_;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp33_ = created_views;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp34_ = created_view;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp33_), _tmp34_);
#line 383 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 383 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						created_view = NULL;
#line 384 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp35_ = created_views;
#line 384 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp36_ = new_view;
#line 384 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp35_), _tmp36_);
#line 2300 "ViewCollection.c"
					}
				}
#line 371 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (new_view);
#line 2305 "ViewCollection.c"
			}
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2317 "ViewCollection.c"
		}
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2321 "ViewCollection.c"
	}
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp37_ = created_view;
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp37_ != NULL) {
#line 2327 "ViewCollection.c"
		DataView* _tmp38_;
#line 390 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp38_ = created_view;
#line 390 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (_tmp38_));
#line 2333 "ViewCollection.c"
	} else {
		gboolean _tmp39_ = FALSE;
		GeeArrayList* _tmp40_;
		gboolean _tmp44_;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp40_ = created_views;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp40_ != NULL) {
#line 2342 "ViewCollection.c"
			GeeArrayList* _tmp41_;
			gint _tmp42_;
			gint _tmp43_;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp41_ = created_views;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp42_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp41_));
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp43_ = _tmp42_;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp39_ = _tmp43_ > 0;
#line 2354 "ViewCollection.c"
		} else {
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp39_ = FALSE;
#line 2358 "ViewCollection.c"
		}
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp44_ = _tmp39_;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp44_) {
#line 2364 "ViewCollection.c"
			GeeArrayList* _tmp45_;
			ProgressMonitor _tmp46_;
			void* _tmp46__target;
			GeeCollection* _tmp47_ = NULL;
			GeeCollection* _tmp48_;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp45_ = created_views;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp46_ = progress_monitor;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp46__target = progress_monitor_target;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp47_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp45_), _tmp46_, _tmp46__target);
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp48_ = _tmp47_;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp48_);
#line 2382 "ViewCollection.c"
		}
	}
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (created_views);
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (created_view);
#line 2389 "ViewCollection.c"
}


static gboolean view_collection_real_add (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataObject* _tmp1_;
	gboolean _tmp2_ = FALSE;
	DataObject* _tmp3_;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* _tmp5_;
#line 395 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 395 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 396 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 396 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_view_internal_set_visible (DATA_VIEW (_tmp0_), TRUE);
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = object;
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add (DATA_COLLECTION (self), _tmp1_);
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp2_) {
#line 399 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = FALSE;
#line 399 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 2420 "ViewCollection.c"
	}
#line 401 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = object;
#line 401 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_singleton (_tmp3_);
#line 401 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = GEE_COLLECTION (_tmp4_);
#line 401 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp5_);
#line 401 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp5_);
#line 403 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 403 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 2436 "ViewCollection.c"
}


static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp7_;
	ProgressMonitor _tmp8_;
	void* _tmp8__target;
	GeeCollection* _tmp9_ = NULL;
	GeeCollection* return_list;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 2452 "ViewCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = objects;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2465 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 2480 "ViewCollection.c"
			}
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 409 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 409 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			data_view_internal_set_visible (DATA_VIEW (_tmp6_), TRUE);
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2494 "ViewCollection.c"
		}
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2498 "ViewCollection.c"
	}
#line 411 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = objects;
#line 411 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = monitor;
#line 411 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8__target = monitor_target;
#line 411 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (DATA_COLLECTION (self), _tmp7_, _tmp8_, _tmp8__target);
#line 411 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return_list = _tmp9_;
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (return_list));
#line 415 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = return_list;
#line 415 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 2516 "ViewCollection.c"
}


static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* marker;
	gboolean _tmp14_ = FALSE;
	Marker* _tmp15_;
	gboolean _tmp18_;
#line 418 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 418 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker = NULL;
#line 2531 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = removed;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_source_it = _tmp1_;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2544 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataSource* source;
			GeeHashMap* _tmp6_;
			DataSource* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataView* view;
			DataView* _tmp9_;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 2563 "ViewCollection.c"
			}
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp5_;
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = source;
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_);
#line 422 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = (DataView*) _tmp8_;
#line 425 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 425 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp9_ != NULL) {
#line 2583 "ViewCollection.c"
				Marker* _tmp10_;
				Marker* _tmp12_;
				DataView* _tmp13_;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp10_ = marker;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp10_ == NULL) {
#line 2591 "ViewCollection.c"
					Marker* _tmp11_ = NULL;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp11_ = data_collection_start_marking (DATA_COLLECTION (self));
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (marker);
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					marker = _tmp11_;
#line 2599 "ViewCollection.c"
				}
#line 429 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = marker;
#line 429 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 429 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				marker_mark (_tmp12_, DATA_OBJECT (_tmp13_));
#line 2607 "ViewCollection.c"
			}
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2613 "ViewCollection.c"
		}
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2617 "ViewCollection.c"
	}
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp15_ != NULL) {
#line 2623 "ViewCollection.c"
		Marker* _tmp16_;
		gint _tmp17_ = 0;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp16_ = marker;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp17_ = marker_get_count (_tmp16_);
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp14_ = _tmp17_ != 0;
#line 2632 "ViewCollection.c"
	} else {
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp14_ = FALSE;
#line 2636 "ViewCollection.c"
	}
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp18_ = _tmp14_;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp18_) {
#line 2642 "ViewCollection.c"
		Marker* _tmp19_;
#line 434 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp19_ = marker;
#line 434 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), _tmp19_);
#line 2648 "ViewCollection.c"
	}
#line 418 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 2652 "ViewCollection.c"
}


static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items) {
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	gboolean ordering_changed;
	GeeArrayList* _tmp87_;
	GeeArrayList* _tmp91_;
	gboolean _tmp95_;
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 440 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	to_add = NULL;
#line 441 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	to_remove = NULL;
#line 442 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	ordering_changed = FALSE;
#line 2675 "ViewCollection.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = items;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2702 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* alteration;
			DataObject* _tmp13_;
			DataSource* _tmp14_;
			DataSource* source;
			ViewCollectionMonitorImpl* monitor;
			gboolean ignored;
			gboolean _tmp39_;
			gboolean _tmp41_ = FALSE;
			ViewCollectionMonitorImpl* _tmp42_;
			gboolean _tmp45_;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 2729 "ViewCollection.c"
			}
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 444 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = items;
#line 444 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = object;
#line 444 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 444 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			alteration = (Alteration*) _tmp12_;
#line 445 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = object;
#line 445 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = _g_object_ref0 (DATA_SOURCE (_tmp13_));
#line 445 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = _tmp14_;
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			monitor = NULL;
#line 448 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			ignored = TRUE;
#line 2755 "ViewCollection.c"
			{
				GeeHashMultiMap* _tmp15_;
				DataCollection* _tmp16_;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* _tmp18_;
				GeeIterator* _tmp19_ = NULL;
				GeeIterator* _tmp20_;
				GeeIterator* _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = self->priv->monitors;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = collection;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = gee_multi_map_get (GEE_MULTI_MAP (_tmp15_), SOURCE_COLLECTION (_tmp16_));
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = _tmp17_;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = gee_iterable_iterator (GEE_ITERABLE (_tmp18_));
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp20_ = _tmp19_;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp18_);
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_monitor_impl_it = _tmp20_;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2782 "ViewCollection.c"
					GeeIterator* _tmp21_;
					gboolean _tmp22_ = FALSE;
					GeeIterator* _tmp23_;
					gpointer _tmp24_ = NULL;
					ViewCollectionMonitorImpl* monitor_impl;
					gboolean _tmp25_ = FALSE;
					ViewCollectionMonitorImpl* _tmp26_;
					Alteration* _tmp27_;
					gboolean _tmp32_;
					ViewCollectionMonitorImpl* _tmp33_;
					ViewManager* _tmp34_;
					DataSource* _tmp35_;
					gboolean _tmp36_ = FALSE;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp21_ = _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp22_ = gee_iterator_next (_tmp21_);
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (!_tmp22_) {
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						break;
#line 2804 "ViewCollection.c"
					}
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp23_ = _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp24_;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp26_ = monitor_impl;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp27_ = _tmp26_->prereq;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp27_ != NULL) {
#line 2818 "ViewCollection.c"
						Alteration* _tmp28_;
						ViewCollectionMonitorImpl* _tmp29_;
						Alteration* _tmp30_;
						gboolean _tmp31_ = FALSE;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp28_ = alteration;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp29_ = monitor_impl;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp30_ = _tmp29_->prereq;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp31_ = alteration_contains_any (_tmp28_, _tmp30_);
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp25_ = !_tmp31_;
#line 2833 "ViewCollection.c"
					} else {
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp25_ = FALSE;
#line 2837 "ViewCollection.c"
					}
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp32_ = _tmp25_;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp32_) {
#line 451 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 451 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						continue;
#line 2847 "ViewCollection.c"
					}
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					ignored = FALSE;
#line 455 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp33_ = monitor_impl;
#line 455 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp34_ = _tmp33_->manager;
#line 455 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp35_ = source;
#line 455 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp36_ = view_manager_include_in_view (_tmp34_, _tmp35_);
#line 455 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp36_) {
#line 2861 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp37_;
						ViewCollectionMonitorImpl* _tmp38_;
#line 456 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp37_ = monitor_impl;
#line 456 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp38_ = _view_collection_monitor_ref0 (_tmp37_);
#line 456 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 456 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						monitor = _tmp38_;
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						break;
#line 2876 "ViewCollection.c"
					}
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor_impl);
#line 2880 "ViewCollection.c"
				}
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_impl_it);
#line 2884 "ViewCollection.c"
			}
#line 462 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp39_ = ignored;
#line 462 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp39_) {
#line 2890 "ViewCollection.c"
				ViewCollectionMonitorImpl* _tmp40_;
#line 463 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp40_ = monitor;
#line 463 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				g_assert (_tmp40_ == NULL);
#line 465 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_view_collection_monitor_unref0 (monitor);
#line 465 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 465 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_alteration_unref0 (alteration);
#line 465 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (object);
#line 465 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				continue;
#line 2906 "ViewCollection.c"
			}
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp42_ = monitor;
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp42_ != NULL) {
#line 2912 "ViewCollection.c"
				DataSource* _tmp43_;
				gboolean _tmp44_ = FALSE;
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp43_ = source;
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp44_ = view_collection_has_view_for_source (self, _tmp43_);
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp41_ = !_tmp44_;
#line 2921 "ViewCollection.c"
			} else {
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp41_ = FALSE;
#line 2925 "ViewCollection.c"
			}
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp45_ = _tmp41_;
#line 468 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp45_) {
#line 2931 "ViewCollection.c"
				GeeArrayList* _tmp46_;
				GeeArrayList* _tmp48_;
				ViewCollectionMonitorImpl* _tmp49_;
				ViewManager* _tmp50_;
				DataSource* _tmp51_;
				DataView* _tmp52_ = NULL;
				DataView* _tmp53_;
#line 469 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp46_ = to_add;
#line 469 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp46_ == NULL) {
#line 2943 "ViewCollection.c"
					GeeArrayList* _tmp47_;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp47_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (to_add);
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					to_add = _tmp47_;
#line 2951 "ViewCollection.c"
				}
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp48_ = to_add;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp49_ = monitor;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp50_ = _tmp49_->manager;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp51_ = source;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp52_ = view_manager_create_view (_tmp50_, _tmp51_);
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp53_ = _tmp52_;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp48_), _tmp53_);
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp53_);
#line 2969 "ViewCollection.c"
			} else {
				gboolean _tmp54_ = FALSE;
				ViewCollectionMonitorImpl* _tmp55_;
				gboolean _tmp58_;
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp55_ = monitor;
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp55_ == NULL) {
#line 2978 "ViewCollection.c"
					DataSource* _tmp56_;
					gboolean _tmp57_ = FALSE;
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp56_ = source;
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp57_ = view_collection_has_view_for_source (self, _tmp56_);
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp54_ = _tmp57_;
#line 2987 "ViewCollection.c"
				} else {
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp54_ = FALSE;
#line 2991 "ViewCollection.c"
				}
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp58_ = _tmp54_;
#line 473 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp58_) {
#line 2997 "ViewCollection.c"
					GeeArrayList* _tmp59_;
					GeeArrayList* _tmp61_;
					DataSource* _tmp62_;
					DataView* _tmp63_ = NULL;
					DataView* _tmp64_;
#line 474 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp59_ = to_remove;
#line 474 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp59_ == NULL) {
#line 3007 "ViewCollection.c"
						GeeArrayList* _tmp60_;
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp60_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (to_remove);
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						to_remove = _tmp60_;
#line 3015 "ViewCollection.c"
					}
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp61_ = to_remove;
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp62_ = source;
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp63_ = view_collection_get_view_for_source (self, _tmp62_);
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp64_ = _tmp63_;
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp61_), _tmp64_);
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp64_);
#line 3029 "ViewCollection.c"
				} else {
					gboolean _tmp65_ = FALSE;
					ViewCollectionMonitorImpl* _tmp66_;
					gboolean _tmp69_;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp66_ = monitor;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp66_ != NULL) {
#line 3038 "ViewCollection.c"
						DataSource* _tmp67_;
						gboolean _tmp68_ = FALSE;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp67_ = source;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp68_ = view_collection_has_view_for_source (self, _tmp67_);
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp65_ = _tmp68_;
#line 3047 "ViewCollection.c"
					} else {
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp65_ = FALSE;
#line 3051 "ViewCollection.c"
					}
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp69_ = _tmp65_;
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp69_) {
#line 3057 "ViewCollection.c"
						DataSource* _tmp70_;
						DataView* _tmp71_ = NULL;
						DataView* view;
						DataSet* _tmp72_;
						DataView* _tmp73_;
						gboolean _tmp74_ = FALSE;
						gboolean _tmp78_ = FALSE;
						DataSet* _tmp79_;
						gboolean _tmp82_;
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp70_ = source;
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp71_ = view_collection_get_view_for_source (self, _tmp70_);
#line 479 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						view = _tmp71_;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp72_ = self->priv->selected;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp73_ = view;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp74_ = data_set_contains (_tmp72_, DATA_OBJECT (_tmp73_));
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						if (_tmp74_) {
#line 3081 "ViewCollection.c"
							DataSet* _tmp75_;
							DataView* _tmp76_;
							Alteration* _tmp77_;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp75_ = self->priv->selected;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp76_ = view;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp77_ = alteration;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							data_set_resort_object (_tmp75_, DATA_OBJECT (_tmp76_), _tmp77_);
#line 3093 "ViewCollection.c"
						}
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp79_ = self->priv->visible;
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						if (_tmp79_ != NULL) {
#line 3099 "ViewCollection.c"
							DataView* _tmp80_;
							gboolean _tmp81_ = FALSE;
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp80_ = view;
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp81_ = view_collection_is_visible (self, _tmp80_);
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp78_ = _tmp81_;
#line 3108 "ViewCollection.c"
						} else {
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp78_ = FALSE;
#line 3112 "ViewCollection.c"
						}
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp82_ = _tmp78_;
#line 484 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						if (_tmp82_) {
#line 3118 "ViewCollection.c"
							DataSet* _tmp83_;
							DataView* _tmp84_;
							Alteration* _tmp85_;
							gboolean _tmp86_ = FALSE;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp83_ = self->priv->visible;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp84_ = view;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp85_ = alteration;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							_tmp86_ = data_set_resort_object (_tmp83_, DATA_OBJECT (_tmp84_), _tmp85_);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
							if (_tmp86_) {
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
								ordering_changed = TRUE;
#line 3135 "ViewCollection.c"
							}
						}
#line 478 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (view);
#line 3140 "ViewCollection.c"
					}
				}
			}
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_collection_monitor_unref0 (monitor);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_alteration_unref0 (alteration);
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3152 "ViewCollection.c"
		}
#line 443 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3156 "ViewCollection.c"
	}
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp87_ = to_add;
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp87_ != NULL) {
#line 3162 "ViewCollection.c"
		GeeArrayList* _tmp88_;
		GeeCollection* _tmp89_ = NULL;
		GeeCollection* _tmp90_;
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp88_ = to_add;
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp89_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp88_), NULL, NULL);
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp90_ = _tmp89_;
#line 492 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp90_);
#line 3174 "ViewCollection.c"
	}
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp91_ = to_remove;
#line 494 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp91_ != NULL) {
#line 3180 "ViewCollection.c"
		GeeArrayList* _tmp92_;
		Marker* _tmp93_ = NULL;
		Marker* _tmp94_;
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp92_ = to_remove;
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp93_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp92_));
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp94_ = _tmp93_;
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), _tmp94_);
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp94_);
#line 3194 "ViewCollection.c"
	}
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp95_ = ordering_changed;
#line 497 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp95_) {
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_collection_notify_ordering_changed (DATA_COLLECTION (self));
#line 3202 "ViewCollection.c"
	}
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (to_remove);
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3208 "ViewCollection.c"
}


static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
	GeeArrayList* _tmp0_;
	GeeArrayList* to_add;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 502 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 502 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	to_add = _tmp0_;
#line 3226 "ViewCollection.c"
	{
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = added;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp2_;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3239 "ViewCollection.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataObject* _tmp7_;
			DataSource* _tmp8_ = NULL;
			DataSource* source;
			gboolean _tmp9_ = FALSE;
			CreateViewPredicate _tmp10_;
			void* _tmp10__target;
			gboolean _tmp14_;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp4_) {
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 3260 "ViewCollection.c"
			}
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (DATA_VIEW (_tmp7_));
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = _tmp8_;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = self->priv->should_mirror;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10__target = self->priv->should_mirror_target;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp10_ == NULL) {
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = TRUE;
#line 3282 "ViewCollection.c"
			} else {
				CreateViewPredicate _tmp11_;
				void* _tmp11__target;
				DataSource* _tmp12_;
				gboolean _tmp13_ = FALSE;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11_ = self->priv->should_mirror;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11__target = self->priv->should_mirror_target;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = _tmp11_ (_tmp12_, _tmp11__target);
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = _tmp13_;
#line 3298 "ViewCollection.c"
			}
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = _tmp9_;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp14_) {
#line 3304 "ViewCollection.c"
				GeeArrayList* _tmp15_;
				CreateView _tmp16_;
				void* _tmp16__target;
				DataSource* _tmp17_;
				DataView* _tmp18_ = NULL;
				DataView* _tmp19_;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = to_add;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = self->priv->mirroring_ctor;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16__target = self->priv->mirroring_ctor_target;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = source;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = _tmp16_ (_tmp17_, _tmp16__target);
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = _tmp18_;
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp15_), _tmp19_);
#line 507 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp19_);
#line 3327 "ViewCollection.c"
			}
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3333 "ViewCollection.c"
		}
#line 503 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3337 "ViewCollection.c"
	}
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp20_ = to_add;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp21_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp20_));
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp22_ = _tmp21_;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp22_ > 0) {
#line 3347 "ViewCollection.c"
		GeeArrayList* _tmp23_;
		GeeCollection* _tmp24_ = NULL;
		GeeCollection* _tmp25_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp23_ = to_add;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp24_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (_tmp23_), NULL, NULL);
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp25_ = _tmp24_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp25_);
#line 3359 "ViewCollection.c"
	}
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3363 "ViewCollection.c"
}


static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	Marker* _tmp17_;
#line 514 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 514 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 515 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
#line 515 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 3379 "ViewCollection.c"
	{
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = removed;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp2_;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3392 "ViewCollection.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataObject* _tmp7_;
			DataView* _tmp8_;
			DataView* view;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			DataView* _tmp12_ = NULL;
			DataView* _tmp13_;
			DataView* our_view;
			DataView* _tmp14_;
			Marker* _tmp15_;
			DataView* _tmp16_;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp4_) {
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 3418 "ViewCollection.c"
			}
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _g_object_ref0 (DATA_VIEW (_tmp7_));
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = _tmp8_;
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = view_collection_get_view_for_source (self, _tmp11_);
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 519 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			our_view = _tmp13_;
#line 520 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = our_view;
#line 520 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_assert (_tmp14_ != NULL);
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = marker;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp16_ = our_view;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			marker_mark (_tmp15_, DATA_OBJECT (_tmp16_));
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (our_view);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3462 "ViewCollection.c"
		}
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3466 "ViewCollection.c"
	}
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp17_ = marker;
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), _tmp17_);
#line 514 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 3474 "ViewCollection.c"
}


static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	GeeArrayList* _tmp32_;
	GeeArrayList* _tmp36_;
	GeeIterable* _tmp39_;
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 530 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	added_visible = NULL;
#line 531 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	added_selected = NULL;
#line 3493 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = added;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3506 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
			DataView* _tmp7_;
			DataView* view;
			GeeHashMap* _tmp8_;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			DataView* _tmp12_;
			gboolean _tmp13_ = FALSE;
			DataView* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp18_;
			gboolean _tmp23_ = FALSE;
			DataView* _tmp24_;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp27_;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 3536 "ViewCollection.c"
			}
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 534 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 534 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = _g_object_ref0 (DATA_VIEW (_tmp6_));
#line 534 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = _tmp7_;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = self->priv->source_map;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = view;
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp8_), _tmp11_, _tmp12_);
#line 535 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = view;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = data_view_is_selected (_tmp14_);
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 3570 "ViewCollection.c"
				DataView* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = data_view_is_visible (_tmp16_);
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = _tmp17_;
#line 3579 "ViewCollection.c"
			} else {
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = FALSE;
#line 3583 "ViewCollection.c"
			}
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp18_ = _tmp13_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp18_) {
#line 3589 "ViewCollection.c"
				GeeArrayList* _tmp19_;
				GeeArrayList* _tmp21_;
				DataView* _tmp22_;
#line 538 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = added_selected;
#line 538 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp19_ == NULL) {
#line 3597 "ViewCollection.c"
					GeeArrayList* _tmp20_;
#line 539 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp20_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 539 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (added_selected);
#line 539 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					added_selected = _tmp20_;
#line 3605 "ViewCollection.c"
				}
#line 541 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp21_ = added_selected;
#line 541 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp22_ = view;
#line 541 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp21_), _tmp22_);
#line 3613 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp24_ = view;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp25_ = data_view_is_visible (_tmp24_);
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp25_) {
#line 3621 "ViewCollection.c"
				DataSet* _tmp26_;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp26_ = self->priv->visible;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = _tmp26_ != NULL;
#line 3627 "ViewCollection.c"
			} else {
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = FALSE;
#line 3631 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp27_ = _tmp23_;
#line 545 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp27_) {
#line 3637 "ViewCollection.c"
				GeeArrayList* _tmp28_;
				GeeArrayList* _tmp30_;
				DataView* _tmp31_;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp28_ = added_visible;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp28_ == NULL) {
#line 3645 "ViewCollection.c"
					GeeArrayList* _tmp29_;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp29_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (added_visible);
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					added_visible = _tmp29_;
#line 3653 "ViewCollection.c"
				}
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp30_ = added_visible;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp31_ = view;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp30_), _tmp31_);
#line 3661 "ViewCollection.c"
			}
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3667 "ViewCollection.c"
		}
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3671 "ViewCollection.c"
	}
#line 553 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp32_ = added_visible;
#line 553 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp32_ != NULL) {
#line 3677 "ViewCollection.c"
		GeeArrayList* _tmp33_;
		gboolean _tmp34_ = FALSE;
		gboolean is_added;
		gboolean _tmp35_;
#line 554 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp33_ = added_visible;
#line 554 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp34_ = view_collection_add_many_visible (self, GEE_COLLECTION (_tmp33_));
#line 554 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		is_added = _tmp34_;
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp35_ = is_added;
#line 555 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_assert (_tmp35_);
#line 3692 "ViewCollection.c"
	}
#line 558 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp36_ = added_selected;
#line 558 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp36_ != NULL) {
#line 3698 "ViewCollection.c"
		GeeArrayList* _tmp37_;
		GeeArrayList* _tmp38_;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp37_ = added_selected;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, GEE_COLLECTION (_tmp37_));
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp38_ = added_selected;
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (_tmp38_), NULL);
#line 3709 "ViewCollection.c"
	}
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp39_ = added;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), _tmp39_);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 529 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (added_visible);
#line 3719 "ViewCollection.c"
}


static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
	ViewCollection * self;
	GeeArrayList* selected_removed;
	GeeArrayList* _tmp37_;
	GeeIterable* _tmp39_;
#line 567 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 567 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 568 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	selected_removed = NULL;
#line 3734 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = removed;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3747 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
			DataView* _tmp7_;
			DataView* view;
			GeeHashMap* _tmp8_;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
			gboolean is_removed;
			gboolean _tmp14_;
			DataView* _tmp15_;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp28_ = FALSE;
			DataView* _tmp29_;
			gboolean _tmp30_ = FALSE;
			gboolean _tmp32_;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 3778 "ViewCollection.c"
			}
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 570 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 570 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = _g_object_ref0 (DATA_VIEW (_tmp6_));
#line 570 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = _tmp7_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = self->priv->source_map;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp8_), _tmp11_, NULL);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 572 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			is_removed = _tmp13_;
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = is_removed;
#line 573 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_assert (_tmp14_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = view;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp16_ = data_view_is_selected (_tmp15_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp16_) {
#line 3818 "ViewCollection.c"
				DataSet* _tmp17_;
				DataView* _tmp18_;
				gboolean _tmp19_ = FALSE;
				DataView* _tmp20_;
				gboolean _tmp21_ = FALSE;
				DataView* _tmp22_;
				gboolean _tmp23_ = FALSE;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = self->priv->selected;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = view;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = data_set_contains (_tmp17_, DATA_OBJECT (_tmp18_));
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp20_ = view;
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp21_ = data_view_is_visible (_tmp20_);
#line 577 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				g_assert (_tmp19_ == _tmp21_);
#line 579 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp22_ = view;
#line 579 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp23_ = data_view_is_visible (_tmp22_);
#line 579 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp23_) {
#line 3844 "ViewCollection.c"
					GeeArrayList* _tmp24_;
					GeeArrayList* _tmp26_;
					DataView* _tmp27_;
#line 580 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp24_ = selected_removed;
#line 580 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp24_ == NULL) {
#line 3852 "ViewCollection.c"
						GeeArrayList* _tmp25_;
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp25_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (selected_removed);
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						selected_removed = _tmp25_;
#line 3860 "ViewCollection.c"
					}
#line 583 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp26_ = selected_removed;
#line 583 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp27_ = view;
#line 583 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp26_), _tmp27_);
#line 3868 "ViewCollection.c"
				}
			}
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp29_ = view;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp30_ = data_view_is_visible (_tmp29_);
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp30_) {
#line 3877 "ViewCollection.c"
				DataSet* _tmp31_;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp31_ = self->priv->visible;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp28_ = _tmp31_ != NULL;
#line 3883 "ViewCollection.c"
			} else {
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp28_ = FALSE;
#line 3887 "ViewCollection.c"
			}
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp32_ = _tmp28_;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp32_) {
#line 3893 "ViewCollection.c"
				DataSet* _tmp33_;
				DataView* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp33_ = self->priv->visible;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp34_ = view;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp35_ = data_set_remove (_tmp33_, DATA_OBJECT (_tmp34_));
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				is_removed = _tmp35_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp36_ = is_removed;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				g_assert (_tmp36_);
#line 3910 "ViewCollection.c"
			}
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3916 "ViewCollection.c"
		}
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3920 "ViewCollection.c"
	}
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp37_ = selected_removed;
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp37_ != NULL) {
#line 3926 "ViewCollection.c"
		GeeArrayList* _tmp38_;
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp38_ = selected_removed;
#line 594 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, GEE_COLLECTION (_tmp38_));
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 3934 "ViewCollection.c"
	}
#line 602 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp39_ = removed;
#line 602 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), _tmp39_);
#line 567 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (selected_removed);
#line 3942 "ViewCollection.c"
}


static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views) {
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp22_;
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 608 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	to_show = NULL;
#line 609 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	to_hide = NULL;
#line 3959 "ViewCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _view_it;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = views;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_view_it = _tmp1_;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3972 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataView* view;
			DataView* _tmp6_;
			gboolean _tmp7_ = FALSE;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = _view_it;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 3988 "ViewCollection.c"
			}
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _view_it;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = (DataView*) _tmp5_;
#line 615 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 615 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = view_collection_is_in_filter (self, _tmp6_);
#line 615 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp7_) {
#line 4002 "ViewCollection.c"
				DataView* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp8_ = view;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = data_view_is_visible (_tmp8_);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp9_) {
#line 4011 "ViewCollection.c"
					GeeArrayList* _tmp10_;
					GeeArrayList* _tmp12_;
					DataView* _tmp13_;
#line 617 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp10_ = to_show;
#line 617 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp10_ == NULL) {
#line 4019 "ViewCollection.c"
						GeeArrayList* _tmp11_;
#line 618 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp11_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 618 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (to_show);
#line 618 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						to_show = _tmp11_;
#line 4027 "ViewCollection.c"
					}
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp12_ = to_show;
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp13_ = view;
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp12_), _tmp13_);
#line 4035 "ViewCollection.c"
				}
			} else {
				DataView* _tmp14_;
				gboolean _tmp15_ = FALSE;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = data_view_is_visible (_tmp14_);
#line 623 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp15_) {
#line 4046 "ViewCollection.c"
					GeeArrayList* _tmp16_;
					GeeArrayList* _tmp18_;
					DataView* _tmp19_;
#line 624 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp16_ = to_hide;
#line 624 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					if (_tmp16_ == NULL) {
#line 4054 "ViewCollection.c"
						GeeArrayList* _tmp17_;
#line 625 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_tmp17_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 625 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						_g_object_unref0 (to_hide);
#line 625 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
						to_hide = _tmp17_;
#line 4062 "ViewCollection.c"
					}
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp18_ = to_hide;
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp19_ = view;
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp18_), _tmp19_);
#line 4070 "ViewCollection.c"
				}
			}
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 4075 "ViewCollection.c"
		}
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 4079 "ViewCollection.c"
	}
#line 636 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp20_ = to_show;
#line 636 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp20_ != NULL) {
#line 4085 "ViewCollection.c"
		GeeArrayList* _tmp21_;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp21_ = to_show;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_show_items (self, GEE_LIST (_tmp21_));
#line 4091 "ViewCollection.c"
	}
#line 639 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp22_ = to_hide;
#line 639 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp22_ != NULL) {
#line 4097 "ViewCollection.c"
		GeeArrayList* _tmp23_;
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp23_ = to_hide;
#line 640 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_hide_items (self, GEE_LIST (_tmp23_));
#line 4103 "ViewCollection.c"
	}
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (to_hide);
#line 605 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (to_show);
#line 4109 "ViewCollection.c"
}


static void view_collection_real_items_altered (DataCollection* base, GeeMap* map) {
	ViewCollection * self;
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeMap* _tmp4_;
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = map;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (_tmp3_));
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 646 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = map;
#line 646 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (DATA_COLLECTION (self), _tmp4_);
#line 4140 "ViewCollection.c"
}


static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
	ViewCollection * self;
	DataSet* _tmp0_;
	Comparator _tmp1_;
	void* _tmp1__target;
	ComparatorPredicate _tmp2_;
	void* _tmp2__target;
	DataSet* _tmp3_;
	Comparator _tmp7_;
	void* _tmp7__target;
	ComparatorPredicate _tmp8_;
	void* _tmp8__target;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = comparator;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1__target = comparator_target;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = predicate;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2__target = predicate_target;
#line 650 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_set_set_comparator (_tmp0_, _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 651 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = self->priv->visible;
#line 651 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 4174 "ViewCollection.c"
		DataSet* _tmp4_;
		Comparator _tmp5_;
		void* _tmp5__target;
		ComparatorPredicate _tmp6_;
		void* _tmp6__target;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->visible;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = comparator;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5__target = comparator_target;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = predicate;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6__target = predicate_target;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_set_set_comparator (_tmp4_, _tmp5_, _tmp5__target, _tmp6_, _tmp6__target);
#line 4192 "ViewCollection.c"
	}
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = comparator;
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7__target = comparator_target;
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = predicate;
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8__target = predicate_target;
#line 654 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), _tmp7_, _tmp7__target, _tmp8_, _tmp8__target);
#line 4204 "ViewCollection.c"
}


static void view_collection_real_reset_comparator (DataCollection* base) {
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 657 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 658 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 658 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_set_reset_comparator (_tmp0_);
#line 659 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 659 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4222 "ViewCollection.c"
		DataSet* _tmp2_;
#line 660 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 660 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data_set_reset_comparator (_tmp2_);
#line 4228 "ViewCollection.c"
	}
#line 662 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
#line 4232 "ViewCollection.c"
}


static GeeCollection* view_collection_real_get_all (DataCollection* base) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 665 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4247 "ViewCollection.c"
		DataSet* _tmp2_;
		GeeList* _tmp3_ = NULL;
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_all (_tmp2_);
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = GEE_COLLECTION (_tmp3_);
#line 4258 "ViewCollection.c"
	} else {
		GeeCollection* _tmp4_ = NULL;
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4267 "ViewCollection.c"
	}
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 666 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4273 "ViewCollection.c"
}


GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
#line 669 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 670 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4288 "ViewCollection.c"
}


static gint view_collection_real_get_count (DataCollection* base) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 673 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4303 "ViewCollection.c"
		DataSet* _tmp2_;
		gint _tmp3_ = 0;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_count (_tmp2_);
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp3_;
#line 4312 "ViewCollection.c"
	} else {
		gint _tmp4_ = 0;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4319 "ViewCollection.c"
	}
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 674 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4325 "ViewCollection.c"
}


gint view_collection_get_unfiltered_count (ViewCollection* self) {
	gint result = 0;
	gint _tmp0_ = 0;
#line 677 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 678 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 678 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 678 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4340 "ViewCollection.c"
}


static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 681 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4355 "ViewCollection.c"
		DataSet* _tmp2_;
		gint _tmp3_;
		DataObject* _tmp4_ = NULL;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = index;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = data_set_get_at (_tmp2_, _tmp3_);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4369 "ViewCollection.c"
	} else {
		gint _tmp5_;
		DataObject* _tmp6_ = NULL;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = index;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), _tmp5_);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp6_;
#line 4381 "ViewCollection.c"
	}
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4387 "ViewCollection.c"
}


static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4404 "ViewCollection.c"
		DataSet* _tmp2_;
		DataObject* _tmp3_;
		gint _tmp4_ = 0;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = object;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = data_set_index_of (_tmp2_, _tmp3_);
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4416 "ViewCollection.c"
	} else {
		DataObject* _tmp5_;
		gint _tmp6_ = 0;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = object;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), _tmp5_);
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp6_;
#line 4426 "ViewCollection.c"
	}
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 686 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4432 "ViewCollection.c"
}


static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DataObject* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 689 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), _tmp0_);
#line 692 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp1_) {
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = FALSE;
#line 693 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4457 "ViewCollection.c"
	}
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = object;
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_is_visible (self, DATA_VIEW (_tmp2_));
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 696 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4467 "ViewCollection.c"
}


static DataView* view_collection_real_get_first (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ > 0) {
#line 4479 "ViewCollection.c"
		DataObject* _tmp2_ = NULL;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_at (DATA_COLLECTION (self), 0);
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = DATA_VIEW (_tmp2_);
#line 4487 "ViewCollection.c"
	} else {
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4493 "ViewCollection.c"
	}
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4499 "ViewCollection.c"
}


DataView* view_collection_get_first (ViewCollection* self) {
#line 699 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 699 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 4508 "ViewCollection.c"
}


static DataView* view_collection_real_get_last (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ > 0) {
#line 4520 "ViewCollection.c"
		gint _tmp2_ = 0;
		DataObject* _tmp3_ = NULL;
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_count (DATA_COLLECTION (self));
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_at (DATA_COLLECTION (self), _tmp2_ - 1);
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = DATA_VIEW (_tmp3_);
#line 4531 "ViewCollection.c"
	} else {
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4537 "ViewCollection.c"
	}
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 704 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4543 "ViewCollection.c"
}


DataView* view_collection_get_last (ViewCollection* self) {
#line 703 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 703 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 4552 "ViewCollection.c"
}


static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_ = 0;
	DataView* _tmp1_;
	gint _tmp2_ = 0;
	gint index;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	DataObject* _tmp8_ = NULL;
#line 707 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 708 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_count (DATA_COLLECTION (self));
#line 708 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp0_ == 0) {
#line 709 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = NULL;
#line 709 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4578 "ViewCollection.c"
	}
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (_tmp1_));
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	index = _tmp2_;
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 712 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_ < 0) {
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = NULL;
#line 713 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4594 "ViewCollection.c"
	}
#line 715 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = index;
#line 715 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	index = _tmp4_ + 1;
#line 716 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = index;
#line 716 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_count (DATA_COLLECTION (self));
#line 716 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_ >= _tmp6_) {
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		index = 0;
#line 4608 "ViewCollection.c"
	}
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = index;
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = data_collection_get_at (DATA_COLLECTION (self), _tmp7_);
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = DATA_VIEW (_tmp8_);
#line 719 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4618 "ViewCollection.c"
}


DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 707 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 707 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 4627 "ViewCollection.c"
}


static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_ = 0;
	DataView* _tmp1_;
	gint _tmp2_ = 0;
	gint index;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp7_;
	DataObject* _tmp8_ = NULL;
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_count (DATA_COLLECTION (self));
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp0_ == 0) {
#line 724 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = NULL;
#line 724 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4652 "ViewCollection.c"
	}
#line 726 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 726 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (_tmp1_));
#line 726 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	index = _tmp2_;
#line 727 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 727 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_ < 0) {
#line 728 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = NULL;
#line 728 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4668 "ViewCollection.c"
	}
#line 730 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = index;
#line 730 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	index = _tmp4_ - 1;
#line 731 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = index;
#line 731 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_ < 0) {
#line 4678 "ViewCollection.c"
		gint _tmp6_ = 0;
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = data_collection_get_count (DATA_COLLECTION (self));
#line 732 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		index = _tmp6_ - 1;
#line 4684 "ViewCollection.c"
	}
#line 734 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = index;
#line 734 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = data_collection_get_at (DATA_COLLECTION (self), _tmp7_);
#line 734 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = DATA_VIEW (_tmp8_);
#line 734 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4694 "ViewCollection.c"
}


DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 4703 "ViewCollection.c"
}


gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector) {
	DataSource* _vala_next = NULL;
	DataSource* _vala_prev = NULL;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* home_view;
	DataView* _tmp2_;
	DataView* _tmp3_;
	DataView* _tmp4_ = NULL;
	DataView* next_view;
	DataView* _tmp20_;
	DataView* _tmp21_ = NULL;
	DataView* prev_view;
#line 737 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 737 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 739 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_next);
#line 739 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_vala_next = NULL;
#line 740 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_prev);
#line 740 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_vala_prev = NULL;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = home;
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 742 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	home_view = _tmp1_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = home_view;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp2_ == NULL) {
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = FALSE;
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (home_view);
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (next) {
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			*next = _vala_next;
#line 4751 "ViewCollection.c"
		} else {
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 4755 "ViewCollection.c"
		}
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (prev) {
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			*prev = _vala_prev;
#line 4761 "ViewCollection.c"
		} else {
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 4765 "ViewCollection.c"
		}
#line 744 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 4769 "ViewCollection.c"
	}
#line 746 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = home_view;
#line 746 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = view_collection_get_next (self, _tmp3_);
#line 746 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	next_view = _tmp4_;
#line 747 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4779 "ViewCollection.c"
		DataView* _tmp5_;
		DataView* _tmp6_;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		gboolean _tmp15_;
		DataView* _tmp18_;
		DataView* _tmp19_ = NULL;
#line 747 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = next_view;
#line 747 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = home_view;
#line 747 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (!(_tmp5_ != _tmp6_)) {
#line 747 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			break;
#line 4795 "ViewCollection.c"
		}
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = type_selector;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp8_ == NULL) {
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = TRUE;
#line 4803 "ViewCollection.c"
		} else {
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			const gchar* _tmp14_;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = next_view;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = data_source_get_typename (_tmp11_);
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = type_selector;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_free0 (_tmp13_);
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 4829 "ViewCollection.c"
		}
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp15_ = _tmp7_;
#line 748 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp15_) {
#line 4835 "ViewCollection.c"
			DataView* _tmp16_;
			DataSource* _tmp17_ = NULL;
#line 749 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp16_ = next_view;
#line 749 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp17_ = data_view_get_source (_tmp16_);
#line 749 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 749 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_vala_next = _tmp17_;
#line 750 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			break;
#line 4848 "ViewCollection.c"
		}
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp18_ = next_view;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp19_ = view_collection_get_next (self, _tmp18_);
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_view);
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		next_view = _tmp19_;
#line 4858 "ViewCollection.c"
	}
#line 755 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp20_ = home_view;
#line 755 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp21_ = view_collection_get_previous (self, _tmp20_);
#line 755 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	prev_view = _tmp21_;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4868 "ViewCollection.c"
		DataView* _tmp22_;
		DataView* _tmp23_;
		gboolean _tmp24_ = FALSE;
		const gchar* _tmp25_;
		gboolean _tmp32_;
		DataView* _tmp35_;
		DataView* _tmp36_ = NULL;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp22_ = prev_view;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp23_ = home_view;
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (!(_tmp22_ != _tmp23_)) {
#line 756 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			break;
#line 4884 "ViewCollection.c"
		}
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp25_ = type_selector;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp25_ == NULL) {
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp24_ = TRUE;
#line 4892 "ViewCollection.c"
		} else {
			DataView* _tmp26_;
			DataSource* _tmp27_ = NULL;
			DataSource* _tmp28_;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_;
			const gchar* _tmp31_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp26_ = prev_view;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp27_ = data_view_get_source (_tmp26_);
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp28_ = _tmp27_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp29_ = data_source_get_typename (_tmp28_);
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp30_ = _tmp29_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp31_ = type_selector;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp24_ = g_strcmp0 (_tmp30_, _tmp31_) == 0;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_free0 (_tmp30_);
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp28_);
#line 4918 "ViewCollection.c"
		}
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp32_ = _tmp24_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp32_) {
#line 4924 "ViewCollection.c"
			DataView* _tmp33_;
			DataSource* _tmp34_ = NULL;
#line 758 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp33_ = prev_view;
#line 758 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp34_ = data_view_get_source (_tmp33_);
#line 758 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 758 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_vala_prev = _tmp34_;
#line 759 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			break;
#line 4937 "ViewCollection.c"
		}
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp35_ = prev_view;
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp36_ = view_collection_get_previous (self, _tmp35_);
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_view);
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		prev_view = _tmp36_;
#line 4947 "ViewCollection.c"
	}
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (prev_view);
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (next_view);
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (home_view);
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (next) {
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*next = _vala_next;
#line 4961 "ViewCollection.c"
	} else {
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_next);
#line 4965 "ViewCollection.c"
	}
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (prev) {
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*prev = _vala_prev;
#line 4971 "ViewCollection.c"
	} else {
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_prev);
#line 4975 "ViewCollection.c"
	}
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 4979 "ViewCollection.c"
}


GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename) {
	GeeSet* result = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* neighbors;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_;
	const gchar* _tmp2_;
	DataSource* _tmp3_ = NULL;
	DataSource* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	DataSource* _tmp6_;
	DataSource* _tmp16_;
	GeeSet* _tmp26_;
	DataSource* _tmp27_;
#line 768 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 768 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 770 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 770 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	neighbors = GEE_SET (_tmp0_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = home;
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = typename;
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = view_collection_get_immediate_neighbors (self, _tmp1_, &_tmp3_, &_tmp4_, _tmp2_);
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	next = _tmp3_;
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	prev = _tmp4_;
#line 774 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp5_) {
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = neighbors;
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (prev);
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next);
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 5030 "ViewCollection.c"
	}
#line 778 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = next;
#line 778 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp6_ != NULL) {
#line 5036 "ViewCollection.c"
		GeeSet* _tmp7_;
		DataSource* _tmp8_;
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp9_;
		const gchar* _tmp10_;
		DataSource* _tmp11_ = NULL;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp13_;
#line 779 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = neighbors;
#line 779 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = next;
#line 779 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_collection_add (GEE_COLLECTION (_tmp7_), _tmp8_);
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp9_ = next;
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp10_ = typename;
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp9_, &_tmp11_, &_tmp12_, _tmp10_);
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		next_next = _tmp11_;
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 782 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		next_prev = _tmp12_;
#line 785 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp13_ = next_next;
#line 785 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp13_ != NULL) {
#line 5070 "ViewCollection.c"
			GeeSet* _tmp14_;
			DataSource* _tmp15_;
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = neighbors;
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = next_next;
#line 786 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			gee_collection_add (GEE_COLLECTION (_tmp14_), _tmp15_);
#line 5079 "ViewCollection.c"
		}
#line 778 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 778 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 5085 "ViewCollection.c"
	}
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp16_ = prev;
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp16_ != NULL) {
#line 5091 "ViewCollection.c"
		GeeSet* _tmp17_;
		DataSource* _tmp18_;
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp19_;
		const gchar* _tmp20_;
		DataSource* _tmp21_ = NULL;
		DataSource* _tmp22_ = NULL;
		DataSource* _tmp23_;
#line 791 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp17_ = neighbors;
#line 791 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp18_ = prev;
#line 791 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_collection_add (GEE_COLLECTION (_tmp17_), _tmp18_);
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp19_ = prev;
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp20_ = typename;
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp19_, &_tmp21_, &_tmp22_, _tmp20_);
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		next_prev = _tmp21_;
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 794 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		prev_prev = _tmp22_;
#line 797 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp23_ = prev_prev;
#line 797 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp23_ != NULL) {
#line 5125 "ViewCollection.c"
			GeeSet* _tmp24_;
			DataSource* _tmp25_;
#line 798 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp24_ = neighbors;
#line 798 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp25_ = prev_prev;
#line 798 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			gee_collection_add (GEE_COLLECTION (_tmp24_), _tmp25_);
#line 5134 "ViewCollection.c"
		}
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 790 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 5140 "ViewCollection.c"
	}
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp26_ = neighbors;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp27_ = home;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_collection_remove (GEE_COLLECTION (_tmp26_), _tmp27_);
#line 804 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = neighbors;
#line 804 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 804 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 804 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5156 "ViewCollection.c"
}


static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp11_;
	GeeCollection* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean added;
	gboolean _tmp14_;
#line 809 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 809 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 810 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 810 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 810 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 810 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp2_ == 0) {
#line 811 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 5183 "ViewCollection.c"
	}
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _view_it;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = views;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_view_it = _tmp4_;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5197 "ViewCollection.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataView* view;
			DataView* _tmp9_;
			gboolean _tmp10_ = FALSE;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = _view_it;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp6_) {
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 5213 "ViewCollection.c"
			}
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = _view_it;
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = (DataView*) _tmp8_;
#line 814 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 814 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = data_view_is_visible (_tmp9_);
#line 814 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_assert (_tmp10_);
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 5229 "ViewCollection.c"
		}
#line 813 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 5233 "ViewCollection.c"
	}
#line 816 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp11_ = self->priv->selected;
#line 816 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp12_ = views;
#line 816 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp13_ = data_set_add_many (_tmp11_, _tmp12_);
#line 816 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	added = _tmp13_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp14_ = added;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp14_);
#line 5247 "ViewCollection.c"
}


static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp3_;
	GeeCollection* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean removed;
	gboolean _tmp6_;
#line 820 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 820 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 821 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 821 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 821 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 821 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp2_ == 0) {
#line 822 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 5274 "ViewCollection.c"
	}
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = self->priv->selected;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = views;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = data_set_remove_many (_tmp3_, _tmp4_);
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	removed = _tmp5_;
#line 825 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = removed;
#line 825 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp6_);
#line 5288 "ViewCollection.c"
}


static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_select_item (self, object, user);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5297 "ViewCollection.c"
}


void view_collection_select_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_;
	GeeArrayList* selected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 829 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 829 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 830 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 830 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	selected = _tmp0_;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = selected;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), _tmp1_, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (_tmp2_));
#line 833 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = selected;
#line 833 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp3_));
#line 833 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 833 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_ > 0) {
#line 5331 "ViewCollection.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
#line 834 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = selected;
#line 834 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, GEE_COLLECTION (_tmp6_));
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = selected;
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (_tmp7_), NULL);
#line 5342 "ViewCollection.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 5346 "ViewCollection.c"
}


void view_collection_select_all (ViewCollection* self) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
#line 841 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker_mark_all (marker);
#line 843 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_select_marked (self, marker);
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5365 "ViewCollection.c"
}


static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	DataView* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp9_;
	DataView* _tmp10_;
	gboolean _tmp11_ = FALSE;
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 847 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 847 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (DATA_VIEW (_tmp0_));
#line 847 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 848 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 848 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = data_view_is_selected (_tmp2_);
#line 848 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_) {
#line 5397 "ViewCollection.c"
		DataView* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 849 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 849 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = data_view_is_visible (_tmp4_);
#line 849 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp5_) {
#line 5406 "ViewCollection.c"
			DataSet* _tmp6_;
			DataView* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->selected;
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = data_set_contains (_tmp6_, DATA_OBJECT (_tmp7_));
#line 850 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			g_assert (_tmp8_);
#line 5418 "ViewCollection.c"
		}
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = TRUE;
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 852 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 5426 "ViewCollection.c"
	}
#line 855 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = view;
#line 855 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp9_, TRUE);
#line 859 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp10_ = view;
#line 859 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp11_ = data_view_is_visible (_tmp10_);
#line 859 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp11_) {
#line 5438 "ViewCollection.c"
		GObject* _tmp12_;
		DataView* _tmp13_;
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp12_ = user;
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp13_ = view;
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (_tmp12_)), _tmp13_);
#line 5447 "ViewCollection.c"
	}
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5455 "ViewCollection.c"
}


static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5464 "ViewCollection.c"
}


void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 866 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 866 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = unselected;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), _tmp1_, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (_tmp2_));
#line 870 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = unselected;
#line 870 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp3_));
#line 870 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 870 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_ > 0) {
#line 5498 "ViewCollection.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
#line 871 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = unselected;
#line 871 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, GEE_COLLECTION (_tmp6_));
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = unselected;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, GEE_COLLECTION (_tmp7_));
#line 5509 "ViewCollection.c"
	}
#line 866 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5513 "ViewCollection.c"
}


void view_collection_unselect_all (ViewCollection* self) {
	DataSet* _tmp0_;
	gint _tmp1_ = 0;
	Marker* _tmp2_ = NULL;
	Marker* marker;
	Marker* _tmp3_;
	GeeList* _tmp4_ = NULL;
	GeeList* _tmp5_;
	Marker* _tmp6_;
#line 877 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 878 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 878 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 878 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 879 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return;
#line 5536 "ViewCollection.c"
	}
#line 881 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_start_marking (DATA_COLLECTION (self));
#line 881 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker = _tmp2_;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = marker;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = view_collection_get_selected (self);
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker_mark_many (_tmp3_, GEE_COLLECTION (_tmp5_));
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp5_);
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = marker;
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp6_);
#line 877 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5558 "ViewCollection.c"
}


void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	Marker* _tmp15_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 5574 "ViewCollection.c"
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all (DATA_COLLECTION (self));
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5595 "ViewCollection.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataObject* object;
			DataObject* _tmp9_;
			DataView* _tmp10_;
			DataView* view;
			DataView* _tmp11_;
			DataView* _tmp12_;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp6_) {
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 5614 "ViewCollection.c"
			}
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = _object_it;
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp8_;
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = object;
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = _g_object_ref0 (DATA_VIEW (_tmp9_));
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = _tmp10_;
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = view;
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = exception;
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp11_ != _tmp12_) {
#line 5634 "ViewCollection.c"
				Marker* _tmp13_;
				DataView* _tmp14_;
#line 893 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = marker;
#line 893 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 893 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				marker_mark (_tmp13_, DATA_OBJECT (_tmp14_));
#line 5643 "ViewCollection.c"
			}
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 5649 "ViewCollection.c"
		}
#line 890 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 5653 "ViewCollection.c"
	}
#line 896 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 896 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp15_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5661 "ViewCollection.c"
}


static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	DataView* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp7_;
	GObject* _tmp8_;
	DataView* _tmp9_;
#line 899 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 899 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 899 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (DATA_VIEW (_tmp0_));
#line 900 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = data_view_is_selected (_tmp2_);
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 5693 "ViewCollection.c"
		DataSet* _tmp4_;
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->selected;
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = view;
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = data_set_contains (_tmp4_, DATA_OBJECT (_tmp5_));
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_assert (!_tmp6_);
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = TRUE;
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 904 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 5711 "ViewCollection.c"
	}
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = view;
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp7_, FALSE);
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = user;
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = view;
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (_tmp8_)), _tmp9_);
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5729 "ViewCollection.c"
}


void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* selected;
	Marker* _tmp3_;
#line 914 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 914 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (unselect));
#line 914 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (select));
#line 915 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 915 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 916 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = unselect;
#line 916 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), _tmp1_, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
#line 918 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, GEE_COLLECTION (unselected));
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	selected = _tmp2_;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = select;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), _tmp3_, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
#line 923 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, GEE_COLLECTION (selected));
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (selected), GEE_COLLECTION (unselected));
#line 914 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 914 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5772 "ViewCollection.c"
}


static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5781 "ViewCollection.c"
}


void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
	ViewCollectionToggleLists* _tmp0_;
	ViewCollectionToggleLists* lists;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_toggle_lists_new ();
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	lists = _tmp0_;
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 932 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), _tmp1_, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
#line 935 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = lists->selected;
#line 935 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, GEE_COLLECTION (_tmp2_));
#line 936 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = lists->unselected;
#line 936 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, GEE_COLLECTION (_tmp3_));
#line 938 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = lists->selected;
#line 938 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = lists->unselected;
#line 938 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (_tmp4_), GEE_COLLECTION (_tmp5_));
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 5821 "ViewCollection.c"
}


static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	GObject* _tmp2_;
	ViewCollectionToggleLists* _tmp3_;
	ViewCollectionToggleLists* lists;
	DataView* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 941 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 941 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 941 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 942 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 942 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (DATA_VIEW (_tmp0_));
#line 942 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 943 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = user;
#line 943 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (_tmp2_));
#line 943 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	lists = _tmp3_;
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = data_view_internal_toggle (_tmp4_);
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_) {
#line 5859 "ViewCollection.c"
		DataView* _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 950 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = view;
#line 950 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = data_view_is_visible (_tmp6_);
#line 950 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp7_) {
#line 5868 "ViewCollection.c"
			ViewCollectionToggleLists* _tmp8_;
			GeeArrayList* _tmp9_;
			DataView* _tmp10_;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = lists;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_->selected;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp9_), _tmp10_);
#line 5880 "ViewCollection.c"
		}
	} else {
		ViewCollectionToggleLists* _tmp11_;
		GeeArrayList* _tmp12_;
		DataView* _tmp13_;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp11_ = lists;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp12_ = _tmp11_->unselected;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp13_ = view;
#line 953 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp12_), _tmp13_);
#line 5894 "ViewCollection.c"
	}
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5904 "ViewCollection.c"
}


gint view_collection_get_selected_count (ViewCollection* self) {
	gint result = 0;
	DataSet* _tmp0_;
	gint _tmp1_ = 0;
#line 959 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp1_;
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5922 "ViewCollection.c"
}


GeeList* view_collection_get_selected (ViewCollection* self) {
	GeeList* result = NULL;
	DataSet* _tmp0_;
	GeeList* _tmp1_ = NULL;
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = GEE_LIST (_tmp1_);
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5940 "ViewCollection.c"
}


DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
	DataView* result = NULL;
	DataSet* _tmp0_;
	gint _tmp1_;
	DataObject* _tmp2_ = NULL;
#line 967 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_at (_tmp0_, _tmp1_);
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = DATA_VIEW (_tmp2_);
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5961 "ViewCollection.c"
}


static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 5977 "ViewCollection.c"
		DataSet* _tmp2_;
		DataView* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = data_set_contains (_tmp2_, DATA_OBJECT (_tmp3_));
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 5989 "ViewCollection.c"
	} else {
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 5993 "ViewCollection.c"
	}
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 5999 "ViewCollection.c"
}


static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many) {
	gboolean result = FALSE;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataSet* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
#line 975 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 975 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (many), FALSE);
#line 976 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->visible;
#line 976 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp0_ == NULL) {
#line 977 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = TRUE;
#line 977 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 6024 "ViewCollection.c"
	}
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = many;
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = data_set_add_many (_tmp1_, _tmp2_);
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = FALSE;
#line 980 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 6038 "ViewCollection.c"
	}
#line 983 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = self->priv->visible;
#line 983 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = data_set_get_count (_tmp4_);
#line 983 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 983 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp5_ == _tmp6_) {
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		self->priv->visible = NULL;
#line 6052 "ViewCollection.c"
	}
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6058 "ViewCollection.c"
}


static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	DataSet* _tmp23_;
	DataSet* _tmp25_;
	GeeList* _tmp26_;
	gboolean _tmp27_ = FALSE;
	gboolean removed;
	gboolean _tmp28_;
	GeeArrayList* _tmp29_;
	GeeArrayList* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 991 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 991 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = to_hide;
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_tmp1_));
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	count = _tmp3_;
#line 6098 "ViewCollection.c"
	{
		gint ctr;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		ctr = 0;
#line 6103 "ViewCollection.c"
		{
			gboolean _tmp4_;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = TRUE;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6110 "ViewCollection.c"
				gboolean _tmp5_;
				gint _tmp7_;
				gint _tmp8_;
				GeeList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_ = NULL;
				DataView* view;
				DataView* _tmp12_;
				gboolean _tmp13_ = FALSE;
				DataView* _tmp14_;
				gboolean _tmp15_ = FALSE;
				DataView* _tmp22_;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp5_ = _tmp4_;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp5_) {
#line 6127 "ViewCollection.c"
					gint _tmp6_;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp6_ = ctr;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					ctr = _tmp6_ + 1;
#line 6133 "ViewCollection.c"
				}
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp4_ = FALSE;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp8_ = count;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 6145 "ViewCollection.c"
				}
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = to_hide;
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 995 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view = (DataView*) _tmp11_;
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = data_view_is_visible (_tmp12_);
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				g_assert (_tmp13_);
#line 998 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 998 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = data_view_is_selected (_tmp14_);
#line 998 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp15_) {
#line 6167 "ViewCollection.c"
					DataView* _tmp16_;
					GeeArrayList* _tmp17_;
					DataView* _tmp18_;
#line 999 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp16_ = view;
#line 999 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					data_view_internal_set_selected (_tmp16_, FALSE);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp17_ = unselected;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp17_), _tmp18_);
#line 6181 "ViewCollection.c"
				} else {
					DataSet* _tmp19_;
					DataView* _tmp20_;
					gboolean _tmp21_ = FALSE;
#line 1002 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp19_ = self->priv->selected;
#line 1002 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp20_ = view;
#line 1002 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp21_ = data_set_contains (_tmp19_, DATA_OBJECT (_tmp20_));
#line 1002 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					g_assert (!_tmp21_);
#line 6194 "ViewCollection.c"
				}
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp22_ = view;
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp22_, FALSE);
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6202 "ViewCollection.c"
			}
		}
	}
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp23_ = self->priv->visible;
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp23_ == NULL) {
#line 6210 "ViewCollection.c"
		DataSet* _tmp24_ = NULL;
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp24_ = data_collection_get_dataset_copy (DATA_COLLECTION (self));
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1010 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		self->priv->visible = _tmp24_;
#line 6218 "ViewCollection.c"
	}
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp25_ = self->priv->visible;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp26_ = to_hide;
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp27_ = data_set_remove_many (_tmp25_, GEE_COLLECTION (_tmp26_));
#line 1013 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	removed = _tmp27_;
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp28_ = removed;
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp28_);
#line 1016 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp29_ = unselected;
#line 1016 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, GEE_COLLECTION (_tmp29_));
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp30_ = unselected;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp31_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp30_));
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp32_ = _tmp31_;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp32_ > 0) {
#line 6244 "ViewCollection.c"
		GeeArrayList* _tmp33_;
#line 1019 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp33_ = unselected;
#line 1019 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, GEE_COLLECTION (_tmp33_));
#line 6250 "ViewCollection.c"
	}
#line 1021 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp34_ = to_hide;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp35_ = gee_collection_get_size (GEE_COLLECTION (_tmp34_));
#line 1021 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp36_ = _tmp35_;
#line 1021 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp36_ > 0) {
#line 6260 "ViewCollection.c"
		GeeList* _tmp37_;
		GeeList* _tmp38_;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp37_ = to_hide;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_hidden (self, GEE_COLLECTION (_tmp37_));
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp38_ = to_hide;
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (_tmp38_));
#line 6271 "ViewCollection.c"
	}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6275 "ViewCollection.c"
}


static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
	GeeArrayList* _tmp0_;
	GeeArrayList* added_selected;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	GeeList* _tmp22_;
	gboolean _tmp23_ = FALSE;
	gboolean added;
	gboolean _tmp24_;
	GeeArrayList* _tmp25_;
	GeeList* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 1029 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1029 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	added_selected = _tmp0_;
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = to_show;
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_tmp1_));
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	count = _tmp3_;
#line 6310 "ViewCollection.c"
	{
		gint ctr;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		ctr = 0;
#line 6315 "ViewCollection.c"
		{
			gboolean _tmp4_;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = TRUE;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6322 "ViewCollection.c"
				gboolean _tmp5_;
				gint _tmp7_;
				gint _tmp8_;
				GeeList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_ = NULL;
				DataView* view;
				DataView* _tmp12_;
				gboolean _tmp13_ = FALSE;
				DataView* _tmp14_;
				DataView* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp5_ = _tmp4_;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp5_) {
#line 6339 "ViewCollection.c"
					gint _tmp6_;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp6_ = ctr;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					ctr = _tmp6_ + 1;
#line 6345 "ViewCollection.c"
				}
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp4_ = FALSE;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp8_ = count;
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 6357 "ViewCollection.c"
				}
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = to_show;
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view = (DataView*) _tmp11_;
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = data_view_is_visible (_tmp12_);
#line 1034 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				g_assert (!_tmp13_);
#line 1036 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1036 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp14_, TRUE);
#line 1039 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = view;
#line 1039 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = data_view_is_selected (_tmp15_);
#line 1039 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp16_) {
#line 6383 "ViewCollection.c"
					DataSet* _tmp17_;
					DataView* _tmp18_;
					gboolean _tmp19_ = FALSE;
					GeeArrayList* _tmp20_;
					DataView* _tmp21_;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp17_ = self->priv->selected;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp19_ = data_set_contains (_tmp17_, DATA_OBJECT (_tmp18_));
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					g_assert (!_tmp19_);
#line 1041 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp20_ = added_selected;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp21_ = view;
#line 1041 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp20_), _tmp21_);
#line 6403 "ViewCollection.c"
				}
#line 1032 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6407 "ViewCollection.c"
			}
		}
	}
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp22_ = to_show;
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp23_ = view_collection_add_many_visible (self, GEE_COLLECTION (_tmp22_));
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	added = _tmp23_;
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp24_ = added;
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp24_);
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp25_ = added_selected;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, GEE_COLLECTION (_tmp25_));
#line 1050 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp26_ = to_show;
#line 1050 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp27_ = gee_collection_get_size (GEE_COLLECTION (_tmp26_));
#line 1050 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp28_ = _tmp27_;
#line 1050 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp28_ > 0) {
#line 6433 "ViewCollection.c"
		GeeList* _tmp29_;
		GeeList* _tmp30_;
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp29_ = to_show;
#line 1051 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_shown (self, GEE_COLLECTION (_tmp29_));
#line 1052 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp30_ = to_show;
#line 1052 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (_tmp30_));
#line 6444 "ViewCollection.c"
	}
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 6448 "ViewCollection.c"
}


gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* _tmp2_;
	gboolean _tmp3_;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1058 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6476 "ViewCollection.c"
}


DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	GeeHashMap* _tmp0_;
	DataSource* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = source;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = (DataView*) _tmp2_;
#line 1063 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6499 "ViewCollection.c"
}


gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* _tmp2_;
	gboolean _tmp3_;
#line 1067 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1067 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source_filtered (self, _tmp0_);
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1068 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6527 "ViewCollection.c"
}


DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	GeeHashMap* _tmp0_;
	DataSource* _tmp1_;
	gpointer _tmp2_ = NULL;
	DataView* view;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp4_;
	gboolean _tmp7_;
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1072 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = source;
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 1073 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view = (DataView*) _tmp2_;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 6556 "ViewCollection.c"
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = view;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = view_collection_is_in_filter (self, _tmp5_);
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = !_tmp6_;
#line 6565 "ViewCollection.c"
	} else {
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 6569 "ViewCollection.c"
	}
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = _tmp3_;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp7_) {
#line 1076 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		result = NULL;
#line 1076 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 1076 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return result;
#line 6581 "ViewCollection.c"
	}
#line 1077 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = view;
#line 1077 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6587 "ViewCollection.c"
}


GeeCollection* view_collection_get_sources (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeCollection* _tmp6_;
#line 1081 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = gee_set_get_read_only_view (_tmp3_);
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = GEE_COLLECTION (_tmp5_);
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp6_;
#line 1082 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6622 "ViewCollection.c"
}


gboolean view_collection_has_source_of_type (ViewCollection* self, GType t) {
	gboolean result = FALSE;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1086 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp1_);
#line 6638 "ViewCollection.c"
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _source_it;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->source_map;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = gee_abstract_map_get_keys (GEE_MAP (_tmp2_));
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = gee_iterable_iterator (GEE_ITERABLE (_tmp5_));
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = _tmp6_;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp5_);
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_source_it = _tmp7_;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6665 "ViewCollection.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _source_it;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp9_) {
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 6683 "ViewCollection.c"
			}
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = _source_it;
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp11_;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_OBJECT (_tmp12_));
#line 1090 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1090 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1090 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 1091 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				result = TRUE;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1091 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_source_it);
#line 1091 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				return result;
#line 6709 "ViewCollection.c"
			}
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 6713 "ViewCollection.c"
		}
#line 1089 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 6717 "ViewCollection.c"
	}
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = FALSE;
#line 1094 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6723 "ViewCollection.c"
}


gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t) {
	gint result = 0;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint count;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1098 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp1_);
#line 1100 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	count = 0;
#line 6742 "ViewCollection.c"
	{
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (DATA_COLLECTION (self));
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6763 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 6784 "ViewCollection.c"
			}
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (DATA_VIEW (_tmp10_));
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = _tmp11_;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_OBJECT (_tmp12_));
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp16_ = _tmp15_;
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp12_);
#line 1102 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp16_) {
#line 6810 "ViewCollection.c"
				gint _tmp17_;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp17_ = count;
#line 1103 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				count = _tmp17_ + 1;
#line 6816 "ViewCollection.c"
			}
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6820 "ViewCollection.c"
		}
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6824 "ViewCollection.c"
	}
#line 1106 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = count;
#line 1106 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6830 "ViewCollection.c"
}


GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeList* sources;
#line 1109 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1110 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1110 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1110 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_assert (_tmp1_);
#line 1112 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	sources = NULL;
#line 6849 "ViewCollection.c"
	{
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (DATA_COLLECTION (self));
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6870 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 6891 "ViewCollection.c"
			}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 1114 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 1114 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (DATA_VIEW (_tmp10_));
#line 1114 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_OBJECT (_tmp12_));
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 6915 "ViewCollection.c"
				GeeList* _tmp16_;
				GeeList* _tmp18_;
				DataSource* _tmp19_;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = sources;
#line 1116 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp16_ == NULL) {
#line 6923 "ViewCollection.c"
					GeeArrayList* _tmp17_;
#line 1117 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp17_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1117 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1117 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					sources = GEE_LIST (_tmp17_);
#line 6931 "ViewCollection.c"
				}
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = sources;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 1119 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_collection_add (GEE_COLLECTION (_tmp18_), _tmp19_);
#line 6939 "ViewCollection.c"
			}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6945 "ViewCollection.c"
		}
#line 1113 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6949 "ViewCollection.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = sources;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 6955 "ViewCollection.c"
}


GeeList* view_collection_get_selected_sources (ViewCollection* self) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeList* sources;
	DataSet* _tmp1_;
	gint _tmp2_ = 0;
	gint count;
#line 1126 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1127 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1127 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	sources = GEE_LIST (_tmp0_);
#line 1129 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->selected;
#line 1129 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_count (_tmp1_);
#line 1129 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	count = _tmp2_;
#line 6978 "ViewCollection.c"
	{
		gint ctr;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		ctr = 0;
#line 6983 "ViewCollection.c"
		{
			gboolean _tmp3_;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6990 "ViewCollection.c"
				gboolean _tmp4_;
				gint _tmp6_;
				gint _tmp7_;
				GeeList* _tmp8_;
				DataSet* _tmp9_;
				gint _tmp10_;
				DataObject* _tmp11_ = NULL;
				DataView* _tmp12_;
				DataSource* _tmp13_ = NULL;
				DataSource* _tmp14_;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp4_ = _tmp3_;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp4_) {
#line 7005 "ViewCollection.c"
					gint _tmp5_;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp5_ = ctr;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					ctr = _tmp5_ + 1;
#line 7011 "ViewCollection.c"
				}
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp6_ = ctr;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp7_ = count;
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 1130 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 7023 "ViewCollection.c"
				}
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp8_ = sources;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp9_ = self->priv->selected;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp11_ = data_set_get_at (_tmp9_, _tmp10_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = DATA_VIEW (_tmp11_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = data_view_get_source (_tmp12_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_collection_add (GEE_COLLECTION (_tmp8_), _tmp14_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp12_);
#line 7045 "ViewCollection.c"
			}
		}
	}
#line 1133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = sources;
#line 1133 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 7053 "ViewCollection.c"
}


DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index) {
	DataSource* result = NULL;
	DataSet* _tmp0_;
	gint _tmp1_;
	DataObject* _tmp2_ = NULL;
	DataObject* object;
	DataSource* _tmp3_ = NULL;
	DataObject* _tmp4_;
#line 1136 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1137 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1137 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 1137 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_at (_tmp0_, _tmp1_);
#line 1137 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	object = _tmp2_;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = object;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 7079 "ViewCollection.c"
		DataObject* _tmp5_;
		DataSource* _tmp6_ = NULL;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = object;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp6_ = data_view_get_source (DATA_VIEW (_tmp5_));
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp6_;
#line 7090 "ViewCollection.c"
	} else {
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = NULL;
#line 7096 "ViewCollection.c"
	}
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (object);
#line 1139 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 7104 "ViewCollection.c"
}


GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	GeeList* sources;
#line 1142 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1143 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	sources = NULL;
#line 7115 "ViewCollection.c"
	{
		GeeList* _tmp0_ = NULL;
		GeeList* _view_list;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _view_size;
		gint _view_index;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp0_ = view_collection_get_selected (self);
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_view_list = _tmp0_;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = _view_list;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (_tmp1_));
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_view_size = _tmp3_;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_view_index = -1;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		while (TRUE) {
#line 7140 "ViewCollection.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			GeeList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_ = NULL;
			DataView* view;
			DataView* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp4_ = _view_index;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_index = _tmp4_ + 1;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp5_ = _view_index;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = _view_size;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				break;
#line 7167 "ViewCollection.c"
			}
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp7_ = _view_list;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp8_ = _view_index;
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp9_ = gee_list_get (_tmp7_, _tmp8_);
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			view = (DataView*) _tmp9_;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 1145 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_OBJECT (_tmp12_));
#line 1146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1146 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 7193 "ViewCollection.c"
				GeeList* _tmp16_;
				GeeList* _tmp18_;
				DataSource* _tmp19_;
#line 1147 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = sources;
#line 1147 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (_tmp16_ == NULL) {
#line 7201 "ViewCollection.c"
					GeeArrayList* _tmp17_;
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_tmp17_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1148 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					sources = GEE_LIST (_tmp17_);
#line 7209 "ViewCollection.c"
				}
#line 1150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp18_ = sources;
#line 1150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 1150 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				gee_collection_add (GEE_COLLECTION (_tmp18_), _tmp19_);
#line 7217 "ViewCollection.c"
			}
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 7223 "ViewCollection.c"
		}
#line 1144 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_list);
#line 7227 "ViewCollection.c"
	}
#line 1154 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = sources;
#line 1154 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 7233 "ViewCollection.c"
}


gint view_collection_index_of_source (ViewCollection* self, DataSource* source) {
	gint result = 0;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* view;
	gint _tmp2_ = 0;
	DataView* _tmp3_;
#line 1158 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1158 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 1159 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = view;
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 7258 "ViewCollection.c"
		DataView* _tmp4_;
		gint _tmp5_ = 0;
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (_tmp4_));
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = _tmp5_;
#line 7267 "ViewCollection.c"
	} else {
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = -1;
#line 7271 "ViewCollection.c"
	}
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1161 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 7279 "ViewCollection.c"
}


void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_ = FALSE;
#line 1165 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1165 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_are_notifications_frozen (DATA_COLLECTION (self));
#line 1166 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp0_) {
#line 7293 "ViewCollection.c"
		DataView* _tmp1_;
		DataView* _tmp2_;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = view;
#line 1167 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_item_view_altered (self, _tmp1_);
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_singleton (DATA_OBJECT (_tmp2_));
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = GEE_COLLECTION (_tmp3_);
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, _tmp4_);
#line 1168 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp4_);
#line 7312 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp5_;
		GeeHashSet* _tmp7_;
		DataView* _tmp8_;
#line 1170 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = self->priv->frozen_views_altered;
#line 1170 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp5_ == NULL) {
#line 7321 "ViewCollection.c"
			GeeHashSet* _tmp6_;
#line 1171 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 1171 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_views_altered);
#line 1171 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			self->priv->frozen_views_altered = _tmp6_;
#line 7329 "ViewCollection.c"
		}
#line 1172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_views_altered;
#line 1172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = view;
#line 1172 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp7_), _tmp8_);
#line 7337 "ViewCollection.c"
	}
}


void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_ = FALSE;
#line 1177 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1177 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1178 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_are_notifications_frozen (DATA_COLLECTION (self));
#line 1178 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!_tmp0_) {
#line 7352 "ViewCollection.c"
		DataView* _tmp1_;
		DataView* _tmp2_;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
#line 1179 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp1_ = view;
#line 1179 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_item_geometry_altered (self, _tmp1_);
#line 1180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 1180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_singleton (DATA_OBJECT (_tmp2_));
#line 1180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp4_ = GEE_COLLECTION (_tmp3_);
#line 1180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp4_);
#line 1180 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp4_);
#line 7371 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp5_;
		GeeHashSet* _tmp7_;
		DataView* _tmp8_;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp5_ = self->priv->frozen_geometries_altered;
#line 1182 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (_tmp5_ == NULL) {
#line 7380 "ViewCollection.c"
			GeeHashSet* _tmp6_;
#line 1183 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp6_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 1183 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1183 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			self->priv->frozen_geometries_altered = _tmp6_;
#line 7388 "ViewCollection.c"
		}
#line 1184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_geometries_altered;
#line 1184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = view;
#line 1184 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp7_), _tmp8_);
#line 7396 "ViewCollection.c"
	}
}


static void view_collection_real_notify_thawed (DataCollection* base) {
	ViewCollection * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp9_;
#line 1188 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (base);
#line 1189 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->frozen_views_altered;
#line 1189 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 7411 "ViewCollection.c"
		GeeHashSet* _tmp8_;
		{
			GeeHashSet* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _view_it;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp1_ = self->priv->frozen_views_altered;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp2_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (_tmp1_));
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_it = _tmp2_;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7425 "ViewCollection.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataView* view;
				DataView* _tmp7_;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp3_ = _view_it;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp4_) {
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 7440 "ViewCollection.c"
				}
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp5_ = _view_it;
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view = (DataView*) _tmp6_;
#line 1191 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1191 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view_collection_notify_item_view_altered (self, _tmp7_);
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7454 "ViewCollection.c"
			}
#line 1190 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7458 "ViewCollection.c"
		}
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp8_ = self->priv->frozen_views_altered;
#line 1192 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (_tmp8_));
#line 1193 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_views_altered);
#line 1193 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		self->priv->frozen_views_altered = NULL;
#line 7468 "ViewCollection.c"
	}
#line 1196 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = self->priv->frozen_geometries_altered;
#line 1196 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (_tmp9_ != NULL) {
#line 7474 "ViewCollection.c"
		GeeHashSet* _tmp17_;
		{
			GeeHashSet* _tmp10_;
			GeeIterator* _tmp11_ = NULL;
			GeeIterator* _view_it;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp10_ = self->priv->frozen_geometries_altered;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_tmp11_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (_tmp10_));
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_view_it = _tmp11_;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7488 "ViewCollection.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				DataView* view;
				DataView* _tmp16_;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp12_ = _view_it;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				if (!_tmp13_) {
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
					break;
#line 7503 "ViewCollection.c"
				}
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp14_ = _view_it;
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view = (DataView*) _tmp15_;
#line 1198 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 1198 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				view_collection_notify_item_geometry_altered (self, _tmp16_);
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7517 "ViewCollection.c"
			}
#line 1197 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7521 "ViewCollection.c"
		}
#line 1199 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_tmp17_ = self->priv->frozen_geometries_altered;
#line 1199 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (_tmp17_));
#line 1200 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1200 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		self->priv->frozen_geometries_altered = NULL;
#line 7531 "ViewCollection.c"
	}
#line 1203 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (DATA_COLLECTION (self));
#line 7535 "ViewCollection.c"
}


gboolean view_collection_are_items_filtered_out (ViewCollection* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 1206 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = _tmp0_ != _tmp1_;
#line 1207 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 7553 "ViewCollection.c"
}


static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 76 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 7560 "ViewCollection.c"
}


static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 80 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 7567 "ViewCollection.c"
}


static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 7574 "ViewCollection.c"
}


static void view_collection_real_selection_group_altered (ViewCollection* self) {
}


static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible) {
#line 95 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (visible));
#line 7585 "ViewCollection.c"
}


static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 7592 "ViewCollection.c"
}


static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 103 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 7599 "ViewCollection.c"
}


static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 107 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7606 "ViewCollection.c"
}


static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 111 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7613 "ViewCollection.c"
}


static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7620 "ViewCollection.c"
}


static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 117 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7627 "ViewCollection.c"
}


static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer) {
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 7634 "ViewCollection.c"
}


static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (n_param_values == 2);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data1 = closure->data;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 7653 "ViewCollection.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		data2 = closure->data;
#line 7659 "ViewCollection.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	callback (data1, value_get_view_filter (param_values + 1), data2);
#line 7665 "ViewCollection.c"
}


static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer) {
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 7672 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_construct (GType object_type) {
	ViewCollectionMonitor* self = NULL;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 7682 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_new (void) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 7689 "ViewCollection.c"
}


static void view_collection_value_monitor_init (GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 7696 "ViewCollection.c"
}


static void view_collection_value_monitor_free_value (GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_monitor_unref (value->data[0].v_pointer);
#line 7705 "ViewCollection.c"
	}
}


static void view_collection_value_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
#line 7715 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7719 "ViewCollection.c"
	}
}


static gpointer view_collection_value_monitor_peek_pointer (const GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7727 "ViewCollection.c"
}


static gchar* view_collection_value_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 7734 "ViewCollection.c"
		ViewCollectionMonitor* object;
		object = collect_values[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7741 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7745 "ViewCollection.c"
		}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_collection_monitor_ref (object);
#line 7749 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7753 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 7757 "ViewCollection.c"
}


static gchar* view_collection_value_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewCollectionMonitor** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!object_p) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7768 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 7774 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 7778 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
#line 7782 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 7786 "ViewCollection.c"
}


GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ViewCollectionParamSpecMonitor* spec;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 7800 "ViewCollection.c"
}


gpointer view_collection_value_get_monitor (const GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7809 "ViewCollection.c"
}


void view_collection_value_set_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_monitor_ref (value->data[0].v_pointer);
#line 7829 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7833 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7839 "ViewCollection.c"
	}
}


void view_collection_value_take_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 7858 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7862 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 7868 "ViewCollection.c"
	}
}


static void view_collection_monitor_class_init (ViewCollectionMonitorClass * klass) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_finalize;
#line 7878 "ViewCollection.c"
}


static void view_collection_monitor_instance_init (ViewCollectionMonitor * self) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 7885 "ViewCollection.c"
}


static void view_collection_monitor_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitor * self;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION_MONITOR (obj);
#line 7893 "ViewCollection.c"
}


GType view_collection_monitor_get_type (void) {
	static volatile gsize view_collection_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&view_collection_monitor_type_id__volatile, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__volatile;
}


gpointer view_collection_monitor_ref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return instance;
#line 7918 "ViewCollection.c"
}


void view_collection_monitor_unref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
#line 22 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7931 "ViewCollection.c"
	}
}


static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_sources_added (self, _sender, added);
#line 7939 "ViewCollection.c"
}


static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_sources_removed (self, removed);
#line 7946 "ViewCollection.c"
}


static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_on_sources_altered (self, _sender, items);
#line 7953 "ViewCollection.c"
}


static gpointer _view_manager_ref0 (gpointer self) {
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self ? view_manager_ref (self) : NULL;
#line 7960 "ViewCollection.c"
}


static gpointer _alteration_ref0 (gpointer self) {
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self ? alteration_ref (self) : NULL;
#line 7967 "ViewCollection.c"
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	SourceCollection* _tmp2_;
	SourceCollection* _tmp3_;
	ViewManager* _tmp4_;
	ViewManager* _tmp5_;
	Alteration* _tmp6_;
	Alteration* _tmp7_;
	SourceCollection* _tmp8_;
	ViewCollection* _tmp9_;
	SourceCollection* _tmp10_;
	ViewCollection* _tmp11_;
	SourceCollection* _tmp12_;
	ViewCollection* _tmp13_;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (owner), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = owner;
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->owner = _tmp1_;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = sources;
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = _data_collection_ref0 (_tmp2_);
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 34 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->sources = _tmp3_;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = manager;
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = _view_manager_ref0 (_tmp4_);
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 35 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->manager = _tmp5_;
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = prereq;
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = _alteration_ref0 (_tmp6_);
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 36 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->prereq = _tmp7_;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp8_ = sources;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp9_ = owner;
#line 38 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (DATA_COLLECTION (_tmp8_), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp9_);
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp10_ = sources;
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp11_ = owner;
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (DATA_COLLECTION (_tmp10_), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp11_);
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp12_ = sources;
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp13_ = owner;
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_connect (DATA_COLLECTION (_tmp12_), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp13_);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 8049 "ViewCollection.c"
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 8056 "ViewCollection.c"
}


static void view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass) {
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_impl_finalize;
#line 8065 "ViewCollection.c"
}


static void view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self) {
}


static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitorImpl * self;
	SourceCollection* _tmp0_;
	ViewCollection* _tmp1_;
	guint _tmp2_ = 0U;
	SourceCollection* _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_ = 0U;
	SourceCollection* _tmp6_;
	ViewCollection* _tmp7_;
	guint _tmp8_ = 0U;
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION_MONITOR_IMPL (obj);
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = self->sources;
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = self->owner;
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 44 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp0_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp1_);
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = self->sources;
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = self->owner;
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 45 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp3_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp4_);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = self->sources;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp7_ = self->owner;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp6_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp7_);
#line 26 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 27 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 28 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 29 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 25 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
#line 8120 "ViewCollection.c"
}


static GType view_collection_monitor_impl_get_type (void) {
	static volatile gsize view_collection_monitor_impl_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_monitor_impl_type_id__volatile, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__volatile;
}


static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
	ViewCollectionToggleLists * self = NULL;
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 8142 "ViewCollection.c"
}


static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 8149 "ViewCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
#line 8158 "ViewCollection.c"
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 51 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 51 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->selected = _tmp0_;
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->unselected = _tmp1_;
#line 8173 "ViewCollection.c"
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
#line 51 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->selected);
#line 52 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->unselected);
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
#line 8187 "ViewCollection.c"
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_collection_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected_unselected = view_collection_real_notify_items_selected_unselected;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_shown = view_collection_real_notify_items_shown;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_hidden = view_collection_real_notify_items_hidden;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_visibility_changed = view_collection_real_notify_items_visibility_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_installed = view_collection_real_notify_view_filter_installed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_removed = view_collection_real_notify_view_filter_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->add = view_collection_real_add;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->add_many = view_collection_real_add_many;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->items_altered = view_collection_real_items_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_thawed = view_collection_real_notify_thawed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->view_filter_installed = view_collection_real_view_filter_installed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->view_filter_removed = view_collection_real_view_filter_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("view_filter_installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("view_filter_removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 8324 "ViewCollection.c"
}


static void view_collection_instance_init (ViewCollection * self) {
	GeeHashMultiMap* _tmp0_;
	GeeHashSet* _tmp1_;
	DataSet* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GEqualFunc _tmp5_;
	GeeHashMap* _tmp6_;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, view_collection_monitor_unref, NULL, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->monitors = _tmp0_;
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 62 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->should_mirror = NULL;
#line 64 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, view_filter_unref, NULL, NULL);
#line 64 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->filters = GEE_SET (_tmp1_);
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp2_ = data_set_new ();
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->selected = _tmp2_;
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->visible = NULL;
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->frozen_views_altered = NULL;
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->frozen_geometries_altered = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp3_ = g_direct_hash;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp4_ = g_direct_equal;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp5_ = g_direct_equal;
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_tmp6_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp3_, _tmp4_, _tmp5_);
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->priv->source_map = _tmp6_;
#line 8372 "ViewCollection.c"
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_COLLECTION (obj);
#line 59 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->monitors);
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 64 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->filters);
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->selected);
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->visible);
#line 67 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_views_altered);
#line 68 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 72 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->source_map);
#line 21 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
#line 8398 "ViewCollection.c"
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}


static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
	gboolean result = FALSE;
#line 1217 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1218 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	result = TRUE;
#line 1218 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return result;
#line 8422 "ViewCollection.c"
}


gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 1217 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1217 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 8431 "ViewCollection.c"
}


static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 8440 "ViewCollection.c"
}


DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
#line 1223 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 8449 "ViewCollection.c"
}


ViewManager* view_manager_construct (GType object_type) {
	ViewManager* self = NULL;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewManager*) g_type_create_instance (object_type);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 8459 "ViewCollection.c"
}


static void value_view_manager_init (GValue* value) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8466 "ViewCollection.c"
}


static void value_view_manager_free_value (GValue* value) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_manager_unref (value->data[0].v_pointer);
#line 8475 "ViewCollection.c"
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
#line 8485 "ViewCollection.c"
	} else {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8489 "ViewCollection.c"
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8497 "ViewCollection.c"
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8504 "ViewCollection.c"
		ViewManager* object;
		object = collect_values[0].v_pointer;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8511 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8515 "ViewCollection.c"
		}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_manager_ref (object);
#line 8519 "ViewCollection.c"
	} else {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8523 "ViewCollection.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 8527 "ViewCollection.c"
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8538 "ViewCollection.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8544 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8548 "ViewCollection.c"
	} else {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = view_manager_ref (value->data[0].v_pointer);
#line 8552 "ViewCollection.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 8556 "ViewCollection.c"
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8570 "ViewCollection.c"
}


gpointer value_get_view_manager (const GValue* value) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8579 "ViewCollection.c"
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_manager_ref (value->data[0].v_pointer);
#line 8599 "ViewCollection.c"
	} else {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8603 "ViewCollection.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8609 "ViewCollection.c"
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8628 "ViewCollection.c"
	} else {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8632 "ViewCollection.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8638 "ViewCollection.c"
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_manager_parent_class = g_type_class_peek_parent (klass);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
#line 8652 "ViewCollection.c"
}


static void view_manager_instance_init (ViewManager * self) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8659 "ViewCollection.c"
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_MANAGER (obj);
#line 8667 "ViewCollection.c"
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return instance;
#line 8692 "ViewCollection.c"
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
#line 1213 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8705 "ViewCollection.c"
	}
}


static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view) {
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return FALSE;
#line 8715 "ViewCollection.c"
}


gboolean view_filter_predicate (ViewFilter* self, DataView* view) {
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (self), FALSE);
#line 1245 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return VIEW_FILTER_GET_CLASS (self)->predicate (self, view);
#line 8724 "ViewCollection.c"
}


ViewFilter* view_filter_construct (GType object_type) {
	ViewFilter* self = NULL;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = (ViewFilter*) g_type_create_instance (object_type);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return self;
#line 8734 "ViewCollection.c"
}


static void view_filter_real_refresh (ViewFilter* self) {
}


static void value_view_filter_init (GValue* value) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8745 "ViewCollection.c"
}


static void value_view_filter_free_value (GValue* value) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_filter_unref (value->data[0].v_pointer);
#line 8754 "ViewCollection.c"
	}
}


static void value_view_filter_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
#line 8764 "ViewCollection.c"
	} else {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8768 "ViewCollection.c"
	}
}


static gpointer value_view_filter_peek_pointer (const GValue* value) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8776 "ViewCollection.c"
}


static gchar* value_view_filter_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8783 "ViewCollection.c"
		ViewFilter* object;
		object = collect_values[0].v_pointer;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8790 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8794 "ViewCollection.c"
		}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_filter_ref (object);
#line 8798 "ViewCollection.c"
	} else {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8802 "ViewCollection.c"
	}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 8806 "ViewCollection.c"
}


static gchar* value_view_filter_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewFilter** object_p;
	object_p = collect_values[0].v_pointer;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8817 "ViewCollection.c"
	}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8823 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8827 "ViewCollection.c"
	} else {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		*object_p = view_filter_ref (value->data[0].v_pointer);
#line 8831 "ViewCollection.c"
	}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return NULL;
#line 8835 "ViewCollection.c"
}


GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewFilter* spec;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8849 "ViewCollection.c"
}


gpointer value_get_view_filter (const GValue* value) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8858 "ViewCollection.c"
}


void value_set_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_filter_ref (value->data[0].v_pointer);
#line 8878 "ViewCollection.c"
	} else {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8882 "ViewCollection.c"
	}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 8888 "ViewCollection.c"
	}
}


void value_take_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (v_object) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8907 "ViewCollection.c"
	} else {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8911 "ViewCollection.c"
	}
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (old) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 8917 "ViewCollection.c"
	}
}


static void view_filter_class_init (ViewFilterClass * klass) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	view_filter_parent_class = g_type_class_peek_parent (klass);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->finalize = view_filter_finalize;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->predicate = view_filter_real_predicate;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->refresh = view_filter_real_refresh;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8933 "ViewCollection.c"
}


static void view_filter_instance_init (ViewFilter * self) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8940 "ViewCollection.c"
}


static void view_filter_finalize (ViewFilter* obj) {
	ViewFilter * self;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	self = VIEW_FILTER (obj);
#line 8948 "ViewCollection.c"
}


GType view_filter_get_type (void) {
	static volatile gsize view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&view_filter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_filter_type_id;
		view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_filter_type_id__volatile, view_filter_type_id);
	}
	return view_filter_type_id__volatile;
}


gpointer view_filter_ref (gpointer instance) {
	ViewFilter* self;
	self = instance;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	return instance;
#line 8973 "ViewCollection.c"
}


void view_filter_unref (gpointer instance) {
	ViewFilter* self;
	self = instance;
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
#line 1238 "/builddir/build/BUILD/shotwell-0.12.0/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8986 "ViewCollection.c"
	}
}



