/* PhotoMetadata.c generated by valac 0.16.0, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2010-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
#define HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField))
#define HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))
#define IS_HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define IS_HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define HIERARCHICAL_KEYWORD_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))

typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
typedef struct _HierarchicalKeywordFieldClass HierarchicalKeywordFieldClass;
typedef struct _HierarchicalKeywordFieldPrivate HierarchicalKeywordFieldPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _gexiv2_metadata_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_metadata_free (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
typedef struct _Block1Data Block1Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _gexiv2_preview_image_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_preview_image_free (var), NULL)))

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _HierarchicalKeywordField {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HierarchicalKeywordFieldPrivate * priv;
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
};

struct _HierarchicalKeywordFieldClass {
	GTypeClass parent_class;
	void (*finalize) (HierarchicalKeywordField *self);
};

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, void* user_data);
struct _Block1Data {
	int _ref_count_;
	PhotoMetadata * self;
	gchar* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata * self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata * self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block5Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataDateTime* date_time;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};


static gpointer hierarchical_keyword_field_parent_class = NULL;
static gpointer photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gchar** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static gchar** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
gpointer hierarchical_keyword_field_ref (gpointer instance);
void hierarchical_keyword_field_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_keyword_field (GValue* value, gpointer v_object);
void value_take_hierarchical_keyword_field (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_keyword_field (const GValue* value);
GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST;
enum  {
	HIERARCHICAL_KEYWORD_FIELD_DUMMY_PROPERTY
};
HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable);
HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable);
static void hierarchical_keyword_field_finalize (HierarchicalKeywordField* obj);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static guint8* _vala_array_dup7 (guint8* self, int length);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag);
gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value);
static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda3_ (Block1Data* _data1_, const gchar* tag);
static void ___lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection);
static void _vala_array_add38 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add39 (gchar*** array, int* length, int* size, gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_, const gchar* tag);
static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda5_ (Block3Data* _data3_, const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gchar* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda6_ (Block4Data* _data4_, const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
const gchar* metadata_domain_to_string (MetadataDomain self);
void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda7_ (Block5Data* _data5_, const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup8 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
#define TAG_PATH_SEPARATOR_STRING "/"
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
HierarchicalTagIndex* hierarchical_tag_index_new (void);
HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
void hierarchical_tag_index_add_path (HierarchicalTagIndex* self, const gchar* tag, const gchar* path);
GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag, const gchar* foreign_separator);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
gint rating_serialize (Rating self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup9 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (MediaMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable) {
	HierarchicalKeywordField* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = field_name;
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 39 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->field_name = _tmp1_;
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = path_separator;
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 40 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp3_;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = wants_leading_separator;
#line 41 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = _tmp4_;
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = is_writeable;
#line 42 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->is_writeable = _tmp5_;
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self;
#line 668 "PhotoMetadata.c"
}


HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable) {
#line 37 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable);
#line 675 "PhotoMetadata.c"
}


static void value_hierarchical_keyword_field_init (GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 682 "PhotoMetadata.c"
}


static void value_hierarchical_keyword_field_free_value (GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 691 "PhotoMetadata.c"
	}
}


static void value_hierarchical_keyword_field_copy_value (const GValue* src_value, GValue* dest_value) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 701 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 705 "PhotoMetadata.c"
	}
}


static gpointer value_hierarchical_keyword_field_peek_pointer (const GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 713 "PhotoMetadata.c"
}


static gchar* value_hierarchical_keyword_field_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 720 "PhotoMetadata.c"
		HierarchicalKeywordField* object;
		object = collect_values[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 727 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 731 "PhotoMetadata.c"
		}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 735 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 739 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 743 "PhotoMetadata.c"
}


static gchar* value_hierarchical_keyword_field_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	HierarchicalKeywordField** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 754 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 760 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 764 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 768 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 772 "PhotoMetadata.c"
}


GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecHierarchicalKeywordField* spec;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 786 "PhotoMetadata.c"
}


gpointer value_get_hierarchical_keyword_field (const GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 795 "PhotoMetadata.c"
}


void value_set_hierarchical_keyword_field (GValue* value, gpointer v_object) {
	HierarchicalKeywordField* old;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 815 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 819 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 825 "PhotoMetadata.c"
	}
}


void value_take_hierarchical_keyword_field (GValue* value, gpointer v_object) {
	HierarchicalKeywordField* old;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 844 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 848 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 854 "PhotoMetadata.c"
	}
}


static void hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	HIERARCHICAL_KEYWORD_FIELD_CLASS (klass)->finalize = hierarchical_keyword_field_finalize;
#line 864 "PhotoMetadata.c"
}


static void hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 871 "PhotoMetadata.c"
}


static void hierarchical_keyword_field_finalize (HierarchicalKeywordField* obj) {
	HierarchicalKeywordField * self;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = HIERARCHICAL_KEYWORD_FIELD (obj);
#line 32 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 33 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 883 "PhotoMetadata.c"
}


GType hierarchical_keyword_field_get_type (void) {
	static volatile gsize hierarchical_keyword_field_type_id__volatile = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&hierarchical_keyword_field_type_id__volatile, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__volatile;
}


gpointer hierarchical_keyword_field_ref (gpointer instance) {
	HierarchicalKeywordField* self;
	self = instance;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return instance;
#line 908 "PhotoMetadata.c"
}


void hierarchical_keyword_field_unref (gpointer instance) {
	HierarchicalKeywordField* self;
	self = instance;
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 31 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 921 "PhotoMetadata.c"
	}
}


PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension) {
	PhotoPreview* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	Dimensions _tmp2_;
	guint32 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 54 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp1_;
#line 55 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = *dimensions;
#line 55 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp2_;
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = size;
#line 56 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->size = _tmp3_;
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = mime_type;
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 57 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp5_;
#line 58 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = extension;
#line 58 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 58 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 58 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp7_;
#line 53 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self;
#line 980 "PhotoMetadata.c"
}


gchar* photo_preview_get_name (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 61 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 62 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 62 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 62 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 62 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 998 "PhotoMetadata.c"
}


void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
	Dimensions _tmp0_;
#line 65 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 66 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return;
#line 1012 "PhotoMetadata.c"
}


guint32 photo_preview_get_size (PhotoPreview* self) {
	guint32 result = 0U;
	guint32 _tmp0_;
#line 69 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->size;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 70 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1027 "PhotoMetadata.c"
}


gchar* photo_preview_get_mime_type (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 73 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 74 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1045 "PhotoMetadata.c"
}


gchar* photo_preview_get_extension (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 77 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 78 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1063 "PhotoMetadata.c"
}


static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1072 "PhotoMetadata.c"
}


guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 81 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 1081 "PhotoMetadata.c"
}


static guint8* _vala_array_dup7 (guint8* self, int length) {
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 1088 "PhotoMetadata.c"
}


static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
	GdkPixbuf* result = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_ = NULL;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	GError * _inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_);
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flattened = _tmp1_;
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flattened_length1 = _tmp0_;
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 84 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return NULL;
#line 1114 "PhotoMetadata.c"
	}
	{
		guint8* _tmp2_;
		gint _tmp2__length1;
		GMemoryInputStream* _tmp3_;
		GMemoryInputStream* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = (flattened != NULL) ? _vala_array_dup7 (flattened, flattened_length1) : ((gpointer) flattened);
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2__length1 = flattened_length1;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp2_, _tmp2__length1, NULL);
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = gdk_pixbuf_new_from_stream (G_INPUT_STREAM (_tmp4_), NULL, &_inner_error_);
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp5_;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp4_);
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (_inner_error_ != NULL) {
#line 1142 "PhotoMetadata.c"
			goto __catch24_g_error;
		}
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = _tmp7_;
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 89 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 1151 "PhotoMetadata.c"
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = self->priv->name;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = err;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_->message;
#line 92 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:92: Unable to decode thumbnail for %s: %s", _tmp8_, _tmp10_);
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 94 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 1180 "PhotoMetadata.c"
	}
	__finally24:
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flattened = (g_free (flattened), NULL);
#line 88 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1189 "PhotoMetadata.c"
}


GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 83 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 1198 "PhotoMetadata.c"
}


static void value_photo_preview_init (GValue* value) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1205 "PhotoMetadata.c"
}


static void value_photo_preview_free_value (GValue* value) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 1214 "PhotoMetadata.c"
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 1224 "PhotoMetadata.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1228 "PhotoMetadata.c"
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1236 "PhotoMetadata.c"
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1243 "PhotoMetadata.c"
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1250 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1254 "PhotoMetadata.c"
		}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 1258 "PhotoMetadata.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1262 "PhotoMetadata.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1266 "PhotoMetadata.c"
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1277 "PhotoMetadata.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1283 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1287 "PhotoMetadata.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 1291 "PhotoMetadata.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 1295 "PhotoMetadata.c"
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1309 "PhotoMetadata.c"
}


gpointer value_get_photo_preview (const GValue* value) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1318 "PhotoMetadata.c"
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 1338 "PhotoMetadata.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1342 "PhotoMetadata.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (old) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1348 "PhotoMetadata.c"
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1367 "PhotoMetadata.c"
	} else {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1371 "PhotoMetadata.c"
	}
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (old) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1377 "PhotoMetadata.c"
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_preview_finalize;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_preview_real_flatten;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->get_pixbuf = photo_preview_real_get_pixbuf;
#line 1393 "PhotoMetadata.c"
}


static void photo_preview_instance_init (PhotoPreview * self) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1402 "PhotoMetadata.c"
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_PREVIEW (obj);
#line 47 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 50 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 51 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 1416 "PhotoMetadata.c"
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return instance;
#line 1441 "PhotoMetadata.c"
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 46 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1454 "PhotoMetadata.c"
	}
}


GType photo_metadata_set_option_get_type (void) {
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}


PhotoMetadata* photo_metadata_construct (GType object_type) {
	PhotoMetadata* self = NULL;
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self;
#line 1477 "PhotoMetadata.c"
}


PhotoMetadata* photo_metadata_new (void) {
#line 139 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1484 "PhotoMetadata.c"
}


static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error) {
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	ExifData* _tmp8_ = NULL;
	GFile* _tmp9_;
	gchar* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 142 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 143 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 144 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = file;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp4_, &_inner_error_);
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp4_);
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 146 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 1534 "PhotoMetadata.c"
	}
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = file;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = exif_data_new_from_file (_tmp7_);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp8_;
#line 147 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = file;
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_file_get_basename (_tmp9_);
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 148 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp10_;
#line 1558 "PhotoMetadata.c"
}


void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
	GExiv2Metadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 151 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = file;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp3_, &_inner_error_);
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 1590 "PhotoMetadata.c"
	}
}


void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	GExiv2Metadata* _tmp4_;
	GExiv2Metadata* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 155 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 156 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1618 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 157 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 157 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 157 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1627 "PhotoMetadata.c"
	}
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 159 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_assert (_tmp2__length1 >= _tmp3_);
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 161 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 162 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 164 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 1663 "PhotoMetadata.c"
	}
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 165 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<memory buffer %d bytes>", _tmp11_);
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 166 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1685 "PhotoMetadata.c"
}


void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	GExiv2Metadata* _tmp4_;
	GExiv2Metadata* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 169 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 170 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1712 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 171 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 171 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 171 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1721 "PhotoMetadata.c"
	}
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 173 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_assert (_tmp2__length1 >= _tmp3_);
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 175 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 176 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 178 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 1757 "PhotoMetadata.c"
	}
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 179 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<app1 segment %d bytes>", _tmp11_);
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 180 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1779 "PhotoMetadata.c"
}


MetadataDomain photo_metadata_get_tag_domain (const gchar* tag) {
	MetadataDomain result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 183 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_is_exif_tag (_tmp0_);
#line 184 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 185 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 1803 "PhotoMetadata.c"
	}
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = tag;
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_is_xmp_tag (_tmp2_);
#line 187 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 188 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 1815 "PhotoMetadata.c"
	}
#line 190 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = tag;
#line 190 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = gexiv2_metadata_is_iptc_tag (_tmp4_);
#line 190 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 191 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 1827 "PhotoMetadata.c"
	}
#line 193 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 193 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1833 "PhotoMetadata.c"
}


gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_;
#line 196 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1848 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_has_exif (_tmp1_);
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 199 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1860 "PhotoMetadata.c"
		}
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1864 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_has_xmp (_tmp3_);
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 202 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1876 "PhotoMetadata.c"
		}
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1880 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_;
			gboolean _tmp6_ = FALSE;
#line 205 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 205 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_has_iptc (_tmp5_);
#line 205 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 205 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1892 "PhotoMetadata.c"
		}
		default:
#line 197 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1897 "PhotoMetadata.c"
		{
#line 209 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 209 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1903 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_has_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 213 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 214 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1920 "PhotoMetadata.c"
}


gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 217 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 218 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 218 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 218 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1935 "PhotoMetadata.c"
}


gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 221 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 222 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 1950 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_;
#line 225 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1965 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_get_supports_exif (_tmp1_);
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 228 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1977 "PhotoMetadata.c"
		}
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1981 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_get_supports_xmp (_tmp3_);
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 231 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 1993 "PhotoMetadata.c"
		}
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1997 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_;
			gboolean _tmp6_ = FALSE;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_get_supports_iptc (_tmp5_);
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 234 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 2009 "PhotoMetadata.c"
		}
		default:
#line 226 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 2014 "PhotoMetadata.c"
		{
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 238 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			return result;
#line 2020 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 242 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 243 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2037 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 246 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 247 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 247 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 247 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2052 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 250 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 251 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2067 "PhotoMetadata.c"
}


gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 254 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_has_tag (_tmp0_, _tmp1_);
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 255 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2090 "PhotoMetadata.c"
}


static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	GCompareFunc _tmp0_;
#line 258 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 260 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 2103 "PhotoMetadata.c"
		GeeHashSet* _tmp1_;
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = GEE_SET (_tmp1_);
#line 261 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 2111 "PhotoMetadata.c"
	} else {
		GCompareFunc _tmp2_;
		GeeTreeSet* _tmp3_;
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = compare_func;
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp2_);
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = GEE_SET (_tmp3_);
#line 263 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 2123 "PhotoMetadata.c"
	}
}


GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	gchar** tags;
	gint tags_length1;
	gint _tags_size_;
	MetadataDomain _tmp0_;
	gboolean _tmp10_ = FALSE;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gboolean _tmp13_;
	GCompareFunc _tmp14_;
	GeeSet* _tmp15_ = NULL;
	GeeCollection* collection;
	gchar** _tmp16_;
	gint _tmp16__length1;
#line 266 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 267 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 2157 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_ = NULL;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_ = gexiv2_metadata_get_exif_tags (_tmp1_);
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = _tmp3_;
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp2_);
#line 270 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 271 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 2176 "PhotoMetadata.c"
		}
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 2180 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_ = NULL;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->exiv2;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = _tmp5_ = gexiv2_metadata_get_xmp_tags (_tmp4_);
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = _tmp6_;
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp5_);
#line 274 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 275 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 2199 "PhotoMetadata.c"
		}
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2203 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp7_;
			gchar** _tmp8_;
			gchar** _tmp9_ = NULL;
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp7_ = self->priv->exiv2;
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_ = gexiv2_metadata_get_iptc_tags (_tmp7_);
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags = _tmp9_;
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp8_);
#line 278 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 279 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 2222 "PhotoMetadata.c"
		}
		default:
#line 268 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		break;
#line 2227 "PhotoMetadata.c"
	}
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = tags;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11__length1 = tags_length1;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp11_ == NULL) {
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = TRUE;
#line 2237 "PhotoMetadata.c"
	} else {
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = tags;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12__length1 = tags_length1;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12__length1 == 0;
#line 2247 "PhotoMetadata.c"
	}
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp10_;
#line 282 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 283 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 2259 "PhotoMetadata.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = compare_func;
#line 285 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15_ = photo_metadata_create_string_set (self, _tmp14_);
#line 285 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	collection = GEE_COLLECTION (_tmp15_);
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = tags;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16__length1 = tags_length1;
#line 2271 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp16_;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp16__length1;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp16__length1; tag_it = tag_it + 1) {
#line 2283 "PhotoMetadata.c"
			gchar* _tmp17_;
			gchar* tag = NULL;
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp17_ = g_strdup (tag_collection[tag_it]);
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp17_;
#line 2290 "PhotoMetadata.c"
			{
				GeeCollection* _tmp18_;
				const gchar* _tmp19_;
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp18_ = collection;
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp19_ = tag;
#line 287 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp18_, _tmp19_);
#line 286 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2302 "PhotoMetadata.c"
			}
		}
	}
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = collection;
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 289 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2312 "PhotoMetadata.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 2319 "PhotoMetadata.c"
}


GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	GCompareFunc _tmp0_;
	GeeSet* _tmp1_ = NULL;
	GeeCollection* all_tags;
	GeeCollection* _tmp2_ = NULL;
	GeeCollection* exif_tags;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	gboolean _tmp8_;
	GeeCollection* _tmp11_ = NULL;
	GeeCollection* xmp_tags;
	gboolean _tmp12_ = FALSE;
	GeeCollection* _tmp13_;
	gboolean _tmp17_;
	GeeCollection* _tmp20_ = NULL;
	GeeCollection* iptc_tags;
	gboolean _tmp21_ = FALSE;
	GeeCollection* _tmp22_;
	gboolean _tmp26_;
	GeeCollection* _tmp29_ = NULL;
	GeeCollection* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeCollection* _tmp34_;
	GeeCollection* _tmp35_;
#line 292 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_);
#line 293 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	all_tags = GEE_COLLECTION (_tmp1_);
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL);
#line 295 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 2365 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 2377 "PhotoMetadata.c"
	} else {
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 2381 "PhotoMetadata.c"
	}
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp3_;
#line 296 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 2387 "PhotoMetadata.c"
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = all_tags;
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = exif_tags;
#line 297 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp9_, _tmp10_);
#line 2396 "PhotoMetadata.c"
	}
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL);
#line 299 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp11_;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = xmp_tags;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp13_ != NULL) {
#line 2406 "PhotoMetadata.c"
		GeeCollection* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp14_ = xmp_tags;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp15_ = gee_collection_get_size (_tmp14_);
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp16_ = _tmp15_;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp16_ > 0;
#line 2418 "PhotoMetadata.c"
	} else {
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = FALSE;
#line 2422 "PhotoMetadata.c"
	}
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = _tmp12_;
#line 300 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp17_) {
#line 2428 "PhotoMetadata.c"
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp18_ = all_tags;
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp19_ = xmp_tags;
#line 301 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp18_, _tmp19_);
#line 2437 "PhotoMetadata.c"
	}
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp20_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL);
#line 303 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp20_;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp22_ = iptc_tags;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp22_ != NULL) {
#line 2447 "PhotoMetadata.c"
		GeeCollection* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = iptc_tags;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = gee_collection_get_size (_tmp23_);
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp25_ = _tmp24_;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp25_ > 0;
#line 2459 "PhotoMetadata.c"
	} else {
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = FALSE;
#line 2463 "PhotoMetadata.c"
	}
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp26_ = _tmp21_;
#line 304 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp26_) {
#line 2469 "PhotoMetadata.c"
		GeeCollection* _tmp27_;
		GeeCollection* _tmp28_;
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp27_ = all_tags;
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp28_ = iptc_tags;
#line 305 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp27_, _tmp28_);
#line 2478 "PhotoMetadata.c"
	}
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp30_ = all_tags;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_ = gee_collection_get_size (_tmp30_);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp32_ = _tmp31_;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp32_ > 0) {
#line 2488 "PhotoMetadata.c"
		GeeCollection* _tmp33_;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp33_ = all_tags;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp29_ = _tmp33_;
#line 2494 "PhotoMetadata.c"
	} else {
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp29_ = NULL;
#line 2498 "PhotoMetadata.c"
	}
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp34_ = _tmp29_;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp35_ = _g_object_ref0 (_tmp34_);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp35_;
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 307 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2516 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
#line 310 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 310 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_label (_tmp0_);
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 311 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2539 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 314 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_description (_tmp0_);
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 315 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2562 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
#line 318 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 318 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_string (_tmp0_, _tmp1_);
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = prepare_input_text (_tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp5_;
#line 319 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2596 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
#line 322 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 322 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, _tmp1_);
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = prepare_input_text (_tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp5_;
#line 323 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2630 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 326 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2644 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2656 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2663 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_ = NULL;
				gchar* value;
				const gchar* _tmp4_;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string (self, _tmp2_);
#line 328 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 329 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 329 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 330 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = value;
#line 330 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 330 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 2685 "PhotoMetadata.c"
				}
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 327 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2691 "PhotoMetadata.c"
			}
		}
	}
#line 333 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 333 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2699 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 336 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2713 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2725 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2732 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_ = NULL;
				gchar* value;
				const gchar* _tmp4_;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_interpreted (self, _tmp2_);
#line 338 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 339 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = value;
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 340 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 2754 "PhotoMetadata.c"
				}
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 337 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2760 "PhotoMetadata.c"
			}
		}
	}
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 343 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2768 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag) {
	GeeList* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp7_;
	GeeArrayList* _tmp8_;
	GeeList* list;
	GeeHashSet* _tmp9_;
	GeeHashSet* collection;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeList* _tmp24_ = NULL;
	GeeList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GeeList* _tmp29_;
	GeeList* _tmp30_;
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 352 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_tag_multiple (_tmp0_, _tmp1_);
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values = _tmp3_;
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp2_);
#line 353 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = values;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = values_length1;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp5_ == NULL) {
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = TRUE;
#line 2821 "PhotoMetadata.c"
	} else {
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = values;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = values_length1;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp6__length1 == 0;
#line 2831 "PhotoMetadata.c"
	}
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp4_;
#line 354 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp7_) {
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 355 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 2843 "PhotoMetadata.c"
	}
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 357 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	list = GEE_LIST (_tmp8_);
#line 359 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 359 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	collection = _tmp9_;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = values;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10__length1 = values_length1;
#line 2857 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value_collection = _tmp10_;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp10__length1;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < _tmp10__length1; value_it = value_it + 1) {
#line 2869 "PhotoMetadata.c"
			gchar* _tmp11_;
			gchar* value = NULL;
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp11_ = g_strdup (value_collection[value_it]);
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			value = _tmp11_;
#line 2876 "PhotoMetadata.c"
			{
				const gchar* _tmp12_;
				gchar* _tmp13_ = NULL;
				gchar* prepped;
				gboolean _tmp14_ = FALSE;
				const gchar* _tmp15_;
				gboolean _tmp19_;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp12_ = value;
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp13_ = prepare_input_text (_tmp12_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 361 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				prepped = _tmp13_;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp15_ = prepped;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp15_ != NULL) {
#line 2894 "PhotoMetadata.c"
					GeeHashSet* _tmp16_;
					const gchar* _tmp17_;
					gboolean _tmp18_ = FALSE;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp16_ = collection;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp17_ = prepped;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp18_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (_tmp16_), _tmp17_);
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp14_ = !_tmp18_;
#line 2906 "PhotoMetadata.c"
				} else {
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp14_ = FALSE;
#line 2910 "PhotoMetadata.c"
				}
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp19_ = _tmp14_;
#line 364 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp19_) {
#line 2916 "PhotoMetadata.c"
					GeeList* _tmp20_;
					const gchar* _tmp21_;
					GeeHashSet* _tmp22_;
					const gchar* _tmp23_;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp20_ = list;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp21_ = prepped;
#line 365 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					gee_collection_add (GEE_COLLECTION (_tmp20_), _tmp21_);
#line 366 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp22_ = collection;
#line 366 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp23_ = prepped;
#line 366 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp22_), _tmp23_);
#line 2933 "PhotoMetadata.c"
				}
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 360 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 2939 "PhotoMetadata.c"
			}
		}
	}
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp25_ = list;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp26_ = gee_collection_get_size (GEE_COLLECTION (_tmp25_));
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp27_ = _tmp26_;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp27_ > 0) {
#line 2951 "PhotoMetadata.c"
		GeeList* _tmp28_;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp28_ = list;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = _tmp28_;
#line 2957 "PhotoMetadata.c"
	} else {
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = NULL;
#line 2961 "PhotoMetadata.c"
	}
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp24_;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp30_ = _g_object_ref0 (_tmp29_);
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp30_;
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 370 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 2977 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1) {
	GeeList* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 379 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2991 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3003 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3010 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				GeeList* _tmp3_ = NULL;
				GeeList* values;
				gboolean _tmp4_ = FALSE;
				GeeList* _tmp5_;
				gboolean _tmp9_;
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 381 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				values = _tmp3_;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 3028 "PhotoMetadata.c"
					GeeList* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (GEE_COLLECTION (_tmp6_));
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 3040 "PhotoMetadata.c"
				} else {
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 3044 "PhotoMetadata.c"
				}
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp4_;
#line 382 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp9_) {
#line 383 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = values;
#line 383 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 383 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 3056 "PhotoMetadata.c"
				}
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 380 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3062 "PhotoMetadata.c"
			}
		}
	}
#line 386 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 386 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 3070 "PhotoMetadata.c"
}


void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* prepped;
	const gchar* _tmp2_;
	GExiv2Metadata* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 390 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 390 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = prepare_input_text (_tmp0_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 390 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	prepped = _tmp1_;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = prepped;
#line 391 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == NULL) {
#line 3099 "PhotoMetadata.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = tag;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = value;
#line 392 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:392: Not setting tag %s to string %s: invalid UTF-8", _tmp3_, _tmp4_);
#line 394 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 394 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 3112 "PhotoMetadata.c"
	}
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = tag;
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = prepped;
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = gexiv2_metadata_set_tag_string (_tmp5_, _tmp6_, _tmp7_);
#line 397 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp8_) {
#line 3124 "PhotoMetadata.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = tag;
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = value;
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp11_ = self->priv->source_name;
#line 398 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:398: Unable to set tag %s to string %s from source " \
"%s", _tmp9_, _tmp10_, _tmp11_);
#line 3136 "PhotoMetadata.c"
	}
#line 389 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 3140 "PhotoMetadata.c"
}


static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target) {
	gboolean written;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PhotoMetadataSetOption _tmp12_;
	gboolean _tmp14_;
	gboolean _tmp16_;
#line 403 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 404 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3161 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3173 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3180 "PhotoMetadata.c"
			{
				gboolean _tmp2_ = FALSE;
				PhotoMetadataSetOption _tmp3_;
				gboolean _tmp7_;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = option;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp3_ == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp2_ = TRUE;
#line 3191 "PhotoMetadata.c"
				} else {
					const gchar* _tmp4_;
					MetadataDomain _tmp5_ = 0;
					gboolean _tmp6_ = FALSE;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = tag;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp5_ = photo_metadata_get_tag_domain (_tmp4_);
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp6_ = photo_metadata_has_domain (self, _tmp5_);
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp2_ = _tmp6_;
#line 3204 "PhotoMetadata.c"
				}
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7_ = _tmp2_;
#line 406 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp7_) {
#line 3210 "PhotoMetadata.c"
					PhotoMetadataSetGenericValue _tmp8_;
					void* _tmp8__target;
					const gchar* _tmp9_;
#line 407 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8_ = setter;
#line 407 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8__target = setter_target;
#line 407 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp9_ = tag;
#line 407 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8_ (_tmp9_, _tmp8__target);
#line 408 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 3224 "PhotoMetadata.c"
				}
#line 405 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3228 "PhotoMetadata.c"
			}
		}
	}
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = option;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp12_ == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 3236 "PhotoMetadata.c"
		gboolean _tmp13_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp13_ = written;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp11_ = !_tmp13_;
#line 3242 "PhotoMetadata.c"
	} else {
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 3246 "PhotoMetadata.c"
	}
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = _tmp11_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp14_) {
#line 3252 "PhotoMetadata.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp15_ = tags;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp15__length1 = tags_length1;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp15__length1 > 0;
#line 3261 "PhotoMetadata.c"
	} else {
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 3265 "PhotoMetadata.c"
	}
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp10_;
#line 412 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp16_) {
#line 3271 "PhotoMetadata.c"
		gchar** _tmp17_;
		gint _tmp17__length1;
		const gchar* _tmp18_;
		MetadataDomain _tmp19_ = 0;
		MetadataDomain default_domain;
		PhotoMetadataSetGenericValue _tmp20_;
		void* _tmp20__target;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp17_ = tags;
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp17__length1 = tags_length1;
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp18_ = _tmp17_[0];
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp19_ = photo_metadata_get_tag_domain (_tmp18_);
#line 413 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		default_domain = _tmp19_;
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp20_ = setter;
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp20__target = setter_target;
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = tags;
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21__length1 = tags_length1;
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_[0];
#line 416 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp20_ (_tmp22_, _tmp20__target);
#line 3304 "PhotoMetadata.c"
		{
			gint ctr;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 3309 "PhotoMetadata.c"
			{
				gboolean _tmp23_;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp23_ = TRUE;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 3316 "PhotoMetadata.c"
					gboolean _tmp24_;
					gint _tmp26_;
					gchar** _tmp27_;
					gint _tmp27__length1;
					gchar** _tmp28_;
					gint _tmp28__length1;
					gint _tmp29_;
					const gchar* _tmp30_;
					MetadataDomain _tmp31_ = 0;
					MetadataDomain _tmp32_;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp24_ = _tmp23_;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (!_tmp24_) {
#line 3331 "PhotoMetadata.c"
						gint _tmp25_;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp25_ = ctr;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						ctr = _tmp25_ + 1;
#line 3337 "PhotoMetadata.c"
					}
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp23_ = FALSE;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp26_ = ctr;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp27_ = tags;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp27__length1 = tags_length1;
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (!(_tmp26_ < _tmp27__length1)) {
#line 419 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						break;
#line 3351 "PhotoMetadata.c"
					}
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp28_ = tags;
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp28__length1 = tags_length1;
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp29_ = ctr;
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp30_ = _tmp28_[_tmp29_];
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp31_ = photo_metadata_get_tag_domain (_tmp30_);
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp32_ = default_domain;
#line 420 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (_tmp31_ == _tmp32_) {
#line 3367 "PhotoMetadata.c"
						PhotoMetadataSetGenericValue _tmp33_;
						void* _tmp33__target;
						gchar** _tmp34_;
						gint _tmp34__length1;
						gint _tmp35_;
						const gchar* _tmp36_;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp33_ = setter;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp33__target = setter_target;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp34_ = tags;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp34__length1 = tags_length1;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp35_ = ctr;
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp36_ = _tmp34_[_tmp35_];
#line 421 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp33_ (_tmp36_, _tmp33__target);
#line 3388 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return _data1_;
#line 3402 "PhotoMetadata.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 3411 "PhotoMetadata.c"
		PhotoMetadata * self;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		self = _data1_->self;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_data1_->value);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_slice_free (Block1Data, _data1_);
#line 3421 "PhotoMetadata.c"
	}
}


static void __lambda3_ (Block1Data* _data1_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = _data1_->self;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data1_->value;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, _tmp0_, _tmp1_);
#line 3440 "PhotoMetadata.c"
}


static void ___lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	__lambda3_ (self, tag);
#line 3447 "PhotoMetadata.c"
}


void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option) {
	Block1Data* _data1_;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data1_->_ref_count_ = 1;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data1_->self = media_metadata_ref (self);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data1_->value = _tmp1_;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 427 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda3__photo_metadata_set_generic_value, _data1_);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	block1_data_unref (_data1_);
#line 426 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data1_ = NULL;
#line 3486 "PhotoMetadata.c"
}


static void _vala_array_add38 (gchar*** array, int* length, int* size, gchar* value) {
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3497 "PhotoMetadata.c"
	}
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3503 "PhotoMetadata.c"
}


static void _vala_array_add39 (gchar*** array, int* length, int* size, gchar* value) {
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3514 "PhotoMetadata.c"
	}
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3520 "PhotoMetadata.c"
}


void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection) {
	gchar** _tmp0_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GExiv2Metadata* _tmp17_;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gboolean _tmp20_ = FALSE;
#line 430 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 430 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 430 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (collection));
#line 431 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 431 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 431 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 431 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 3552 "PhotoMetadata.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _value_it;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = collection;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_value_it = _tmp2_;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 3565 "PhotoMetadata.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			gchar* value;
			const gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* prepped;
			const gchar* _tmp9_;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			if (!_tmp4_) {
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				break;
#line 3583 "PhotoMetadata.c"
			}
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp5_ = _value_it;
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp6_;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp7_ = value;
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp8_ = prepare_input_text (_tmp7_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 433 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			prepped = _tmp8_;
#line 434 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp9_ = prepped;
#line 434 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			if (_tmp9_ != NULL) {
#line 3601 "PhotoMetadata.c"
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar* _tmp12_;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp10_ = values;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp10__length1 = values_length1;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp11_ = prepped;
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 435 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_vala_array_add38 (&values, &values_length1, &_values_size_, _tmp12_);
#line 3616 "PhotoMetadata.c"
			} else {
				const gchar* _tmp13_;
				const gchar* _tmp14_;
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp13_ = value;
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp14_ = tag;
#line 437 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:437: Unable to set string %s to %s: invalid UTF-8", _tmp13_, _tmp14_);
#line 3626 "PhotoMetadata.c"
			}
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 3632 "PhotoMetadata.c"
		}
#line 432 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 3636 "PhotoMetadata.c"
	}
#line 440 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15_ = values;
#line 440 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15__length1 = values_length1;
#line 440 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp15__length1 == 0) {
#line 441 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 441 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 3648 "PhotoMetadata.c"
	}
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = values;
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16__length1 = values_length1;
#line 447 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_array_add39 (&values, &values_length1, &_values_size_, NULL);
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = self->priv->exiv2;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_ = tag;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp19_ = values;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = values_length1;
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp20_ = gexiv2_metadata_set_tag_multiple (_tmp17_, _tmp18_, _tmp19_);
#line 449 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp20_) {
#line 3668 "PhotoMetadata.c"
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = values;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21__length1 = values_length1;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp22_ = tag;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = self->priv->source_name;
#line 450 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:450: Unable to set %d strings to tag %s from source" \
" %s", _tmp21__length1, _tmp22_, _tmp23_);
#line 3683 "PhotoMetadata.c"
	}
#line 430 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 3687 "PhotoMetadata.c"
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return _data2_;
#line 3696 "PhotoMetadata.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3705 "PhotoMetadata.c"
		PhotoMetadata * self;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		self = _data2_->self;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data2_->values);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_slice_free (Block2Data, _data2_);
#line 3715 "PhotoMetadata.c"
	}
}


static void __lambda4_ (Block2Data* _data2_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	GeeCollection* _tmp1_;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = _data2_->self;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data2_->values;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, _tmp0_, _tmp1_);
#line 3734 "PhotoMetadata.c"
}


static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	__lambda4_ (self, tag);
#line 3741 "PhotoMetadata.c"
}


void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option) {
	Block2Data* _data2_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (values));
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data2_->_ref_count_ = 1;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data2_->self = media_metadata_ref (self);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = values;
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data2_->values = _tmp1_;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 454 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda4__photo_metadata_set_generic_value, _data2_);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	block2_data_unref (_data2_);
#line 453 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data2_ = NULL;
#line 3780 "PhotoMetadata.c"
}


gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GExiv2Metadata* _tmp2_;
	const gchar* _tmp3_;
	glong _tmp4_ = 0L;
#line 457 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 457 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, _tmp0_);
#line 458 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 459 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_vala_value = (glong) 0;
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (value) {
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 3810 "PhotoMetadata.c"
		}
#line 461 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 3814 "PhotoMetadata.c"
	}
#line 464 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 464 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = tag;
#line 464 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_tag_long (_tmp2_, _tmp3_);
#line 464 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_value = _tmp4_;
#line 466 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 466 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (value) {
#line 466 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3830 "PhotoMetadata.c"
	}
#line 466 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 3834 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 469 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3849 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3861 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3868 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				glong _tmp3_ = 0L;
				gboolean _tmp4_ = FALSE;
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_long (self, _tmp2_, &_tmp3_);
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_vala_value = _tmp3_;
#line 471 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (value) {
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 3889 "PhotoMetadata.c"
					}
#line 472 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 3893 "PhotoMetadata.c"
				}
#line 470 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3897 "PhotoMetadata.c"
			}
		}
	}
#line 475 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (value) {
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3909 "PhotoMetadata.c"
	}
#line 477 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 3913 "PhotoMetadata.c"
}


void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	glong _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 480 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 480 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_set_tag_long (_tmp0_, _tmp1_, _tmp2_);
#line 481 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp3_) {
#line 3936 "PhotoMetadata.c"
		const gchar* _tmp4_;
		glong _tmp5_;
		const gchar* _tmp6_;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = tag;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = value;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->source_name;
#line 482 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:482: Unable to set tag %s to long %ld from source %" \
"s", _tmp4_, _tmp5_, _tmp6_);
#line 3948 "PhotoMetadata.c"
	}
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return _data3_;
#line 3958 "PhotoMetadata.c"
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3967 "PhotoMetadata.c"
		PhotoMetadata * self;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		self = _data3_->self;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 3975 "PhotoMetadata.c"
	}
}


static void __lambda5_ (Block3Data* _data3_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	glong _tmp1_;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data3_->value;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, _tmp0_, _tmp1_);
#line 3994 "PhotoMetadata.c"
}


static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 4001 "PhotoMetadata.c"
}


void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option) {
	Block3Data* _data3_;
	glong _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	PhotoMetadataSetOption _tmp2_;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data3_->value = _tmp0_;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 486 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda5__photo_metadata_set_generic_value, _data3_);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 485 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 4035 "PhotoMetadata.c"
}


gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gint numerator = 0;
	gint denominator = 0;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _result_;
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 489 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	numerator = _tmp2_;
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	denominator = _tmp3_;
#line 491 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_result_ = _tmp4_;
#line 493 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, numerator, denominator);
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _result_;
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4074 "PhotoMetadata.c"
	}
#line 495 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 4078 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 498 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4093 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4105 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4112 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				MetadataRational _tmp3_ = {0};
				gboolean _tmp4_ = FALSE;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_rational (self, _tmp2_, &_tmp3_);
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp3_;
#line 500 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (rational) {
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 4133 "PhotoMetadata.c"
					}
#line 501 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 4137 "PhotoMetadata.c"
				}
#line 499 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4141 "PhotoMetadata.c"
			}
		}
	}
#line 504 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4153 "PhotoMetadata.c"
	}
#line 506 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 4157 "PhotoMetadata.c"
}


void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	MetadataRational _tmp2_;
	gint _tmp3_;
	MetadataRational _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 509 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = *rational;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = gexiv2_metadata_set_exif_tag_rational (_tmp0_, _tmp1_, _tmp3_, _tmp5_);
#line 510 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 4191 "PhotoMetadata.c"
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		const gchar* _tmp10_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = tag;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = metadata_rational_to_string (rational);
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:511: Unable to set tag %s to rational %s from sourc" \
"e %s", _tmp7_, _tmp9_, _tmp10_);
#line 511 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp9_);
#line 4208 "PhotoMetadata.c"
	}
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return _data4_;
#line 4218 "PhotoMetadata.c"
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4227 "PhotoMetadata.c"
		PhotoMetadata * self;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		self = _data4_->self;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 4235 "PhotoMetadata.c"
	}
}


static void __lambda6_ (Block4Data* _data4_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	MetadataRational _tmp1_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data4_->rational;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, _tmp0_, &_tmp1_);
#line 4254 "PhotoMetadata.c"
}


static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 4261 "PhotoMetadata.c"
}


void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option) {
	Block4Data* _data4_;
	MetadataRational _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	PhotoMetadataSetOption _tmp2_;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data4_->rational = _tmp0_;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 517 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda6__photo_metadata_set_generic_value, _data4_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 516 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 4297 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag) {
	MetadataDateTime* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* value;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 520 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 520 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_string (self, _tmp0_);
#line 521 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	value = _tmp1_;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 522 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == NULL) {
#line 523 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 523 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 523 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 4328 "PhotoMetadata.c"
	}
	{
		const gchar* _tmp3_;
		MetadataDomain _tmp4_ = 0;
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = tag;
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_tag_domain (_tmp3_);
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		switch (_tmp4_) {
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 4341 "PhotoMetadata.c"
			{
				const gchar* _tmp5_;
				MetadataDateTime* _tmp6_;
				MetadataDateTime* _tmp7_;
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = value;
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6_ = metadata_date_time_new_from_xmp (_tmp5_, &_inner_error_);
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7_ = _tmp6_;
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_inner_error_ != NULL) {
#line 4354 "PhotoMetadata.c"
					goto __catch25_g_error;
				}
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				result = _tmp7_;
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 528 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				return result;
#line 4363 "PhotoMetadata.c"
			}
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 4367 "PhotoMetadata.c"
			{
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				result = NULL;
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 533 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				return result;
#line 4375 "PhotoMetadata.c"
			}
			default:
#line 526 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 4380 "PhotoMetadata.c"
			{
				const gchar* _tmp8_;
				MetadataDateTime* _tmp9_;
				MetadataDateTime* _tmp10_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp8_ = value;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = metadata_date_time_new_from_exif (_tmp8_, &_inner_error_);
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_inner_error_ != NULL) {
#line 4393 "PhotoMetadata.c"
					goto __catch25_g_error;
				}
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				result = _tmp10_;
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 537 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				return result;
#line 4402 "PhotoMetadata.c"
			}
		}
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 540 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp11_ = tag;
#line 540 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->source_name;
#line 540 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp13_ = err;
#line 540 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_->message;
#line 540 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:540: Unable to read date/time %s from source %s: %s", _tmp11_, _tmp12_, _tmp14_);
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 542 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 4436 "PhotoMetadata.c"
	}
	__finally25:
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error_);
#line 525 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return NULL;
#line 4447 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 546 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4461 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4473 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4480 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				MetadataDateTime* _tmp3_ = NULL;
				MetadataDateTime* date_time;
				MetadataDateTime* _tmp4_;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_date_time (self, _tmp2_);
#line 548 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				date_time = _tmp3_;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = date_time;
#line 549 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 550 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = date_time;
#line 550 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 550 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 4502 "PhotoMetadata.c"
				}
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 547 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4508 "PhotoMetadata.c"
			}
		}
	}
#line 553 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 553 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 4516 "PhotoMetadata.c"
}


void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time) {
	const gchar* _tmp0_;
	MetadataDomain _tmp1_ = 0;
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 556 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_tag_domain (_tmp0_);
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	switch (_tmp1_) {
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4537 "PhotoMetadata.c"
		{
			const gchar* _tmp2_;
			MetadataDateTime* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp2_ = tag;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = date_time;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = metadata_date_time_get_exif_label (_tmp3_);
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_;
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp2_, _tmp5_);
#line 559 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp5_);
#line 560 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 4557 "PhotoMetadata.c"
		}
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4561 "PhotoMetadata.c"
		{
			const gchar* _tmp6_;
			MetadataDateTime* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = tag;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp7_ = date_time;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp8_ = metadata_date_time_get_xmp_label (_tmp7_);
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_;
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp6_, _tmp9_);
#line 563 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp9_);
#line 564 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 4581 "PhotoMetadata.c"
		}
		default:
#line 557 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4586 "PhotoMetadata.c"
		{
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			MetadataDomain _tmp13_ = 0;
			GEnumValue* _tmp14_;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp10_ = tag;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp11_ = self->priv->source_name;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp12_ = tag;
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp13_ = photo_metadata_get_tag_domain (_tmp12_);
#line 570 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp14_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), _tmp13_);
#line 569 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:569: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", _tmp10_, _tmp11_, (_tmp14_ != NULL) ? _tmp14_->value_name : NULL);
#line 571 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 4607 "PhotoMetadata.c"
		}
	}
}


static gpointer _metadata_date_time_ref0 (gpointer self) {
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 4616 "PhotoMetadata.c"
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return _data5_;
#line 4625 "PhotoMetadata.c"
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4634 "PhotoMetadata.c"
		PhotoMetadata * self;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		self = _data5_->self;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data5_->date_time);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 4644 "PhotoMetadata.c"
	}
}


static void __lambda7_ (Block5Data* _data5_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	MetadataDateTime* _tmp1_;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data5_->date_time;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, _tmp0_, _tmp1_);
#line 4663 "PhotoMetadata.c"
}


static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 4670 "PhotoMetadata.c"
}


void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	Block5Data* _data5_;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _metadata_date_time_ref0 (_tmp0_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data5_->date_time = _tmp1_;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 576 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda7__photo_metadata_set_generic_value, _data5_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 575 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 4709 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
	guint8* result = NULL;
	ExifData* _tmp0_;
	ExifData* _tmp2_;
	guchar* _tmp3_;
	guchar* thumbnail;
	ExifData* _tmp4_;
	guint _tmp5_;
	guint thumbnail_size;
	gboolean _tmp6_;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	guchar* saved_data;
	guint saved_size;
	ExifData* _tmp9_;
	gboolean _tmp10_ = FALSE;
	guint _tmp11_;
	gboolean _tmp13_;
	ExifData* _tmp22_;
	guchar* _tmp23_;
	ExifData* _tmp24_;
	guint _tmp25_;
	guint8* _tmp26_;
	gint _tmp26__length1;
#line 580 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 581 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 4744 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = 0;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (result_length1) {
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*result_length1 = _tmp1__length1;
#line 4755 "PhotoMetadata.c"
		}
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = _tmp1_;
#line 582 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 4761 "PhotoMetadata.c"
	}
#line 586 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exif;
#line 586 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_->data;
#line 586 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	thumbnail = _tmp3_;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_->size;
#line 587 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	thumbnail_size = _tmp5_;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = include_preview;
#line 588 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 4779 "PhotoMetadata.c"
		ExifData* _tmp7_;
		ExifData* _tmp8_;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 589 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_->data = NULL;
#line 590 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = self->priv->exif;
#line 590 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_->size = (guint) 0;
#line 4790 "PhotoMetadata.c"
	}
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flattened = NULL;
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flattened_length1 = 0;
#line 593 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 596 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 597 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 598 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = self->priv->exif;
#line 598 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp9_, &saved_data, &saved_size);
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = saved_size;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp11_ > ((guint) 0)) {
#line 4810 "PhotoMetadata.c"
		guchar* _tmp12_;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = saved_data;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4816 "PhotoMetadata.c"
	} else {
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 4820 "PhotoMetadata.c"
	}
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp10_;
#line 599 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 4826 "PhotoMetadata.c"
		guint _tmp14_;
		guint8* _tmp15_ = NULL;
		guint8* _tmp16_;
		gint _tmp16__length1;
		guchar* _tmp17_;
		guint _tmp18_;
		ExifMem* _tmp19_ = NULL;
		ExifMem* _tmp20_;
		guchar* _tmp21_;
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp14_ = saved_size;
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp15_ = g_new0 (guint8, _tmp14_);
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		flattened = _tmp15_;
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		flattened_length1 = _tmp14_;
#line 600 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_flattened_size_ = flattened_length1;
#line 601 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp16_ = flattened;
#line 601 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp16__length1 = flattened_length1;
#line 601 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp17_ = saved_data;
#line 601 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp18_ = saved_size;
#line 601 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		memcpy (_tmp16_, _tmp17_, (gsize) _tmp18_);
#line 603 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp19_ = exif_mem_new_default ();
#line 603 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp19_;
#line 603 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = saved_data;
#line 603 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp20_, _tmp21_);
#line 603 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp20_);
#line 4868 "PhotoMetadata.c"
	}
#line 607 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp22_ = self->priv->exif;
#line 607 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_ = thumbnail;
#line 607 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp22_->data = _tmp23_;
#line 608 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp24_ = self->priv->exif;
#line 608 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp25_ = thumbnail_size;
#line 608 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp24_->size = _tmp25_;
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp26_ = flattened;
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp26__length1 = flattened_length1;
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp26__length1;
#line 4890 "PhotoMetadata.c"
	}
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp26_;
#line 610 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 4896 "PhotoMetadata.c"
}


static guint8* _vala_array_dup8 (guint8* self, int length) {
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4903 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
	guint8* result = NULL;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	GExiv2Metadata* _tmp1_;
	guchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	guchar* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* _tmp8_;
	gint _tmp8__length1;
#line 614 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_thumbnail (_tmp1_, &_tmp2_, &_tmp3_);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	buffer = _tmp2_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp3_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4941 "PhotoMetadata.c"
		guchar* _tmp5_;
		gint _tmp5__length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = buffer;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = buffer_length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp5_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = _tmp5__length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4954 "PhotoMetadata.c"
	} else {
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = 0;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4962 "PhotoMetadata.c"
	}
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp0_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = _tmp0__length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup8 (_tmp6_, _tmp6__length1) : ((gpointer) _tmp6_);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7__length1 = _tmp6__length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = _tmp7__length1;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp8__length1;
#line 4980 "PhotoMetadata.c"
	}
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp8_;
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 616 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 4988 "PhotoMetadata.c"
}


guint photo_metadata_get_preview_count (PhotoMetadata* self) {
	guint result = 0U;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	gint _tmp6_;
#line 619 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 620 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 5022 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 5031 "PhotoMetadata.c"
	} else {
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 5035 "PhotoMetadata.c"
	}
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = (guint) _tmp6_;
#line 622 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5043 "PhotoMetadata.c"
}


PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
	PhotoPreview* result = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	gboolean _tmp7_;
	const gchar* _tmp8_;
	guint _tmp9_;
	GExiv2PreviewProperties** _tmp10_;
	gint _tmp10__length1;
	guint _tmp11_;
	GExiv2PreviewProperties* _tmp12_;
	PhotoMetadataInternalPhotoPreview* _tmp13_;
#line 626 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 627 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 5086 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
		guint _tmp6_;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = number;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= _tmp6_;
#line 5099 "PhotoMetadata.c"
	}
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp3_;
#line 628 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp7_) {
#line 629 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 629 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 5109 "PhotoMetadata.c"
	}
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = self->priv->source_name;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = number;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10__length1 = props_length1;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = number;
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp10_[_tmp11_];
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_internal_photo_preview_new (self, _tmp8_, _tmp9_, _tmp12_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = PHOTO_PREVIEW (_tmp13_);
#line 631 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5129 "PhotoMetadata.c"
}


void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
#line 634 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 635 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 636 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 636 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 5146 "PhotoMetadata.c"
		ExifMem* _tmp2_ = NULL;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 637 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 638 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 638 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 639 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 639 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 5173 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 643 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 644 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, _tmp1_);
#line 5191 "PhotoMetadata.c"
}


void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 647 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 5204 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 5216 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 5223 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 649 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp2_);
#line 648 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5232 "PhotoMetadata.c"
			}
		}
	}
}


void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
	MetadataDomain _tmp0_;
#line 652 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 5249 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 655 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 655 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp1_);
#line 656 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 5258 "PhotoMetadata.c"
		}
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 5262 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 659 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 659 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp2_);
#line 660 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 5271 "PhotoMetadata.c"
		}
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 5275 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 663 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp3_);
#line 664 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			break;
#line 5284 "PhotoMetadata.c"
		}
		default:
#line 653 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		break;
#line 5289 "PhotoMetadata.c"
	}
}


void photo_metadata_clear (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_;
#line 668 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 669 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 669 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 5302 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 678 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 679 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 679 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 679 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 679 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 679 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5323 "PhotoMetadata.c"
}


void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 682 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 684 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 684 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5337 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 685 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5352 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DATE_TIME_TAGS;
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 687 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5362 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 699 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 700 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5384 "PhotoMetadata.c"
}


void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 703 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 703 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 705 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 705 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5398 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 706 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5413 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 708 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 708 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 708 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5423 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 716 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 717 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5445 "PhotoMetadata.c"
}


void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 720 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 720 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 722 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5459 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 723 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5474 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 725 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 725 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 725 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5484 "PhotoMetadata.c"
	}
}


static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base) {
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	MetadataDateTime* creation;
	MetadataDateTime* _tmp1_;
#line 728 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 729 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 729 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 730 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 730 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 5505 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_ = NULL;
#line 731 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 731 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 731 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 5513 "PhotoMetadata.c"
	}
#line 733 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = creation;
#line 733 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5519 "PhotoMetadata.c"
}


static gpointer _dimensions_dup0 (gpointer self) {
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 5526 "PhotoMetadata.c"
}


Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
	Dimensions* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 750 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 752 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_assert (_tmp0__length1 == _tmp1__length1);
#line 5548 "PhotoMetadata.c"
	{
		gint ctr;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 5553 "PhotoMetadata.c"
		{
			gboolean _tmp2_;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 5560 "PhotoMetadata.c"
				gboolean _tmp3_;
				gint _tmp5_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				glong width = 0L;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				const gchar* _tmp9_;
				glong _tmp10_ = 0L;
				gboolean _tmp11_ = FALSE;
				glong height = 0L;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				const gchar* _tmp14_;
				glong _tmp15_ = 0L;
				gboolean _tmp16_ = FALSE;
				glong _tmp17_;
				glong _tmp18_;
				Dimensions _tmp19_ = {0};
				Dimensions* _tmp20_;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!_tmp3_) {
#line 5587 "PhotoMetadata.c"
					gint _tmp4_;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = ctr;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					ctr = _tmp4_ + 1;
#line 5593 "PhotoMetadata.c"
				}
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = ctr;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6_ = photo_metadata_WIDTH_TAGS;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!(_tmp5_ < _tmp6__length1)) {
#line 753 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					break;
#line 5607 "PhotoMetadata.c"
				}
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7_ = photo_metadata_WIDTH_TAGS;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp8_ = ctr;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp7_[_tmp8_];
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp11_ = photo_metadata_get_long (self, _tmp9_, &_tmp10_);
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				width = _tmp10_;
#line 757 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!_tmp11_) {
#line 758 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					continue;
#line 5625 "PhotoMetadata.c"
				}
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_HEIGHT_TAGS;
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp12__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp13_ = ctr;
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp14_ = _tmp12_[_tmp13_];
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp16_ = photo_metadata_get_long (self, _tmp14_, &_tmp15_);
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				height = _tmp15_;
#line 761 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!_tmp16_) {
#line 762 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					continue;
#line 5643 "PhotoMetadata.c"
				}
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp17_ = width;
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp18_ = height;
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp19_, (gint) _tmp17_, (gint) _tmp18_);
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp20_ = _dimensions_dup0 (&_tmp19_);
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				result = _tmp20_;
#line 764 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				return result;
#line 5657 "PhotoMetadata.c"
			}
		}
	}
#line 767 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 767 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5665 "PhotoMetadata.c"
}


void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option) {
	Dimensions* _tmp0_;
#line 770 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 771 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = dim;
#line 771 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5677 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		Dimensions* _tmp2_;
		gint _tmp3_;
		PhotoMetadataSetOption _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		Dimensions* _tmp6_;
		gint _tmp7_;
		PhotoMetadataSetOption _tmp8_;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_WIDTH_TAGS;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = dim;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = (*_tmp2_).width;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = option;
#line 772 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, _tmp1__length1, (glong) _tmp3_, _tmp4_);
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = photo_metadata_HEIGHT_TAGS;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = dim;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = (*_tmp6_).height;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = option;
#line 773 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp5_, _tmp5__length1, (glong) _tmp7_, _tmp8_);
#line 5712 "PhotoMetadata.c"
	} else {
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar** _tmp10_;
		gint _tmp10__length1;
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = photo_metadata_WIDTH_TAGS;
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 775 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp9_, _tmp9__length1);
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = photo_metadata_HEIGHT_TAGS;
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 776 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp10_, _tmp10__length1);
#line 5730 "PhotoMetadata.c"
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
#line 1232 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1233 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1233 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1234 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1234 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1235 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _result_;
#line 1235 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 5754 "PhotoMetadata.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1385 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1385 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1386 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1386 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1386 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1386 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 5774 "PhotoMetadata.c"
}


static gchar* photo_metadata_real_get_title (MediaMetadata* base) {
	PhotoMetadata * self;
	gchar* result = NULL;
	GeeList* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	GeeList* titles;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GeeList* _tmp9_;
	gboolean _tmp13_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* title;
	const gchar* _tmp18_;
	const gchar* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	const gchar* _tmp24_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp28_;
	gboolean _tmp31_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
#line 809 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 5809 "PhotoMetadata.c"
		GeeList* _tmp2_ = NULL;
#line 818 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 818 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 818 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp2_;
#line 5817 "PhotoMetadata.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
		GeeList* _tmp4_ = NULL;
#line 819 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 819 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 819 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_first_string_multiple (self, _tmp3_, _tmp3__length1);
#line 819 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 819 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp4_;
#line 5832 "PhotoMetadata.c"
	}
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp0_;
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 817 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	titles = _tmp6_;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = titles;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp9_ != NULL) {
#line 5844 "PhotoMetadata.c"
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp10_ = titles;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp11_ = gee_collection_get_size (GEE_COLLECTION (_tmp10_));
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp12_ > 0;
#line 5856 "PhotoMetadata.c"
	} else {
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp8_ = FALSE;
#line 5860 "PhotoMetadata.c"
	}
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp8_;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 5866 "PhotoMetadata.c"
		GeeList* _tmp14_;
		gpointer _tmp15_ = NULL;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp14_ = titles;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp15_ = gee_list_get (_tmp14_, 0);
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp7_);
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = (gchar*) _tmp15_;
#line 5877 "PhotoMetadata.c"
	} else {
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp7_);
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = NULL;
#line 5883 "PhotoMetadata.c"
	}
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp7_;
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 824 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	title = _tmp17_;
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_ = title;
#line 827 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp18_ != NULL) {
#line 5895 "PhotoMetadata.c"
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
#line 828 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp19_ = title;
#line 828 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp20_ = string_strip (_tmp19_);
#line 828 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 828 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		title = _tmp20_;
#line 5906 "PhotoMetadata.c"
	}
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp24_ = title;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp25_ = is_string_empty (_tmp24_);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp25_) {
#line 5914 "PhotoMetadata.c"
		const gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp26_ = title;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp27_ = string_contains (_tmp26_, "\n");
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = !_tmp27_;
#line 5923 "PhotoMetadata.c"
	} else {
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = FALSE;
#line 5927 "PhotoMetadata.c"
	}
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_ = _tmp23_;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp28_) {
#line 5933 "PhotoMetadata.c"
		const gchar* _tmp29_;
		gboolean _tmp30_ = FALSE;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp29_ = title;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp30_ = string_contains (_tmp29_, "\r");
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp22_ = !_tmp30_;
#line 5942 "PhotoMetadata.c"
	} else {
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 5946 "PhotoMetadata.c"
	}
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_ = _tmp22_;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp31_) {
#line 5952 "PhotoMetadata.c"
		const gchar* _tmp32_;
#line 832 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp32_ = title;
#line 832 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp32_;
#line 5958 "PhotoMetadata.c"
	} else {
#line 832 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 5962 "PhotoMetadata.c"
	}
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp33_ = _tmp21_;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp34_;
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 831 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 5980 "PhotoMetadata.c"
}


void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 835 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 836 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = title;
#line 836 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 836 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 5995 "PhotoMetadata.c"
		gboolean _tmp2_ = FALSE;
#line 837 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 837 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (_tmp2_) {
#line 6001 "PhotoMetadata.c"
			const gchar* _tmp3_;
#line 838 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = title;
#line 838 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, _tmp3_);
#line 6007 "PhotoMetadata.c"
		} else {
			gchar** _tmp4_;
			gint _tmp4__length1;
			const gchar* _tmp5_;
			PhotoMetadataSetOption _tmp6_;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp5_ = title;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = option;
#line 840 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp4_, _tmp4__length1, _tmp5_, _tmp6_);
#line 6023 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp7_;
		gint _tmp7__length1;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 842 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp7_, _tmp7__length1);
#line 6034 "PhotoMetadata.c"
	}
}


GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	GeeSet* keywords;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	GeeSet* _tmp25_;
	gboolean _tmp29_;
	GeeSet* _tmp31_;
	GeeSet* _tmp32_;
#line 859 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 860 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 6058 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 6070 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 6077 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				GeeList* _tmp3_ = NULL;
				GeeCollection* values;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
				gboolean _tmp9_;
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 862 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				values = GEE_COLLECTION (_tmp3_);
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 6095 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 6107 "PhotoMetadata.c"
				} else {
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 6111 "PhotoMetadata.c"
				}
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp4_;
#line 863 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp9_) {
#line 6117 "PhotoMetadata.c"
					GeeSet* _tmp10_;
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp10_ = keywords;
#line 864 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					if (_tmp10_ == NULL) {
#line 6123 "PhotoMetadata.c"
						GCompareFunc _tmp11_;
						GeeSet* _tmp12_ = NULL;
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp11_ = compare_func;
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp12_ = photo_metadata_create_string_set (self, _tmp11_);
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 865 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						keywords = _tmp12_;
#line 6134 "PhotoMetadata.c"
					}
					{
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_ = NULL;
						GeeIterator* _current_value_it;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp13_ = values;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterable_iterator (GEE_ITERABLE (_tmp13_));
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp14_;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6148 "PhotoMetadata.c"
							GeeIterator* _tmp15_;
							gboolean _tmp16_ = FALSE;
							GeeIterator* _tmp17_;
							gpointer _tmp18_ = NULL;
							gchar* current_value;
							GeeSet* _tmp19_;
							const gchar* _tmp20_;
							gchar* _tmp21_ = NULL;
							gchar* _tmp22_;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp15_ = _current_value_it;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_next (_tmp15_);
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							if (!_tmp16_) {
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
								break;
#line 6166 "PhotoMetadata.c"
							}
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp17_ = _current_value_it;
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp18_ = gee_iterator_get (_tmp17_);
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp18_;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp19_ = keywords;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp20_ = current_value;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp21_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp20_);
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp22_ = _tmp21_;
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							gee_collection_add (GEE_COLLECTION (_tmp19_), _tmp22_);
#line 868 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp22_);
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 6188 "PhotoMetadata.c"
						}
#line 867 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 6192 "PhotoMetadata.c"
					}
				}
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 861 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 6199 "PhotoMetadata.c"
			}
		}
	}
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp25_ = keywords;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp25_ != NULL) {
#line 6207 "PhotoMetadata.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp26_ = keywords;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp27_ = gee_collection_get_size (GEE_COLLECTION (_tmp26_));
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp28_ = _tmp27_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = _tmp28_ > 0;
#line 6219 "PhotoMetadata.c"
	} else {
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = FALSE;
#line 6223 "PhotoMetadata.c"
	}
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp24_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp29_) {
#line 6229 "PhotoMetadata.c"
		GeeSet* _tmp30_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp30_ = keywords;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp30_;
#line 6235 "PhotoMetadata.c"
	} else {
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp23_ = NULL;
#line 6239 "PhotoMetadata.c"
	}
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_ = _tmp23_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp32_ = _g_object_ref0 (_tmp31_);
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp32_;
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 872 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 6251 "PhotoMetadata.c"
}


static gpointer _hierarchical_keyword_field_ref0 (gpointer self) {
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 6258 "PhotoMetadata.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 6271 "PhotoMetadata.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 6301 "PhotoMetadata.c"
				goto __catch26_g_regex_error;
			}
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			return NULL;
#line 6310 "PhotoMetadata.c"
		}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = regex;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = replacement;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 6326 "PhotoMetadata.c"
				goto __catch26_g_regex_error;
			}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			return NULL;
#line 6337 "PhotoMetadata.c"
		}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = _tmp8_;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 6345 "PhotoMetadata.c"
	}
	goto __finally26;
	__catch26_g_regex_error:
	{
		GError* e = NULL;
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1394 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 6359 "PhotoMetadata.c"
	}
	__finally26:
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return NULL;
#line 6370 "PhotoMetadata.c"
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1304 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1305 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 6394 "PhotoMetadata.c"
		glong _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1306 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 6402 "PhotoMetadata.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1308 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 6414 "PhotoMetadata.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1315 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 6439 "PhotoMetadata.c"
		glong _tmp2_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 6445 "PhotoMetadata.c"
	} else {
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 6449 "PhotoMetadata.c"
	}
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1317 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 6455 "PhotoMetadata.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1319 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 6467 "PhotoMetadata.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1321 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 6477 "PhotoMetadata.c"
	}
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1324 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 6483 "PhotoMetadata.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1326 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 6497 "PhotoMetadata.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1328 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 6507 "PhotoMetadata.c"
	}
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1330 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 6513 "PhotoMetadata.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1331 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 6522 "PhotoMetadata.c"
	}
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1333 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1334 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 6542 "PhotoMetadata.c"
}


static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index) {
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	HierarchicalTagIndex* _tmp4_;
	HierarchicalKeywordField** _tmp5_;
	gint _tmp5__length1;
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 875 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((index == NULL) || IS_HIERARCHICAL_TAG_INDEX (index));
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6560 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp0__length1; current_field_it = current_field_it + 1) {
#line 6572 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* current_field = NULL;
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 6579 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
#line 877 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 877 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 877 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 876 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6591 "PhotoMetadata.c"
			}
		}
	}
#line 879 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = index;
#line 879 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 880 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return;
#line 6601 "PhotoMetadata.c"
	}
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6607 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp5_;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp5__length1;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp5__length1; current_field_it = current_field_it + 1) {
#line 6619 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp6_;
			HierarchicalKeywordField* current_field = NULL;
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp6_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			current_field = _tmp6_;
#line 6626 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp7_;
				gboolean _tmp8_;
				GeeTreeSet* _tmp9_;
				GeeSet* writeable_set;
				HierarchicalKeywordField* _tmp29_;
				const gchar* _tmp30_;
				GeeSet* _tmp31_;
#line 883 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7_ = current_field;
#line 883 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp8_ = _tmp7_->is_writeable;
#line 883 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 884 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					continue;
#line 6645 "PhotoMetadata.c"
				}
#line 886 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 886 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				writeable_set = GEE_SET (_tmp9_);
#line 6651 "PhotoMetadata.c"
				{
					HierarchicalTagIndex* _tmp10_;
					GeeCollection* _tmp11_ = NULL;
					GeeCollection* _tmp12_;
					GeeIterator* _tmp13_ = NULL;
					GeeIterator* _tmp14_;
					GeeIterator* _current_path_it;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp10_ = index;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp11_ = hierarchical_tag_index_get_all_paths (_tmp10_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp12_ = _tmp11_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp13_ = gee_iterable_iterator (GEE_ITERABLE (_tmp12_));
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp14_ = _tmp13_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp12_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp14_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 6675 "PhotoMetadata.c"
						GeeIterator* _tmp15_;
						gboolean _tmp16_ = FALSE;
						GeeIterator* _tmp17_;
						gpointer _tmp18_ = NULL;
						gchar* current_path;
						const gchar* _tmp19_;
						HierarchicalKeywordField* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_ = NULL;
						gchar* writeable_path;
						HierarchicalKeywordField* _tmp23_;
						gboolean _tmp24_;
						GeeSet* _tmp27_;
						const gchar* _tmp28_;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp15_ = _current_path_it;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp16_ = gee_iterator_next (_tmp15_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						if (!_tmp16_) {
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							break;
#line 6698 "PhotoMetadata.c"
						}
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp17_ = _current_path_it;
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp18_;
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp19_ = current_path;
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp20_ = current_field;
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp21_ = _tmp20_->path_separator;
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp22_ = string_replace (_tmp19_, TAG_PATH_SEPARATOR_STRING, _tmp21_);
#line 889 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						writeable_path = _tmp22_;
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp23_ = current_field;
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp24_ = _tmp23_->wants_leading_separator;
#line 891 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						if (!_tmp24_) {
#line 6722 "PhotoMetadata.c"
							const gchar* _tmp25_;
							gchar* _tmp26_ = NULL;
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp25_ = writeable_path;
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp26_ = string_substring (_tmp25_, (glong) 1, (glong) (-1));
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 892 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							writeable_path = _tmp26_;
#line 6733 "PhotoMetadata.c"
						}
#line 894 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp27_ = writeable_set;
#line 894 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp28_ = writeable_path;
#line 894 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						gee_collection_add (GEE_COLLECTION (_tmp27_), _tmp28_);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 6745 "PhotoMetadata.c"
					}
#line 888 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 6749 "PhotoMetadata.c"
				}
#line 897 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp29_ = current_field;
#line 897 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp30_ = _tmp29_->field_name;
#line 897 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp31_ = writeable_set;
#line 897 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp30_, GEE_COLLECTION (_tmp31_));
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 882 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6763 "PhotoMetadata.c"
			}
		}
	}
}


void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option) {
	HierarchicalTagIndex* _tmp0_;
	HierarchicalTagIndex* htag_index;
	GeeTreeSet* _tmp1_;
	GeeSet* flat_keywords;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp28_;
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || GEE_IS_COLLECTION (keywords));
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 902 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 903 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	flat_keywords = GEE_SET (_tmp1_);
#line 905 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = keywords;
#line 905 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp2_ != NULL) {
#line 6793 "PhotoMetadata.c"
		GeeSet* _tmp24_;
		HierarchicalTagIndex* _tmp25_;
		GeeCollection* _tmp26_ = NULL;
		GeeCollection* _tmp27_;
		{
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_ = NULL;
			GeeIterator* _keyword_it;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = keywords;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp4_;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6810 "PhotoMetadata.c"
				GeeIterator* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeIterator* _tmp7_;
				gpointer _tmp8_ = NULL;
				gchar* keyword;
				const gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = _keyword_it;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6_ = gee_iterator_next (_tmp5_);
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (!_tmp6_) {
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					break;
#line 6826 "PhotoMetadata.c"
				}
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp7_ = _keyword_it;
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp8_;
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp9_ = keyword;
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp10_ = g_str_has_prefix (_tmp9_, TAG_PATH_SEPARATOR_STRING);
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp10_) {
#line 6840 "PhotoMetadata.c"
					const gchar* _tmp11_;
					GeeList* _tmp12_ = NULL;
					GeeCollection* path_components;
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp11_ = keyword;
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp12_ = hierarchical_tag_utilities_enumerate_path_components (_tmp11_);
#line 908 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					path_components = GEE_COLLECTION (_tmp12_);
#line 6850 "PhotoMetadata.c"
					{
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_ = NULL;
						GeeIterator* _component_it;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp13_ = path_components;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterable_iterator (GEE_ITERABLE (_tmp13_));
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_component_it = _tmp14_;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6863 "PhotoMetadata.c"
							GeeIterator* _tmp15_;
							gboolean _tmp16_ = FALSE;
							GeeIterator* _tmp17_;
							gpointer _tmp18_ = NULL;
							gchar* component;
							HierarchicalTagIndex* _tmp19_;
							const gchar* _tmp20_;
							const gchar* _tmp21_;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp15_ = _component_it;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_next (_tmp15_);
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							if (!_tmp16_) {
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
								break;
#line 6880 "PhotoMetadata.c"
							}
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp17_ = _component_it;
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp18_ = gee_iterator_get (_tmp17_);
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp18_;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp19_ = htag_index;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp20_ = component;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp21_ = keyword;
#line 911 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp19_, _tmp20_, _tmp21_);
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 6898 "PhotoMetadata.c"
						}
#line 910 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 6902 "PhotoMetadata.c"
					}
#line 907 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 6906 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp22_;
					const gchar* _tmp23_;
#line 913 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp22_ = flat_keywords;
#line 913 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp23_ = keyword;
#line 913 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					gee_collection_add (GEE_COLLECTION (_tmp22_), _tmp23_);
#line 6916 "PhotoMetadata.c"
				}
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 6920 "PhotoMetadata.c"
			}
#line 906 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 6924 "PhotoMetadata.c"
		}
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp26_ = hierarchical_tag_index_get_all_tags (_tmp25_);
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp27_ = _tmp26_;
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (GEE_COLLECTION (_tmp24_), _tmp27_);
#line 917 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp27_);
#line 6938 "PhotoMetadata.c"
	}
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_ = keywords;
#line 920 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp28_ != NULL) {
#line 6944 "PhotoMetadata.c"
		gchar** _tmp29_;
		gint _tmp29__length1;
		GeeSet* _tmp30_;
		PhotoMetadataSetOption _tmp31_;
		HierarchicalTagIndex* _tmp32_;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp29_ = photo_metadata_KEYWORD_TAGS;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp29__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp30_ = flat_keywords;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp31_ = option;
#line 921 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp29_, _tmp29__length1, GEE_COLLECTION (_tmp30_), _tmp31_);
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp32_ = htag_index;
#line 922 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp32_);
#line 6964 "PhotoMetadata.c"
	} else {
		gchar** _tmp33_;
		gint _tmp33__length1;
#line 924 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp33_ = photo_metadata_KEYWORD_TAGS;
#line 924 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp33__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 924 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp33_, _tmp33__length1);
#line 925 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 6976 "PhotoMetadata.c"
	}
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 901 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 6982 "PhotoMetadata.c"
}


gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self) {
	gboolean result = FALSE;
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
#line 929 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6996 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp0__length1; field_it = field_it + 1) {
#line 7008 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* field = NULL;
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 7015 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
				GeeList* _tmp4_ = NULL;
				GeeCollection* values;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_;
				gboolean _tmp10_;
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 931 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				values = GEE_COLLECTION (_tmp4_);
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 7036 "PhotoMetadata.c"
					GeeCollection* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 7048 "PhotoMetadata.c"
				} else {
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 7052 "PhotoMetadata.c"
				}
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp5_;
#line 933 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp10_) {
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 934 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					return result;
#line 7066 "PhotoMetadata.c"
				}
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 930 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 7072 "PhotoMetadata.c"
			}
		}
	}
#line 937 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 937 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7080 "PhotoMetadata.c"
}


GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self) {
	GeeSet* result = NULL;
	gboolean _tmp0_ = FALSE;
	GeeSet* _tmp1_ = NULL;
	GeeSet* h_keywords;
	HierarchicalKeywordField** _tmp2_;
	gint _tmp2__length1;
#line 940 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 941 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_hierarchical_keywords (self);
#line 941 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_assert (_tmp0_);
#line 943 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, NULL);
#line 943 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	h_keywords = _tmp1_;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 7105 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		field_collection = _tmp2_;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp2__length1;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp2__length1; field_it = field_it + 1) {
#line 7117 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp3_;
			HierarchicalKeywordField* field = NULL;
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_tmp3_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			field = _tmp3_;
#line 7124 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp4_;
				const gchar* _tmp5_;
				GeeList* _tmp6_ = NULL;
				GeeCollection* values;
				gboolean _tmp7_ = FALSE;
				GeeCollection* _tmp8_;
				gboolean _tmp12_;
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp4_ = field;
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp4_->field_name;
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp6_ = photo_metadata_get_string_multiple (self, _tmp5_);
#line 946 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				values = GEE_COLLECTION (_tmp6_);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp8_ = values;
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp8_ == NULL) {
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp7_ = TRUE;
#line 7147 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp9_;
					gint _tmp10_;
					gint _tmp11_;
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp9_ = values;
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_collection_get_size (_tmp9_);
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp11_ < 1;
#line 7160 "PhotoMetadata.c"
				}
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_tmp12_ = _tmp7_;
#line 948 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				if (_tmp12_) {
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 949 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					continue;
#line 7172 "PhotoMetadata.c"
				}
				{
					GeeCollection* _tmp13_;
					GeeIterator* _tmp14_ = NULL;
					GeeIterator* _current_value_it;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp13_ = values;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_tmp14_ = gee_iterable_iterator (GEE_ITERABLE (_tmp13_));
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp14_;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 7186 "PhotoMetadata.c"
						GeeIterator* _tmp15_;
						gboolean _tmp16_ = FALSE;
						GeeIterator* _tmp17_;
						gpointer _tmp18_ = NULL;
						gchar* current_value;
						const gchar* _tmp19_;
						HierarchicalKeywordField* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_ = NULL;
						gchar* canonicalized;
						const gchar* _tmp23_;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp15_ = _current_value_it;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp16_ = gee_iterator_next (_tmp15_);
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						if (!_tmp16_) {
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							break;
#line 7206 "PhotoMetadata.c"
						}
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp17_ = _current_value_it;
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp18_;
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp19_ = current_value;
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp20_ = field;
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp21_ = _tmp20_->path_separator;
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp22_ = hierarchical_tag_utilities_canonicalize (_tmp19_, _tmp21_);
#line 952 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						canonicalized = _tmp22_;
#line 955 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_tmp23_ = canonicalized;
#line 955 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						if (_tmp23_ != NULL) {
#line 7228 "PhotoMetadata.c"
							GeeSet* _tmp24_;
							const gchar* _tmp25_;
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp24_ = h_keywords;
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							_tmp25_ = canonicalized;
#line 956 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
							gee_collection_add (GEE_COLLECTION (_tmp24_), _tmp25_);
#line 7237 "PhotoMetadata.c"
						}
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 7243 "PhotoMetadata.c"
					}
#line 951 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 7247 "PhotoMetadata.c"
				}
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 945 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 7253 "PhotoMetadata.c"
			}
		}
	}
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 960 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7261 "PhotoMetadata.c"
}


gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	GExiv2Orientation _tmp1_ = 0;
#line 963 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_ == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 964 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7279 "PhotoMetadata.c"
}


Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
	Orientation result = 0;
	GExiv2Metadata* _tmp0_;
	GExiv2Orientation _tmp1_ = 0;
	GExiv2Orientation orientation;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GExiv2Orientation _tmp4_;
	gboolean _tmp6_;
	gboolean _tmp8_;
#line 968 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 971 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	orientation = _tmp1_;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = orientation;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 7307 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp5_;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = orientation;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ < ORIENTATION_MIN;
#line 7314 "PhotoMetadata.c"
	}
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 7322 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp7_;
#line 973 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = orientation;
#line 973 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp7_ > ORIENTATION_MAX;
#line 7329 "PhotoMetadata.c"
	}
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp2_;
#line 972 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 974 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 974 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7339 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp9_;
#line 976 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = orientation;
#line 976 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = (Orientation) _tmp9_;
#line 976 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7348 "PhotoMetadata.c"
	}
}


void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
	GExiv2Metadata* _tmp0_;
	Orientation _tmp1_;
#line 979 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 981 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 981 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = orientation;
#line 981 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) _tmp1_);
#line 7364 "PhotoMetadata.c"
}


gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude) {
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 984 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 986 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 987 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 987 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_vala_long_ref = NULL;
#line 988 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 988 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_vala_lat_ref = NULL;
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 7410 "PhotoMetadata.c"
		}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 7416 "PhotoMetadata.c"
		} else {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 7420 "PhotoMetadata.c"
		}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 7426 "PhotoMetadata.c"
		}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 7432 "PhotoMetadata.c"
		} else {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 7436 "PhotoMetadata.c"
		}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 7442 "PhotoMetadata.c"
		}
#line 990 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7446 "PhotoMetadata.c"
	}
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef");
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 993 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef");
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 994 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 7466 "PhotoMetadata.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 7472 "PhotoMetadata.c"
	} else {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 7476 "PhotoMetadata.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 7482 "PhotoMetadata.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 7488 "PhotoMetadata.c"
	} else {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 7492 "PhotoMetadata.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 7498 "PhotoMetadata.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7502 "PhotoMetadata.c"
}


gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
	MetadataRational _vala_exposure = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 999 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 7523 "PhotoMetadata.c"
	}
#line 1000 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7527 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_string (PhotoMetadata* self) {
	gchar* result = NULL;
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
#line 1003 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1005 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1006 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1006 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7550 "PhotoMetadata.c"
	}
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = metadata_rational_is_valid (&exposure_time);
#line 1008 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp2_) {
#line 1009 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1009 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7560 "PhotoMetadata.c"
	}
#line 1011 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime");
#line 1011 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp3_;
#line 1011 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7568 "PhotoMetadata.c"
}


gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
	glong _vala_iso = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gboolean fetched_ok;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	glong _tmp4_;
	gboolean _tmp6_;
#line 1014 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1015 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1015 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1015 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = fetched_ok;
#line 1017 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == FALSE) {
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7600 "PhotoMetadata.c"
		}
#line 1018 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7604 "PhotoMetadata.c"
	}
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = _vala_iso;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_ < ((glong) 6)) {
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 7612 "PhotoMetadata.c"
	} else {
		glong _tmp5_;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = _vala_iso;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ > ((glong) 409600);
#line 7619 "PhotoMetadata.c"
	}
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 1022 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7631 "PhotoMetadata.c"
		}
#line 1023 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7635 "PhotoMetadata.c"
	}
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 7643 "PhotoMetadata.c"
	}
#line 1025 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7647 "PhotoMetadata.c"
}


gchar* photo_metadata_get_iso_string (PhotoMetadata* self) {
	gchar* result = NULL;
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_ = NULL;
#line 1028 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1030 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1031 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7669 "PhotoMetadata.c"
	}
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings");
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1033 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7677 "PhotoMetadata.c"
}


gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
	MetadataRational _vala_aperture = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 1036 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 7698 "PhotoMetadata.c"
	}
#line 1037 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7702 "PhotoMetadata.c"
}


gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
	gchar* result = NULL;
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	MetadataRational _tmp2_;
	gint _tmp3_;
	MetadataRational _tmp4_;
	gint _tmp5_;
	gdouble aperture_value;
	gdouble _tmp6_;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_;
	const gchar* _tmp9_ = NULL;
	gdouble _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gdouble _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
#line 1040 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1042 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1043 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1043 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		return result;
#line 7740 "PhotoMetadata.c"
	}
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = aperture;
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 1045 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp3_) / ((gdouble) _tmp5_);
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = aperture_value;
#line 1046 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (_tmp6_ * 10.0)) / 10.0;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = pango_formatted;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = "<i>f</i>/";
#line 7762 "PhotoMetadata.c"
	} else {
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = "f/";
#line 7766 "PhotoMetadata.c"
	}
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = aperture_value;
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (fmod (_tmp10_, 1) == ((gdouble) 0)) {
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.0f";
#line 7774 "PhotoMetadata.c"
	} else {
#line 1049 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.1f";
#line 7778 "PhotoMetadata.c"
	}
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = _tmp7_;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp9_;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = aperture_value;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup_printf (_tmp12_, _tmp13_);
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strconcat (_tmp11_, _tmp15_, NULL);
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = _tmp16_;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp15_);
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp17_;
#line 1048 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7800 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_make (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1052 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make");
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1053 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7815 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_model (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1056 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model");
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1057 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7830 "PhotoMetadata.c"
}


gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
	glong _vala_flash = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
#line 1060 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 7851 "PhotoMetadata.c"
	}
#line 1062 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7855 "PhotoMetadata.c"
}


gchar* photo_metadata_get_flash_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1065 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1067 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash");
#line 1067 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1067 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7870 "PhotoMetadata.c"
}


gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
	MetadataRational _vala_focal_length = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 1070 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 7891 "PhotoMetadata.c"
	}
#line 1071 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7895 "PhotoMetadata.c"
}


gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1074 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength");
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1075 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7910 "PhotoMetadata.c"
}


gchar* photo_metadata_get_artist (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_ = NULL;
#line 1083 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1084 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, _tmp0__length1);
#line 1084 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1084 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7931 "PhotoMetadata.c"
}


gchar* photo_metadata_get_copyright (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1087 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1088 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright");
#line 1088 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1088 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7946 "PhotoMetadata.c"
}


gchar* photo_metadata_get_software (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1091 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1092 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software");
#line 1092 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1092 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 7961 "PhotoMetadata.c"
}


void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 1095 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1095 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1095 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = software;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = version;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%s %s", _tmp0_, _tmp1_);
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp3_);
#line 1097 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 1099 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_has_iptc (self);
#line 1099 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 7993 "PhotoMetadata.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = software;
#line 1100 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", _tmp5_);
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = version;
#line 1101 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", _tmp6_);
#line 8004 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_software (PhotoMetadata* self) {
#line 1105 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1106 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1107 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1108 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 8018 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1111 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1112 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue");
#line 1112 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1112 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 8033 "PhotoMetadata.c"
}


Rating photo_metadata_get_rating (PhotoMetadata* self) {
	Rating result = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_ = NULL;
	gchar* rating_string;
	Rating _tmp2_ = 0;
	const gchar* _tmp3_;
#line 1121 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_RATING_TAGS;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_RATING_TAGS_length1;
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string (self, _tmp0_, _tmp0__length1);
#line 1122 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	rating_string = _tmp1_;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = rating_string;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp3_ == NULL) {
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = RATING_UNRATED;
#line 8061 "PhotoMetadata.c"
	} else {
		const gchar* _tmp4_;
		gint _tmp5_ = 0;
		Rating _tmp6_ = 0;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = rating_string;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp5_ = atoi (_tmp4_);
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = rating_unserialize (_tmp5_);
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp6_;
#line 8074 "PhotoMetadata.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 8082 "PhotoMetadata.c"
}


void photo_metadata_set_rating (PhotoMetadata* self, Rating rating) {
	Rating _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
#line 1131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = rating;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = rating_serialize (_tmp0_);
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp3_);
#line 1132 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 8105 "PhotoMetadata.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 8112 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
	PhotoMetadataInternalPhotoPreview* self = NULL;
	const gchar* _tmp0_;
	GExiv2PreviewProperties* _tmp1_;
	guint32 _tmp2_ = 0U;
	GExiv2PreviewProperties* _tmp3_;
	guint32 _tmp4_ = 0U;
	Dimensions _tmp5_ = {0};
	GExiv2PreviewProperties* _tmp6_;
	guint32 _tmp7_ = 0U;
	GExiv2PreviewProperties* _tmp8_;
	const gchar* _tmp9_ = NULL;
	GExiv2PreviewProperties* _tmp10_;
	const gchar* _tmp11_ = NULL;
	PhotoMetadata* _tmp12_;
	PhotoMetadata* _tmp13_;
	guint _tmp14_;
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = props;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_width (_tmp1_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = props;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_preview_properties_get_height (_tmp3_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp5_, (gint) _tmp2_, (gint) _tmp4_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = props;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = gexiv2_preview_properties_get_size (_tmp6_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = props;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = gexiv2_preview_properties_get_mime_type (_tmp8_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_preview_properties_get_extension (_tmp10_);
#line 120 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, _tmp0_, &_tmp5_, _tmp7_, _tmp9_, _tmp11_);
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = owner;
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = _media_metadata_ref0 (_tmp12_);
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 123 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->owner = _tmp13_;
#line 124 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = number;
#line 124 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->number = _tmp14_;
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return self;
#line 8179 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
#line 118 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 8186 "PhotoMetadata.c"
}


static guint8* _vala_array_dup9 (guint8* self, int length) {
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 8193 "PhotoMetadata.c"
}


static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp8_;
	PhotoMetadata* _tmp9_;
	GExiv2Metadata* _tmp10_;
	GExiv2PreviewProperties** _tmp11_;
	gint _tmp11__length1;
	guint _tmp12_;
	GExiv2PreviewProperties* _tmp13_;
	GExiv2PreviewImage* _tmp14_ = NULL;
	GExiv2PreviewImage* _tmp15_;
	gint _tmp16_ = 0;
	guint8* _tmp17_ = NULL;
	guint8* _tmp18_;
	gint _tmp18__length1;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
#line 127 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (base);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 128 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 8247 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
		guint _tmp7_;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->number;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > _tmp7_;
#line 8259 "PhotoMetadata.c"
	} else {
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 8263 "PhotoMetadata.c"
	}
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp4_;
#line 129 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_assert (_tmp8_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = self->owner;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = _tmp9_->priv->exiv2;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = props;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11__length1 = props_length1;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = self->number;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp11_[_tmp12_];
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = gexiv2_metadata_get_preview_image (_tmp10_, _tmp13_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = gexiv2_preview_image_get_data (_tmp15_, &_tmp16_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_ = (_tmp17_ != NULL) ? _vala_array_dup9 (_tmp17_, _tmp16_) : ((gpointer) _tmp17_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18__length1 = _tmp16_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp19_ = _tmp18_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = _tmp18__length1;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_gexiv2_preview_image_free0 (_tmp15_);
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp20_ = _tmp19_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp20__length1 = _tmp19__length1;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp20__length1;
#line 8305 "PhotoMetadata.c"
	}
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	result = _tmp20_;
#line 131 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	return result;
#line 8311 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
#line 8322 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (obj);
#line 115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 114 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 8338 "PhotoMetadata.c"
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_ = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_ = NULL;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_ = NULL;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_ = NULL;
	HierarchicalKeywordField* _tmp32_;
	HierarchicalKeywordField* _tmp33_;
	HierarchicalKeywordField* _tmp34_;
	HierarchicalKeywordField** _tmp35_ = NULL;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_ = NULL;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar** _tmp42_ = NULL;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->finalize = photo_metadata_finalize;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->read_from_file = photo_metadata_real_read_from_file;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->get_creation_date_time = photo_metadata_real_get_creation_date_time;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->get_title = photo_metadata_real_get_title;
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_[0] = _tmp0_;
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_[1] = _tmp1_;
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp3_[2] = _tmp2_;
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp3_;
#line 672 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_new0 (gchar*, 6 + 1);
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[0] = _tmp4_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[1] = _tmp5_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[2] = _tmp6_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[3] = _tmp7_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[4] = _tmp8_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp10_[5] = _tmp9_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp10_;
#line 690 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_[0] = _tmp11_;
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp13_[1] = _tmp12_;
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp13_;
#line 711 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_ = g_new0 (gchar*, 4 + 1);
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_[0] = _tmp14_;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_[1] = _tmp15_;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_[2] = _tmp16_;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp18_[3] = _tmp17_;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp18_;
#line 736 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_ = g_new0 (gchar*, 4 + 1);
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_[0] = _tmp19_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_[1] = _tmp20_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_[2] = _tmp21_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp23_[3] = _tmp22_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp23_;
#line 743 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Xmp.dc.title");
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_ = g_new0 (gchar*, 4 + 1);
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_[0] = _tmp24_;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_[1] = _tmp25_;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_[2] = _tmp26_;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp28_[3] = _tmp27_;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp28_;
#line 802 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.dc.subject");
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_[0] = _tmp29_;
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp31_[1] = _tmp30_;
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp31_;
#line 846 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 2;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp32_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, FALSE);
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp33_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE);
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp34_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE);
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp35_ = g_new0 (HierarchicalKeywordField*, 3 + 1);
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp35_[0] = _tmp32_;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp35_[1] = _tmp33_;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp35_[2] = _tmp34_;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp35_;
#line 851 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 3;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Exif.Image.Artist");
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp37_ = g_strdup ("Exif.Canon.OwnerName");
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp38_ = g_new0 (gchar*, 2 + 1);
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp38_[0] = _tmp36_;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp38_[1] = _tmp37_;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp38_;
#line 1078 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 2;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp39_ = g_strdup ("Xmp.xmp.Rating");
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp40_ = g_strdup ("Iptc.Application2.Urgency");
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp41_ = g_strdup ("Xmp.photoshop.Urgency");
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp42_ = g_new0 (gchar*, 3 + 1);
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp42_[0] = _tmp39_;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp42_[1] = _tmp40_;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp42_[2] = _tmp41_;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS = _tmp42_;
#line 1115 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS_length1 = 3;
#line 8602 "PhotoMetadata.c"
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 8621 "PhotoMetadata.c"
}


static void photo_metadata_finalize (MediaMetadata* obj) {
	PhotoMetadata * self;
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (obj);
#line 135 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 136 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 137 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 99 "/builddir/build/BUILD/shotwell-0.12.0/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 8637 "PhotoMetadata.c"
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



